/*
 ķ
   Program..: _DCGETBX.PRG                                 
   Author...:  Roger J. Donnay                             
   Notice...: (c) DONNAY Software Designs 1987-2006        
   Date.....: Feb  4, 2006                                 
   Notes....: eXPress++ GUI Dialog Processor               
 Ľ
*/

#define _METHOD METHOD

#include 'dcdialog.ch'
#include 'dccursor.ch'
#include "dcbitmap.ch"
#include "dcicon.ch"
#INCLUDE "dcmouse.CH"
#include "Gra.ch"
#include "Xbp.ch"
#include "Appevent.ch"
#include "Inkey.ch"
#include "font.ch"
#include "common.ch"
#include "app.ch"
#include "error.ch"
#include "dcmsg.ch"
#include "thread.ch"
#include "dll.ch"
#include "class.ch"
#include "dmlb.ch"

#define COLOR_ORANGE     GraMakeRGBColor( { 253, 120,  41 } )

#define BORDER_SIZE     6

//****************************************************************************
// Constants for XbpWindow:InvalidateRect()
//****************************************************************************
#ifndef XBP_INVREGION_LOCK
#define XBP_INVREGION_LOCK             0x10000
#define XBP_INVREGION_DISCARD          0x20000
#define XBP_INVREGION_RELEASE          0x40000
#define XBP_INVREGION_AND              1
#define XBP_INVREGION_OR               2
#define XBP_INVREGION_XOR              3
#define XBP_INVREGION_DIFF             4
#endif

#DEFINE CRLF Chr(13)+Chr(10)

#pragma Library("ADAC20B.LIB")

#ifndef XBPMENUBAR_MIA_OWNERDRAW
#define XBPMENUBAR_MIA_OWNERDRAW       131072
#endif

#ifndef xbeM_Enter
  #define xbeM_Enter  (005 + xbeB_Event)
#endif

#ifndef xbeM_Leave
  #define xbeM_Leave  (006 + xbeB_Event)
#endif

#ifndef xbeP_PresParamChanged
  #define xbeP_PresParamChanged          (051 + xbeB_Event)
#endif

#ifndef xbeP_MeasureItem
  #define xbeP_MeasureItem               (072 + xbeB_Event)
  #define xbeP_DrawItem                  (073 + xbeB_Event)
  #define xbeP_DragEnter                 (074 + xbeB_Event)
  #define xbeP_DragMotion                (075 + xbeB_Event)
  #define xbeP_DragLeave                 (076 + xbeB_Event)
  #define xbeP_DragDrop                  (077 + xbeB_Event)
#endif

#define XBPSTATIC_SYSICON_SYSTEM        0       // Windows Default Pointer

MEMVAR plDataLink

STATIC snEventSpy := 0
// STATIC oMagicHelpThread   // J. Duijf 17-07-2014
STATIC soDragDialog
STATIC slMenuWhenFlag := .f.

MEMVAR __GETLIST

Procedure Dc_Break(o)
Break(o)

Return

FUNCTION DC_ReadGui( aGetList, cTitle, aOptions, nButtons, ;
                     bEventHandler, xRef, oParentDlg, lFit, lDesignOn, ;
                     lExit, oAppWindow, lModal, bEval, ;
                     lExitEnter, lArrayTranslate, oOwner, xSetFocus, ;
                     aGroup, anTimeOut, nWait, lClearEvents, lDestroy, ;
                     lSetAppWindow, cSourceFile, lExpress, nPostEvent, ;
                     lMultiLists, lNoRestore, oGetList, lNoKeyPress )

LOCAL lRet, nSeconds := Seconds()

oGetList := DC_GetList():new( aGetList, cTitle, aOptions, nButtons, ;
                     bEventHandler, @xRef, @oParentDlg, lFit, lDesignOn, ;
                     lExit, oAppWindow, lModal, bEval, ;
                     lExitEnter, lArrayTranslate, oOwner, @xSetFocus, ;
                     aGroup, anTimeOut, nWait, lClearEvents, lDestroy, ;
                     lSetAppWindow, cSourceFile, lExpress, nPostEvent, ;
                     lMultiLists, lNoRestore, lNoKeyPress )

IF oGetList:ParentDlg:Status() = XBP_STAT_CREATE
   lRet := oGetList:ReadGui(@xRef,@oParentDlg,@xSetFocus,lExpress)
ELSE
   oGetList:parentDlg:Destroy()
ENDIF

Return lRet

* ========================================================

CLASS DC_GetList

HIDDEN:
  VAR lToolTipCreated
  VAR buildErrorMsg

EXPORTED:

  // passed in variables are assigned to iVars
  VAR getListArray             // aGetList
  VAR getOptions               // aOptions
  VAR title                    // cTitle
  VAR buttons                  // nButtons
  VAR eventHandlerBlock        // bEventHandler
  VAR referenceData            // aRef
  VAR parentDlg                // oParentDlg
  VAR isFit                    // lFit
  VAR isDesignOn               // lDesignOn
  VAR isExit                   // lExit
  VAR appWindow                // oAppWindow
  VAR modalState               // lModal - nGETOPT_MODALSTATE
  VAR evalBlock                // bEval
  VAR isExitEnter              // lExitEnter
  VAR isArrayTranslate         // lArrayTranslate
  VAR owner                    // oOwner
  VAR setFocus                 // xSetFocus
  VAR group                    // aGroup
  VAR timeOut                  // anTimeOut
  VAR wait                     // nWait
  VAR isClearEvents            // lClearEvents
  VAR isDestroy                // lDestroy
  VAR isSetAppWindow           // lSetAppWindow
  VAR sourceFile               // cSourceFile
  VAR saveAppWindow
  VAR saveAppFocus
  VAR lastFocus
  VAR editControlLastFocus
  VAR isAutoRestore
  VAR restoreArray
  VAR isNoKeyPress

  // options array items are assigned to iVars
  VAR rowOffset                // nGETOPT_ROWOFFSET
  VAR colOffset                // nGETOPT_COLOFFSET
  VAR rowSpace                 // nGETOPT_ROWSPACE
  VAR getHeight                // nGETOPT_GETHEIGHT
  VAR sayHeight                // nGETOPT_SAYHEIGHT
  VAR isPixel                  // lGETOPT_PIXEL
  VAR isCheckGet               // lGETOPT_CHECKGET
  VAR isVisible                // lGETOPT_VISIBLE
  VAR isDesignMode             // lGETOPT_DESIGN
  VAR isTranslate              // lGETOPT_TRANSLATE
  VAR isSayRight               // lGETOPT_SAYRIGHT
  VAR isMaxButton              // lGETOPT_MAXBUTTON
  VAR isMinButton              // lGETOPT_MINBUTTON
  VAR isTabStop                // lGETOPT_TABSTOP
  VAR rowPixels                // nGETOPT_ROWPIXELS
  VAR colPixels                // nGETOPT_COLPIXELS
  VAR isEscapeKey              // lGETOPT_ESCAPEKEY
  VAR isExitValidate           // lGETOPT_EXVALID
  VAR isNoTaskList             // lGETOPT_NOTASKLIST
  VAR isNoMove                 // lGETOPT_NOMOVE
  VAR isNoReSize               // lGETOPT_NORESIZE
  VAR isNoTitleBar             // lGETOPT_NOTITLEBAR
  VAR origin                   // nGETOPT_ORIGIN
  VAR hiliteColor              // nGETOPT_HILITECOLOR
  VAR isSupervise              // lGETOPT_SUPERVISE
  VAR isHideDialog             // lGETOPT_HIDEDIALOG
  VAR isNoBusy                 // lGETOPT_NOBUSY
  VAR busyMsg                  // cGETOPT_BUSYMSG
  VAR busyColor                // nGETOPT_BUSYCOLOR
  VAR isCascade                // lGETOPT_CASCADE
  VAR isAutoResize             // lGETOPT_AUTORESIZE
  VAR colorGets                // aGETOPT_COLORGETS
  VAR isConfirm                // lGETOPT_CONFIRM
  VAR fitPad                   // nGETOPT_FITPAD
  VAR disabledColor            // nGETOPT_DISABLEDCOLOR
  VAR isEnterTab               // lGETOPT_ENTERTAB
  VAR font                     // cGETOPT_FONT
  VAR sayfont                  // cGETOPT_SAYFONT
  VAR getfont                  // cGETOPT_GETFONT
  VAR backgroundColor          // nGETOPT_BGCOLOR
  VAR noEditNavKeyBlock        // bGETOPT_NOEDITNAVKEYS
  VAR buttonSound              // aGETOPT_BUTTONSOUND
  VAR designKey                // nGETOPT_DESIGNKEY
  VAR icon                     // nGETOPT_ICON
  VAR bitmap                   // nGETOPT_BITMAP
  VAR border                   // nGETOPT_BORDER
  VAR minSize                  // nGETOPT_MINSIZE
  VAR maxSize                  // nGETOPT_MAXSIZE
  VAR isExitQuery              // lGETOPT_EXITQUERY[1]
  VAR exitQueryBlock           // lGETOPT_EXITQUERY[2]
  VAR isCloseQuery             // lGETOPT_CLOSEQUERY[1]
  VAR closeQueryBlock          // lGETOPT_CLOSEQUERY[2]
  VAR isAbortQuery             // lGETOPT_ABORTQUERY[1]
  VAR abortQueryBlock          // lGETOPT_ABORTQUERY[2]
  VAR editProtectBlock         // bGETOPT_EDITPROTECT
  VAR messageInto              // oGETOPT_MESSAGEINTO
  VAR loopWhenBlock            // bGETOPT_LOOPWHEN
  VAR windowHeight             // nGETOPT_WINDOWHEIGHT
  VAR windowWidth              // nGETOPT_WINDOWWIDTH
  VAR sayOptions               // nGETOPT_SAYOPT
  VAR isQuitQuery              // lGETOPT_QUITQUERY[1]
  VAR quitQueryBlock           // lGETOPT_QUITQUERY[2]
  VAR isAlwaysOnTop            // lGETOPT_ALWAYSONTOP
  VAR onClickBlock             // bGETOPT_GOTFOCUS
  VAR restoreDefaultButton     // lGETOPT_RESTDEFBUTT
  VAR editProtectBlockSafe     // bGETOPT_EDITPROTECTSAFE
  VAR lockWindowToOwner        // lGETOPT_LOCKTOOWNER

  // DataStore variables
  VAR dataStore                // Pointer to GetList Item containing DataStore record
  VAR drawingArea              // drawingArea
  VAR getListPointer           // i
  VAR editControls             // aEDITCONTROLS
  VAR graControls              // aGRACONTROLS
  VAR browseControls           // aBROWSECONTROLS
  VAR tabpageControls          // aTABPAGECONTROLS
  VAR pickControls             // aPICKCONTROLS
  VAR appcontrols              // aAPPCONTROLS
  VAR keyboardControls         // aKEYBOARDCONTROLS
  VAR tooltipControls          // aTOOLTIPCONTROLS
  VAR isDisplayFocus           // lDISPLAYFOCUS
  VAR isOkstatus               // lOKSTATUS
  VAR messageBox               // oMESSAGEBOX
  VAR isGetListUndo            // lGETLISTUNDO
  VAR isDialogActive           // lDIALOGACTIVE
  VAR dialogWindow             // oDIALOGWINDOW
  VAR lastEvent                // nLASTEVENT
  VAR designOptions            // aDESIGNOPTIONS
  VAR reSize                   // aRESIZE
  VAR menuBar                  // oMENUBAR
  VAR statusBar                // aSTATUSBAR
  VAR dialogControls           // aDIALOGCONTROLS
  VAR lastKey                  // nLASTKEY
  VAR isMenu                   // lMenu
  VAR isNewDlg                 // lNewDlg
  VAR cargo
  VAR isMultiLists
  VAR isDataToolTips
  VAR pointerDlg
  VAR isClearMessage           // lCLEARMESSAGE
  VAR autoWinMenu
  VAR autoFocus
  VAR noWinMenu
  VAR postEvent
  VAR keyboardQueue
  VAR keyboardBuffer
  VAR keyhandlingcompleted    // Jack Duijf 17-07-2014
  VAR name
  VAR staticButtonControls
  VAR helpCode
  VAR restorePointer
  VAR isResize
  VAR scaleFactor
  VAR fontDefault
  VAR resizeDefault
  VAR popupMenu
  VAR helpfile
  VAR helpObject
  VAR restoreWindow
  VAR dragDrop
  VAR toolBarControls
  VAR scrollBars
  VAR isRestoreWindow
  VAR userEvents
  VAR sourceCode
  VAR sourceEditor
  VAR metrics
  VAR designer
  VAR isNoUndo
  VAR gestures
  VAR gestureHandlerBlock
  VAR isSleep
  VAR isStoreProfile

  _METHOD Init, ReadGui, EventLoop, PaintGraControls, AutoFit, Message, ;
          AddDataStore, AddHotKey, CellEditSetup, Refresh, CreateObject

ENDCLASS

* ---------------------------------------

METHOD dc_getList:init( aGetList, cTitle, aOptions, nButtons, ;
                     bEventHandler, aRef, oParentDlg, lFit, lDesignOn, ;
                     lExit, oAppWindow, lModal, bEval, ;
                     lExitEnter, lArrayTranslate, oOwner, xSetFocus, ;
                     aGroup, anTimeOut, nWait, lClearEvents, lDestroy, ;
                     lSetAppWindow, cSourceFile, lExpress, nPostEvent, ;
                     lMultiLists, lNoRestore, lNoKeyPress )

LOCAL aArray, lDebugCreate, cProcName, ;
      nRow, nCol, bBlock, aMenu, aGetOptDefault, nDisabledBGColor, ;
      boMsgBox, nKeyType, cKeyList, lMDI := .f., oFont, cFont

DC_Gui(.t.)
Grok(aRef) ; Grok(xSetFocus)
lDebugCreate := DC_BitTest( DC_ReadGuiDebug(),DCGUI_DEBUG_CREATE )

::saveAppWindow := SetAppWindow()
::restorePointer := .f.
::lToolTipCreated := .f.

IF !DC_Do('DC_ExpressDemo()',,.f.,.t.)
  QUIT
ENDIF

DEFAULT aOptions := {}, ;
        lFit := .f., ;
        lExit := .f., ;
        lDesignOn := .f., ;
        lModal := .f., ;
        lArrayTranslate := .f., ;
        lClearEvents := .f., ;
        lSetAppWindow := .f., ;
        nPostEvent := 0, ;
        lMultiLists := .f., ;
        lNoKeyPress := .f.

::isRestoreWindow := .f.
::userEvents := {}
::owner := oOwner

IF !Empty(DC_AutoRestoreWindow())
  IF Valtype(lNoRestore) == 'L'
    ::isRestoreWindow := !lNoRestore
  ELSE
    ::isRestoreWindow := DC_AutoRestoreWindow()[3]
  ENDIF
ELSE
  ::isRestoreWindow := .f.
ENDIF

IF Valtype(nButtons) = 'L'
  nButtons := IIF( nButtons, DCGUI_BUTTON_OK + DCGUI_BUTTON_CANCEL, 0 )
ELSEIF Empty(nButtons)
  nButtons := 0
ENDIF

IF !Empty(cSourceFile)
  IF !IsFunction('DC_GetList2Source')
    DllLoad('DCLIP1.DLL')
  ENDIF
  IF IsFunction('DC_GetList2Source')
    PRIVATE __GETLIST := aGetList
    &('DC_GetList2Source(__GETLIST,,"' + cSourceFile + '")')
  ENDIF
ENDIF

ASIZE(aOptions,nGETOPT_ARRAY_SIZE)

::getListArray := aGetList
::getOptions := aOptions

::dataStore := ::AddDataStore()

::saveAppFocus := SetAppFocus()

aGetOptDefault := DC_GetOptDefault(nil,lExpress)

DEFAULT aOptions[nGETOPT_ROWOFFSET]    := aGetOptDefault[nGETOPT_ROWOFFSET]
::rowOffset := aOptions[nGETOPT_ROWOFFSET]

DEFAULT aOptions[nGETOPT_COLOFFSET]    := aGetOptDefault[nGETOPT_COLOFFSET]
::colOffset := aOptions[nGETOPT_COLOFFSET]

IF !Empty(cTitle)
  aOptions[cGETOPT_TITLE] := cTitle
ELSE // IF Valtype(aOptions[cGETOPT_TITLE]) # 'B'
  DEFAULT aOptions[cGETOPT_TITLE]      := aGetOptDefault[cGETOPT_TITLE]
ENDIF
::title := aOptions[cGETOPT_TITLE]

DEFAULT aOptions[nGETOPT_ROWSPACE]     := aGetOptDefault[nGETOPT_ROWSPACE]
::rowSpace := aOptions[nGETOPT_ROWSPACE]

DEFAULT aOptions[nGETOPT_GETHEIGHT]    := aGetOptDefault[nGETOPT_GETHEIGHT]
::getHeight := aOptions[nGETOPT_GETHEIGHT]

DEFAULT aOptions[nGETOPT_SAYHEIGHT]    := aGetOptDefault[nGETOPT_SAYHEIGHT]
::sayHeight := aOptions[nGETOPT_SAYHEIGHT]

DEFAULT aOptions[lGETOPT_PIXEL]        := aGetOptDefault[lGETOPT_PIXEL]
::isPixel := aOptions[lGETOPT_PIXEL]

DEFAULT aOptions[lGETOPT_CHECKGET]     := aGetOptDefault[lGETOPT_CHECKGET]
::isCheckGet := aOptions[lGETOPT_CHECKGET]

DEFAULT aOptions[lGETOPT_VISIBLE]      := aGetOptDefault[lGETOPT_VISIBLE]
::isVisible := aOptions[lGETOPT_VISIBLE]

DEFAULT aOptions[lGETOPT_DESIGN]       := aGetOptDefault[lGETOPT_DESIGN]
::isDesignMode := aOptions[lGETOPT_DESIGN]

DEFAULT aOptions[lGETOPT_TRANSLATE]    := aGetOptDefault[lGETOPT_TRANSLATE]
::isTranslate := aOptions[lGETOPT_TRANSLATE]

DEFAULT aOptions[lGETOPT_SAYRIGHT]     := aGetOptDefault[lGETOPT_SAYRIGHT]
::isSayRight := aOptions[lGETOPT_SAYRIGHT]

DEFAULT aOptions[lGETOPT_MAXBUTTON]    := aGetOptDefault[lGETOPT_MAXBUTTON]
::isMaxButton := aOptions[lGETOPT_MAXBUTTON]

DEFAULT aOptions[lGETOPT_MINBUTTON]    := aGetOptDefault[lGETOPT_MINBUTTON]
::isMinButton := aOptions[lGETOPT_MINBUTTON]

DEFAULT aOptions[cGETOPT_GETTEMPLATE]  := aGetOptDefault[cGETOPT_GETTEMPLATE]

IF Valtype(aOptions[nGETOPT_MODALSTATE]) # 'N'
  IF lModal
    aOptions[nGETOPT_MODALSTATE] := XBP_DISP_APPMODAL
  ELSE
    aOptions[nGETOPT_MODALSTATE] := XBP_DISP_MODELESS
  ENDIF
ENDIF
::modalState := aOptions[nGETOPT_MODALSTATE]

DEFAULT aOptions[lGETOPT_TABSTOP]      := aGetOptDefault[lGETOPT_TABSTOP]
::isTabStop := aOptions[lGETOPT_TABSTOP]

DEFAULT aOptions[lGETOPT_NOTABSTOP] := .F.
IF !aOptions[lGETOPT_NOTABSTOP]
  ::isTabStop := .F.
ENDIF

DEFAULT aOptions[nGETOPT_ROWPIXELS]    := aGetOptDefault[nGETOPT_ROWPIXELS]
::rowPixels := aOptions[nGETOPT_ROWPIXELS]

DEFAULT aOptions[nGETOPT_COLPIXELS]    := aGetOptDefault[nGETOPT_COLPIXELS]
::colPixels := aOptions[nGETOPT_COLPIXELS]

DEFAULT aOptions[lGETOPT_ESCAPEKEY]    := aGetOptDefault[lGETOPT_ESCAPEKEY]
::isEscapeKey := aOptions[lGETOPT_ESCAPEKEY]

DEFAULT aOptions[lGETOPT_EXVALID]      := aGetOptDefault[lGETOPT_EXVALID]
::isExitValidate := aOptions[lGETOPT_EXVALID]

DEFAULT aOptions[lGETOPT_NOTASKLIST]   := aGetOptDefault[lGETOPT_NOTASKLIST]
::isNoTaskList := aOptions[lGETOPT_NOTASKLIST]

DEFAULT aOptions[lGETOPT_NOMOVE]       := aGetOptDefault[lGETOPT_NOMOVE]
::isNoMove := aOptions[lGETOPT_NOMOVE]

DEFAULT aOptions[lGETOPT_NORESIZE]     := aGetOptDefault[lGETOPT_NORESIZE]
::isNoReSize := aOptions[lGETOPT_NORESIZE]

DEFAULT aOptions[lGETOPT_NOTITLEBAR]   := aGetOptDefault[lGETOPT_NOTITLEBAR]
::isNoTitleBar := aOptions[lGETOPT_NOTITLEBAR]

DEFAULT aOptions[nGETOPT_ORIGIN]       := aGetOptDefault[nGETOPT_ORIGIN]
::origin := aOptions[nGETOPT_ORIGIN]

DEFAULT aOptions[nGETOPT_HILITECOLOR]  := aGetOptDefault[nGETOPT_HILITECOLOR]
::hiliteColor := aOptions[nGETOPT_HILITECOLOR]

DEFAULT aOptions[lGETOPT_SUPERVISE]    := aGetOptDefault[lGETOPT_SUPERVISE]
::isSupervise := aOptions[lGETOPT_SUPERVISE]

DEFAULT aOptions[lGETOPT_HIDEDIALOG]   := aGetOptDefault[lGETOPT_HIDEDIALOG]
::isHideDialog := aOptions[lGETOPT_HIDEDIALOG]

DEFAULT aOptions[lGETOPT_NOBUSY]       := aGetOptDefault[lGETOPT_NOBUSY]
::isNoBusy := aOptions[lGETOPT_NOBUSY]

DEFAULT aOptions[cGETOPT_BUSYMSG]      := aGetOptDefault[cGETOPT_BUSYMSG]
::busyMsg := aOptions[cGETOPT_BUSYMSG]

DEFAULT aOptions[nGETOPT_BUSYCOLOR]    := aGetOptDefault[nGETOPT_BUSYCOLOR]
::busyColor := aOptions[nGETOPT_BUSYCOLOR]

DEFAULT aOptions[lGETOPT_CASCADE]      := aGetOptDefault[lGETOPT_CASCADE]
::isCascade := aOptions[lGETOPT_CASCADE]

DEFAULT aOptions[lGETOPT_AUTORESIZE]   := aGetOptDefault[lGETOPT_AUTORESIZE]
::isAutoResize := aOptions[lGETOPT_AUTORESIZE]

DEFAULT aOptions[lGETOPT_RESIZE]   := aGetOptDefault[lGETOPT_RESIZE]
::isResize := aOptions[lGETOPT_RESIZE]

DEFAULT aOptions[aGETOPT_COLORGETS]    := aGetOptDefault[aGETOPT_COLORGETS]
::colorGets := aOptions[aGETOPT_COLORGETS]

DEFAULT aOptions[lGETOPT_CONFIRM]      := aGetOptDefault[lGETOPT_CONFIRM]
::isConfirm = aOptions[lGETOPT_CONFIRM]

DEFAULT aOptions[nGETOPT_SAYOPT]       := aGetOptDefault[nGETOPT_SAYOPT]
::sayOptions := aOptions[nGETOPT_SAYOPT]

DEFAULT aOptions[nGETOPT_DISABLEDCOLOR]:= aGetOptDefault[nGETOPT_DISABLEDCOLOR]
nDisabledBGColor := aOptions[nGETOPT_DISABLEDCOLOR]
IF Valtype(nDisabledBGColor) = 'A' .AND. Len(nDisabledBGColor) = 3
  nDisabledBGColor := GraMakeRGBColor(nDisabledBGColor)
ENDIF
::disabledColor := nDisabledBGColor

DEFAULT aOptions[lGETOPT_ENTERTAB]     := aGetOptDefault[lGETOPT_ENTERTAB]
::isEnterTab := aOptions[lGETOPT_ENTERTAB]

DEFAULT aOptions[cGETOPT_FONT]         := aGetOptDefault[cGETOPT_FONT]
::font := aOptions[cGETOPT_FONT]

DEFAULT aOptions[cGETOPT_GETFONT]      := aGetOptDefault[cGETOPT_GETFONT]
::getfont := aOptions[cGETOPT_GETFONT]

DEFAULT aOptions[cGETOPT_SAYFONT]      := aGetOptDefault[cGETOPT_SAYFONT]
::sayfont := aOptions[cGETOPT_SAYFONT]

DEFAULT aOptions[nGETOPT_BGCOLOR]      := aGetOptDefault[nGETOPT_BGCOLOR]
::backgroundColor := aOptions[nGETOPT_BGCOLOR]

DEFAULT aOptions[bGETOPT_NOEDITNAVKEYS]:= aGetOptDefault[bGETOPT_NOEDITNAVKEYS]
::noEditNavKeyBlock := aOptions[bGETOPT_NOEDITNAVKEYS]

DEFAULT aOptions[aGETOPT_BUTTONSOUND]  := aGetOptDefault[aGETOPT_BUTTONSOUND]
::buttonSound := aOptions[aGETOPT_BUTTONSOUND]

DEFAULT aOptions[nGETOPT_DESIGNKEY]  := aGetOptDefault[nGETOPT_DESIGNKEY]
::designKey := aOptions[nGETOPT_DESIGNKEY]

::autoWinMenu := aOptions[lGETOPT_AUTOWINMENU]
DEFAULT ::autoWinMenu := .f.

DEFAULT aOptions[lGETOPT_NOWINMENU] := aGetOptDefault[lGETOPT_NOWINMENU]
::noWinMenu := aOptions[lGETOPT_NOWINMENU]

DEFAULT aOptions[lGETOPT_ALWAYSONTOP] := aGetOptDefault[lGETOPT_ALWAYSONTOP]
::isAlwaysOnTop := aOptions[lGETOPT_ALWAYSONTOP]

DEFAULT aOptions[lGETOPT_ENTEREXIT] := aGetOptDefault[lGETOPT_ENTEREXIT]
IF aOptions[lGETOPT_ENTEREXIT]
  ::isExitEnter := .t.
ENDIF

DEFAULT aOptions[lGETOPT_AUTOFOCUS] := aGetOptDefault[lGETOPT_AUTOFOCUS]
::autoFocus := aOptions[lGETOPT_AUTOFOCUS]

DEFAULT aOptions[nGETOPT_BUTTONALIGN] := aGetOptDefault[nGETOPT_BUTTONALIGN]

DEFAULT aOptions[cGETOPT_KEYBOARD]  := aGetOptDefault[cGETOPT_KEYBOARD]
::keyboardBuffer := aOptions[cGETOPT_KEYBOARD]

DEFAULT aOptions[cGETOPT_NAME]  := aGetOptDefault[cGETOPT_NAME]
::name := aOptions[cGETOPT_NAME]

DEFAULT aOptions[aGETOPT_TOOLCOLOR]  := aGetOptDefault[aGETOPT_TOOLCOLOR]

DEFAULT aOptions[cGETOPT_HELPCODE]  := aGetOptDefault[cGETOPT_HELPCODE]
::helpCode := aOptions[cGETOPT_HELPCODE]
IF !Empty(::helpCode)
  aGetList[::dataStore,cGETLIST_HELPCODE] := ::helpCode
ENDIF

DEFAULT aOptions[cGETOPT_HELPFILE]  := aGetOptDefault[cGETOPT_HELPFILE]
::helpfile := aOptions[cGETOPT_HELPFILE]

DEFAULT aOptions[cGETOPT_SOURCECODE]  := aGetOptDefault[cGETOPT_SOURCECODE]
::sourceCode := aOptions[cGETOPT_SOURCECODE]

DEFAULT aOptions[cGETOPT_SOURCEEDITOR]  := aGetOptDefault[cGETOPT_SOURCEEDITOR]
::sourceEditor := aOptions[cGETOPT_SOURCEEDITOR]

IF !lExit
  DEFAULT aOptions[bGETOPT_EVAL]  := aGetOptDefault[bGETOPT_EVAL]
ENDIF

DEFAULT aOptions[aGETOPT_SCALEFACTOR] := aGetOptDefault[aGETOPT_SCALEFACTOR]
::scaleFactor := aOptions[aGETOPT_SCALEFACTOR]

DEFAULT ::scaleFactor := {1,1,1,1,.f.,.f.}
ASize(::scaleFactor,6)
DEFAULT ::scaleFactor[5] := .F., ;
        ::scaleFactor[6] := .F.

DEFAULT aOptions[nGETOPT_FITPAD] := aGetOptDefault[nGETOPT_FITPAD]
::fitPad := aOptions[nGETOPT_FITPAD]
DEFAULT ::fitPad := 10 * ::scaleFactor[1]

DEFAULT aOptions[cGETOPT_FONTDEFAULT] := aGetOptDefault[cGETOPT_FONTDEFAULT]
::fontDefault := aOptions[cGETOPT_FONTDEFAULT]

DEFAULT aOptions[nGETOPT_BITMAP] := aGetOptDefault[nGETOPT_BITMAP]

DEFAULT aOptions[nGETOPT_SCROLLBARS] := aGetOptDefault[nGETOPT_SCROLLBARS]
::scrollBars := aOptions[nGETOPT_SCROLLBARS]

DEFAULT aOptions[aGETOPT_RESIZEDEFAULT] := aGetOptDefault[aGETOPT_RESIZEDEFAULT]
::resizeDefault := aOptions[aGETOPT_RESIZEDEFAULT]

DEFAULT aOptions[bGETOPT_ONCLICK] := aGetOptDefault[bGETOPT_ONCLICK]
::onClickBlock := aOptions[bGETOPT_ONCLICK]

DEFAULT aOptions[lGETOPT_RESTDEFBUTT] := aGetOptDefault[lGETOPT_RESTDEFBUTT]
::restoreDefaultButton := aOptions[lGETOPT_RESTDEFBUTT]

DEFAULT aOptions[lGETOPT_LOCKTOOWNER] := aGetOptDefault[lGETOPT_LOCKTOOWNER]
::lockWindowToOwner := aOptions[lGETOPT_LOCKTOOWNER]

DEFAULT aOptions[lGETOPT_MESSAGECLEAR] := aGetOptDefault[lGETOPT_MESSAGECLEAR]
::isClearMessage := aOptions[lGETOPT_MESSAGECLEAR]

DEFAULT aOptions[nGETOPT_GESTURES] := aGetOptDefault[nGETOPT_GESTURES]
::gestures := aOptions[nGETOPT_GESTURES]

DEFAULT aOptions[bGETOPT_GESTUREHANDLER] := aGetOptDefault[bGETOPT_GESTUREHANDLER]
::gestureHandlerBlock := aOptions[bGETOPT_GESTUREHANDLER]

DEFAULT aOptions[lGETOPT_SLEEP] := aGetOptDefault[lGETOPT_SLEEP]
::isSleep := aOptions[lGETOPT_SLEEP]

DEFAULT aOptions[lGETOPT_STOREPROFILE] := aGetOptDefault[lGETOPT_STOREPROFILE]
::isStoreProfile := aOptions[lGETOPT_STOREPROFILE]

::isNoUndo := .f.
IF Valtype(aOptions[lGETOPT_NO_UNDO]) == 'L'
  ::isNoUndo := aOptions[lGETOPT_NO_UNDO]
ENDIF

IF Valtype(oAppWindow) == 'O'
  _BuildHelpCode( aGetList[::dataStore],,oAppWindow )
ENDIF

::keyboardQueue := Array(0)

::icon := aOptions[nGETOPT_ICON]
::bitmap := DC_GetBitmap(aOptions[nGETOPT_BITMAP],,,,,.t.)
::border := aOptions[nGETOPT_BORDER]

IF !aOptions[lGETOPT_NOBUSY] .AND. Valtype(::saveAppWindow) = 'O' .AND. ;
      IsMethod(::saveAppWindow,'CHILDLIST') .AND. Empty(oParentDlg)
  ::pointerDlg := ::saveAppWindow
  IF IsMethod(::pointerDlg, 'CAPTUREMOUSE')
    ::pointerDlg:SetPointer( nil, XBPSTATIC_SYSICON_WAIT, XBPWINDOW_POINTERTYPE_SYSPOINTER )
    ::pointerDlg:captureMouse(.t.)
    ::RestorePointer := .t.
  ENDIF

ENDIF

IF ::isHideDialog
  ::isVisible := .f.
ENDIF

IF lArrayTranslate
  aOptions[lGETOPT_TRANSLATE] := .f.
  ::isTranslate := .f.
ENDIF
::isArrayTranslate := lArrayTranslate

::dragDrop := .t.
::isGetlistUndo := .f.
::isDesignOn := lDesignOn
::parentDlg := oParentDlg
::isNewDlg := .f.
::isMenu := .f.
::isFit := lFit
::buttons := nButtons
::statusBar := {}
::isClearEvents := lClearEvents
::evalBlock := bEval
::isSetAppWindow := lSetAppWindow
::isExit := lExit
::isMultiLists := lMultiLists
::eventHandlerBlock := bEventHandler
::isDataToolTips := .f.
::isDisplayFocus := .t.
::isOkStatus := .f.
::timeOut := anTimeOut
::wait := nWait
::restoreWindow := .t.
::isNoKeyPress := lNoKeyPress

IF Empty(::parentDlg) .OR. lMDI

  IF lDebugCreate
    DCQDEBUG 'Creating Dialog Window'
  ENDIF

  ::isNewDlg := .t.

  DEFAULT lDestroy := .t.
  lMDI := .f.

  ::windowHeight := aOptions[nGETOPT_WNDHEIGHT]
  ::windowWidth := aOptions[nGETOPT_WNDWIDTH]
  DEFAULT ::windowHeight := aGetOptDefault[nGETOPT_WNDHEIGHT]
  DEFAULT ::windowWidth := aGetOptDefault[nGETOPT_WNDWIDTH]

  DEFAULT ::windowHeight := 450 // AppDeskTop():currentSize()[2]-30
  DEFAULT ::windowWidth := 600 // AppDeskTop():currentSize()[1]-30

  ::windowWidth *= ::scaleFactor[3]
  ::windowHeight *= ::scaleFactor[4]

  IF nButtons > 0 .AND. ::isTranslate
    ::windowHeight += 40
  ENDIF

  IF ::isArrayTranslate
     aOptions[nGETOPT_WNDHEIGHT] := ::windowHeight
     aOptions[nGETOPT_WNDWIDTH] := ::windowWidth
  ENDIF

  IF Valtype(oAppWindow) # 'O'
    oAppWindow := AppDeskTop()
    IF aOptions[nGETOPT_MODALSTATE] == XBP_DISP_APPMODAL .AND. Valtype(oOwner) # 'O'
      oOwner := SetAppWindow()
    ENDIF
  ELSE
    lMDI := .t.
  ENDIF

  IF Valtype(aOptions[nGETOPT_WNDROW]) = 'N'
    nRow := aOptions[nGETOPT_WNDROW]
  ELSEIF ::origin = XBPDLG_ORIGIN_MOUSE
    nRow := 0
  ELSE
    nRow := (oAppWindow:currentSize()[2]-::windowHeight)/2
  ENDIF

  IF Valtype(aOptions[nGETOPT_WNDCOL]) ='N'
    nCol := aOptions[nGETOPT_WNDCOL]
  ELSEIF ::origin = XBPDLG_ORIGIN_MOUSE
    nCol := 0
  ELSE
    nCol := (oAppWindow:currentSize()[1]-::windowWidth)/2
  ENDIF

  IF ::isCascade
    nCol := 0
    nRow := ::windowHeight
    aArray := DC_CascadeCoords(oAppWindow,.f.,{ nRow, nCol },.t.)
    nRow := aArray[1] - ::windowHeight
    nCol := aArray[2]
  ENDIF

  ::parentDlg := DC_XbpDialog1():new( oAppWindow, oOwner, ;   // <<< Jack Djuif
        { nCol, nRow }, ;
        { ::windowWidth, ::windowHeight }, ;
        aOptions[aGETOPT_PRESENT], .t. )

  ::parentDlg:taskList := !::isNoTaskList

  ::parentDlg:alwaysOnTop := ::isAlwaysOnTop

  IF Valtype(::title) == 'B'
    ::parentDlg:title := Eval(::title)
  ELSE
    ::parentDlg:title := ::title
  ENDIF

  IF Valtype(::icon) $ 'NO'
    ::parentDlg:icon := ::icon
  ELSEIF Valtype(DC_IconDefault()) $ 'NO'
    ::parentDlg:icon := DC_IconDefault()
  ENDIF
  ::minSize := aOptions[aGETOPT_MINSIZE]
  ::maxSize := aOptions[aGETOPT_MAXSIZE]
  IF Valtype(::minSize) = 'A'
    ::parentDlg:minSize := ::minSize
  ENDIF
  IF Valtype(::maxSize) = 'A'
    ::parentDlg:maxSize := ::maxSize
  ENDIF
  IF ::isNoResize .AND. !::isFit
    ::parentDlg:minSize := { ::windowWidth, ::windowHeight }
    ::parentDlg:maxSize := { ::windowWidth, ::windowHeight }
  ENDIF

  IF Valtype(::isNoMove) = 'L'
    ::parentDlg:movewithOwner := !::isNoMove
  ENDIF
  IF !Empty(::origin)
    ::parentDlg:origin := ::origin
  ENDIF
  ::parentDlg:titleBar := !::isNoTitleBar
  ::parentDlg:visible := ::isVisible .AND. Empty(DC_AutoRestoreWindow())
  ::parentDlg:minButton := ::isMinButton
  ::parentDlg:maxButton := ::isMaxButton

  IF ::isRestoreWindow .AND. !Empty(DC_AutoRestoreWindow()) .AND. ;
      Valtype(::parentDlg) = 'O' .AND. ;
     ::parentDlg:isDerivedFrom('XbpDialog') .AND. !Empty(::parentDlg:title)

    IF Valtype(DC_AutoRestoreWindow()[1]) == 'B'
      ::restoreArray := Eval(DC_AutoRestoreWindow()[1],ProcName(2) + ':' + ::parentDlg:title,nil,.f.)
    ELSE
      ::restoreArray := DC_RegQuery(DC_AutoRestoreWindow()[1],DC_AutoRestoreWindow()[2], ;
                        ProcName(2) + ':' + Alltrim(::parentDlg:title))
    ENDIF

    IF Valtype(::restoreArray) == 'A'
      ASize(::restoreArray,4)
      IF Valtype(::restoreArray[4]) == 'A' .AND. ::scaleFactor[6]
        ::scaleFactor[1] *= ((::restoreArray[2,1]-8)/(::restoreArray[4,1]-8))
        ::scaleFactor[2] *= ((::restoreArray[2,2]-DC_GetTitleBarHeight()-8)/(::restoreArray[4,2]-DC_GetTitleBarHeight()-8))
        ::scaleFactor[3] *= ((::restoreArray[2,1]-8)/(::restoreArray[4,1]-8))
        ::scaleFactor[4] *= ((::restoreArray[2,2]-DC_GetTitleBarHeight()-8)/(::restoreArray[4,2]-DC_GetTitleBarHeight()-8))
      ENDIF
    ENDIF

ENDIF

  IF ::isAutoResize
    ::parentDlg:resize := {|a,b,o,x|x := SetAppFocus(), ;
                                    ::parentDlg:drawingArea:lockUpdate(.t.), ;
                                    DC_AutoReSize(a,b,o,aGetList), ;
                                    ::parentDlg:drawingArea:lockUpdate(.f.), ;
                                    SetAppFocus(x), ;
                                    ::parentDlg:drawingArea:invalidateRect(), ;
                                    ;// DC_RestoreWindow(self,5), ;
                                    nil }
  ELSEIF ::isResize
    ::parentDlg:resize := {|a,b,o,x|x := SetAppFocus(), ;
                                    ::parentDlg:drawingArea:lockUpdate(.t.), ;
                                    DC_ReSize(a,b,o,aGetList,self), ;
                                    ::parentDlg:drawingArea:lockUpdate(.f.), ;
                                    SetAppFocus(x), ;
                                    ::parentDlg:drawingArea:invalidateRect(), ;
                                    ;// DC_RestoreWindow(self,5), ;
                                    ;// DC_CompleteEvents(), ;
                                    ;// IIF(ProcLine(100)==0,DC_CompleteEvents(),nil), ;     // <<< causes stack overflow
                                    nil }

  ELSE
    ::parentDlg:resize := {|a,b,o|;
                        aOptions[nGETOPT_WNDCOL] := o:currentPos()[1], ;
                        aOptions[nGETOPT_WNDROW] := o:currentPos()[2], ;
                        aOptions[nGETOPT_WNDWIDTH] := o:currentSize()[1], ;
                        aOptions[nGETOPT_WNDHEIGHT] := o:currentSize()[2] }
  ENDIF
  ::drawingArea := ::parentDlg:drawingArea
  IF Valtype(::bitmap) $ 'CNO'
    ::drawingArea:bitmap := DC_GetBitMap(::bitmap,,,,,.t.)
  ENDIF
  IF !Empty(::border)
    ::parentDlg:border := ::border
  ENDIF

  #if XPPVER > 1900000
  ::drawingArea:scrollBars := ::scrollBars
  #endif

  bBlock := DC_GetBlock( aOptions[bGETOPT_PREEVAL] )
  IF Valtype(bBlock) = 'B'
    Eval(bBlock,::parentDlg,aGetList,self)
  ENDIF

  ::parentDlg:cargo := { 0, aGetList }

// ::parentDlg:drawingArea:clipChildren := .f.

  IF ::parentDlg:status() # XBP_STAT_INIT
    DC_WinAlert(Dc_LangMsg(DCMSG_DIALOGFAIL))
    BREAK
  ENDIF

  IF !Empty(::gestures)
    ::parentDlg:clipChildren := .t.
    ::parentDlg:drawingArea:inputMode := ::gestures
    ::parentDlg:drawingArea:gesture := ::gestureHandlerBlock
  ENDIF

  ::parentDlg:create()// :show()  // REMOVE THIS !!!!!!!!!!

  IF Valtype(::backgroundColor) = 'N'
    ::drawingArea:setColorBG( ::backgroundColor )
  ELSEIF Valtype(::backgroundColor) = 'A'
    ::drawingArea:setColorBG( GraMakeRGBColor( ::backgroundColor ) )
  ELSE
    ::drawingArea:setColorBG( GRA_CLR_BACKGROUND )
  ENDIF

  IF !Empty(aOptions[cGETOPT_FONT])
    ::drawingArea:setFontCompoundName(aOptions[cGETOPT_FONT])
  ELSE
//    ::drawingArea:setFontCompoundName( Dc_BaseFont(7) )
    ::drawingArea:setFontCompoundName( Dc_BaseFont() )  // Jack Duijf 17-07-2014
  ENDIF
  IF ::scaleFactor[5]
    oFont := ::drawingArea:setFont()
    IF Valtype(oFont) = 'O'
      cFont := Alltrim(Str(Round(oFont:nominalPointSize * ::scaleFactor[3],0))) + ;
                '.' + oFont:familyName
      ::drawingArea:setFontCompoundName(cFont)
    ENDIF
  ENDIF
  ::parentDlg:SetModalState(aOptions[nGETOPT_MODALSTATE])

ELSEIF ::parentDlg:isDerivedFrom('XbpDialog')

  ::drawingArea := ::parentDlg:drawingArea
  lDestroy := .f.

ELSE

  ::drawingArea := ::parentDlg
  lDestroy := .f.

ENDIF

::isDestroy := lDestroy

oParentDlg := ::parentDlg

IF Valtype(aOptions[bGETOPT_EVAL]) = 'B'
  Eval( aOptions[bGETOPT_EVAL], ::parentDlg, aGetList, self )
ENDIF

IF !Empty(aOptions[cGETOPT_MENU])

  aMenu := aOptions[cGETOPT_MENU]

  IF Valtype(aMenu)='C' .OR. (Valtype(aMenu) = 'A' .AND. Valtype(aMenu[1]) = 'C')
    IF Valtype(aMenu) = 'A'
      ASize(aMenu,4)
      nKeyType := aMenu[4]
      cKeyList := aMenu[3]
      boMsgBox := aMenu[2]
      aMenu := aMenu[1]
    ENDIF
    IF lDebugCreate
      DCQDEBUG 'Loading Menu ' + aMenu
    ENDIF
    aMenu := DC_DO('DC_MenuCompile(DC_MenuLoad("'+aMenu+'"))')

  ELSEIF Valtype(aMenu) = 'A' .AND. Len(aMenu) == 5
    IF !Empty(aMenu[1])
      nKeyType := aMenu[4]
      cKeyList := aMenu[3]
      boMsgBox := aMenu[2]
      aMenu := aMenu[1]
    ELSE
      aMenu := nil
    ENDIF
  ENDIF

  IF Valtype(aMenu)='A'
    // Install menu bar in dialog window
    ::menuBar := DC_MenuOSys( aMenu, ::parentDlg, .f., aGetList, boMsgBox, cKeyList, nKeyType )
    ::menuBar:beginMenu := {|a,b,o|_MenuWhen(o)}
    IF Valtype(boMsgBox) == 'B'
      ::menuBar:endMenu := {||Eval(boMsgBox):setCaption('')}
    ENDIF
    ::isMenu := .t.
  ENDIF

ENDIF

IF AScan(aGetList,{|a|Valtype(a)='A'.AND.a[nGETLIST_TYPE]==GETLIST_MENUBAR}) > 0
  ::isMenu := .t.
ENDIF

::metrics := GetSystemMetrics(4) + ;  // Title bar Height
             GetSystemMetrics(32)*2 + ; // Frame Width
             IIF(::isMenu, GetSystemMetrics(15), 0 ) // Menu Height

::group := aGroup
IF Valtype(::group)='C'
  ::group := { ::group }
ENDIF

::editControls    := {}
::graControls      := {}
::browseControls   := {}
::appControls      := {}
::pickControls     := {}
::keyboardControls := {}
::tabpageControls  := {}
::tooltipControls  := {}
::dialogControls   := {}
::staticButtonControls := {}
::toolBarControls  := {}

IF Valtype(lExitEnter) == 'L'
  ::isExitEnter := lExitEnter
ENDIF
DEFAULT ::isExitEnter := .f.

DEFAULT aOptions[oGETOPT_MESSAGEINTO] := aGetOptDefault[oGETOPT_MESSAGEINTO]

::isDesignOn       := lDesignOn
::isDialogActive   := .t.
::lastEvent        := DCGUI_NONE
::editProtectBlock := aOptions[bGETOPT_EDITPROTECT]
::messageInto      := aOptions[oGETOPT_MESSAGEINTO]
::postEvent        := nPostEvent
::editProtectBlockSafe := aOptions[bGETOPT_EDITPROTECTSAFE]

IF Valtype(aOptions[lGETOPT_ABORTQUERY]) = 'A'
  ::isAbortQuery := aOptions[lGETOPT_ABORTQUERY,1]
  ::abortQueryBlock := aOptions[lGETOPT_ABORTQUERY,2]
ELSE
  ::isAbortQuery := aOptions[lGETOPT_ABORTQUERY]
  ::abortQueryBlock := nil
ENDIF

IF Valtype(aOptions[lGETOPT_CLOSEQUERY]) = 'A'
  ::isCloseQuery := aOptions[lGETOPT_CLOSEQUERY,1]
  ::closeQueryBlock := aOptions[lGETOPT_CLOSEQUERY,2]
ELSE
  ::isCloseQuery := aOptions[lGETOPT_CLOSEQUERY]
  ::closeQueryBlock := nil
ENDIF

IF Valtype(aOptions[lGETOPT_EXITQUERY]) = 'A'
  ::isExitQuery := aOptions[lGETOPT_EXITQUERY,1]
  ::exitQueryBlock := aOptions[lGETOPT_EXITQUERY,2]
ELSE
  ::isExitQuery := aOptions[lGETOPT_EXITQUERY]
  ::exitQueryBlock := nil
ENDIF

IF Valtype(aOptions[lGETOPT_QUITQUERY]) = 'A'
  ::isQuitQuery := aOptions[lGETOPT_QUITQUERY,1]
  ::quitQueryBlock := aOptions[lGETOPT_QUITQUERY,2]
  DEFAULT ::quitQueryBlock := {||QuitQuery()}
ELSE
  ::isQuitQuery := aOptions[lGETOPT_QUITQUERY]
  ::quitQueryBlock := {||QuitQuery()}
ENDIF

::appWindow := oAppWindow

DEFAULT ::isAbortQuery := .f., ;
        ::isCloseQuery := .f., ;
        ::isExitQuery := .f., ;
        ::isQuitQuery := .f.

IF ::isQuitQuery
  oParentDlg:quit := ::quitQueryBlock
ENDIF

IF ::isCloseQuery .AND. Valtype(::closeQueryBlock) # 'B'
  ::closeQueryBlock := {||DC_MsgBox(,,{DC_LangMsg(DCMSG_CLOSEQUERY)},,,,.t.)}
ENDIF

RETURN self

* ---------------------------

METHOD DC_GetList:readGui(xRef,oParentDlg,xSetFocus,lExpress)

LOCAL i, j, aButtons, nButtonCol, nColOffSet := 0, nRowOffset := 0, ;
      oXbp, oParent, nSetSayOption, aChildList, nOldWidth, nOldHeight, ;
      nWidth, oOptions, cCaption, nHeight, nStartRow, aArray, xOptions, ;
      lPixel, nStartCol, nParentHeight, nType, nPointer, xCargo, ;
      lLoop, aEvents[0], oFont, cFont

LOCAL nToolTip, cToolTip, nCursor, nAlign, xData, oRel, ;
      nRelStartCol, nRelStartRow, bBlock, cSetFont, aSetColor, ;
      bOutBlock, cHelpCode, oApp, oDirs, lVisible := .f., ;
      aColor, aReference, xParent, nStyle, nAttr, lParentMenu, ;
      nDirWidth, bDataLink, lDebugCreate, nMenuType, lToolTips

LOCAL nDefaultHeight, bEval, oMenu, oBusyScreen, lSetBitmap, ;
      oSetParent, lKeepRow, lKeepCol, aTokens, aSetResize, ;
      nGetListLen, cSetGroup, oWinMenu, oFocusButton, ;
      nEvent, mp1, mp2, aGetListItem, aGetList, aOptions, ;
      aButtonConfig, nButtonWidth, lReadInsert, nFrameState, ;
      cProcname, lDebugEvent, bMenuError, oConfig, cSubClass, ;
      nFound, lMergeChildren := .f.

LOCAL oProgress, oDialog, cButtonFont, oOwner, nSeconds := Seconds()

lDebugCreate := DC_BitTest( DC_ReadGuiDebug(),DCGUI_DEBUG_CREATE )

lDebugEvent := DC_BitTest( DC_ReadGuiDebug(), DCGUI_DEBUG_EVENTS ) .OR. Upper(GetEnv('DC_READGUIDEBUG'))='Y'
IF lDebugEvent .AND. snEventSpy = 0
  snEventSpy := DllLoad('EVENTSPY.DLL')
ENDIF

PRIVATE plDataLink
GROK(oParentDlg)

BEGIN SEQUENCE

IF Empty(xSetFocus) .AND. Valtype(::parentDlg) == 'O' .AND. !::isExit
  SetAppFocus(::parentDlg)
ENDIF

M->plDataLink := .f.
DC_GetDataLink(.f.)
IF !Empty(::helpFile)
  IF lDebugCreate
    DCQDEBUG 'Creating XbpHelp() for ' + ::helpFile
  ENDIF
  IF Valtype(::helpFile) = 'B'
    ::helpObject := ::helpFile
  ELSE
    ::helpObject := XbpHelp():New( , ::helpFile )
    ::helpObject:Create()
    IF !Empty(::getOptions[cGETOPT_HELPCODE]) .AND. IsMemberVar(::parentDlg,'HELPLINK')
      ::parentDlg:HelpLink := DC_SetHelpLink( ::parentDlg:HelpLink, DCGUI_HELP_REQUEST, ;
                            XbpHelpLabel():New( ::getOptions[cGETOPT_HELPCODE] ), ::helpObject )
    ENDIF
  ENDIF
ENDIF

nGetListLen := Len(::GetListArray)
aGetList := ::getListArray
aOptions := ::getOptions
nStartRow := 0
nStartCol := 0
nWidth := 0
nHeight := 0

IF !Empty(::busyMsg)
   // $MR oBusyScreen := DC_WaitOn(::getOptions[cGETOPT_BUSYMSG],,,,,,,,,,.t.)
   ProgressBar(0,0,nGetListLen,::busyMsg,@oProgress,@oDialog,::busyColor)
ENDIF

IF DC_GetReadInsert() > 0
  lReadInsert := ReadInsert(DC_GetReadInsert()==2)
ENDIF
::buildErrorMsg := ''

nFound := AScan(::getListArray,{|a|a[nGETLIST_TYPE]==GETLIST_TABPAGE .AND. !Empty(a[xGETLIST_OPTIONS6])})
IF nFound > 0
  lMergeChildren := .t.
ENDIF

FOR ::getListPointer := 1 TO nGetListLen

   // $MR:
   IF !Empty(::busyMsg)  // $MR
      ProgressBar(1,int((::getListPointer / nGetListLen) * 100),100,::busyMsg,oProgress,oDialog,::busyColor)  // $MR
   ENDIF // $MR

   IF ::isSleep
     Sleep(0) // give up a time slice only if needed by another task
   ENDIF

   IF Valtype(::GetListArray[::getListPointer]) # 'A'
      DC_WinAlert('Element #' + Str(::getListPointer) + ' of the GetList array is not a valid item')
      RETURN .f.
   ENDIF

   aGetListItem := ::getListArray[::getListPointer]

   IF Len(aGetListItem) < nGET_ARRAY_SIZE
      ASize( aGetListItem, nGET_ARRAY_SIZE )
   ENDIF

   IF !Empty(::group)
      IF Empty(aGetlistItem[cGETLIST_GETGROUP])
         LOOP
      ENDIF
      lLoop := .t.
      FOR j := 1 TO Len(::group)
         IF aGetListItem[cGETLIST_GETGROUP]==::group[j]
            lLoop := .f.
            EXIT
         ENDIF
      NEXT
      IF lLoop
         LOOP
      ENDIF
   ENDIF

   IF Valtype(cSetGroup) = 'C' .AND. Empty(aGetListItem[cGETLIST_GETGROUP]) .AND. ;
         aGetListItem[nGETLIST_TYPE] # GETLIST_SETGROUP
      aGetListItem[cGETLIST_GETGROUP] := cSetGroup
   ENDIF

   IF Valtype(aSetResize) = 'A' .AND. Empty(aGetListItem[aGETLIST_RESIZE]) .AND. ;
         aGetListItem[nGETLIST_TYPE] # GETLIST_SETRESIZE
      aGetListItem[aGETLIST_RESIZE] := aSetResize
   ENDIF

   IF Valtype(cSetFont) = 'C' .AND. Empty(aGetListItem[cGETLIST_FONT]) .AND. ;
         aGetListItem[nGETLIST_TYPE] # GETLIST_SETFONT
      aGetListItem[cGETLIST_FONT] := cSetFont
   ENDIF

   IF Valtype(aSetColor) = 'A' .AND. Empty(aGetListItem[aGETLIST_COLOR]) .AND. ;
         aGetListItem[nGETLIST_TYPE] # GETLIST_SETCOLOR
      aGetListItem[aGETLIST_COLOR] := aSetColor
   ENDIF

   IF Valtype(nSetSayOption) = 'N' .AND. Empty(aGetListItem[xGETLIST_OPTIONS]) .AND. ;
      aGetListItem[nGETLIST_TYPE] == GETLIST_SAY
      aGetListItem[xGETLIST_OPTIONS] := { nSetSayOption }
   ENDIF

   nType := aGetListItem[nGETLIST_TYPE]

   IF nType = GETLIST_DATASTORE
      LOOP
   ENDIF

   IF ::isStoreProfile
     aGetListItem[aGETLIST_PROFILE] := {MilliSeconds(),0}
   ENDIF

   IF lDebugCreate
      DCQDEBUG 'Creating Getlist item ' + Alltrim(Str(::getListPointer)) + ' Type: ' + ;
         DC_GetListType(nType)
   ENDIF

   cSubClass := aGetListItem[cGETLIST_SUBCLASS]

   oParent := nil
   IF Valtype(xParent := aGetListItem[bGETLIST_PARENT]) = 'C' .AND. !(xParent[1] $ '{') // it's an ID
      oParent := DC_GetObject(::getListArray,xParent)
      oOptions := oParent
      IF oParent == nil .AND. !(nType $ {GETLIST_SUBMENU,GETLIST_HOTKEY}) .AND. lMergeChildren
        LOOP
      ENDIF
   ELSE
      bBlock := DC_GetBlock(xParent,'O')
      IF Valtype(bBlock) = 'B'
        oParent := Eval( bBlock )
        oOptions := oParent
        IF oParent == nil .AND. !(nType $ {GETLIST_SUBMENU,GETLIST_HOTKEY}) .AND. lMergeChildren
          LOOP
        ENDIF
      ENDIF
   ENDIF

   IF Valtype(aGetListItem[oGETLIST_OBJECT]) == 'O'
     LOOP
   ENDIF

   IF nType == GETLIST_SETPARENT
      xParent := aGetListItem[bGETLIST_PARENT]
      IF Valtype(xParent) == 'C' .AND. !(xParent[1]=='{') // it's an ID
         oSetParent := DC_GetObject(::getListArray,xParent)
      ELSE
         bBlock := DC_GetBlock(aGetListItem[bGETLIST_PARENT],'O')
         IF Valtype( bBlock ) = 'B'
            oSetParent := Eval( bBlock )
         ELSE
            oSetParent := nil
         ENDIF
      ENDIF
      IF ::isStoreProfile
        aGetListItem[aGETLIST_PROFILE,1] := 0
      ENDIF
      LOOP
   ENDIF

   IF !DC_IsCreateChildren(oParent)
     LOOP
   ENDIF

   IF oParent == NIL .AND. Valtype(oSetParent) = 'O'
      oParent := oSetParent
      oOptions := oSetParent
      aGetListItem[bGETLIST_PARENT] := oParent
   ENDIF

   IF oParent == NIL
      IF !::isNewDlg
         oParent := ::drawingArea
         oOptions := oParent
      ELSE
         oParent := ::drawingArea
         oOptions := aOptions
      ENDIF
   ENDIF

   cToolTip  := aGetListItem[cGETLIST_TOOLTIP]
   cHelpCode := aGetListItem[cGETLIST_HELPCODE]
   nCursor   := aGetListItem[nGETLIST_CURSOR]
   xOptions  := aGetListItem[xGETLIST_OPTIONS]
   DEFAULT xOptions := {}

   IF !Empty(cToolTip)
      AADD(::tooltipControls,cToolTip)
      nToolTip := Len(::tooltipControls)
   ENDIF

   IF nType = GETLIST_MENUBAR .OR. nType = GETLIST_SUBMENU .OR. ;
      nType = GETLIST_MENUITEM .OR. nType = GETLIST_HOTKEY

      lLoop := .t.

      oXbp := nil

      IF nType = GETLIST_MENUBAR

         IF !oParent:isDerivedFrom('XBPDIALOG')
            oParent := ::parentDlg
         ENDIF

         DEFAULT cSubClass := 'DC_XbpMenuBar()'
         oXbp := &cSubClass
         oXbp := oXbp:new( oParent,,,self )

         ::CreateObject( oXbp )

         ::menuBar := oXbp
         IF IsMemberVar(oParent,'MENUBAR')
           oParent:menuBar := oXbp
         ENDIF
         bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
         IF Valtype(bBlock) == 'O'
           Eval( bBlock, oXbp )
         ENDIF

      ELSEIF nType = GETLIST_SUBMENU

         bBlock := DC_GetBlock(aGetListItem[bGETLIST_PROTECT])
         IF Valtype(bBlock) = 'B' .AND. Eval(bBlock)
            LOOP
         ENDIF

         aArray := xOptions
         DEFAULT aArray := {}
         ASIZE(aArray,10)
         nStyle := aArray[6]
         nAttr  := aArray[7]
         IF oParent == nil
           LOOP
         ELSEIF Valtype(aArray[3]) = 'C' .AND. !_MenuAccess(aArray[3])
           LOOP
         ENDIF

         IF oParent:isDerivedFrom('XbpTreeView') .OR. oParent:isDerivedFrom('XbpTreeViewItem')

            IF Valtype(aArray[5])='L' .AND. aArray[5] // separator
               aGetListItem[cGETLIST_CAPTION] := ''
            ENDIF

            nType := GETLIST_TREEITEM
            lLoop := .f.

         ELSE

            lParentMenu := ( 'XBPMENU' $ Upper(oParent:ClassName()) )
            IF lParentMenu
               bBlock := DC_GetBlock(aGetListItem[bGETLIST_WHEN])
            ELSE
               bBlock := nil
            ENDIF
            IF Valtype(nStyle) # 'N'
               nStyle := 0
               IF Valtype(aArray[5])='L' .AND. aArray[5]
                  nStyle += XBPMENUBAR_MIS_SEPARATOR
               ENDIF
            ENDIF
            lSetBitmap := .T.
            IF Valtype(nAttr) # 'N'
               nAttr := 0
               IF Valtype(aArray[4])='L' .AND. aArray[4]
                  nAttr += XBPMENUBAR_MIA_CHECKED
               ENDIF
               IF Valtype(aArray[10])='L' .AND. aArray[10]
                  nAttr += XBPMENUBAR_MIS_BREAKSEPARATOR
               ENDIF
               IF !Empty(bBlock) .AND. !Eval(bBlock)
                  nAttr += XBPMENUBAR_MIA_DISABLED
               ENDIF
               #if XPPVER > 1900000
                 IF Valtype(oParent) = 'O' .AND. IsMemberVar(oParent,'ownerdraw') .AND. ;
                     oParent:ownerdraw
                    IF !DC_MenuOwnerDrawDisable()
                      nAttr += XBPMENUBAR_MIA_OWNERDRAW
                      lSetBitmap := .F.
                    ENDIF
                 ENDIF
               #endif
            ENDIF
            bBlock := DC_GetBlock(aGetListItem[bGETLIST_ACTION])
            IF Valtype(bBlock) = 'B'
               oXbp := nil
            ELSE
               DEFAULT cSubClass := 'DC_XbpMenu()'
               oXbp := &cSubClass
               oXbp := oXbp:new( oParent,,,self )

               cCaption := aGetListItem[cGETLIST_CAPTION]
               IF Valtype(cCaption) = 'B'
                  cCaption := Eval(cCaption)
               ENDIF
               oXbp:title := cCaption
               oXbp:clipSiblings := .t.
               IF Valtype(aGetListItem[xGETLIST_OPTIONS6]) = 'B'
                 oXbp:activateItem := aGetListITem[xGETLIST_OPTIONS6]
               ENDIF
               ::createObject(oXbp)
               IF Valtype(aGetListItem[xGETLIST_OPTIONS5]) = 'N'
                 oXbp:setName(aGetListITem[xGETLIST_OPTIONS5])
               ENDIF
            ENDIF

            IF lParentMenu

               IF Valtype(oParent:cargo) # 'A'
                  oParent:cargo := { nil, nil, nil, {}, {}, {}, {}, {}, {} }
               ENDIF
               cCaption := aGetListItem[cGETLIST_CAPTION]
               IF Valtype(cCaption) == 'B'
                  cCaption := Eval(cCaption)
               ENDIF

               nPointer := oParent:Additem( { IIF(oXbp==NIL,cCaption,oXbp), ;
                  bBlock, nStyle, nAttr }, ;
                  aGetListItem[xGETLIST_OPTIONS2] )

               bBlock := DC_GetBlock(aGetListItem[bGETLIST_VAR])
               IF Valtype(bBlock) = 'B'
                  Eval( bBlock, nPointer )
               ENDIF
               bBlock := DC_GetBlock(aGetListItem[bGETLIST_WHEN])
               IF Valtype(bBlock) = 'B' .AND. !Eval(bBlock,oXbp)
                  oParent:disableItem(nPointer)
               ENDIF

               AAdd( oParent:cargo[4], {bBlock,.t.} )
               AAdd( oParent:cargo[5], aGetListItem[cGETLIST_MESSAGE] )
               AAdd( oParent:cargo[6], nPointer )
               AAdd( oParent:cargo[7], {DC_GetBlock(aArray[9]),.f.})
               AAdd( oParent:cargo[8], aGetListItem[cGETLIST_CAPTION] )
               AAdd( oParent:cargo[9], aGetListItem[xGETLIST_OPTIONS2] )

               aArray := aGetListItem[xGETLIST_OPTIONS2]
               IF Valtype(aArray) = 'A' .AND. lSetBitmap
                  ASize(aArray,2)
                  DEFAULT aArray[2] := aArray[1]
                  bMenuError := ErrorBlock({|e|Break()})
                  BEGIN SEQUENCE
                  DC_SetMenuItemBitMap(oParent,aArray,nPointer)
                  END SEQUENCE
                  ErrorBlock(bMenuError)
               ENDIF
            ENDIF

            IF !(oXbp == NIL)
               bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
               Eval( bBlock, oXbp )
               oXbp:cargo := ;
                 { ::getListPointer, aGetList, aGetListItem[xGETLIST_CARGO], ;
                   {}, {}, {}, {}, {}, {} }
               IF !Empty(cToolTip)
                  oXbp:helpLink := ;
                     DC_SetHelpLink(oXbp:helpLink,DCGUI_HELP_TOOLTIP, ;
                     MagicHelpLabel():New(nToolTip,cToolTip))
               ENDIF
            ENDIF

            _BuildHelpCode( aGetListItem,oXbp,oParent )

         ENDIF

      ELSEIF nType = GETLIST_MENUITEM

         aArray := xOptions
         DEFAULT aArray := {}
         ASIZE(aArray,10)
         nStyle := aArray[6]
         nAttr  := aArray[7]
         IF oParent == nil
           LOOP
         ELSEIF Valtype(aArray[3]) = 'C' .AND. !_MenuAccess(aArray[3])
           LOOP
         ENDIF

         IF oParent:isDerivedFrom('XbpTreeViewItem')

            IF Valtype(aArray[5])='L' .AND. aArray[5] // separator
               aGetListItem[cGETLIST_CAPTION] := ''
            ELSEIF Empty(aGetlistItem[cGETLIST_CAPTION])
               LOOP
            ENDIF

            nType := GETLIST_TREEITEM
            lLoop := .f.

         ELSE

            bBlock := DC_GetBlock(aGetListItem[bGETLIST_PROTECT])
            IF Valtype(bBlock) = 'B' .AND. Eval(bBlock)
               LOOP
            ELSEIF !(oParent:isDerivedFrom('XbpMenuBar'))
               LOOP
            ENDIF

            AAdd( oParent:cargo[4], {DC_GetBlock(aGetListItem[bGETLIST_WHEN]),.t.} )
            AAdd( oParent:cargo[5], aGetListItem[cGETLIST_MESSAGE] )
            AAdd( oParent:cargo[7], {DC_GetBlock(aArray[9]),.f.} )
            AAdd( oParent:cargo[8], aGetListItem[cGETLIST_CAPTION] )
            AAdd( oParent:cargo[9], aGetListItem[xGETLIST_OPTIONS2] )

            IF Valtype(nStyle) # 'N'
               nStyle := 0
               IF Valtype(aArray[5])='L' .AND. aArray[5]
                  nStyle += XBPMENUBAR_MIS_SEPARATOR
               ENDIF
            ENDIF
            lSetBitmap := .T.

            IF Valtype(nAttr) # 'N'
               nAttr := 0
               IF Valtype(aArray[4])='L' .AND. aArray[4]
                  nAttr += XBPMENUBAR_MIA_CHECKED
               ENDIF
               IF Valtype(aArray[10])='L' .AND. aArray[10]
                  nStyle += XBPMENUBAR_MIS_BREAKSEPARATOR
               ENDIF
               #if XPPVER > 1900000
               IF IsMemberVar(oParent,'ownerdraw') .AND. oParent:ownerDraw
                  IF !DC_MenuOwnerDrawDisable()
                    nAttr += XBPMENUBAR_MIA_OWNERDRAW
                    lSetBitmap := .f.
                  ENDIF
               ENDIF
               #endif
            ENDIF

            bBlock := DC_GetBlock(aGetListItem[bGETLIST_ACTION])

            cCaption := aGetListItem[cGETLIST_CAPTION]
            IF Valtype(cCaption) = 'B'
               cCaption := Eval(cCaption)
            ENDIF

            nPointer := oParent:addItem( { cCaption, bBlock, nStyle, nAttr }, ;
               aGetListItem[xGETLIST_OPTIONS2])

            aGetListItem[nGETLIST_POINTER] := nPointer

            AAdd( oParent:cargo[6], nPointer )

            _BuildHelpCode( aGetListItem,,oParent )

            aArray := aGetListItem[xGETLIST_OPTIONS2]

            IF Valtype(aArray) = 'A' .AND. lSetBitmap
               ASize(aArray,2)
               DEFAULT aArray[2] := aArray[1]
               bMenuError := ErrorBlock({|e|Break()})
               BEGIN SEQUENCE
               DC_SetMenuItemBitMap(oParent,aArray,nPointer)
               END SEQUENCE
               ErrorBlock(bMenuError)
            ENDIF

            bBlock := DC_GetBlock(aGetListItem[bGETLIST_VAR])
            IF Valtype(bBlock) = 'B'
               Eval( bBlock, nPointer )
            ENDIF

            aGetListItem[bGETLIST_REFVAR] := oParent

         ENDIF

      ENDIF

      IF lLoop

        IF ::isStoreProfile
          aGetListItem[aGETLIST_PROFILE] := {0,0}
        ENDIF

        IF nType = GETLIST_HOTKEY
           bBlock := DC_GetBlock(aGetListItem[bGETLIST_PARENT],'O')
           IF Valtype(bBlock) = 'B'
              oParent := Eval( bBlock )
           ELSE
              oParent := nil
           ENDIF
        ELSE
           aGetListItem[oGETLIST_OBJECT] := oXbp
           oParent := nil
        ENDIF

        aArray := aGetListItem[nGETLIST_ACCELKEY]

        IF Valtype( aArray ) $ 'AN'
           ::AddHotKey( aArray, ;
              DC_GetBlock(aGetListItem[bGETLIST_ACTION]), ;
              DC_GetBlock(aGetListItem[bGETLIST_WHEN]), ;
              DC_GetBlock(aGetListItem[bGETLIST_HIDE]), ;
              oParent, oXbp, ;
              aGetListItem[xGETLIST_CARGO], !Empty(oParent) )
        ENDIF

        IF Valtype(oXbp) # 'O'
           LOOP
        ENDIF

        bBlock := DC_GetBlock(aGetListItem[bGETLIST_EVAL])
        IF Valtype( bBlock ) = 'B'
           Eval( bBlock, oXbp, aGetList )
        ENDIF

        _BuildHelpCode(nil,oXbp)

        LOOP

      ENDIF

   ENDIF

   nPointer := aGetListItem[nGETLIST_POINTER]
   lVisible := aGetListItem[lGETLIST_VISIBLE]

   lPixel := aGetListItem[lGETLIST_PIXEL] .OR. ;
      IIF(Valtype(aOptions[lGETOPT_PIXEL])='L', ;
      aOptions[lGETOPT_PIXEL], .f. )

   bBlock := DC_GetBlock(aGetListItem[bGETLIST_RELATIVE],'O')
   IF Valtype( bBlock ) = 'B'
      oRel := Eval( bBlock )
      IF Valtype(oRel) == 'O'
         nRelStartCol := oRel:CurrentPos()[1]
         nRelStartRow := oRel:CurrentPos()[2] + oRel:CurrentSize()[2]
      ELSE
         nRelStartCol := 0
         nRelStartRow := 0
         oRel := nil
      ENDIF
   ELSE
      nRelStartCol := 0
      nRelStartRow := 0
      oRel := nil
   ENDIF

   IF Valtype(aGetListItem[bGETLIST_VAR])$'AB'

      bBlock := DC_GetBlock(aGetListItem[bGETLIST_VAR])
      IF Valtype(bBlock) = 'B'
         aGetListItem[xGETLIST_ORIGVALUE] := Eval( bBlock )
      ENDIF

   ENDIF

   IF nType # GETLIST_ADDBUTTON .AND. ;
      nType # GETLIST_XPADDBUTTON .AND. ;
      nType # GETLIST_BROWSECOL .AND. ;
      nType # GETLIST_APPCRT .AND. ;
      nType # GETLIST_BITMAP .AND. ;
      nType # GETLIST_APPFIELD .AND. ;
      nType # GETLIST_TREEITEM .AND. ;
      nType # GETLIST_MXADDBUTTON

      BEGIN SEQUENCE

      lLoop := .F.

      IF (aGetListItem[nGETLIST_STARTCOL] == nil  .OR. aGetListItem[nGETLIST_STARTROW] == nil) .AND. ;
            Valtype(aGetListItem[nGETLIST_STARTROW]) # 'A'
         IF nType = GETLIST_TOOLBAR
            BREAK
         ELSEIF ( nType = GETLIST_GET .OR. nType = GETLIST_COMBOBOX .OR. ;
               nType = GETLIST_LISTBOX .OR. nType = GETLIST_MLE .OR. ;
               nType = GETLIST_SLE .OR. ;
               nType = GETLIST_SPINBUTTON .OR. nType == GETLIST_KLMLE .OR. ;
               nType = GETLIST_CHECKBOX .OR. nType = GETLIST_3STATE ) .AND. ;
               Empty(nPointer)
            lLoop := .t.
         ENDIF
      ENDIF
      IF Valtype(aGetListItem[nGETLIST_STARTCOL]) = 'N' .AND. aGetListItem[nGETLIST_STARTCOL] < DCGUI_COL + 1000
         aGetListItem[nGETLIST_STARTCOL] := ;
            nStartCol + nWidth - ( DCGUI_COL - aGetListItem[nGETLIST_STARTCOL] )
         lKeepCol := .t.
      ELSE
         lKeepCol := .f.
      ENDIF
      IF Valtype(aGetListItem[nGETLIST_STARTROW]) == 'N' .AND. aGetListItem[nGETLIST_STARTROW] == DCGUI_ROW
         aGetListItem[nGETLIST_STARTROW] := nStartRow
         lKeepRow := .t.
      ELSE
         lKeepRow := .f.
      ENDIF
      IF Valtype(aGetListItem[nGETLIST_ENDCOL]) = 'N'
         aGetListItem[nGETLIST_WIDTH] := ;
            (aGetListItem[nGETLIST_ENDCOL]-aGetListItem[nGETLIST_STARTCOL])
      ENDIF

      IF Valtype(aGetListItem[nGETLIST_ENDROW]) = 'N'
         aGetListItem[nGETLIST_HEIGHT] := ;
            (aGetListItem[nGETLIST_ENDROW]-aGetListItem[nGETLIST_STARTROW])
      ENDIF

      nWidth  := aGetListItem[nGETLIST_WIDTH]
      nHeight := aGetListItem[nGETLIST_HEIGHT]

      IF !nType $ { GETLIST_GRALINE, GETLIST_GRABOX, GETLIST_GRASTRING, GETLIST_GRAPROC }

        IF Valtype(nWidth) == 'N' .AND. nWidth < 0 .AND. Valtype(oParent) == 'O'
          nWidth := DCGUI_PARENTWIDTH - nWidth
          IF lPixel
            nWidth := oParent:currentSize()[1] - nWidth
          ELSE
            nWidth := (oParent:currentSize()[1] / ::colPixels) - nWidth
          ENDIF
        ENDIF

        IF Valtype(nHeight) == 'N' .AND. nHeight < 0 .AND. Valtype(oParent) == 'O'
          nHeight := DCGUI_PARENTHEIGHT - nHeight
          IF lPixel
            nHeight := oParent:currentSize()[2] - nHeight
          ELSE
            nHeight := (oParent:currentSize()[2] / ::rowPixels) - nHeight
          ENDIF
        ENDIF

      ENDIF

      IF Valtype(nWidth) = 'B'
         nWidth := Eval(nWidth)
      ELSEIF Valtype(nWidth) = 'A'
         nHeight := nWidth[2]
         nWidth := nWidth[1]
         lPixel := .t.
      ENDIF
      IF Valtype(nHeight) = 'B'
         nHeight := Eval(nHeight)
         lPixel := .t.
      ENDIF
      IF nType = GETLIST_DIRTREE
         DEFAULT nWidth := 40
         DEFAULT nWidth := 12
      ELSEIF nType = GETLIST_OBJECT .AND. Valtype(aGetListItem[oGETLIST_OBJECT]) = 'O'
         DEFAULT nWidth := aGetListItem[oGETLIST_OBJECT]:currentSize()[1]
         DEFAULT nHeight := aGetListItem[oGETLIST_OBJECT]:currentSize()[2]
      ELSE
         DEFAULT nWidth := IIF( nType = GETLIST_SAY, -1, 0 )
         DEFAULT nHeight := IIF(lPixel,::rowPixels,1)
      ENDIF

      nWidth *= ::scaleFactor[3]
      nHeight *= ::scaleFactor[4]

      IF Empty(nWidth) .AND. Valtype(oRel) = 'O' .AND. oRel:isDerivedFrom('XbpTabPage')
         nWidth := oRel:currentSize()[1]
         nHeight := oRel:currentSize()[2]
         lKeepCol := .T.
      ELSEIF !(nType == GETLIST_OBJECT)
         nWidth *= IIF(lPixel,1,::colPixels)
         IF nType = GETLIST_GET
            nDefaultHeight := aOptions[nGETOPT_GETHEIGHT]
         ELSEIF nType = GETLIST_SAY
            nDefaultHeight := aOptions[nGETOPT_SAYHEIGHT]
         ELSE
            nDefaultHeight := ::rowPixels
         ENDIF
         nHeight *= IIF(lPixel,1,nDefaultHeight)
      ENDIF
      IF nHeight < 1 .AND. nHeight > 0
         nHeight := 1
      ENDIF
      IF nWidth < 1 .AND. nWidth > 0
         nWidth := 1
      ENDIF

      IF ::isArrayTranslate .OR. lLoop
         aGetListItem[nGETLIST_WIDTH] := nWidth
         aGetListItem[nGETLIST_HEIGHT] := nHeight
         aGetListItem[lGETLIST_PIXEL]  := .T.                                 // J. Duijf 25-07-2017
      ENDIF

      IF Valtype(aGetListItem[nGETLIST_STARTCOL]) = 'B'
         nStartCol := Eval(aGetListItem[nGETLIST_STARTCOL])
      ELSEIF Valtype(aGetListItem[nGETLIST_STARTCOL]) # 'N'
         IF Valtype(nPointer) = 'N'
            xCargo := aGetList[nPointer,xGETLIST_CARGO]
            nStartCol := xCargo[1]
         ELSE
            nStartCol := 0
         ENDIF
         lKeepCol := .T.
      ELSEIF !::isTranslate .OR. lKeepCol
         nStartCol := aGetListItem[nGETLIST_STARTCOL] + nRelStartCol
         IF Valtype(oOptions)='A'
            nStartCol += oOptions[nGETOPT_COLOFFSET]
         ENDIF
      ELSE
         nStartCol := ;
            ( aGetListItem[nGETLIST_STARTCOL] * IIF(lPixel,1,::colPixels) ) + nRelStartCol
         IF Valtype(oOptions)='A'
            nStartCol += oOptions[nGETOPT_COLOFFSET]
         ENDIF
      ENDIF

      IF Valtype(aGetListItem[nGETLIST_STARTROW]) = 'B'
         nStartRow := Eval(aGetListItem[nGETLIST_STARTROW])
      ELSEIF nType == GETLIST_RMCHARTREGION
         nStartRow := aGetListItem[nGETLIST_STARTROW]
      ELSEIF Valtype(aGetListItem[nGETLIST_STARTROW]) = 'A'
         nStartRow := aGetListItem[nGETLIST_STARTROW,2]
         nStartCol := aGetListItem[nGETLIST_STARTROW,1]
      ELSEIF Valtype(aGetListItem[nGETLIST_STARTROW]) # 'N'
         IF Valtype(nPointer) = 'N'
            xCargo := aGetList[nPointer,xGETLIST_CARGO]
            nStartRow := xCargo[2]
         ELSE
            nStartRow := 0
         ENDIF
      ELSEIF Valtype(oRel) == 'O'               // nRelStartRow # 0
         nStartRow := nRelStartRow - ;
            ( aGetListItem[nGETLIST_STARTROW] * IIF(lPixel,1,::rowSpace) ) - oRel:currentSize()[2]
      ELSEIF !::isTranslate .OR. lKeepRow
         nStartRow := aGetListItem[nGETLIST_STARTROW]
      ELSE
         nStartRow := ;
            ( aGetListItem[nGETLIST_STARTROW] * IIF(lPixel,1,::rowSpace) )

         IF Valtype(oOptions)='A'
            nParentHeight := ::windowHeight
            nStartRow *= ::scaleFactor[2]
            nStartRow := nParentHeight - nStartRow - ::metrics - ;
                aOptions[nGETOPT_ROWOFFSET]
         ELSEIF Valtype(oOptions)='O'
            nStartRow *= ::scaleFactor[2]
            nStartRow := oOptions:currentsize()[2] - nStartRow
         ENDIF
         nStartRow -= nHeight
      ENDIF

      IF !lKeepCol
         nStartCol *= ::scaleFactor[1]
      ENDIF

      IF ::isArrayTranslate .AND. !lLoop
         aGetListItem[nGETLIST_STARTROW] := nStartRow
         aGetListItem[nGETLIST_STARTCOL] := nStartCol
      ENDIF

      END SEQUENCE
      IF lLoop
        IF ::isStoreProfile
          aGetListItem[aGETLIST_PROFILE,1] := MilliSeconds() - aGetListItem[aGETLIST_PROFILE,1]
        ENDIF
        LOOP
      ENDIF

   ELSE

      nWidth  := aGetListItem[nGETLIST_WIDTH]
      nHeight := aGetListItem[nGETLIST_HEIGHT]

   ENDIF

   oXbp := NIL
   aGetListItem[lGETLIST_PIXEL] := lPixel

   IF Valtype(::disabledColor) = 'N' .AND. nType # GETLIST_GRASTRING .AND. nType # GETLIST_SAY
      aGetListItem[aGETLIST_PRESENTATION] := ;
         DC_PresAdd( _Pres(aGetListItem[aGETLIST_PRESENTATION]), ;
         { XBP_PP_DISABLED_BGCLR, ::disabledColor } )
   ENDIF

   IF !Empty(::fontDefault)
      IF aGetListItem[nGETLIST_TYPE] == GETLIST_SAY .AND. !Empty(::sayFont)
      ELSEIF aGetListItem[nGETLIST_TYPE] == GETLIST_GET .AND. !Empty(::getFont)
      ELSE
         aGetListItem[cGETLIST_FONT] := ::fontDefault
      ENDIF
   ENDIF

   IF nType == GETLIST_DIALOG

      xParent := aGetListItem[xGETLIST_OPTIONS6]
      bBlock := DC_GetBlock(xParent,'O')
      IF Valtype(bBlock) = 'B'
        oOwner := Eval( bBlock )
      ENDIF

      DEFAULT cSubClass := 'DC_XbpDialog()'
      oXbp := &cSubClass
      oXbp := oXbp:new( oParent, oOwner, ;
         { nStartCol, nStartRow }, { nWidth, nHeight }, ;
         _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )

      ::CreateObject( oXbp )

      ::isMenu := Valtype(oXbp:menuBar) == 'O'
      IF Empty(::menuBar)
         ::menuBar := oXbp:menuBar
      ENDIF

      AAdd(::dialogControls,oXbp)

      IF ::modalState == XBP_DISP_MODELESS .AND. ;
            !::noWinMenu .AND. ;
            Valtype(oParent:setParent()) == 'O' .AND. ;
            IsMethod(oParent:setParent(),'ChildList')
         aArray := oParent:setParent():childList()
         IF Len(aArray) >= 2 .AND. aArray[2] == DC_SetAppMenu()
            oMenu := DC_WinMenu(self)
            IF Valtype(oMenu) == 'O'
               ::parentDlg:setdisplayfocus:= {|a,b,o|DC_WinMenu():checkitem(o)}
               oMenu:additem(oXbp)
               oMenu:checkitem(oXbp)
               IF DC_WinMenuDestroyMode() == DCGUI_WINMENU_DESTROYMODE_CLOSE
                  oXbp:close := {|a,b,o|DC_WinMenu():delitem(o)}
               ENDIF
            ENDIF
         ENDIF
      ENDIF

   ELSEIF nType == GETLIST_SAY

      IF nWidth < 0
         nWidth := aOptions[nGETOPT_SAYWIDTH]
         IF Valtype(nWidth) = 'N'
            nWidth *= ::scaleFactor[3]
         ENDIF
      ENDIF

      IF !Empty(::sayFont)
         DEFAULT aGetListItem[cGETLIST_FONT] := ::sayFont
      ENDIF

      IF (Valtype(aGetListItem[xGETLIST_OPTIONS2]) = 'L' .AND. aGetListItem[xGETLIST_OPTIONS2]) // graphics

         ASize(xOptions,1)

         nColOffset := 0
         nRowOffset := 0

         DEFAULT xOptions[1] := 0
         cCaption := aGetListItem[cGETLIST_CAPTION]
         DEFAULT cCaption := ''
         DEFAULT nWidth := LEN(cCaption) * ::colPixels
         DEFAULT nHeight := ::rowPixels

         nAlign := xOptions[1]
         IF Empty(xOptions[1])
            nAlign := ::sayOptions
         ENDIF

         IF nWidth == 0
           nWidth := DC_GraQueryTextBox( cCaption, aGetListItem[cGETLIST_FONT] )[1]
         ENDIF

         AADD( ::graControls, { GETLIST_GRASTRING, ;
            aGetListItem[cGETLIST_CAPTION], ;
            aGetListItem[cGETLIST_PICTURE], ;
            oParent, ;
            nStartCol + nColOffset, ;
            nStartRow + nRowOffset, ;
            nWidth, ;
            nHeight, ;
            aGetListItem[cGETLIST_FONT], ;
            aGetListItem[aGETLIST_PRESENTATION], ; // Attributes
            DC_GetBlock(aGetListItem[bGETLIST_WHEN]), ;
            DC_GetBlock(aGetListItem[bGETLIST_HIDE]), ;
            aGetListItem[cGETLIST_GETGROUP], ;
            aGetListItem[aGETLIST_COLOR], ;
            aGetListItem[xGETLIST_OPTIONS2], ;
            aGetListItem[xGETLIST_OPTIONS3], ;
            aGetListItem[xGETLIST_OPTIONS4], ;
            nAlign } )

         IF Valtype(oParent:paint) # 'B' .AND. !oParent:isderivedFrom('XbpCrt')
            oParent:paint := {|a,b,o|::paintGraControls(o)}
         ENDIF

         IF Valtype(ATail(::graControls)[12]) # 'B' .OR. !Eval(ATail(::graControls)[12])

            IF Valtype(lVisible) = 'L' .AND. lVisible
               ::PaintGraControls( oParent,, Len(::graControls) )
            ENDIF
         ENDIF

      ELSE

         oXbp := _GetClass(cSubClass,DC_XbpStatic())
         //DEFAULT cSubClass := 'DC_XbpStatic()'
         //oXbp := &cSubClass
         oXbp := oXbp:new( oParent, , ;
            { nStartCol, nStartRow }, { nWidth, nHeight }, ;
            _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )

         ::createObject(oXbp)
         nStartCol := oXbp:currentPos()[1]
         nStartRow := oXbp:currentPos()[2]
         nWidth := oXbp:currentSize()[1]

      ENDIF

      aGetListItem[xGETLIST_CARGO] := ;
         { nStartCol + nWidth + 10*::scaleFactor[1],  nStartRow }

   ELSEIF nType == GETLIST_STATIC

      // oXbp := _GetClass(cSubClass,DC_XbpStatic())
      DEFAULT cSubClass := 'DC_XbpStatic()'
      oXbp := &cSubClass
      oXbp := oXbp:new( oParent, , ;
         { nStartCol, nStartRow }, { nWidth, nHeight }, ;
         _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )

      ::createObject(oXbp)

   ELSEIF nType == GETLIST_GET

      bOutBlock := DC_GetBlock(aGetListItem[bGETLIST_REFVAR])
      bDataLink := DC_GetBlock(aGetListItem[bGETLIST_VAR])

      IF aOptions[lGETOPT_CHECKGET] .AND. Valtype(Eval(bOutBlock)) = 'L'

         DEFAULT cSubClass := 'DC_XbpCheckBox()'
         oXbp := &cSubClass
         oXbp := oXbp:new( oParent, , ;
            { nStartCol, nStartRow }, { nWidth, nHeight }, ;
            _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )

         oXbp:selection := Eval( bOutBlock )
         oXbp:datalink := bDataLink             // bOutBlock
         oXbp:caption := ''

         ::createObject(oXbp,::editControls)

         aGetListItem[nGETLIST_TYPE] := GETLIST_CHECKBOX

      ELSE

         xData := Eval(bDataLink)

         IF !DC_ReadDataCheck( xData, 'DLCNMFI', aGetList, ::getListPointer,, @oBusyScreen )
            BREAK
         ENDIF

         IF Valtype(nWidth) # 'N' .OR. nWidth = 0
            nWidth := 0
         ENDIF

         IF nWidth > 0
            nWidth := _GetWidth( nWidth, oOptions, nStartCol, xOptions, 0, ;
               ::windowWidth, ::isFit )
         ENDIF

         IF Empty(nHeight)
            nHeight := ::rowPixels
         ENDIF

         IF !Empty(DC_XbpGetPres()) .AND. Empty(aGetListItem[aGETLIST_PRESENTATION])
            aGetListItem[aGETLIST_PRESENTATION] := DC_XbpGetPres()
         ENDIF

         IF DC_LangSet() == DCLANG_CHINESE
            DEFAULT cSubClass := 'DC_XbpGetC()'
            oXbp := &cSubClass
            oXbp := oXbp:new( oParent, , ;
               { nStartCol, nStartRow }, { nWidth, nHeight }, ;
               _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )
         ELSE
            DEFAULT cSubClass := 'DC_XbpGet()'
            oXbp := &cSubClass
            oXbp := oXbp:new( oParent, , ;
               { nStartCol, nStartRow }, { nWidth, nHeight }, ;
               _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )
         ENDIF

         ::createObject(oXbp,::editControls)

         IF Valtype(oXbp:popupButton) == 'O'
            IF !Empty(oXbp:popupButton:cargo[6])
               AADD(::tooltipControls,oXbp:popupButton:cargo[6])
               nToolTip := Len(::tooltipControls)
               oXbp:popupButton:HelpLink := ;
                  DC_SetHelpLink( oXbp:popupButton:HelpLink, DCGUI_HELP_TOOLTIP, ;
                  MagicHelpLabel():New(nToolTip,oXbp:popupButton:cargo[6]))
            ENDIF
            IF !(oXbp:popupButton:setParent() == oXbp)
               nStartCol += oXbp:popupButton:currentSize()[2]
            ENDIF
         ENDIF

      ENDIF

   ELSEIF nType == GETLIST_MLE

      IF DC_LangSet() == DCLANG_CHINESE
         DEFAULT cSubClass := 'DC_XbpMleC()'
         oXbp := &cSubClass
         oXbp := oXbp:new( oParent, , ;
            { nStartCol, nStartRow }, { nWidth, nHeight },;
            _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )
      ELSE
         DEFAULT cSubClass := 'DC_XbpMLE()'
         oXbp := &cSubClass
         oXbp := oXbp:new( oParent, , ;
            { nStartCol, nStartRow }, { nWidth, nHeight },;
            _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )
      ENDIF

      ::createObject(oXbp,::editControls)

   ELSEIF nType == GETLIST_SLE

      DEFAULT cSubClass := 'DC_XbpSLE()'
      oXbp := &cSubClass
      oXbp := oXbp:new( oParent, , ;
            { nStartCol, nStartRow }, { nWidth, nHeight },;
            _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )

      ::createObject(oXbp,::editControls)

   ELSEIF nType == GETLIST_COMBOBOX

      DEFAULT cSubClass := 'DC_XbpComboBox()'
      oXbp := &cSubClass
      oXbp := oXbp:new( oParent, , ;
         { nStartCol, nStartRow }, { nWidth, nHeight }, ;
         _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )

      ::createObject(oXbp,::editControls)

   ELSEIF nType == GETLIST_CHECKBOX

      DEFAULT cSubClass := 'DC_XbpCheckBox()'
      oXbp := &cSubClass
      oXbp := oXbp:new( oParent, , ;
         { nStartCol, nStartRow }, { nWidth, nHeight }, ;
         _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )

      ::createObject(oXbp,::editControls)

   ELSEIF nType == GETLIST_3STATE

      DEFAULT cSubClass := 'DC_Xbp3State()'
      oXbp := &cSubClass
      oXbp := oXbp:new( oParent, , ;
         { nStartCol, nStartRow }, { nWidth, nHeight }, ;
         _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )

      ::createObject(oXbp,::editControls)

   ELSEIF nType = GETLIST_PUSHBUTTON

      aArray := aGetListItem[xGETLIST_OPTIONS]
      DEFAULT aArray := {}
      ASize(aArray,10)
      DEFAULT aArray[6] := .f.  // static
      DEFAULT aArray[8] := .f.  // exclude XP
      oConfig := aGetListItem[oGETLIST_CONFIG]
      IF Empty(oConfig) .AND. oParent:isDerivedFrom('DC_XbpToolBar')
        oConfig := oParent:buttonConfig
      ENDIF

      IF Valtype(oConfig) = 'O' .AND. !aArray[6] .AND. !aArray[8] .AND. !lExpress
        #if XPPVER > 1900000
        oXbp := DC_XbpPushButtonXP():new( oParent, , ;
            { nStartCol, nStartRow }, { nWidth, nHeight }, ;
            _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self, oConfig )
        #endif
      ELSEIF Valtype(DC_PushButtonStyle()) = 'O' .AND. !aArray[6] .AND. !aArray[8] .AND. !lExpress
        #if XPPVER > 1900000
        oXbp := DC_XbpPushButtonXp():new( oParent, , ;
            { nStartCol, nStartRow }, { nWidth, nHeight }, ;
            _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self, DC_PushButtonStyle() )
        #endif
      ELSEIF aArray[6] // static button
         #if XPPVER > 1800000
         oXbp := DC_XbpPushButtonStatic():new( oParent, , ;
            { nStartCol, nStartRow }, { nWidth, nHeight }, ;
            _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )
         AAdd(::staticButtonControls,oXbp)
         #endif
      ELSE
         oXbp := DC_XbpPushButton():new( oParent, , ;
            { nStartCol, nStartRow }, { nWidth, nHeight }, ;
            _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )
      ENDIF

      ::createObject(oXbp)

      oParent := nil
      IF Empty(aGetListItem[xGETLIST_CARGO])
        aGetListItem[xGETLIST_CARGO] := ;
           { nStartCol + nWidth + 10*::scaleFactor[1],  nStartRow }
      ENDIF

   #if XPPVER > 1900000
   ELSEIF nType = GETLIST_XPPUSHBUTTON

      DEFAULT cSubClass := 'DC_XbpPushButtonXP()'
      oXbp := &cSubClass
      oXbp := oXbp:new( oParent, , ;
            { nStartCol, nStartRow }, { nWidth, nHeight }, ;
            _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )
      ::createObject(oXbp)
      oParent := nil
      IF Empty(aGetListItem[xGETLIST_CARGO])
        aGetListItem[xGETLIST_CARGO] := ;
           { nStartCol + nWidth + 10*::scaleFactor[1],  nStartRow }
      ENDIF
   #endif

   ELSEIF nType == GETLIST_TOOLBAR

      aArray := aGetListItem[xGETLIST_OPTIONS]
      DEFAULT aArray := {}
      ASize(aArray,8)
      DEFAULT aArray[1] := 0
      IF aArray[1] == DCGUI_ALIGN_RIGHT
        nStartCol -= nWidth
      ELSEIF aArray[1] == DCGUI_ALIGN_CENTER
        nStartCol -= nWidth/2
      ENDIF
      DEFAULT cSubClass := 'DC_XbpToolBar()'
      oXbp := &cSubClass
      oXbp := oXbp:new( oParent, , ;
         { nStartCol, nStartRow }, { nWidth, nHeight }, ;
         _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )

      ::createObject( oXbp, ::toolBarControls )

   ELSEIF nType = GETLIST_ADDBUTTON .OR. nType == GETLIST_XPADDBUTTON

      nStyle := aGetListItem[nGETLIST_SUBTYPE]
      DEFAULT nStyle := 0, nWidth := 0, nHeight := 0
      nPointer  := oParent:getListPointer
      nAlign    := oParent:align
      nStartCol := oParent:buttonCol
      nStartRow := oParent:buttonRow
      lPixel    := oParent:pixel
      nWidth *= IIF( lPixel,1,::colPixels )
      nHeight *= IIF( lPixel, 1, ::rowPixels )

      IF Empty(nWidth)
         nWidth    := oParent:buttonWidth
      ENDIF
      IF Empty(nHeight)
         nHeight   := oParent:buttonHeight
      ENDIF

      nWidth *= ::scaleFactor[3]

      nStartRow := oParent:currentsize()[2] - nStartRow - nHeight

      IF aGetListItem[nGETLIST_TYPE] == GETLIST_ADDBUTTON
        aArray := aGetListItem[xGETLIST_OPTIONS]
        DEFAULT aArray := {}
        ASize(aArray,10)
        DEFAULT aArray[6] := .f. // static
        DEFAULT aArray[8] := .f. // exclude XP
        oConfig := aGetListItem[oGETLIST_CONFIG]
        IF Empty(oConfig) .AND. oParent:isDerivedFrom('DC_XbpToolBar')
          oConfig := oParent:buttonConfig
        ENDIF
      ELSE
        aArray := {,,,,,.f.,.f.,.f.}
        nStyle := 0
      ENDIF

      IF nType == GETLIST_XPADDBUTTON
         #if XPPVER > 1900000
         oXbp := DC_XbpPushButtonXP():new( oParent, , ;
            { nStartCol, nStartRow }, { nWidth, nHeight }, ;
            _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )
         #endif
      ELSEIF Valtype(oConfig) = 'O' .AND. !aArray[6] .AND. !aArray[8] .AND. !lExpress
        #if XPPVER > 1900000
        oXbp := DC_XbpPushButtonXP():new( oParent, , ;
            { nStartCol, nStartRow }, { nWidth, nHeight }, ;
            _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self, oConfig )
        #endif
      ELSEIF Valtype(DC_PushButtonStyle()) = 'O' .AND. !aArray[6] .AND. !aArray[8] .AND. !lExpress
        #if XPPVER > 1900000
        oXbp := DC_XbpPushButtonXP():new( oParent, , ;
            { nStartCol, nStartRow }, { nWidth, nHeight }, ;
            _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self, DC_PushButtonStyle() )
        #endif
      ELSEIF aArray[6]  // static button

         oXbp := DC_XbpPushButtonStatic():new( oParent, , ;
            { nStartCol, nStartRow }, { nWidth, nHeight }, ;
            _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )

      ELSEIF nStyle > 0

         oXbp := DC_XbpStatic():new( oParent,, ;
            { nStartCol, nStartRow }, { nWidth, nHeight }, ;
            _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )

      ELSE

         oXbp := DC_XbpPushButton():new( oParent, , ;
            { nStartCol, nStartRow }, { nWidth, nHeight }, ;
            _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )

      ENDIF

      IF oParent:align = TOOLBAR_TOP .OR. oParent:align = TOOLBAR_BOTTOM
         oParent:buttonCol += nWidth + oParent:spacing
      ELSE
         oParent:buttonRow += nHeight + oParent:spacing
      ENDIF

      ::createObject(oXbp)
      oParent := nil

   ELSEIF nType = GETLIST_MXPUSHBUTTON .OR. nType == GETLIST_MXADDBUTTON

      IF !IsFunction('DC_MxPushButton')
         DllLoad('DCMXBUTT.DLL')
      ENDIF

      IF Valtype(oParent) == 'O' .AND. oParent:isDerivedFrom('DC_XbpToolBar')
        DEFAULT nWidth := 0, nHeight := 0
        nPointer  := oParent:getListPointer
        nAlign    := oParent:align
        nStartCol := oParent:buttonCol
        nStartRow := oParent:buttonRow
        lPixel    := oParent:pixel
        aGetListItem[lGETLIST_PIXEL] := lPixel
        nWidth *= IIF( lPixel,1,::colPixels )
        nHeight *= IIF( lPixel, 1, ::rowPixels )
        IF Empty(nWidth)
           nWidth    := oParent:buttonWidth
        ENDIF
        IF Empty(nHeight)
           nHeight   := oParent:buttonHeight
        ENDIF
        nWidth *= ::scaleFactor[3]
        nStartRow := oParent:currentsize()[2] - nStartRow - nHeight
        IF oParent:align = TOOLBAR_TOP .OR. oParent:align = TOOLBAR_BOTTOM
          oParent:buttonCol += nWidth
        ELSE
          oParent:buttonRow += nHeight
        ENDIF
      ENDIF

      oXbp := &('DC_MxPushButton()')
      oXbp := oXbp:new( oParent, , ;
            { nStartCol, nStartRow }, { nWidth, nHeight }, ;
            _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )

      ::createObject(oXbp)
      oParent := nil
      IF Empty(aGetListItem[xGETLIST_CARGO])
         aGetListItem[xGETLIST_CARGO] := { nStartCol + nWidth + 10,  nStartRow }
      ENDIF

   ELSEIF nType == GETLIST_RADIOBUTTON

      DEFAULT cSubClass := 'DC_XbpRadioButton()'
      oXbp := &cSubClass
      oXbp := oXbp:new( oParent, , ;
         { nStartCol, nStartRow }, { nWidth, nHeight }, ;
         _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )

      ::createObject(oXbp,::editControls)

   ELSEIF nType == GETLIST_TABPAGE

      DEFAULT cSubClass := 'DC_XbpTabPage()'
      oXbp := &cSubClass
      oXbp := oXbp:new( oParent, , ;
         { nStartCol, nStartRow }, { nWidth, nHeight }, ;
         _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )

      ::createObject(oXbp,::tabPageControls)

   ELSEIF nType == GETLIST_ACTIVEX

      #if XPPVER > 1900000

      IF Valtype(cSubClass)=='C' .AND. IsFunction(Strtran(cSubClass,'()',''))
        IF !('(' $ cSubClass)
          cSubClass += '()'
        ENDIF

        oXbp := &cSubClass
        oXbp := oXbp:new( oParent, , ;
            { nStartCol, nStartRow }, { nWidth, nHeight }, ;
            _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )

      ELSE
        oXbp := DC_XbpActiveXControl():new( oParent, , ;
         { nStartCol, nStartRow }, { nWidth, nHeight }, ;
         _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )
      ENDIF
      ::createObject(oXbp)

      #endif

   ELSEIF nType == GETLIST_GENERIC

      IF Valtype(cSubClass)=='C' .AND. IsFunction(Strtran(cSubClass,'()',''))

        oXbp := &(cSubClass+'()')

        oXbp := oXbp:new( oParent, , ;
            { nStartCol, nStartRow }, { nWidth, nHeight }, ;
            _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )

      ENDIF
      ::createObject(oXbp)

   ELSEIF nType == GETLIST_RMCHART

      #if XPPVER > 1900000

      DEFAULT cSubClass := 'DC_XbpRMChart()'
      oXbp := &cSubClass
      oXbp := oXbp:new( oParent, , ;
         { nStartCol, nStartRow }, { nWidth, nHeight }, ;
         _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )

      ::createObject(oXbp)

      #endif


   ELSEIF nType == GETLIST_RMCHARTREGION

      #if XPPVER > 1900000

      DEFAULT cSubClass := 'DC_XbpRMChartRegion()'
      oXbp := &cSubClass
      oXbp := oXbp:new( oParent, ;
                   { nStartCol, nStartRow }, { nWidth, nHeight }, self )

      #endif

   ELSEIF nType == GETLIST_HTMLVIEWER

      #if XPPVER > 1900000

      DEFAULT cSubClass := 'DC_XbpHTMLViewer()'
      oXbp := &cSubClass
      oXbp := oXbp:new( oParent, , ;
         { nStartCol, nStartRow }, { nWidth, nHeight }, ;
         _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )

      ::createObject(oXbp)

      #endif

   ELSEIF nType == GETLIST_RTF

      #if XPPVER > 1900000

      DEFAULT cSubClass := 'DC_XbpRTF()'
      oXbp := &cSubClass
      oXbp := oXbp:new( oParent, , ;
         { nStartCol, nStartRow }, { nWidth, nHeight }, ;
         _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )

      ::createObject(oXbp)

      #endif

   ELSEIF nType == GETLIST_LISTBOX

      DEFAULT cSubClass := 'DC_XbpListBox()'
      oXbp := &cSubClass
      oXbp := oXbp:new( oParent, , ;
         { nStartCol, nStartRow }, { nWidth, nHeight }, ;
         _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )

      ::createObject(oXbp)

   ELSEIF nType == GETLIST_STATUSBAR .AND. ::parentDlg:isDerivedFrom('XbpDialog')

      DEFAULT cSubClass := 'DC_XbpStatusBar()'
      oXbp := &cSubClass
      oXbp := oXbp:new( ::parentDlg:drawingArea,, ;
         { 0, 0 }, { nWidth, nHeight }, ;
         _Pres(aGetListItem[aGETLIST_PRESENTATION]), .f., self )

      ::createObject(oXbp)
      oXbp:setParent(::parentDlg)
      AAdd(::statusBar,oXbp)

   ELSEIF nType == GETLIST_SPLITBAR

      DEFAULT cSubClass := 'DC_XbpSplitBar()'
      oXbp := &cSubClass

      oXbp := oXbp:new( oParent, , ;
         { nStartCol, nStartRow }, { nWidth, nHeight }, ;
         _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )

      ::createObject(oXbp)

   ELSEIF nType == GETLIST_PANEL .AND. ::parentDlg:isDerivedFrom('XbpDialog')

      oXbp := DC_XbpPanel():new( ::parentDlg:drawingArea,, ;
         { 0, 0 }, { nWidth, nHeight }, ;
         _Pres(aGetListItem[aGETLIST_PRESENTATION]), .f., self )

      ::createObject(oXbp)
      oXbp:setParent(::parentDlg)
      AAdd(::statusBar,oXbp)

   ELSEIF nType == GETLIST_BITMAP

      nStartCol := oParent:currentPos()[1]
      nStartRow := oParent:currentPos()[2]
      nWidth := oParent:currentSize()[1]
      nHeight := oParent:currentSize()[2]

      DEFAULT cSubClass := 'DC_XbpBitMap()'
      oXbp := &cSubClass
      oXbp := oXbp:new( oParent, , ;
         { nStartCol, nStartRow }, { nWidth, nHeight }, self )

   ELSEIF nType == GETLIST_SPINBUTTON

      DEFAULT cSubClass := 'DC_XbpSpinButton()'
      oXbp := &cSubClass
      oXbp := oXbp:new( oParent, , ;
         { nStartCol, nStartRow }, { nWidth, nHeight }, ;
         _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )

      ::createObject(oXbp,::editControls)

   ELSEIF nType == GETLIST_SCROLLBAR

      DEFAULT cSubClass := 'DC_XbpScrollBar()'
      oXbp := &cSubClass
      oXbp := oXbp:new( oParent, , ;
         { nStartCol, nStartRow }, { nWidth, nHeight }, ;
         _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )

      ::createObject(oXbp)

   ELSEIF nType == GETLIST_BROWSE

      DEFAULT cSubClass := 'DC_XbpBrowse()'
      oXbp := &cSubClass
      oXbp := oXbp:new( oParent,,;
         { nStartCol, nStartRow }, { nWidth, nHeight }, ;
         _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )

      ::createObject(oXbp,::browseControls)

   ELSEIF nType == GETLIST_BROWSECOL

      aArray := aGetListItem[xGETLIST_OPTIONS]
      ASize(aArray,17)
      DEFAULT aArray[7] := .f.                  // don't create column object if TRUE
      DEFAULT aArray[16] := 0                   // column create - 0=DEFAULT, 1=YES, 2=NO
      IF Valtype(oParent) # 'O'
         LOOP
      ELSEIF oParent:isDerivedFrom('DC_XbpBrowse')
         IF aArray[16]==DCBROWSECOL_CREATE_NO .OR. aArray[7]
            // do nothing
         ELSEIF aArray[16] == DCBROWSECOL_CREATE_YES .OR. oParent:colCount < oParent:columnCache
            DEFAULT cSubClass := 'DC_XbpColumn()'
            oXbp := &cSubClass
            oXbp := oXbp:new( oParent, self )
         ENDIF
      ELSEIF oParent:isDerivedFrom('DC_XbpQuickBrowse')
         DEFAULT cSubClass := 'DC_QBColumn()'
         oXbp := &cSubClass
         oXbp := oXbp:new( oParent, self )
      ENDIF

   ELSEIF nType == GETLIST_QUICKBROWSE

      DEFAULT cSubClass := 'DC_XbpQuickBrowse()'
      oXbp := &cSubClass
      oXbp := oXbp:new( oParent ,,;
         { nStartCol, nStartRow }, { nWidth, nHeight }, ;
         _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )

      ::CellEditSetup( oXbp )

      AADD(::browseControls,oXbp)

   ELSEIF nType >= GETLIST_GRASTRING .AND. nType <= GETLIST_GRAPROC

      AADD( ::graControls, { nType, ;
         aGetListItem[cGETLIST_CAPTION], ;
         aGetListItem[cGETLIST_PICTURE], ;
         oParent, ;
         nStartCol, ;
         nStartRow, ;
         nWidth, ;
         nHeight, ;
         aGetListItem[cGETLIST_FONT], ;
         aGetListItem[aGETLIST_PRESENTATION], ;
         DC_GetBlock(aGetListItem[bGETLIST_WHEN]), ;
         DC_GetBlock(aGetListItem[bGETLIST_HIDE]), ;
         aGetListItem[cGETLIST_GETGROUP], ;
         aGetListItem[aGETLIST_COLOR], ;
         aGetListItem[xGETLIST_OPTIONS2], ;
         aGetListItem[xGETLIST_OPTIONS3], ;
         aGetListItem[xGETLIST_OPTIONS4], ;
         0 } )

      IF Valtype(oParent:paint) # 'B' .AND. !oParent:isderivedFrom('XbpCrt')
         oParent:paint := {|a,b,o|::paintGraControls(o)}
      ENDIF

      IF Valtype(lVisible) = 'L' .AND. lVisible
         ::paintGraControls( oParent,, Len(::graControls) )
      ENDIF

   ELSEIF nType == GETLIST_MESSAGEBOX

      ASize(xOptions,3)
      nAlign := xOptions[1]
      DEFAULT nAlign := MESSAGEBOX_BOTTOM
      DEFAULT xOptions[2] := .f., ;             // update with mouse motion
         xOptions[3] := XBPSTATIC_TEXT_LEFT
      IF Empty(nWidth)
         nWidth := oParent:CurrentSize()[1]
      ENDIF
      IF Empty(nHeight)
         nHeight := 25
      ENDIF

      IF nStartCol = 0 .AND. nStartRow = 0
         IF nAlign = MESSAGEBOX_TOP
            nStartRow := 0
         ELSEIF nAlign = MESSAGEBOX_BOTTOM
            nStartRow := oParent:CurrentSize()[2] - nHeight - ;
               IIF(::buttons>0,50,0)
         ENDIF
         IF Valtype(oOptions)='A'
            nParentHeight := ::windowHeight
            nStartRow := nParentHeight - nStartRow - 27 + ;
               aOptions[nGETOPT_ROWOFFSET]
         ELSEIF Valtype(oOptions)='O'
            nStartRow := oOptions:currentsize()[2] - nStartRow
         ENDIF
         nStartRow -= nHeight
      ENDIF

      DEFAULT aGetListItem[nGETLIST_SUBTYPE] := XBPSTATIC_TYPE_TEXT
      ::messageBox := XbpStatic():new( oParent, , ;
         { nStartCol, nStartRow }, { nWidth, nHeight }, ;
         _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible )

      ::messageBox:type := aGetListItem[nGETLIST_SUBTYPE]
      IF Empty(::messageBox:type)
         ::messageBox:type := XBPSTATIC_TYPE_TEXT
      ENDIF

      ::messageBox:cargo := ;
         { ::getListPointer, ;                  // 1 Getlist element
         aGetlist, ;                            // 2 Getlist
         aGetListItem[xGETLIST_CARGO], ;        // 3 user cargo
         DC_GetBlock(aGetListItem[bGETLIST_HIDE]),; // 4 HIDE clause
         xOptions[2],                           ; // 5 Mouse Motion Update
         nil }                                  // 6 Pointer to Static child
      ::messageBox:clipSiblings := .T.
      ::messageBox:resize := {|x,y,o|o:ChildList()[1]:setSize({y[1]-10,y[2]-5})}

      ::messageBox:create()
      IF Valtype(::messageBox:cargo[4])='B' .AND. Eval(::messageBox:cargo[4])
         ::messageBox:hide()
      ENDIF

      bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
      IF Valtype( bBlock ) = 'B'
         Eval( bBlock, ::messageBox )
      ENDIF
      nWidth  := ::messageBox:CurrentSize()[1] - 10
      nHeight := ::messageBox:CurrentSize()[2] - 5
      oXbp := XbpStatic():new( ::messageBox,, {5,2}, { nWidth, nHeight }, nil, lVisible )
      IF !Empty(aGetListItem[cGETLIST_FONT])
         oXbp:SetFontCompoundName( Alltrim(aGetListItem[cGETLIST_FONT] ))
      ENDIF

      bBlock := DC_GetBlock(aGetListItem[bGETLIST_PREEVAL])
      IF Valtype(bBlock) = 'B'
         Eval( bBlock, oXbp )
      ENDIF

      oXbp:options := xOptions[3]
      oXbp:create()
      DC_XbpSetColor( aGetListItem[aGETLIST_COLOR], oXbp, oParent, ;
         aGetlistItem[aGETLIST_PRESENTATION], .t., .t. )
      ::messageBox:cargo[6] := oXbp
      bBlock := DC_GetBlock(aGetListItem[xGETLIST_OPTIONS2],'O')
      IF Valtype( bBlock ) = 'B'
         Eval( bBlock, oXbp )
      ENDIF
      oXbp := ::messageBox

   ELSEIF nType == GETLIST_PROGRESS

      DEFAULT cSubClass := 'DC_XbpProgressBar()'
      oXbp := &cSubClass
      oXbp := oXbp:new( oParent,, ;
         {nStartCol,nStartRow}, {nWidth,nHeight},, lVisible, self )

      ::createObject(oXbp)

   ELSEIF nType == GETLIST_HTMLWINDOW

      DEFAULT cSubClass := 'DC_XbpHtmlWindow()'
      oXbp := &cSubClass
      oXbp := oXbp:new( oParent, , ;
         { nStartCol, nStartRow }, { nWidth, nHeight }, ;
         _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )

      ::createObject(oXbp)

   ELSEIF nType == GETLIST_APPCRT

      oXbp := _XbpCrtCall( aGetList, ::getListPointer, xOptions, oParent )

   ELSEIF nType == GETLIST_CUSTOM .OR. nType >= GETLIST_USER

      bBlock := DC_GetBlock(aGetListItem[bGETLIST_REFVAR])

      oXbp := Eval( bBlock, { aGetList, ::getListPointer, oParent, ;
         { nStartCol, nStartRow }, { nWidth, nHeight }, ;
         _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self } )

      IF Empty(oXbp:cargo)
         oXbp:cargo := { ::getListPointer, aGetList, aGetListItem[xGETLIST_CARGO], ;
            DC_GetBlock(aGetListItem[bGETLIST_WHEN]), ;
            DC_GetBlock(aGetListItem[bGETLIST_VALID]), ;
            DC_GetBlock(aGetListItem[bGETLIST_HIDE]) }
      ENDIF

      bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
      IF Valtype( bBlock ) = 'B'
         Eval( bBlock, oXbp )
      ENDIF

   ELSEIF nType == GETLIST_OBJECT .AND. ;
         Valtype(aGetListItem[oGETLIST_OBJECT]) = 'O'

      oXbp := aGetListItem[oGETLIST_OBJECT]
      oXbp:setParent(oParent)
      oXbp:setPos( {nStartCol, nStartRow})

      IF Empty(oXbp:cargo)
         oXbp:cargo := { ::getListPointer, aGetList, aGetListItem[xGETLIST_CARGO], ;
            DC_GetBlock(aGetListItem[bGETLIST_WHEN]), ;
            DC_GetBlock(aGetListItem[bGETLIST_VALID]), ;
            DC_GetBlock(aGetListItem[bGETLIST_HIDE]) }
      ENDIF


   ELSEIF nType == GETLIST_DIRTREE

      nDirWidth := aGetListItem[xGETLIST_OPTIONS4]
      IF Valtype( nDirWidth ) = 'A'
         nDirWidth := nDirWidth[1]
      ENDIF
      IF Valtype( nDirWidth ) # 'N'
         nDirWidth := nWidth * .6
      ELSE
         nDirWidth := nDirWidth * IIF(lPixel,1,::colPixels)
      ENDIF

      oDirs := DC_DirSelector():new ( oParent, , ;
         { nStartCol, nStartRow }, { nDirWidth, nHeight }, nil, lVisible )
      oDirs:tabStop := .T.
      oDirs:availDrives := aGetListItem[xGETLIST_OPTIONS8]
      oDirs:excludeDrives := aGetListITem[xGETLIST_OPTIONS9]
      oDirs:create()

      bBlock := DC_GetBlock(aGetListItem[bGETLIST_VAR])
      oDirs:datalink := bBlock

      bBlock := DC_GetBlock(aGetListItem[xGETLIST_OPTIONS2])
      IF Valtype(bBlock)='B'
         Eval(bBlock,oDirs)
      ENDIF
      oDirs:cargo := { i, aGetListItem[xGETLIST_CARGO], xOptions }
      bBlock := DC_GetBlock(aGetListItem[bGETLIST_HIDE])
      AAdd(oDirs:cargo,bBlock)
      aColor := aGetListItem[aGETLIST_COLOR]
      IF Valtype(aColor) = 'A'
         DC_XbpSetColor( aColor, oDirs:dirTree, oParent, ;
            aGetListItem[aGETLIST_PRESENTATION], .t., .t. )
         DC_XbpSetColor( aColor, oDirs:driveList, oParent, ;
            aGetListItem[aGETLIST_PRESENTATION], .t., .t. )
      ENDIF
      IF Valtype(aGetListItem[cGETLIST_FONT]) == 'O'
         oDirs:dirTree:SetFont(aGetListItem[cGETLIST_FONT])
      ELSEIF !Empty(aGetListItem[cGETLIST_FONT])
         oDirs:dirTree:SetFontCompoundName( Alltrim(aGetListItem[cGETLIST_FONT]) )
      ENDIF

      IF nDirWidth < nWidth

         oXbp := DC_FileSelector():new( oParent, , ;
            { nStartCol + nDirWidth + 2, nStartRow }, ;
            { nWidth-nDirWidth-2, nHeight }, nil, lVisible )

         bBlock := DC_GetBlock(aGetListItem[bGETLIST_REFVAR])
         oXbp:datalink := bBlock

         oXbp:tabStop := .T.
         ::createObject(oXbp)

         bBlock := DC_GetBlock(aGetListItem[xGETLIST_OPTIONS3])
         IF Valtype(bBlock)='B'
            Eval(bBlock,oXbp)
         ENDIF
         oXbp:setFilesTo( oDirs:curDir(), xOptions )
         oXbp:dirObject := oDirs
         oDirs:fileObject := oXbp
         IF Valtype(aColor) = 'A'
            DC_XbpSetColor( aColor, oXbp:fileList, oParent, ;
               aGetListItem[aGETLIST_PRESENTATION], .t., .t. )
            DC_XbpSetColor( aColor, oXbp:extList, oParent, ;
               aGetListItem[aGETLIST_PRESENTATION], .t., .t. )
         ENDIF
         IF Valtype(aGetListItem[cGETLIST_FONT]) == 'O'
            oXbp:fileList:SetFont(aGetListItem[cGETLIST_FONT])
         ELSEIF !Empty(aGetListItem[cGETLIST_FONT])
            oXbp:fileList:SetFontCompoundName( Alltrim(aGetListItem[cGETLIST_FONT]) )
         ENDIF

      ENDIF

   ELSEIF nType == GETLIST_TREEROOT

      DEFAULT cSubClass := 'DC_XbpTreeView()'
      oXbp := &cSubClass
      oXbp := oXbp:new( oParent,, {nStartCol,nStartRow}, {nWidth,nHeight}, ;
         _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, ;
         self )
      ::createObject(oXbp)

   ELSEIF nType == GETLIST_TREEITEM

      bBlock := DC_GetBlock(aGetListItem[bGETLIST_PROTECT])

      IF Valtype(bBlock) = 'B' .AND. Eval(bBlock)
         LOOP
      ELSEIF !(IsMemberVar(oParent,'ROOTITEM') .OR. oParent:isDerivedFrom('XbpTreeViewItem'))
         LOOP
      ENDIF

      DEFAULT xOptions := {}
      ASIZE(xOptions,1)
      IF Valtype(xOptions[1]) = 'C' .AND. !_MenuAccess(xOptions[1])
         LOOP
      ENDIF

      DEFAULT cSubClass := 'DC_XbpTreeViewItem()'
      oXbp := &cSubClass
      oXbp := oXbp:new(oParent,self)
      ::createObject(oXbp)

   ELSEIF nType == GETLIST_TREEARRAY

      ASize( xOptions,2 )
      DEFAULT xOptions[1] := {}

      bBlock := DC_GetBlock(aGetListItem[bGETLIST_VAR])
      aArray := Eval(bBlock)

      bBlock := DC_GetBlock(aGetListItem[bGETLIST_REFVAR])
      IF Valtype(bBlock) = 'B'
         aReference := Eval(bBlock)
      ELSE
         aReference := nil
      ENDIF

      bBlock := DC_GetBlock(aGetListItem[xGETLIST_OPTIONS2])

      oXbp := DC_GuiAbrowse( aArray, aReference, oParent, ;
         {nStartCol,nStartRow}, {nWidth,nHeight}, ;
         aGetListItem[cGETLIST_CAPTION],;
         xOptions[1],;
         xOptions[1],;
         nil,;
         bBlock )

      IF Empty(oXbp:cargo)
         oXbp:cargo := { ::getListPointer, aGetList, aGetListItem[xGETLIST_CARGO], ;
            DC_GetBlock(aGetListItem[bGETLIST_HIDE]) }
      ENDIF
      bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
      IF Valtype( bBlock ) = 'B'
         Eval( bBlock, oXbp )
      ENDIF

   ELSEIF nType == GETLIST_PICKLIST

      DEFAULT cSubClass := 'DC_XbpPickList()'
      oXbp := &cSubClass
      oXbp := oXbp:new( oParent, , ;
         { nStartCol, nStartRow }, { nWidth, nHeight }, ;
         _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )

      ::createObject(oXbp)

      IF !::isHideDialog
         oXbp:show()
      ENDIF

   ELSEIF nType == GETLIST_BARGRAPH

      oXbp := DC_BarGraph():new( oParent, , ;
         { nStartCol, nStartRow }, { nWidth, nHeight }, ;
         _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, self )

      ::createObject(oXbp)

/*
   ELSEIF nType == GETLIST_SETPARENT

      xParent := aGetListItem[bGETLIST_PARENT]
      IF Valtype(xParent) == 'C' .AND. !(xParent[1]=='{') // it's an ID
         oSetParent := DC_GetObject(::getListArray,xParent)
      ELSE
         bBlock := DC_GetBlock(aGetListItem[bGETLIST_PARENT],'O')
         IF Valtype( bBlock ) = 'B'
            oSetParent := Eval( bBlock )
         ELSE
            oSetParent := nil
         ENDIF
      ENDIF
*/

   ELSEIF nType == GETLIST_SETGROUP
      cSetGroup := aGetListItem[cGETLIST_GETGROUP]

   ELSEIF nType == GETLIST_SETRESIZE
      aSetResize := aGetListItem[aGETLIST_RESIZE]

   ELSEIF nType == GETLIST_SETFONT
      cSetFont := aGetListItem[cGETLIST_FONT]

   ELSEIF nType == GETLIST_SETCOLOR
      aSetColor := aGetListItem[aGETLIST_COLOR]

   ELSEIF nType == GETLIST_SETSAYOPTION
      nSetSayOption := aGetListItem[xGETLIST_OPTIONS]

   ELSEIF nType == GETLIST_USEREVENT
      AAdd( ::userEvents, { aGetListItem[nGETLIST_SUBTYPE],aGetListItem[bGETLIST_ACTION] } )

   ELSEIF nType == GETLIST_EVAL

      bBlock := aGetListItem[bGETLIST_ACTION]
      IF Valtype(bBlock) == 'B'
        Eval(bBlock)
      ENDIF

   ELSEIF nType == GETLIST_APPEDIT

      DEFAULT aGetListItem[cGETLIST_CAPTION] := ''
      DEFAULT aGetListItem[cGETLIST_FONT] := '8.Courier'
      DEFAULT aGetListItem[aGETLIST_COLOR,1] := XBPSYSCLR_WINDOWSTATICTEXT
      DEFAULT aGetListItem[aGETLIST_COLOR,2] := XBPSYSCLR_DIALOGBACKGROUND
      DEFAULT aGetListItem[xGETLIST_OPTIONS2] := Array(4)
      DEFAULT aGetListItem[xGETLIST_OPTIONS2,1] := '8.Courier'
      DEFAULT aGetListItem[xGETLIST_OPTIONS2,2] := XBPSYSCLR_WINDOWSTATICTEXT
      DEFAULT aGetListItem[xGETLIST_OPTIONS2,3] := XBPSYSCLR_DIALOGBACKGROUND
      DEFAULT aGetListItem[xGETLIST_OPTIONS2,4] := 0

      oApp := ;
         AppEditNew( oParent ,,;
         { "TOP", "LEFT" },;
         nil, ;
         __PresParam({XBP_PP_CAPTION,aGetListItem[cGETLIST_CAPTION]},;
         {XBP_PP_COMPOUNDNAME,aGetListItem[cGETLIST_FONT]},;
         {XBP_PP_FGCLR,aGetListItem[aGETLIST_COLOR,1]},;
         {XBP_PP_BGCLR,aGetListItem[aGETLIST_COLOR,2]}),;
         aGetListItem[nGETLIST_SUBTYPE],;
         nil,  ;
         __PresParam({XBP_PP_COMPOUNDNAME,aGetListItem[xGETLIST_OPTIONS2,1]},;
         {XBP_PP_FGCLR,aGetListItem[xGETLIST_OPTIONS2,2]},;
         {XBP_PP_BGCLR,aGetListItem[xGETLIST_OPTIONS2,3]},;
         {XBP_PP_ALIGNMENT,aGetListItem[xGETLIST_OPTIONS2,4]}),;
         __PresParam({XBP_PP_CAPTION,aGetListItem[xGETLIST_OPTIONS4,1]},;
         {XBP_PP_COMPOUNDNAME,aGetListItem[xGETLIST_OPTIONS4,2]},;
         {XBP_PP_FGCLR,aGetListItem[xGETLIST_OPTIONS4,3]},;
         {XBP_PP_BGCLR,aGetListItem[xGETLIST_OPTIONS4,4]},;
         {XBP_PP_ALIGNMENT,aGetListItem[xGETLIST_OPTIONS4,5]}),;
         {aGetListItem[xGETLIST_OPTIONS8,1],aGetListItem[xGETLIST_OPTIONS8,2]},;
         aGetListItem[cGETLIST_VARNAME], ;
         {aGetListItem[xGETLIST_OPTIONS3,1],aGetListItem[xGETLIST_OPTIONS3,2]},;
         {aGetListItem[bGETLIST_WHEN,1],aGetListItem[bGETLIST_WHEN,2]},;
         {aGetListItem[bGETLIST_VALID,1],aGetListItem[bGETLIST_VALID,2]},;
         {nil,nil,nil} )

      IF !Empty(aGetListItem[xGETLIST_OPTIONS])
         oApp:FieldList( aGetListItem[xGETLIST_OPTIONS] )
      ENDIF

      bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
      IF Valtype( bBlock ) = 'B'
         Eval( bBlock, oApp )
      ENDIF

      AAdd(::appControls, ;
         {oApp,aGetListItem[xGETLIST_OPTIONS9,1],aGetListItem[xGETLIST_OPTIONS9,2]})


   ELSEIF nType == GETLIST_APPBROWSE

      DEFAULT aGetListItem[cGETLIST_CAPTION] := ''
      DEFAULT aGetListItem[cGETLIST_FONT] := '8.Courier'
      DEFAULT aGetListItem[aGETLIST_COLOR,1] := XBPSYSCLR_WINDOWSTATICTEXT
      DEFAULT aGetListItem[aGETLIST_COLOR,2] := XBPSYSCLR_DIALOGBACKGROUND
      DEFAULT aGetListItem[xGETLIST_OPTIONS2] := Array(2)
      DEFAULT aGetListItem[xGETLIST_OPTIONS2,1] := XBPSYSCLR_WINDOWSTATICTEXT
      DEFAULT aGetListItem[xGETLIST_OPTIONS2,2] := XBPSYSCLR_DIALOGBACKGROUND

      oApp := ;
         AppBrowseNew( oParent,,;
         { "TOP", "LEFT" },;
         nil, ;
         __PresParam({XBP_PP_CAPTION,aGetListItem[cGETLIST_CAPTION]},;
         {XBP_PP_COMPOUNDNAME,aGetListItem[cGETLIST_FONT]},;
         {XBP_PP_FGCLR,aGetListItem[aGETLIST_COLOR,1]},;
         {XBP_PP_BGCLR,aGetListItem[aGETLIST_COLOR,2]},;
         {XBP_PP_HILITE_FGCLR,aGetListItem[xGETLIST_OPTIONS2,1]},;
         {XBP_PP_HILITE_BGCLR,aGetListItem[xGETLIST_OPTIONS2,2]}),;
         aGetListItem[nGETLIST_SUBTYPE],;
         aGetListItem[cGETLIST_VARNAME],;
         {aGetListItem[bGETLIST_WHEN,1],aGetListItem[bGETLIST_WHEN,2]})

      IF !Empty(aGetListItem[xGETLIST_OPTIONS])
         oApp:FieldList( aGetListItem[xGETLIST_OPTIONS] )
      ENDIF

      bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
      IF Valtype( bBlock ) = 'B'
         Eval( bBlock, oApp )
      ENDIF

      AAdd(::appControls, ;
         {oApp,aGetListItem[xGETLIST_OPTIONS9,1],aGetListItem[xGETLIST_OPTIONS9,2]})

   ELSEIF nType == GETLIST_APPFIELD

      aArray := { {},{},{} }

      * --- Build first array of options --- *
      IF !Empty(aGetListItem[cGETLIST_FONT])
         DC_PresAdd( aArray[1], {XBP_PP_COMPOUNDNAME,aGetListItem[cGETLIST_FONT]} )
      ENDIF
      IF !Empty(aGetListItem[aGETLIST_COLOR,1])
         DC_PresAdd( aArray[1], {XBP_PP_FGCLR,aGetListItem[aGETLIST_COLOR,1]} )
      ENDIF
      IF !Empty(aGetListItem[aGETLIST_COLOR,2])
         DC_PresAdd( aArray[1], {XBP_PP_BGCLR,aGetListItem[aGETLIST_COLOR,2]} )
      ENDIF
      IF !Empty(aGetListItem[xGETLIST_OPTIONS2,1])
         DC_PresAdd( aArray[1], {XBP_PP_HILITE_FGCLR,aGetListItem[xGETLIST_OPTIONS2,1]} )
      ENDIF
      IF !Empty(aGetListItem[xGETLIST_OPTIONS2,2])
         DC_PresAdd( aArray[1], {XBP_PP_HILITE_BGCLR,aGetListItem[xGETLIST_OPTIONS2,2]} )
      ENDIF
      IF !Empty(aGetListItem[xGETLIST_OPTIONS5])
         DC_PresAdd( aArray[1], aGetListItem[xGETLIST_OPTIONS5] )
      ENDIF

      * --- Build second array of options --- *
      IF !Empty(aGetListItem[xGETLIST_OPTIONS6,1])
         DC_PresAdd( aArray[2], { XBP_PP_CAPTION, aGetListItem[xGETLIST_OPTIONS6,1] } )
      ENDIF
      IF !Empty(aGetListItem[xGETLIST_OPTIONS6,2])
         DC_PresAdd( aArray[2], { XBP_PP_COMPOUNDNAME, aGetListItem[xGETLIST_OPTIONS6,2] } )
      ENDIF
      IF !Empty(aGetListItem[xGETLIST_OPTIONS6,3])
         DC_PresAdd( aArray[2], { XBP_PP_FGCLR, aGetListItem[xGETLIST_OPTIONS6,3] } )
      ENDIF
      IF !Empty(aGetListItem[xGETLIST_OPTIONS6,4])
         DC_PresAdd( aArray[2], { XBP_PP_BGCLR, aGetListItem[xGETLIST_OPTIONS6,4] } )
      ENDIF
      IF !Empty(aGetListItem[xGETLIST_OPTIONS6,5])
         DC_PresAdd( aArray[1], aGetListItem[xGETLIST_OPTIONS6,5] )
      ENDIF

      * --- Build third array of options --- *
      IF !Empty(aGetListItem[xGETLIST_OPTIONS7,1])
         DC_PresAdd( aArray[3], { XBP_PP_CAPTION, aGetListItem[xGETLIST_OPTIONS7,1] } )
      ENDIF
      IF !Empty(aGetListItem[xGETLIST_OPTIONS7,2])
         DC_PresAdd( aArray[3], { XBP_PP_COMPOUNDNAME, aGetListItem[xGETLIST_OPTIONS7,2] } )
      ENDIF
      IF !Empty(aGetListItem[xGETLIST_OPTIONS7,3])
         DC_PresAdd( aArray[3], { XBP_PP_FGCLR, aGetListItem[xGETLIST_OPTIONS7,3] } )
      ENDIF
      IF !Empty(aGetListItem[xGETLIST_OPTIONS7,4])
         DC_PresAdd( aArray[3], { XBP_PP_BGCLR, aGetListItem[xGETLIST_OPTIONS7,4] } )
      ENDIF
      IF !Empty(aGetListItem[xGETLIST_OPTIONS7,5])
         AAdd( aArray[3], aGetListItem[xGETLIST_OPTIONS7,5] )
      ENDIF

      oParent:fieldDef( { aGetListItem[cGETLIST_VARNAME], ;
         aGetListItem[nGETLIST_SUBTYPE], ;
         aGetListItem[xGETLIST_OPTIONS3], ;
         aGetListItem[xGETLIST_OPTIONS4], ;
         aGetListItem[xGETLIST_OPTIONS8], ;
         aGetListItem[bGETLIST_VAR], ;
         aGetListItem[xGETLIST_OPTIONS9], ;
         aGetListItem[nGETLIST_WIDTH],,,, }, ;
         IIF( Empty(aArray[1]),nil,aArray[1]), ;
         IIF( Empty(aArray[2]),nil,aArray[2]), ;
         IIF( Empty(aArray[3]),nil,aArray[3])  )

   ELSEIF nType >= GETLIST_3P_START .AND. nType <= GETLIST_3P_END

      oXbp := DC_ReadGui3p( nType, aGetList, ::getListPointer, oParent, ;
         nStartCol, nStartRow, nWidth, nHeight, ;
         _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible, ;
         aOptions, xOptions )

      IF Empty(oXbp:cargo)
         oXbp:cargo := { ::getListPointer, aGetList, aGetListItem[xGETLIST_CARGO], ;
            DC_GetBlock(aGetListItem[bGETLIST_WHEN]), ;
            DC_GetBlock(aGetListItem[bGETLIST_VALID]), ;
            DC_GetBlock(aGetListItem[bGETLIST_HIDE]) }
      ENDIF

      bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
      IF Valtype( bBlock ) = 'B'
         Eval( bBlock, oXbp )
      ENDIF

   ENDIF

   aGetListItem[oGETLIST_OBJECT] := oXbp

   IF !Empty(cToolTip) .AND. Valtype(oXbp) = 'O' .AND. IsMemberVar(oXbp,'HELPLINK')
      IF oXbp:isDerivedFrom('XbpColumn')
         oXbp:heading:HelpLink := ;
            DC_SetHelpLink( oXbp:HelpLink, DCGUI_HELP_TOOLTIP, ;
            MagicHelpLabel():New(nToolTip,cToolTip))
      ELSE
         oXbp:HelpLink := ;
            DC_SetHelpLink( oXbp:HelpLink, DCGUI_HELP_TOOLTIP, ;
            MagicHelpLabel():New(nToolTip,cToolTip))
      ENDIF
   ENDIF
   IF !Empty(cHelpCode) .AND. Valtype(oXbp) = 'O' .AND. IsMemberVar(oXbp,'HELPLINK')
      oXbp:HelpLink := DC_SetHelpLink( oXbp:HelpLink, DCGUI_HELP_REQUEST, XbpHelpLabel():New( cHelpCode ), ::helpObject )
   ENDIF
   IF Valtype(nCursor) $ 'NA'
      IF Valtype(nCursor) = 'A'
         ASize(nCursor,3)
         DEFAULT nCursor[2] := 0
         DEFAULT nCursor[3] := XBPWINDOW_POINTERTYPE_POINTER
         oXbp:SetPointer( nCursor[1], nCursor[2], nCursor[3] )
      ELSEIF nCursor > 3 .AND. nCursor < 60
         oXbp:SetPointer(nil,nCursor,XBPWINDOW_POINTERTYPE_SYSPOINTER)
      ELSE
         oXbp:Setpointer(nil,nCursor)
      ENDIF
   ENDIF

   IF Valtype(oXbp) # 'O'
     IF ::isStoreProfile
       aGetListItem[aGETLIST_PROFILE,1] := 0
     ENDIF
     LOOP
   ENDIF

   IF ::scaleFactor[5] .AND. IsMethod(oXbp,'SetFont') .AND. ;
         !oXbp:isDerivedFrom('DC_XbpGet') .AND. !oXbp:isDerivedFrom('DC_XbpStatic')
      IF oXbp:isDerivedFrom('DC_XbpTabPage') .AND. !Empty(oXbp:relTabPage)
        oFont := oXbp:relTabPage:setFont()
        IF Valtype(oFont) = 'O'
          cFont := Alltrim(Str(Round(oFont:nominalPointSize,0))) + ;
             '.' + oFont:familyName
          oXbp:setFontCompoundName(cFont)
        ENDIF
      ELSE
        oFont := oXbp:setFont()
        IF Valtype(oFont) = 'O'
           cFont := Alltrim(Str(Round(oFont:nominalPointSize * ::scaleFactor[3],0))) + ;
              '.' + oFont:familyName
           oXbp:setFontCompoundName(cFont)
        ENDIF
      ENDIF
   ENDIF

   bBlock := DC_GetBlock(aGetListItem[bGETLIST_EVAL])
   IF Valtype( bBlock ) = 'B'
      Eval( bBlock, oXbp, aGetList )
   ENDIF

   bBlock := DC_GetBlock(aGetListItem[bGETLIST_GOTFOCUS])
   IF Valtype( bBlock ) = 'B' .AND. nType # GETLIST_TABPAGE
      oXbp:setInputFocus := DC_MergeBlocks( bBlock, oXbp:setInputFocus, oXbp )
   ENDIF

   bBlock := DC_GetBlock(aGetListItem[bGETLIST_LOSTFOCUS])
   IF Valtype( bBlock ) = 'B'                   // .AND. nType # GETLIST_BROWSECOL
      oXbp:killInputFocus := DC_MergeBlocks( oXbp:killInputFocus, bBlock, oXbp )
   ENDIF

   IF Valtype(oXbp) = 'O' .AND. IsMemberVar(oXbp,'TABSTOP')
      oXbp:tabstop := aOptions[lGETOPT_TABSTOP]
      IF Valtype(aGetListItem[lGETLIST_TABSTOP]) = 'L'
         oXbp:tabstop := aGetListItem[lGETLIST_TABSTOP]
      ENDIF
   ENDIF

   IF Valtype(aGetListItem[nGETLIST_TABGROUP]) = 'N' .AND. ;
         Valtype(oXbp) = 'O' .AND. IsMemberVar(oXbp,'GROUP')
      oXbp:group := aGetListItem[nGETLIST_TABGROUP]
   ENDIF

   IF Valtype( aGetListItem[nGETLIST_ACCELKEY] ) $ 'AN'
      ::AddHotKey( aGetListItem[nGETLIST_ACCELKEY], ;
         DC_GetBlock(aGetListItem[bGETLIST_ACTION]), ;
         DC_GetBlock(aGetListItem[bGETLIST_WHEN]), ;
         DC_GetBlock(aGetListItem[bGETLIST_HIDE]), ;
         IIF( oParent=nil,nil,oXbp), oXbp, ;
         aGetListItem[xGETLIST_CARGO] )
   ENDIF

   IF IsMethod(oXbp,'currentSize')
      nWidth := oXbp:currentSize()[1]
      nHeight := oXbp:currentSize()[2]
   ENDIF

   _BuildHelpCode(,oXbp,oParent)

   IF ::isStoreProfile
     aGetListItem[aGETLIST_PROFILE,1] := MilliSeconds() - aGetListItem[aGETLIST_PROFILE,1]
   ENDIF

NEXT

/*
IF !Empty(::busyMsg) // $MR
   ProgressBar(2)                        // $MR
ENDIF                                    // $MR
*/

/*
 J. Duijf 17-12-2009
 Check if any problems has occured while creating xbp's
 Show a descriptive error message and terminate the Window
 */
IF !Empty(::buildErrorMsg)
   /*
    Maybe creating a logfile including callstack and getlist parameters for future analisys
    */
   Dc_Impl(oBusyScreen)
   DC_WinAlert(::buildErrorMsg + Chr(13) + Chr(13) + DC_LangMsg(DCMSG_CREATE_ERROR))
   DC_GetListUndo(aGetList)
   Break()
ENDIF

* --- Show all browse windows --- *

FOR i := 1 TO Len(::browseControls)
  oParent := ::browseControls[i]
//   xData := oParent:dataSource                                                 // J. Duijf 27-11-2002
  IF oParent:isDerivedFrom('DC_XbpBrowse')
    IF Valtype(oParent:freezeLeft) = 'A' .AND. Empty(oParent:setLeftFrozen())
      oParent:setLeftFrozen( oParent:freezeLeft )
    ENDIF
    IF Valtype(oParent:freezeRight) = 'A' .AND. Empty(oParent:setRightFrozen())
      oParent:setRightFrozen( oParent:freezeRight )
    ENDIF
  ELSEIF oParent:isDerivedFrom('DC_XbpQuickBrowse') .AND. oParent:status() <= 0
    oParent:create()
  ENDIF


  IF oParent:fit // fit
    nWidth := 0
    FOR j := 1 TO oParent:colCount
      nWidth += oParent:getColumn(j):currentSize()[1]
    NEXT

    IF oParent:vScroll
      IF Valtype(oParent:scrollBarHeight) = 'N'
        nWidth += oParent:scrollBarHeight
      ENDIF
    ENDIF

    IF !Empty(oParent:fitMax) .AND. nWidth > oParent:fitMax
      nWidth := oParent:fitMax
    ENDIF

    oParent:setSize({nWidth,oParent:currentSize()[2]})
    oParent:refreshAll()
  ENDIF
  oParent:show()
  IF oParent:isderivedFrom('DC_XbpBrowse')
    oParent:setTimerRefresh()
  ENDIF
NEXT

* -------------

FOR i := 1 TO Len(::toolBarControls)
  oXbp := ::toolBarControls[i]
  IF oXbp:fit
    aChildList := oXbp:childList()
    IF oXbp:align $ { TOOLBAR_LEFT, TOOLBAR_RIGHT }
      nHeight := 0
      FOR j := 1 TO Len(aChildList)
        nHeight += aChildList[j]:currentSize()[2] + oXbp:spacing
      NEXT
      nOldHeight := oXbp:currentSize()[2]
      oXbp:setSize({oXbp:currentSize()[1],nHeight})
      IF oXbp:anchor $ { 0, DCGUI_ALIGN_LEFT, DCGUI_ALIGN_RIGHT }
        oXbp:setPos({oXbp:currentPos()[1],oXbp:currentPos()[2]+(nOldHeight-nHeight)})
      ELSEIF oXbp:anchor == DCGUI_ALIGN_CENTER
        oXbp:setPos({oXbp:currentPos()[1],oXbp:currentPos()[2]+(nOldHeight-nHeight)/2})
      ENDIF
      FOR j := 1 TO Len(aChildList)
        oXbp := aChildList[j]
        oXbp:setPos( { oXbp:currentPos()[1], oXbp:currentPos()[2] - (nOldHeight-nHeight)} )
      NEXT
   ELSE
      nWidth := 0
      FOR j := 1 TO Len(aChildList)
        nWidth += aChildList[j]:currentSize()[1] + oXbp:spacing // IIF(j<Len(aChildList),0,oXbp:spacing)
      NEXT
      nOldWidth := oXbp:currentSize()[1]
      oXbp:setSize({nWidth,oXbp:currentSize()[2]})
      IF oXbp:anchor == DCGUI_ALIGN_RIGHT
        oXbp:setPos({oXbp:currentPos()[1]+(nOldWidth-nWidth),oXbp:currentPos()[2]})
      ELSEIF oXbp:anchor == DCGUI_ALIGN_CENTER
        oXbp:setPos({oXbp:currentPos()[1]+(nOldWidth-nWidth)/2,oXbp:currentPos()[2]})
      ENDIF
    ENDIF
  ENDIF
NEXT

IF ::autoWinMenu .AND. Valtype(DC_WinMenu()) # 'O'
  DC_SetAppMenu(::menuBar) // store pointer to menu bar
  DC_WinMenu(,.t.,self) // create "Window" menu on menu bar

ELSEIF ::modalState == XBP_DISP_MODELESS .AND. ;
       ::isNewDlg .AND. !(::appWindow==AppDeskTop())

  aArray := ::appWindow:setParent():childList()

  IF !::noWinMenu .AND. Len(aArray) >= 2 .AND. DC_SetAppMenu() $ aArray
    oXbp := DC_WinMenu()
    IF Valtype(oXbp) == 'O'
      ::parentDlg:setdisplayfocus:= {|a,b,o|Sleep(10),DC_WinMenu():checkitem(o)}
      oXbp:additem(::parentDlg)
      oXbp:checkitem(::parentDlg)
      IF DC_WinMenuDestroyMode() == DCGUI_WINMENU_DESTROYMODE_CLOSE
        ::parentDlg:close := ;
          DC_MergeBlocks(::parentDlg:close,{|a,b,o|DC_WinMenu():delItem(o)})
      ENDIF
    ENDIF
  ENDIF
ENDIF

IF DC_ReadGuiTypeAhead()

  IF Valtype(::keyboardBuffer) = 'C'
    IF !Empty(::keyboardBuffer)
      KEYBOARD ::keyboardBuffer
    ENDIF
    DO WHILE ( mp1 := Inkey(.1)) # 0
      AAdd( ::keyboardQueue, mp1 )
    ENDDO
  ENDIF

  DO WHILE (nEvent := AppEvent(@mp1,@mp2,@oXbp,1)) # 0
    IF nEvent == xbeP_Keyboard
      AAdd( ::keyboardQueue, mp1 )
    ELSE
      AAdd( aEvents, { nEvent, mp1, mp2, oXbp } )
    ENDIF
  ENDDO

  FOR i := 1 TO Len(aEvents)
    PostAppEvent( aEvents[i,1], aEvents[i,2], aEvents[i,3], aEvents[i,4] )
  NEXT

ENDIF

FOR i := 1 TO Len(::dialogControls)
  IF ::dialogControls[i]:fit  // FIT
    ::AutoFit( ::dialogControls[i], ::dialogControls[i]:fitPad, .f. )
     DC_ClearEvents()
  ENDIF
NEXT

aButtons := aOptions[aGETOPT_BUTTONS]
DEFAULT aButtons := {}

* --- FIT clause was used --- *
IF ::isFit
  ::AutoFit( ::parentDlg, ::fitPad, .t., aButtons )
  DC_ClearEvents(,,,{xbeP_Keyboard})
ENDIF

IF ::restoreDefaultButton .AND. Valtype(::parentDlg) == 'O' .AND. ;
   ::parentDlg:isDerivedFrom('XbpDialog')
  oXbp := XbpStatic():new(::parentDlg:drawingArea,,{1,1},{12,12})
  oXbp:caption := 'y'
  oXbp:options := XBPALIGN_BOTTOM + XBPALIGN_LEFT
  cProcName := ProcName(2)
  oXbp:rbClick := {||RestDefButt( self, cProcName + ':' + ::parentDlg:title )}
  oXbp:create()
  oXbp:setColorBG(XBPSYSCLR_TRANSPARENT)
  oXbp:setFontCompoundName('12.Marlett')
  cToolTip := DC_LangMsg(DCMSG_RESTDEF_TOOLTIP)
  AAdd(::toolTipControls,cToolTip)
  nToolTip := Len(::tooltipControls)
  oXbp:HelpLink := ;
       DC_SetHelpLink( oXbp:HelpLink, DCGUI_HELP_TOOLTIP, ;
       MagicHelpLabel():New(nToolTip,cToolTip))
ENDIF

DC_GetDataLink(.t.)

// need to make sure all added buttons are in same TABGROUP

IF ::buttons > 0 .OR. (Valtype(aButtons)='A' .AND. Len(aButtons) > 0)

  nButtonWidth := 0
  nButtonCol := 0
  IF DC_BitTest(::buttons,1)
    nButtonCol++
    aButtonConfig := DC_AddButtonConfig(DCGUI_BUTTON_OK)
    nButtonWidth += aButtonConfig[3]
    cButtonFont := aButtonConfig[6]
  ENDIF
  IF DC_BitTest(::buttons,2)
    nButtonCol++
    aButtonConfig := DC_AddButtonConfig(DCGUI_BUTTON_CANCEL)
    nButtonWidth += aButtonConfig[3]
    cButtonFont := aButtonConfig[6]
  ENDIF
  IF DC_BitTest(::buttons,3)
    nButtonCol++
    aButtonConfig := DC_AddButtonConfig(DCGUI_BUTTON_EXIT)
    nButtonWidth += aButtonConfig[3]
    cButtonFont := aButtonConfig[6]
  ENDIF
  IF DC_BitTest(::buttons,4)
    nButtonCol++
    aButtonConfig := DC_AddButtonConfig(DCGUI_BUTTON_HELP)
    nButtonWidth += aButtonConfig[3]
    cButtonFont := aButtonConfig[6]
  ENDIF
  IF DC_BitTest(::buttons,5)
    nButtonCol++
    aButtonConfig := DC_AddButtonConfig(DCGUI_BUTTON_YES)
    nButtonWidth += aButtonConfig[3]
    cButtonFont := aButtonConfig[6]
  ENDIF
  IF DC_BitTest(::buttons,6)
    nButtonCol++
    aButtonConfig := DC_AddButtonConfig(DCGUI_BUTTON_NO)
    nButtonWidth += aButtonConfig[3]
    cButtonFont := aButtonConfig[6]
  ENDIF

  FOR i := 1 TO Len(aButtons)
    nButtonWidth += aButtons[i,2]
    nButtonCol++
  NEXT
  nButtonWidth += (nButtonCol-1) * 10
  nAlign := aOptions[nGETOPT_BUTTONALIGN]
  DEFAULT nAlign := 0

  IF nAlign = DCGUI_BUTTONALIGN_CENTER
    nButtonCol := (( ::parentDlg:drawingArea:currentSize()[1] - nButtonWidth ) / 2) - (::fitPad/2)
  ELSEIF nAlign = DCGUI_BUTTONALIGN_RIGHT
    nButtonCol := ::parentDlg:drawingArea:currentSize()[1] - nButtonWidth - ::fitPad
  ELSE
    nButtonCol := ::fitPad
  ENDIF

  IF DC_BitTest( ::buttons, 1 ) .OR. DC_BitTest( ::buttons, 3 )
    // aButtonConfig := DC_AddButtonConfig()
    IF DC_BitTest( ::buttons, 1 )
      aButtonConfig := DC_AddButtonConfig(DCGUI_BUTTON_OK)
    ELSE
      aButtonConfig := DC_AddButtonConfig(DCGUI_BUTTON_EXIT)
    ENDIF
    AADD(aGetList,DC_GetTemplate())
    ::getListPointer := Len(aGetList)
    aGetListItem := aGetList[::getListPointer]
    aGetListItem[nGETLIST_TYPE] := GETLIST_PUSHBUTTON
    aGetListItem[cGETLIST_CAPTION] := aButtonConfig[2]
    aGetListItem[bGETLIST_ACTION] := {||DC_ReadGuiExit(self)}
    aGetListItem[nGETLIST_STARTCOL] := nButtonCol * ::scaleFactor[1]
    aGetListItem[nGETLIST_STARTROW] := 15 - aButtonConfig[4] * ::scaleFactor[2]
    aGetListItem[nGETLIST_WIDTH] := aButtonConfig[3] * ::scaleFactor[3]
    aGetListItem[nGETLIST_HEIGHT] := aButtonConfig[4] * ::scaleFactor[4]
    aGetListItem[cGETLIST_ID] := 'DCGUI_BUTTON_OK'
    aGetListItem[lGETLIST_PIXEL] := .t.
    aGetListItem[cGETLIST_FONT] := cButtonFont
    aGetListItem[aGETLIST_RESIZE] := DCGUI_RESIZE_NONE
    aGetListItem[xGETLIST_OPTIONS9] := {,,,,aButtonConfig[5]}
    oXbp := _ExpressPushButton(::drawingArea,nButtonCol,aButtonConfig,::scaleFactor,::fitPad,self,lExpress)
    oXbp:tabstop := .t.
    oXbp:create()
    oFocusButton := oXbp
    nButtonCol += aButtonConfig[3] + 10
    aGetListItem[oGETLIST_OBJECT] := oXbp
    ::AddHotKey( aGetListItem[cGETLIST_CAPTION],aGetListItem[bGETLIST_ACTION], ;
                 nil, nil, oParent, oXbp, nil, .f. )
  ENDIF

  IF DC_BitTest( ::buttons, 2 )
    aButtonConfig := DC_AddButtonConfig(DCGUI_BUTTON_CANCEL)
    AADD(aGetList,DC_GetTemplate())
    ::getListPointer := Len(aGetList)
    aGetListItem := aGetList[::getListPointer]
    aGetListItem[nGETLIST_TYPE] := GETLIST_PUSHBUTTON
    aGetListItem[cGETLIST_CAPTION] := aButtonConfig[2]
    aGetListItem[bGETLIST_ACTION] := {||DC_ReadGuiAbort(aGetList)}
    aGetListItem[nGETLIST_STARTCOL] := nButtonCol * ::scaleFactor[1]
    aGetListItem[nGETLIST_STARTROW] := (15 - aButtonConfig[4]) * ::scaleFactor[2]
    aGetListItem[nGETLIST_WIDTH] := aButtonConfig[3] * ::scaleFactor[3]
    aGetListItem[nGETLIST_HEIGHT] := aButtonConfig[4] * ::scaleFactor[4]
    aGetListItem[cGETLIST_ID] := 'DCGUI_BUTTON_CANCEL'
    aGetListItem[xGETLIST_CARGO] := 'CANCEL'
    aGetListItem[lGETLIST_PIXEL] := .t.
    aGetListItem[cGETLIST_FONT] := cButtonFont
    aGetListITem[aGETLIST_RESIZE] := DCGUI_RESIZE_NONE
    aGetListItem[xGETLIST_OPTIONS9] := {,,,,aButtonConfig[5]}
    oXbp := _ExpressPushButton(::drawingArea,nButtonCol,aButtonConfig,::scaleFactor,::fitPad,self)
    oXbp:tabstop := .t.
    oXbp:create()
    nButtonCol += aButtonConfig[3] + 10
    aGetListItem[oGETLIST_OBJECT] := oXbp
    ::AddHotKey( aGetListItem[cGETLIST_CAPTION],aGetListItem[bGETLIST_ACTION], ;
                 nil, nil, oParent, oXbp, nil, .f. )
  ENDIF

  IF DC_BitTest( ::buttons, 5 )
    aButtonConfig := DC_AddButtonConfig(DCGUI_BUTTON_YES)
    AADD(aGetList,DC_GetTemplate())
    ::getListPointer := Len(aGetList)
    aGetListItem := aGetList[::getListPointer]
    aGetListItem[nGETLIST_TYPE] := GETLIST_PUSHBUTTON
    aGetListItem[cGETLIST_CAPTION] := aButtonConfig[2]
    aGetListItem[bGETLIST_ACTION] := {||DC_ReadGuiExit(self)}
    aGetListItem[nGETLIST_STARTCOL] := nButtonCol * ::scaleFactor[1]
    aGetListItem[nGETLIST_STARTROW] := ( 15 - aButtonConfig[4] ) * ::scaleFactor[2]
    aGetListItem[nGETLIST_WIDTH] := aButtonConfig[3] * ::scaleFactor[3]
    aGetListItem[nGETLIST_HEIGHT] := aButtonConfig[4] * ::scaleFactor[4]
    aGetListItem[cGETLIST_ID] := 'DCGUI_BUTTON_YES'
    aGetListItem[lGETLIST_PIXEL] := .t.
    aGetListItem[cGETLIST_FONT] := cButtonFont      //Zolifree
    aGetListITem[aGETLIST_RESIZE] := DCGUI_RESIZE_NONE
    aGetListItem[xGETLIST_OPTIONS9] := {,,,,aButtonConfig[5]}
    oXbp := _ExpressPushButton(::drawingArea,nButtonCol,aButtonConfig,::scaleFactor,::fitPad,self)
    oXbp:tabstop := .t.
    oXbp:create()
    nButtonCol += aButtonConfig[3] + 10
    aGetListItem[oGETLIST_OBJECT] := oXbp
    ::AddHotKey( aGetListItem[cGETLIST_CAPTION],aGetListItem[bGETLIST_ACTION], ;
                 nil, nil, oParent, oXbp, nil, .f. )
  ENDIF

  IF DC_BitTest( ::buttons, 6 )
    aButtonConfig := DC_AddButtonConfig(DCGUI_BUTTON_NO)
    AADD(aGetList,DC_GetTemplate())
    ::getListPointer := Len(aGetList)
    aGetListItem := aGetList[::getListPointer]
    aGetListItem[nGETLIST_TYPE] := GETLIST_PUSHBUTTON
    aGetListItem[cGETLIST_CAPTION] := aButtonConfig[2]
    aGetListItem[bGETLIST_ACTION] := {||DC_ReadGuiAbort(aGetList)}
    aGetListItem[nGETLIST_STARTCOL] := nButtonCol * ::scaleFactor[1]
    aGetListItem[nGETLIST_STARTROW] := ( 15 - aButtonConfig[4] ) * ::scaleFactor[2]
    aGetListItem[nGETLIST_WIDTH] := aButtonConfig[3] * ::scaleFactor[3]
    aGetListItem[nGETLIST_HEIGHT] := aButtonConfig[4] * ::scaleFactor[4]
    aGetListItem[cGETLIST_ID] := 'DCGUI_BUTTON_NO'
    aGetListItem[xGETLIST_CARGO] := 'CANCEL'
    aGetListItem[lGETLIST_PIXEL] := .t.
    aGetListItem[cGETLIST_FONT] := cButtonFont      //Zolifree
    aGetListITem[aGETLIST_RESIZE] := DCGUI_RESIZE_NONE
    aGetListItem[xGETLIST_OPTIONS9] := {,,,,aButtonConfig[5]}
    oXbp := _ExpressPushButton(::drawingArea,nButtonCol,aButtonConfig,::scaleFactor,::fitPad,self)
    oXbp:tabstop := .t.
    oXbp:create()
    nButtonCol += aButtonConfig[3] + 10
    aGetListItem[oGETLIST_OBJECT] := oXbp
    ::AddHotKey( aGetListItem[cGETLIST_CAPTION],aGetListItem[bGETLIST_ACTION], ;
                 nil, nil, oParent, oXbp, nil, .f. )
  ENDIF


  FOR i := 1 TO LEN(aButtons)
    ASIZE(aButtons[i],12)
    DEFAULT aButtons[i,2] := 70, ;
            aButtons[i,3] := 22
    AADD(aGetList,DC_GetTemplate())
    ::getListPointer := Len(aGetList)

    aGetListItem := aGetList[::getListPointer]
    aGetListItem[nGETLIST_TYPE] := GETLIST_PUSHBUTTON
    aGetListItem[cGETLIST_CAPTION] := aButtons[i,1]
    aGetListItem[bGETLIST_ACTION] := aButtons[i,4]
    aGetListItem[nGETLIST_STARTCOL] := nButtonCol * ::scaleFactor[1]
    aGetListItem[nGETLIST_STARTROW] := 15 * ::scaleFactor[2]
    aGetListItem[nGETLIST_WIDTH] := aButtons[i,2] * ::scaleFactor[3]
    aGetListItem[nGETLIST_HEIGHT] := aButtons[i,3] * ::scaleFactor[4]
    aGetListItem[cGETLIST_ID] := 'DCGUI_BUTTON_CUSTOM_'+Alltrim(Str(i))
    aGetListItem[lGETLIST_PIXEL] := .t.
    aGetListItem[xGETLIST_OPTIONS9] := {aButtons[i,12],,,,aButtons[i,6]}
    aGetListItem[oGETLIST_CONFIG] := aButtons[i,7]
    aGetListItem[bGETLIST_WHEN] := aButtons[i,8]
    aGetListItem[cGETLIST_TOOLTIP] := aButtons[i,9]
    aGetListItem[cGETLIST_FONT] := aButtons[i,10]
    aGetListITem[aGETLIST_RESIZE] := DCGUI_RESIZE_NONE
    aGetListItem[nGETLIST_ACCELKEY] := aButtons[i,11]

    IF Valtype(aButtons[i,7]) == 'O'
      #if XPPVER > 1900000
      oXbp := DC_XbpPushButtonXP():new( ::drawingArea, , ;
              {nButtonCol*::scaleFactor[1],::fitPad}, ;
              {aButtons[i,2]*::scaleFactor[3], ;
               aButtons[i,3]*::scaleFactor[4]}, nil, nil, self )
      #endif
    ELSEIF Valtype(DC_ExpressButtonStyle()) == 'O'
      #if XPPVER > 1900000
      oXbp := DC_XbpPushButtonXP():new( ::drawingArea, , ;
              {nButtonCol*::scaleFactor[1],::fitPad}, ;
              {aButtons[i,2]*::scaleFactor[3], ;
               aButtons[i,3]*::scaleFactor[4]}, nil, nil, self, DC_ExpressButtonStyle() )
      #endif
    ELSE
      oXbp := DC_XbpPushButton():new( ::drawingArea, , ;
              {nButtonCol*::scaleFactor[1],::fitPad}, ;
              {aButtons[i,2]*::scaleFactor[3], ;
               aButtons[i,3]*::scaleFactor[4]}, nil, nil, self )
    ENDIF
    oXbp:tabstop := .t.
    oXbp:create()
    oXbp:cargo := aButtons[i,5]
    nButtonCol += aButtons[i,2] + 10
    aGetListItem[oGETLIST_OBJECT] := oXbp

    aArray := aGetListItem[nGETLIST_ACCELKEY]

    IF Valtype( aArray ) $ 'AN'
      ::AddHotKey( aArray, ;
        DC_GetBlock(aGetListItem[bGETLIST_ACTION]), ;
        DC_GetBlock(aGetListItem[bGETLIST_WHEN]), ;
        DC_GetBlock(aGetListItem[bGETLIST_HIDE]), ;
        oParent, oXbp, ;
        aGetListItem[xGETLIST_CARGO], !Empty(oParent) )
    ENDIF

    cToolTip := aGetListItem[cGETLIST_TOOLTIP]

    IF !Empty(cToolTip)
      AADD(::tooltipControls,cToolTip)
      nToolTip := Len(::tooltipControls)
      oXbp:HelpLink := ;
            DC_SetHelpLink( oXbp:HelpLink, DCGUI_HELP_TOOLTIP, ;
            MagicHelpLabel():New(nToolTip,cToolTip))
    ENDIF

  NEXT

  IF !Empty(::helpObject) .AND. DC_BitTest(::buttons,4)
    aButtonConfig := DC_AddButtonConfig(DCGUI_BUTTON_HELP)
    AADD(aGetList,DC_GetTemplate())
    i := Len(aGetList)
    aGetListItem := aGetlist[i]
    aGetListItem[nGETLIST_TYPE] := GETLIST_PUSHBUTTON
    aGetListItem[cGETLIST_CAPTION] := aButtonConfig[2]
    aGetListItem[bGETLIST_ACTION] := ;
       {|| IIF( Valtype(::helpObject)='O',::helpObject:ShowHelpContents(),Eval(::helpObject)) }
    aGetListItem[nGETLIST_STARTCOL] := nButtonCol * ::scaleFactor[1]
    aGetListItem[nGETLIST_STARTROW] := 15 * ::scaleFactor[2]
    aGetListItem[nGETLIST_WIDTH] := aButtonConfig[3] * ::scaleFactor[3]
    aGetListItem[nGETLIST_HEIGHT] := aButtonConfig[4] * ::scaleFactor[4]
    aGetListItem[cGETLIST_ID] := 'DCGUI_BUTTON_HELP'
    aGetListItem[lGETLIST_TABSTOP] := .t.
    aGetListITem[aGETLIST_RESIZE] := DCGUI_RESIZE_NONE
    aGetListItem[lGETLIST_PIXEL] := .t.
    oXbp := _ExpressPushButton(::drawingArea,nButtonCol,aButtonConfig,::scaleFactor,::fitPad,self)
    oXbp:create()
    nButtonCol += aButtonConfig[3] + 10
    aGetListItem[oGETLIST_OBJECT] := oXbp
  ENDIF

ENDIF

* --- Show all application windows --- *
IF !::isHideDialog
  FOR i := 1 TO Len(::appControls)
     ::appControls[i,1]:Display(.t.,.f.)
  NEXT
ENDIF


* --- Set Focus to first tabpage in each group --- *
FOR i := Len(::tabpageControls) TO 1 STEP -1
  oXbp := ::tabpageControls[i]
  IF i = 1 .OR. !(oXbp:setParent()==::tabpageControls[i-1]:setParent())
     _TabActivate( ::tabpageControls, oXbp, .t. )
     ::Message( oXbp, .f., 0, 0 )
  ENDIF
NEXT

* --- Initialize mouse hotspots on static Button controls --- *

FOR i := 1 TO Len(::staticButtonControls)
  ::staticButtonControls[i]:mouseInit()
NEXT

IF Valtype(oBusyScreen) $ 'OA'
   DC_Impl(oBusyScreen)
   oBusyScreen := nil
ENDIF

IF Valtype(::restoreArray) == 'A'

  /*
  ::parentDlg:setPos(::restoreArray[1])
  IF !::isNoResize .AND. !::scaleFactor[6]
    ::parentDlg:setSize(::restoreArray[2])
  ENDIF

  IF !::isNoResize .AND. Valtype(::restoreArray[3]) == 'N' .AND. ;
      !(::parentDlg:getFrameState() == ::restoreArray[3])
    ::parentDlg:setFrameState(::restoreArray[3])
  ENDIF
  */

  IF ::restoreArray[2,2] > 100

    IF !::isNoResize .AND. !::scaleFactor[6]
      ::parentDlg:setSize(::restoreArray[2])
    ENDIF
    IF ::restoreArray[1,2] + ::parentDlg:currentSize()[2] > ;
      ::parentDlg:parent:currentSize()[2]
    ELSE
      ::parentDlg:setPos(::restoreArray[1])
    ENDIF

  ENDIF

  IF ::restoreArray[3] = XBPDLG_FRAMESTAT_NORMALIZED
    IF !::isNoResize .AND. Valtype(::restoreArray[3]) == 'N' .AND. ;
       !(::parentDlg:getFrameState() == ::restoreArray[3])
      ::parentDlg:setFrameState(::restoreArray[3])
    ENDIF
  ENDIF

ENDIF

IF ::scaleFactor[1] > 1 .OR. Valtype(::restoreArray) == 'A'

    #DEFINE SM_CMONITORS 80

    IF ::parentDlg:currentPos()[2] + ::parentDlg:currentSize()[2] > ::parentDlg:setParent():currentSize()[2]
      ::parentDlg:setPos({::parentDlg:currentPos()[1], ;
                          ::parentDlg:setParent():currentSize()[2]-::parentDlg:currentSize()[2]-20})
    ENDIF

    IF GetSystemMetrics(SM_CMONITORS) = 1

      IF ::parentDlg:currentPos()[1] + ::parentDlg:currentSize()[1] < 10
        ::parentDlg:setPos({0, ;
                          ::parentDlg:setParent():currentSize()[2]-::parentDlg:currentSize()[2]-20})
      ENDIF

      IF ::parentDlg:currentPos()[1] > ::parentDlg:setParent():currentSize()[1]
        ::parentDlg:setPos({::parentDlg:setParent():currentSize()[1]-100, ;
                            ::parentDlg:currentPos()[2]})
      ENDIF
    ENDIF

ENDIF

IF Valtype(::restoreArray) # 'A' .AND. ::isRestoreWindow .AND. ;
     !Empty(DC_AutoRestoreWindow()) .AND. ;
     Valtype(::parentDlg) = 'O' .AND. ;
     ::parentDlg:isDerivedFrom('XbpDialog') .AND. ;
     !Empty(::parentDlg:title) .AND. ;
     ::restoreWindow

   ::restoreArray := { ::parentDlg:currentPos(),  ;
                       ::parentDlg:currentSize(), ;
                       ::parentDlg:getFrameState(), ;
                       ::parentDlg:currentSize()}

   IF Valtype(DC_AutoRestoreWindow()[1]) == 'B'
     Eval(DC_AutoRestoreWindow()[1],ProcName(2) + ':' + ::parentDlg:title,::restoreArray,.f.)
   ELSE
     DC_RegWrite(DC_AutoRestoreWindow()[1],DC_AutoRestoreWindow()[2], ;
                 ProcName(2) + ':' + Alltrim(::parentDlg:title), ::restoreArray)
   ENDIF

ENDIF

IF !::isHideDialog .AND. IsMethod(::parentDlg,'SHOW') .AND. !::parentDlg:isVisible()
  ::parentDlg:show()
ELSEIF ::parentDlg:isDerivedFrom('DC_XbpTabPage') // .AND. !::parentDlg:lockUpdate
  ::parentDlg:show()
ENDIF

IF ::isClearEvents
  DC_ClearEvents()
  IF ::isAutoResize .AND. ::parentDlg:isDerivedFrom('XbpDialog')
    ::parentDlg:drawingArea:hide()
    DC_AutoReSize(::parentDlg:currentSize(),::parentDlg:currentSize(), ;
                  ::parentDlg,aGetList)
    ::parentDlg:drawingArea:show()
  ELSEIF ::isResize .AND. ::parentDlg:isDerivedFrom('XbpDialog')
    ::parentDlg:drawingArea:hide()
    DC_ReSize(::parentDlg:currentSize(),::parentDlg:currentSize(), ;
              ::parentDlg,aGetList,self)
    ::parentDlg:drawingArea:show()
  ENDIF
ENDIF

IF Len(::graControls) > 0
  ::paintGraControls()
ENDIF

IF ::parentDlg:isDerivedFrom('DC_XbpDialog1') .AND. ;
    Valtype(::parentDlg:menubar) == 'O' .AND. ::parentDlg:menubar:isDerivedFrom('DC_XbpMenuBar')
  DC_MenuWhenChecked(::parentDlg:menuBar)
ENDIF

DC_GetWhen(aGetList)

IF ::parentDlg:isDerivedFrom('XbpDialog') .AND. ;
     (Empty(::parentDlg:cargo) .OR. (Valtype(::parentDlg:cargo)=='A' .AND. ;
         Len(::parentDlg:cargo)==2 .AND. Valtype(::parentDlg:cargo[2])=='A' .AND. ;
             ::parentDlg:cargo[2] == aGetList))
  nHeight := ::parentDlg:currentSize()[2] - ;
          ::parentDlg:drawingArea:currentSize()[2]
  ::parentDlg:cargo := ;
     { 0, ;
       aGetList, ;
       nil, ;
       nHeight, ;
       ::statusBar, ;
       ThreadID(), ;
       self, ;
       nil, ;
       nil, ;           // resize info
       nil, ;
       { 0, 30 } }      // Drag Drop offset
ELSE
  nHeight := 0
ENDIF

IF ::isSetAppWindow
  SetAppWindow(::parentDlg)
ELSEIF Valtype(DC_ReadGuiSetAppWindow())=='O' .AND. ;
    ::parentDlg:setParent() == DC_ReadGuiSetAppWindow()
  SetAppWindow(::parentDlg)
ENDIF

* --- Set Focus to designated object --- *

::setFocus := xSetFocus

IF !Empty(::setFocus)
   IF Valtype(::setFocus) = 'O'
     oXbp := ::setFocus
   ELSE
     oXbp := DC_GetObject( aGetList, ::setFocus )
   ENDIF
   IF Valtype(oXbp) = 'O'
     SetAppFocus(oXbp)
   ENDIF
ELSEIF !Empty(::editControls) .AND. !::isExit
  FOR i := 1 TO Len(::editControls)
    oXbp := ::editControls[i]
    IF oXbp:isEnabled() .AND. oXbp:isVisible() .AND. ;
       ( Empty(oXbp:protectBlock) .OR. !Eval(oXbp:protectBlock) )
      SetAppFocus(::editControls[i])
      EXIT
    ENDIF
  NEXT
ELSEIF !Empty(oFocusButton)
  SetAppFocus(oFocusButton)
ENDIF

FOR i := 1 TO Len(::browseControls)
  PostAppEvent(xbeBRW_ItemMarked,,,::browseControls[i])
NEXT

IF ::restorePointer
  // DC_SetPointerTree(::pointerDlg)
  ::pointerDlg:SetPointer( nil, XBPSTATIC_SYSICON_SYSTEM, XBPWINDOW_POINTERTYPE_SYSPOINTER )
  ::pointerDlg:captureMouse(.f.)

  ::restorePointer := .f.
  IF Valtype(::parentDlg) = 'O' .AND. ::parentDlg:isDerivedFrom('XbpDialog')
    //DC_SetPointerTree(::parentDlg)
   ::parentDlg:SetPointer( nil, XBPSTATIC_SYSICON_SYSTEM, XBPWINDOW_POINTERTYPE_SYSPOINTER )
   ::parentDlg:captureMouse(.f.)
  ENDIF
ENDIF

IF Valtype( ::evalBlock ) = 'B'
  Eval( ::evalBlock, ::parentDlg, ::getListArray, self )
ENDIF

IF !Empty(::busyMsg) // $MR
   ProgressBar(2,,,,oProgress,oDialog)                        // $MR
ENDIF                                    // $MR

IF !Empty(::statusBar)
  DC_StatusBarRepaint(::parentDlg)

  #if XXPVER > 1900000

    ::parentDlg:reSize := DC_MergeBlocks(::parentDlg:reSize, ;
                         {|a,b,o|DC_StatusBarRePaint(o)})
  #else

    ::parentDlg:reSize := DC_MergeBlocks( ;
                         {|a,b,o|DC_StatusBarRePaint(o)}, ;
                            ::parentDlg:reSize)
  #endif
ENDIF

::PaintGraControls()

bEval := DC_ReadGuiEval()
IF Valtype(bEval) == 'B'
  Eval( bEval, ::parentDlg )
ENDIF

IF !Empty(::postEvent)
  PostAppEvent(::postEvent,,,::parentDlg)
ENDIF

IF ::lockWindowToOwner
  ::parentDlg:move := {|aOld,aNew,oWindow|DC_LockWindowToOwner(aOld,aNew,oWindow,::owner)}
ENDIF

* --- EXIT clause was used --- *

IF ::isExit
  IF Valtype(::parentDlg) == 'O' .AND. IsMethod(::parentDlg,'INVALIDATERECT')
    ::parentDlg:invalidateRect()
  ENDIF
  BREAK
ENDIF

* --- Store profile info --- *

IF ::isStoreProfile
  FOR i := Len(aGetList) TO 1 STEP -1
    IF Valtype(aGetList[i,aGETLIST_PROFILE])=='A'
      oXbp := aGetList[i,oGETLIST_OBJECT]
      IF Valtype(oXbp)=='O'
        oParent := oXbp:parent
        IF Valtype(oParent) == 'O'
          nFound := AScan(aGetList,{|a|a[oGETLIST_OBJECT]==oParent})
          IF nFound > 0 .AND. Valtype(aGetList[nFound,aGETLIST_PROFILE])=='A'
            aGetList[nFound,aGETLIST_PROFILE,2] += ;
               (aGetList[i,aGETLIST_PROFILE,1] + aGetList[i,aGETLIST_PROFILE,2])
          ENDIF
        ENDIF
      ENDIF
    ENDIF
  NEXT
ENDIF

* --- Start up Event Loop --- *

::referenceData := xRef

::EventLoop(nil,nil,nil,@xRef)

ReadInsert( lReadInsert )

IF ::isDestroy
  SetAppFocus(::parentDlg:setOwner())
  IF ::parentDlg:status() > 0
    ::parentDlg:setModalState(XBP_DISP_MODELESS)
    oWinMenu := DC_WinMenu()
    IF Valtype(oWinMenu) == 'O' .AND. !::autoWinMenu
      DC_WinMenu():delItem(::parentDlg)
    ENDIF

    DC_RestoreWindow(self,3)

    ::parentDlg:Destroy()

  ENDIF
  IF Valtype(::helpObject) = 'O'
    ::helpObject:destroy()
  ENDIF

ELSEIF !::parentDlg:isDerivedFrom("DC_XbpDialog1")

 lToolTips := DC_ToolTipEnable() .AND. ;
   (Len(::tooltipControls) > 0 .OR. ::isDataToolTips)

// IF Valtype(oMagicHelpThread) == 'O' .AND. lToolTips
 IF Valtype(DC_HelpThreadObject()) == 'O' .AND. lToolTips  // Jack Duijf 17-07-2014
   IF DC_TooltipThread() == 2
//
// 02-04-2011 J. Duijf Tooltip thread is removed in ::Eventloop
//
//     DC_HelpThreadObject():RemoveTooltip()
   ELSE
    // oMagicHelpThread:terminate()
     DC_HelpThreadObject():terminate()
//     oMagicHelpThread:Synchronize(0)
     DC_HelpThreadObject():Synchronize(0)  // Jack Duijf 17-07-2014
   ENDIF
 ENDIF

ENDIF

END SEQUENCE

IF ::restorePointer
  // DC_SetPointerTree(::pointerDlg)
  ::pointerDlg:SetPointer( nil, XBPSTATIC_SYSICON_SYSTEM, XBPWINDOW_POINTERTYPE_SYSPOINTER )
  ::pointerDlg:captureMouse(.f.)
ENDIF

IF ::parentDlg:isDerivedFrom('XbpIWindow') .AND. !::isExit
  oParent := ::parentDlg:setParent()
  IF Valtype(oParent)=='O' .AND. oParent:isDerivedFrom('XbpDialog') ;
     .AND. Valtype(oParent:menuBar) == 'O' .AND. ;
       oParent:menuBar == DC_SetAppMenu()
    oWinMenu := DC_WinMenu()
    IF Valtype(oWinMenu)=='O'
      oWinMenu:delitem(::parentDlg)
    ENDIF
  ENDIF
ENDIF

IF Valtype(oBusyScreen) $ 'OA'
   DC_Impl(oBusyScreen)
   oBusyScreen := nil
ENDIF

DC_Gui()

IF ::lastEvent # DCGUI_NONE .OR. ::isGetlistUndo
  ::isOkStatus := ::lastEvent # DCGUI_EXIT_ABORT .AND. !::isGetlistUndo
  ::lastEvent := DCGUI_NONE
  IF !::isOkStatus
    DC_GetListUndo(aGetList)
  ENDIF
ENDIF

IF Valtype(::saveAppWindow) = 'O' .AND. ::saveAppWindow:status() # 0
  SetAppWindow(::saveAppWindow)
ENDIF

IF !::isExit .AND. Valtype(::saveAppFocus) = 'O' .AND. ::isDestroy .AND. ::saveAppFocus:status() > 0
  DC_CompleteEvents()
  SetAppFocus(::saveAppFocus)
ENDIF

RETURN ::IsOkStatus

* -------------------------

GETSETFUNCTION DC_aMagicHelp DEFAULT {}   // <-TW

* -------------------------

FUNCTION DC_ReadGuiEventLoop( aGetList, bEventHandler, nEvent, oParentDlg, ;
                              xRef, anTimeOut, nWait, lMultiLists, lNoKeyPress )

LOCAL oGetList

oGetList := DC_GetListObject( aGetList )

RETURN oGetList:EventLoop( bEventHandler, nEvent, oParentDlg, @xRef, anTimeOut, ;
                           nWait, lMultiLists, nil, lNoKeyPress )

* ------------------------

FUNCTION DC_GetListObject( aGetList )

LOCAL nDataStore, oGetList

IF Valtype(aGetList) == 'A'
  nDataStore := AScan(aGetList,{|a|a[nGETLIST_TYPE]==GETLIST_DATASTORE})
  IF nDataStore > 0
    oGetList := aGetList[nDataStore,oGETLIST_OBJECT]
  ENDIF
ENDIF

RETURN oGetList

* ------------------------

METHOD DC_GetList:EventLoop( bEventHandler, nEvent, oParentDlg, xRef, anTimeOut, ;
                             nWait, lMultiLists, lExitWhenQueueEmpty, lNoKeyPress )

LOCAL oXbp, nDataStore, oEventSpy, mp1, mp2, i, aData, ;
      bBlock, nHotkey, lHitBottom, nWidth, nHeight, nDragMode := 0, nCursor, ;
      nPointer, nSeconds := Seconds(), oAppFocus, nLastKey := 0, ;
      lEditNav, oLastXbp, nLastCursor := 0, aEditorGetList, oHelpLink, ;
      lLoadSpy, GetList, GetOptions, cSource, cSourceLine, nStartPos, ;
      nEndPos, cMemo, lOk, aCoords, aTokens, cSaveSource, oMove, ;
      nTimeOut, bTimeOut, aMasterGetList, nMasterDataStore, aPos, ;
      oMasterParentDlg, nSaveRecord, nCellRecord, nOffset, aGetList, ;
      oGetList, bDotBlock, nThreadID := ThreadID(), lToolTips, oHelp, ;
      lToolTipCreated, oDrop, nDropSeconds, lDrop, oWaitXbp, nSkipped, ;
      lGetWhen, dTimeOut, nElapSeconds

DC_ValidateSkip(.f.)

IF Type('plDataLink') # 'L'
  PRIVATE plDataLink := .t.
ENDIF

DEFAULT aGetList := ::getListArray
DEFAULT lExitWhenQueueEmpty := .F.

IF Valtype(bEventHandler) # 'B'
  bEventHandler := ::eventHandlerBlock
ENDIF
IF Valtype(xRef) == 'U'
  xRef := ::referenceData
ENDIF
IF Valtype(anTimeOut) == 'U'
  anTimeOut := ::timeout
ENDIF
IF Valtype(oParentDlg) == 'U'
  oParentDlg := ::parentDlg
ENDIF
IF Valtype(nWait) == 'U'
  nWait := ::wait
ENDIF
IF Valtype(lMultiLists) == 'U'
  lMultiLists := ::isMultiLists
ENDIF
IF Valtype(lNoKeyPress) == 'U'
  lNoKeyPress := ::isNoKeyPress
ENDIF

DEFAULT nWait := 0
IF lExitWhenQueueEmpty
  nWait := .1
ENDIF

IF !Empty(anTimeOut)
  IF nWait = 0
    nWait := 10
  ENDIF
  IF Valtype(anTimeOut) = 'A' .AND. Len(anTimeOut) = 2
    nTimeOut := anTimeOut[1]
    bTimeOut := anTimeOut[2]
  ELSEIF Valtype(anTimeOut) = 'N'
    nTimeOut := anTimeOut
  ENDIF
ENDIF

oXbp := SetAppFocus()

nEvent := xbeP_None
DC_GetEditUpdated(.t.)

nDataStore := ::AddDataStore()

::isDialogActive := .t.
::lastEvent := DCGUI_NONE
::loopWhenBlock := DC_ReadGuiEventLoopWhen()

* --- Enable Tooltip thread --- *
lToolTips := DC_ToolTipEnable() .AND. ;
   !lExitWhenQueueEmpty .AND. ;
   (Len(::tooltipControls) > 0 .OR. lMultiLists .OR. ::isDataToolTips)

IF lToolTips
  IF Len(DC_aMagicHelp()) < nThreadID                          // <-TW
    DC_aMagicHelp( ASize( DC_aMagicHelp(),nThreadID ) )        // <-TW
  ENDIF
  IF Valtype(DC_aMagicHelp()[nThreadID]) == 'O'                // <-TW
    lToolTips := .f.
  ENDIF
ENDIF

IF lToolTips
  IF DC_ToolTipThread() = 2  // <<< Jack Duijf's Single-Thread system
    IF ValType(DC_HelpThreadObject()) # "O"                                                         // No Tooltip thread running
      DC_HelpThreadObject(JD_MagicHelpThread():New()) // Create tooltip thread
      Sleep(10)
      DC_HelpThreadObject():Start()                            // And start it.
    ENDIF
    oHelp := JD_MagicHelp():New()
  ELSE // <<< Standard Multi-Thread system
    oHelp := MagicHelp():New()
    DC_aMagicHelp()[nThreadID] := oHelp                        // <-TW
  ENDIF
  IF Valtype(::getOptions[aGETOPT_TOOLCOLOR]) = 'A'
    ASize(::getOptions[aGETOPT_TOOLCOLOR],2)
    DEFAULT ::getOptions[aGETOPT_TOOLCOLOR,1] := GRA_CLR_BLACK
    DEFAULT ::getOptions[aGETOPT_TOOLCOLOR,2] := GRA_CLR_WHITE
    oHelp:aToolColor := ::getOptions[aGETOPT_TOOLCOLOR]
  ENDIF
  oHelp:cToolFont := ::getOptions[cGETOPT_TOOLFONT]
  oHelp:nToolTime := ::getOptions[nGETOPT_TOOLTIME]
  IF DC_ToolTipThread() = 2
    lTooltipCreated := DC_HelpThreadObject():AddToolTip(oHelp)
  ELSE
    Sleep(5)
    oHelp:start()
  ENDIF
  IF IsMemberVar(oParentDlg,'oMagicHelp')
    IF DC_ToolTipThread() = 2
      oParentDlg:oMagicHelp  := DC_HelpThreadObject()  // <<< Jack Duijf
      oParentDlg:lCreated := lToolTipCreated
    ELSE
      oParentDlg:oMagicHelp  := oHelp  // <<< Jack Duijf
    ENDIF
  ENDIF
ENDIF

* --- Process Messages --- *
::Message( oXbp, .f., 0, 0 )

IF Valtype(bEventHandler)='B'
  Eval( bEventHandler, @nEvent, nil, nil, nil, oParentDlg, aGetList, @xRef, .f. )
ENDIF

lLoadSpy := snEventSpy > 0

oGetList := self
aMasterGetList := aGetList
nMasterDataStore := nDataStore
oMasterParentDlg := oParentDlg

* --- Start Event Loop --- *

dTimeOut := Date()
nElapSeconds := 0
DO WHILE TRUE

  IF !oGetList:isDialogActive
    EXIT
  ENDIF

  IF !Empty(nTimeOut)
    IF Date() > dTimeOut
      nSeconds := -1*nElapSeconds
      dTimeOut := Date()
    ELSE
      nElapSeconds := Seconds() - nSeconds
    ENDIF
    IF nElapSeconds > nTimeOut
      IF Valtype(bTimeOut) = 'B' .AND. !Eval(bTimeOut)
        nSeconds := Seconds()
        nElapSeconds := 0
      ELSE
        oGetList:IsOkStatus := .t.
        EXIT
      ENDIF
    ENDIF
  ENDIF

  IF oGetList:lastEvent = DCGUI_NONE
    IF snEventSpy > 0
      nEvent := DllCall( snEventSpy, DLL_XPPCALL, 'SpyAppEvent', ;
                @mp1, @mp2, @oXbp, IIF( Empty(nTimeOut), 0, 10 ) )
    ELSE
      nEvent := AppEvent( @mp1, @mp2, @oXbp, ;
               IIF( Empty(nTimeOut), IIF(Empty(::keyboardQueue),nWait,1), Min(nWait,10) ) )
    ENDIF

    // if there are Keyboard-Events in :keyboardQueue (dc_readguitypeahead()),
    // "new" Keyboard-Events have to add to the :keyboardQueue... Thanks to Markus Walter for this fix
    IF !Cliff()
      IF nEvent == xbeP_Keyboard .and. !Empty(::keyboardQueue) .AND. Empty(mp2)
        AAdd(::keyboardQueue, mp1)
        LOOP
      ENDIF
    ENDIF

    IF nEvent = 0 .OR. (nEvent = xbeM_Motion .AND. mp1 == NIL) .OR. Valtype(oXbp) # 'O'
      IF lExitWhenQueueEmpty
        RETURN .T.
      ELSEIF nWait == 0
        DO WHILE !Empty(::keyboardQueue)
          PostAppEvent( xbeP_Keyboard, ::keyboardQueue[1],'QUEUE',SetAppFocus() )
          ARemove(::keyboardQueue,1)
        ENDDO
        /*
        IF !Empty(::keyboardQueue)
          PostAppEvent( xbeP_Keyboard, ::keyboardQueue[1],'QUEUE',SetAppFocus() )
          ARemove(::keyboardQueue,1)
        ENDIF
        */
        LOOP
      ENDIF
    ELSEIF Valtype(oGetList:loopWhenBlock) = 'B' .AND. !Eval(oGetList:loopWhenBlock)
      LOOP
    ELSEIF !lNoKeyPress
      nSeconds := Seconds()
    ELSEIF nEvent == xbeP_Keyboard
      nTimeOut := 0
    ENDIF

  ENDIF

  BEGIN SEQUENCE

  IF lMultiLists .AND. Valtype(oXbp)='O'
    IF IsMemberVar(oXbp,'GETLIST') .AND. Valtype(oXbp:GetList) == 'O' .AND. ;
       IsMemberVar(oXbp:GetList,'GETLISTARRAY')
      oGetList := oXbp:GetList
      aGetList := oGetList:getListArray
      oParentDlg := oGetList:parentDlg
    ELSEIF oXbp:isDerivedFrom('XbpDialog') .AND. Valtype(oXbp:cargo) == 'A' .AND. Len(oXbp:cargo) >= 9 .AND. ;
           Valtype(oXbp:cargo[7]) == 'O' .AND. oXbp:cargo[7]:isDerivedFrom('DC_GetList')
      oGetList := oXbp:cargo[7]
      aGetList := oGetList:getListArray
      oParentDlg := oGetList:parentDlg
    ELSEIF !(oGetList == self)
      oGetList := self
    ENDIF
  ENDIF

  IF (Valtype(DC_ReadGuiHandler()) == 'B' .OR. ;
      Valtype(bEventHandler)='B' .OR. !Empty(oGetList:designKey) .OR. ;
      ::lastEvent # DCGUI_NONE)

    IF oGetList:lastEvent == DCGUI_NONE

      IF !Empty(oGetList:designKey) .AND. ;
          (nEvent == xbeP_Keyboard .AND. mp1 == oGetList:designKey) .OR. oGetList:isDesignOn
        oGetList:lastEvent := ;
         DC_DesignHandler( @nEvent, @mp1, @mp2, oXbp, oParentDlg, ;
                           aGetList, self )
      ENDIF

      IF oGetList:lastEvent == DCGUI_NONE .AND. Valtype(DC_ReadGuiHandler()) == 'B'
        oGetList:lastEvent := ;
         Eval( DC_ReadGuiHandler(), @nEvent, @mp1, @mp2, oXbp, oParentDlg, ;
               aGetList, @xRef, oGetList:IsOkStatus )
      ENDIF

      IF oGetList:lastEvent == DCGUI_NONE .AND. Valtype(bEventHandler)=='B'
        oGetList:lastEvent := ;
         Eval( bEventHandler, @nEvent, @mp1, @mp2, oXbp, oParentDlg, ;
               aGetList, @xRef, oGetList:IsOkStatus )
      ENDIF

    ENDIF

    IF Valtype(oGetList:lastEvent) = 'N'
      IF oGetList:lastEvent == DCGUI_EXIT .OR. oGetList:lastEvent == DCGUI_EXIT_OK
        DC_GetGather(aGetList)
        // DC_ReadGuiExit(aGetList)
        DC_ReadGuiExit(oGetList)
        IF !oGetList:isDialogActive
          nEvent := xbeP_Close
        ENDIF
        oGetList:lastEvent := DCGUI_NONE
        BREAK
      ELSEIF oGetList:lastEvent == DCGUI_IGNORE
        oGetList:lastEvent := DCGUI_NONE
        BREAK
      ELSEIF oGetList:lastEvent == DCGUI_CLEAR
        DC_ClearEvents()
        oGetList:lastEvent := DCGUI_NONE
        BREAK
      ELSEIF oGetList:lastEvent == DCGUI_EXIT_ABORT
        DC_ReadGuiAbort(aGetList)
        IF !oGetList:isDialogActive
          nEvent := xbeP_Close
        ENDIF
        oGetList:lastEvent := DCGUI_NONE
        BREAK
      ELSEIF oGetList:lastEvent >= DCGUI_MOVE_UP .AND. oGetList:lastEvent <= DCGUI_MOVE_BOTTOM_PAR
        _SetFocus( aGetList, oXbp, oGetList:lastEvent )
        oGetList:lastEvent := DCGUI_NONE
        BREAK
      ENDIF
    ELSE
      oGetList:lastEvent := DCGUI_NONE
    ENDIF
  ENDIF

  // drag-drop stuff
  #if XPPVER > 1900000

  IF nEvent == xbeM_Enter

    IF oXbp:isDerivedFrom('XbpCellGroup')
      oDrop := oXbp:parent
    ELSE
      oDrop := oXbp
    ENDIF
    IF !Empty(DC_DropData()[1]) // .AND. !(DC_DropData()[3]==oDrop)
      IF IsMemberVar(oDrop,'DROPBLOCK') .AND. Valtype(oDrop:dropBlock) == 'B' .AND. ;
         oDrop:dropType == DC_DropData()[2]
        nCursor := oDrop:dropCursor
        IF Valtype(nCursor) == 'B'
          nCursor := Eval(nCursor,oXbp,oDrop)
        ENDIF
        DEFAULT nCursor := POINTER_DATADROP_COPY
        oXbp:setPointer(,nCursor)
      ENDIF
    ENDIF

  ELSEIF nEvent == xbeM_Leave

    IF !Empty(DC_DropData()[1]) .AND. oXbp:isDerivedFrom('XbpScrollbar') .AND. ;
      oXbp:type == XBPSCROLL_HORIZONTAL .AND. oXbp:parent:isDerivedFrom('XbpBrowse')
      DC_ClearEvents()
    ELSEIF !Empty(DC_DropData()[1]) .AND. oXbp:isDerivedFrom('XbpCellGroup') .AND. ;
        oXbp == oXbp:setParent():heading
      DC_ClearEvents()
    ENDIF

  ELSEIF nEvent == xbeM_LbUp

    IF oXbp:isDerivedFrom("XbpCellGroup") .OR. ;
         (oXbp:isDerivedFrom('XbpIWindow') .AND. oXbp:parent:isDerivedFrom('DC_XbpDialog1'))
      oDrop := oXbp:parent
    ELSE
      oDrop := oXbp
    ENDIF

    IF !Empty(DC_DropData()[1]) // .AND. !(oDrop == DC_DropData()[3])
      IF IsMemberVar(oDrop,'DROPBLOCK') .AND. Valtype(oDrop:dropBlock) == 'B' .AND. ;
          oDrop:dropType == DC_DropData()[2]
        Eval( oDrop:dropBlock, oDrop, DC_DropData()[1], mp1, mp2 )
      ENDIF
    ENDIF
    IF !Empty(DC_DropData()[1])
      DC_PointerArrow()
    ENDIF
    IF !Empty(soDragDialog)
      soDragDialog:destroy()
      soDragDialog := nil
    ENDIF
    DC_DropData(nil,nil,nil)

  ELSEIF nEvent == xbeM_LbDown

    IF Valtype(soDragDialog) == 'O'
      soDragDialog:destroy()
      soDragDialog := nil
    ENDIF

    IF oXbp:isDerivedFrom("XbpCellGroup")
      oDrop := oXbp:parent
      IF oXbp == oXbp:setParent():childList()[1] // was mouse clicked in header?
        IF IsMemberVar(oDrop,'heading') // .AND. 'oColumn:Sort' $ DC_GetCodeBlockText(oDrop:heading:lbDown)
          oDrop := nil
        ENDIF
      ENDIF
//      DC_CompleteEvents()  <<< this causes validations to fail when clicking into a browse
    ELSEIF oXbp:isDerivedFrom("XbpTreeView")
      oDrop := oXbp
      oDrop:handleEvent(nEvent,mp1,mp2)
      oXbp := nil
    ELSE
      oDrop := oXbp
    ENDIF

    Sleep(1)

    IF Empty(DC_DropData()[1]) .AND. !Empty(oDrop)
      IF IsMemberVar(oDrop,'DRAGBLOCK') .AND. Valtype(oDrop:dragBlock) == 'B'
        IF !oDrop:isDerivedFrom("XbpTreeView")
          oDrop:handleEvent(nEvent,mp1,mp2)
        ENDIF
        lDrop := .t.
        nDropSeconds := Seconds()
        aPos := mp1
        lDrop := .f.
        DO WHILE Seconds() - nDropSeconds < .50
          IF Empty(snEventSpy)
            nEvent := AppEvent(@mp1,@mp2,@oWaitXbp,10)
          ELSE
            nEvent := DllCall( snEventSpy, DLL_XPPCALL, 'SpyAppEvent', ;
                      @mp1, @mp2, @oWaitXbp, 10 )
          ENDIF
          IF Valtype(oWaitXbp) == 'O' .AND. nEvent # 0
            oWaitXbp:handleEvent(nEvent,mp1,mp2)
          ENDIF
          IF nEvent == xbeM_Motion .AND. ( Abs(aPos[1]-mp1[1]) > 10 .OR. Abs(aPos[2]-mp1[2]) > 10 )
            lDrop := .t.
            EXIT
          ELSEIF nEvent == xbeM_LbUp .OR. nEvent == xbeTV_ItemMarked .OR. nEvent == xbeTV_ItemSelected
            lDrop := .f.
            EXIT
          ENDIF
        ENDDO

        IF lDrop
          BEGIN SEQUENCE
          IF oDrop:isDerivedFrom("XbpTreeView")
            oDrop:setData(oDrop:itemFromPos(aPos))
            IF Empty(oDrop:getData())
              BREAK
            ENDIF
          ENDIF
          aData := Eval(oDrop:dragBlock,oDrop)
          IF aData # nil
            DC_DropData( aData, oDrop:dragType, oDrop )
            DC_PointerNo()
            IF Valtype(oDrop:dragDialogBlock) == 'B'
              soDragDialog := Eval(oDrop:dragDialogBlock,mp1,mp2,oDrop)
            ENDIF
          ENDIF
          END SEQUENCE
        ENDIF
      ENDIF
    ENDIF

  ELSEIF nEvent == xbeM_Motion .AND. Valtype(soDragDialog) = 'O'

    lDrop := .f.
    IF !Empty(DC_DropData()[1]) .AND. oXbp:isDerivedFrom('XbpScrollbar') .AND. ;
      oXbp:type == XBPSCROLL_HORIZONTAL .AND. oXbp:parent:isDerivedFrom('XbpBrowse') .AND. ;
      !Empty(oXbp:leave)
      oDrop := oXbp:parent
      oDrop:down()
      oDrop:forceStable()
      Sleep(5)
      lDrop := .t.
      PostAppEvent(xbeM_Motion,{0,0},,oXbp)
    ELSEIF !Empty(DC_DropData()[1]) .AND. oXbp:isDerivedFrom('XbpCellGroup') .AND. ;
        oXbp == oXbp:setParent():heading .AND. !Empty(oXbp:leave)
      oDrop := oXbp:parent:parent
      oDrop:up()
      oDrop:forceStable()
      Sleep(5)
      lDrop := .t.
      PostAppEvent(xbeM_Motion,{0,0},,oXbp)
    ENDIF
    IF !lDrop
      aPos := DC_CalcAbsolutePosition(mp1,oXbp)
      IF soDragDialog:isDerivedFrom('DC_XbpDialog1')
        aPos[1] -= soDragDialog:cargo[11,2]
        aPos[2] -= (soDragDialog:currentSize()[2] + soDragDialog:cargo[11,1])
        soDragDialog:setPos( aPos )
      ELSE
        aPos[2] -= (soDragDialog:currentSize()[2] + 30)
        soDragDialog:setPos( aPos )
      ENDIF
    ENDIF

  ELSEIF nEvent == DCGUI_EVENT_DRAGDROP

    IF oXbp:isDerivedFrom("XbpCellGroup")
      oDrop := oXbp:parent
    ELSE
      oDrop := oXbp
    ENDIF

    IF IsMemberVar(oDrop,'DROPBLOCK') .AND. Valtype(oDrop:dropBlock) == 'B'
      Eval( oDrop:dropBlock, oDrop, mp2, mp1 )
    ENDIF

  ELSEIF nEvent == DCGUI_EVENT_ACTION

    Eval(mp1,mp2)

  ENDIF

  #endif

  lEditNav := nEvent == xbeP_Keyboard  .AND. _NavKey( oXbp, @mp1 )

  IF lEditNav .AND. Valtype(oGetList:noEditNavKeyBlock) = 'B'
    lEditNav := Eval(oGetList:noEditNavKeyBlock)
  ENDIF

  IF oGetList:isEnterTab .AND. lEditNav .AND. _IsNavEnterTabObject(oXbp)
     IF ( mp1 = xbeK_ENTER .OR. mp1 = K_ENTER .OR. mp1 = xbeK_DOWN )
       PostAppEvent( xbeP_Keyboard, xbeK_TAB, nil, oXbp )
       BREAK
     ELSEIF ( mp1 == xbeK_UP )
       PostAppEvent( xbeP_Keyboard, xbeK_SH_TAB, nil, oXbp )
       BREAK
     ENDIF
  ENDIF

  IF Valtype(oXbp) # 'O'
    BREAK
  ELSEIF nEvent = xbeM_LbUp .AND. Valtype(oXbp:cargo) = 'A' .AND. ;
         Len(oXbp:cargo) = 1 .AND. Valtype(oXbp:cargo[1]) = 'A' .AND. ;
         Len(oXbp:cargo[1]) = 3 .AND. Valtype(oXbp:cargo[1,3]) = 'O' .AND. ;
         oXbp:cargo[1,3]:isDerivedFrom('DC_XbpGet') // it's a popup button
    IF mp1[1] < 0 .OR. mp1[2] < 0 .OR. mp1[1] > oXbp:currentSize()[1] .OR. ;
       mp1[2] > oXbp:currentSize()[2]
       SetAppFocus(oXbp:cargo[1,3])
    ENDIF
    // the below code prevents validations from getting fired when selecting another window
  ELSEIF (nEvent = xbeP_KillDisplayFocus .AND. oXbp == oParentDlg)

    oGetList:IsDisplayFocus := .f.
    IF SetAppFocus() $ oGetList:editControls .AND. SetAppFocus():status() = XBP_STAT_CREATE
      oGetList:lastFocus := SetAppFocus() // this fixes problem of validation getting skipped when clicking to another window and then back to a different Get
    ENDIF

  ELSEIF nEvent == xbeP_SetInputFocus .AND. oXbp:isDerivedFrom('XbpColumn')

  ELSEIF (nEvent = xbeP_SetDisplayFocus .OR. nEvent = xbeP_SetInputFocus .OR. nEvent = xbeP_Resize ) ;
         .AND. Valtype(oParentDlg)='O' .AND. ;
         (oXbp == oParentDlg .OR. (oParentDlg:isDerivedFrom('XbpDialog') .AND. ;
         oXbp == oParentDlg:drawingArea .AND. ;
          !oParentDlg:getFrameState()==XBPDLG_FRAMESTAT_MINIMIZED))

    IF Valtype(oGetList:lastFocus) = 'O' .AND. ;
         !_EditProtected( oGetList:lastFocus, .f., oParentDlg, oGetList ) ;
         .AND. oGetList:lastFocus:isVisible()

      IF oGetList:lastFocus:status() == XBP_STAT_CREATE .AND. !oXbp:owner:isDerivedFrom('DC_XbpDialog1')
        IF IsMemberVar(oGetList:lastFocus,"goHomeOnSetFocus")
          oGetList:lastFocus:goHomeOnSetFocus := .f.
        ENDIF
        SetAppFocus(oGetList:lastFocus)
      ELSE
        oGetList:lastFocus := nil
      ENDIF

      IF  DC_ClearLastFocusWhenMinimized ()
        oGetList:lastFocus := nil  // <<< for Cliff Wiernik (2/11/2009)
      ENDIF

    ENDIF
    oGetList:IsDisplayFocus := .t.
  ELSEIF nEvent == xbeP_ActivateItem .AND. oXbp:isDerivedFrom('DC_XbpMenu') .AND. ;
    AppKeyState(xbeK_SHIFT) == 1 .AND. Valtype(DC_XbpMenuShift())=='B'
    IF mp1 == 0
      oXbp := _GetChildMenuItem( oXbp, @mp1, mp2 )
    ENDIF
    Eval(DC_XbpMenuShift(),oXbp:items[mp1], ;
         IIF(Valtype(oXbp:cargo)=='A'.AND.Len(oXbp:cargo)>=9,oXbp:cargo[9,mp1],nil))
     BREAK
  ELSEIF (nEvent $ {xbeP_ItemMarked,xbeP_ActivateItem,xbeMENB_EndMenu} ;
         .AND. IsMethod(oXbp,'handleMessage'))
    oXbp:handleMessage(nEvent,mp1,oParentDlg)
  ELSEIF (nEvent = xbeP_ItemMarked .AND. oXbp:isDerivedFrom('XbpMenuBar')) .OR. ;
         (nEvent = xbeP_ItemSelected .AND. oXbp:isDerivedFrom('DC_WindowMenu'))
    DC_ValidateSkip(.t.)

  ELSEIF (nEvent = xbeM_LbDown .AND. ;
        (oXbp:isDerivedFrom('XbpStatic') .OR. oXbp:isDerivedFrom('XbpIWindow')))
    DC_ValidateSkip(.t.)
  ELSEIF (nEvent = xbeM_LbUp .AND. ;
        (oXbp:isDerivedFrom('XbpStatic') .OR. oXbp:isDerivedFrom('XbpIWindow')))
    DC_ValidateSkip(.f.)
  ELSEIF nEvent == xbeMENB_BeginMenu
    // DC_ValidateSkip(.t.)
    DC_MenuWhenChecked(oXbp)
  ELSEIF nEvent == xbeMENB_EndMenu
    /*
    IF !(NextAppEvent() == xbeP_ItemSelected)
      DC_ValidateSkip(.f.)
    ENDIF
    */
  ELSEIF nEvent = xbeP_SetInputFocus
    IF !oXbp:isDerivedFrom("XbpIWindow") .AND. ;
       !oXbp:isDerivedFrom("XbpCrt") .AND. ;
       !oXbp:isDerivedFrom("XbpDialog") .AND. ;
       (oGetList:autoFocus .OR. ;
        DC_IsGetEditControl(oXbp) .OR. ;
        (oXbp:isDerivedFrom('XbpPushButton') .AND. ;
           (Empty(oXbp:activate) .OR. !'_PopUpButtonActivate' $ DC_GetCodeBlockText(oXbp:activate))) .OR. ;
        oXbp:isDerivedFrom('XbpCellGroup') .OR. ;
        oXbp:isDerivedFrom('XbpBrowse') .OR. ;
        oXbp:isDerivedFrom('XbpColumn'))

      IF !_EditProtected( oXbp, .f., oParentDlg, oGetList)
        IF oXbp:status() == XBP_STAT_CREATE
          oGetList:lastFocus := oXbp
        ENDIF
      ENDIF
    ELSE
      oGetList:lastFocus := nil
    ENDIF
    DC_ValidateSkip(.f.)
  ELSEIF nEvent = xbeM_LbDown .AND. Valtype(oGetList:onClickBlock) = 'B'
    Eval(oGetList:onClickBlock,oXbp,GetList)
  ELSEIF nEvent = xbeP_HelpRequest
    DC_ClearEvents()
    oHelpLink := DC_GetHelpLink(oXbp,DCGUI_HELP_REQUEST)
    IF oHelpLink == NIL
      oHelpLink := DC_GetHelpLink(oParentDlg,DCGUI_HELP_REQUEST)
    ENDIF
    IF Valtype(oHelpLink) # 'O' .AND. oXbp:isDerivedFrom('XbpBrowse')
      oHelpLink := DC_GetHelpLink(oXbp:GetColumn(oXbp:colpos),DCGUI_HELP_REQUEST)
    ENDIF
    IF Valtype(oHelpLink) # 'O' .AND. oXbp:isDerivedFrom('XbpTreeView')
      oHelpLink := DC_GetHelpLink(oXbp:getData(),DCGUI_HELP_REQUEST)
    ENDIF

    IF Valtype(oHelpLink) = 'O' .AND. IsMethod(oHelpLink,'ShowHelpLink')
       oAppFocus := SetAppFocus()
       oHelpLink:ShowHelpLink()
       SetAppFocus(oAppFocus)
    ELSEIF Valtype(oHelpLink) = 'B'
       nPointer := oXbp:cargo[1]
       Eval(oHelpLink,oXbp:cargo[2,nPointer,cGETLIST_HELPCODE])
    ELSEIF !Empty(oGetList:helpFile) .AND. Valtype(oGetList:helpFile) = 'C'
       ::helpObject:showHelpContents()
    ENDIF
    BREAK
  ELSEIF (nPointer := AScan( ::userEvents, {|a|a[1]==nEvent})) > 0
    Eval( ::userEvents[nPointer,2], mp1, mp2, oXbp )
  ELSEIF !nEvent $ { xbeM_Motion, ;
                     xbeP_Resize, ;
                     xbeP_Paint, ;
                     xbeP_Move, ;
                     xbeM_Leave, ;
                     xbeM_Enter, ;
                     xbeP_KillInputFocus, ;
                     xbeMLE_HScroll, ;
                     xbeMLE_VScroll, ;
                     xbeBRW_ItemMarked, ;
                     xbeP_PresParamChanged, ;
                     xbeP_MeasureItem, ;
                     xbeP_DrawItem, ;
                     xbeP_DragEnter, ;
                     xbeP_DragMotion, ;
                     xbeP_DragLeave, ;
                     xbeP_DragDrop } .AND. ;
         !oXbp:isderivedFrom('XBPCOLUMN') .AND. ;
         !oXbp:isderivedFrom('XBPCELLGROUP')

    IF _EditProtected( oXbp, lEditNav, oParentDlg, oGetList, nEvent )
      oGetList:Message( oXbp, .F., mp1, nEvent )
      BREAK
    ENDIF

  ENDIF

  IF nEvent = xbeP_KillInputFocus

    IF !oXbp:IsDerivedFrom('XBPCRT')
      IF IsMethod(oXbp,'GETDATA') .AND. oXbp:isderivedFrom('XBPSLE')
        DC_GetDataLink(.f.)
        IF !(oXbp:isDerivedFrom('DC_XbpGet')) .OR. oXbp:isGetDataOnLostFocus
          oXbp:GetData()
        ENDIF
        DC_GetDataLink(.t.)
      ENDIF

      DC_GetWhen(aGetList)
      IF oGetList:isDisplayFocus .AND. !DC_ValidateSkip()
        IF _EditProtected( oXbp, .f., oParentDlg, oGetList)
          DC_HiliteGets(oXbp,2,GRA_CLR_BACKGROUND)
          IF oXbp:isDerivedFrom('DC_XbpGet')
            DC_ColorGets(oXbp,2,oGetList:colorGets)
          ENDIF
          BREAK
        ELSEIF !DC_GetValidate( oXbp )
          // DC_ClearEvents()
          BREAK
        ELSE
          oGetList:lastFocus := nil
        ENDIF
      ENDIF
      IF oXbp $ ::editControls
        DC_ValidateSkip(.f.)
      ENDIF
    ENDIF
    IF oXbp $ oGetList:editControls
      oGetList:editControlLastFocus := oXbp
    ENDIF
  ELSEIF AScan( { 1048646,1048960,1048961, xbeTV_ItemMarked }, nEvent ) > 0
    oGetList:Message( oXbp, nEvent==xbeM_Motion, mp1, nEvent )
  ELSEIF nEvent == xbeP_Keyboard

    /*
    IF !(mp1 == oGetList:lastKey)
      KEYBOARD Chr(mp1)
      Inkey(0)
    ENDIF
    */
    oGetList:lastKey := mp1
    IF mp1 = xbeK_CTRL_TAB // Go to next TabPage
      IF _TabSelect(::tabpageControls,DCGUI_TAB_SELECT_NEXT)
        BREAK
      ENDIF
    ELSEIF mp1 = 720905 // xbeK_CTRL_SHIFT_TAB // Go to previous TabPage
      IF _TabSelect(oGetList:tabpageControls,DCGUI_TAB_SELECT_PREVIOUS)
        BREAK
      ENDIF
    ENDIF
  ENDIF

  IF Valtype(oXbp) == 'O' .AND. IsMethod(oXbp,'HandleEvent')
    IF !oGetList:IsDesignOn .OR. oParentDlg == NIL .OR. oXbp == oParentDlg
      IF nEvent == xbeP_Quit
        QUIT
      ENDIF
      //
      // J. Duijf 17-07-2014
      // Required for my cell-edit class Dc_xbpCellEditBrowse
      //

      If nEvent <> xbeP_Keyboard
         oXbp:handleEvent(@nEvent,@mp1,@mp2 )                                 // J. Duijf 17-07-2014  Pass event parameters by refference
      Else
         //
         // Jack Duijf 17-07-2014
         // Sometimes is is NOT possible to signal that the key has been
         // processed. This results in double handling, or (in case of <Enter>) unwanted behaviour
         // If the ::keyhandlingcompleted is set, then further processing is suppressed.
         //
         ::keyhandlingcompleted              := FALSE
         oXbp:handleEvent(@nEvent,@mp1,@mp2 )                                 // J. Duijf 17-07-2014  Pass event parameters by refference
         If ::keyhandlingcompleted
            mp1      := 0
            nEvent   := xbeP_None
         Endif
      Endif
      //
    ENDIF
  ELSE
    BREAK
  ENDIF

  IF (nEvent = xbeP_Selected .OR. nEvent = xbeSpin_EndSpin) .AND. ;
      !oXbp:isDerivedFrom('XbpCrt') .AND. !oGetList:IsDesignOn

    IF IsMethod(oXbp,'GETDATA') .AND. !oXbp:isDerivedFrom('XbpCheckBox')
      oXbp:GetData()
    ENDIF
    DC_GetWhen(aGetList)

  ELSEIF nEvent = xbeM_LbUp .AND. ;
      (oXbp:isDerivedFrom('XbpRadioButton') .OR. oXbp:isDerivedFrom('XbpCheckBox')) ;
      .AND. !oGetList:IsDesignOn

    oXbp:GetData()
    DC_GetWhen(aGetList)

  ELSEIF ( nEvent = xbeP_Keyboard .AND. (mp1 = K_ESC .OR. ;
           mp1 = DC_ReadGuiExitKey(DCGUI_EXIT_ABORT) ) .AND. ;
          ( oGetList:isEscapeKey  .OR. oGetList:IsDesignOn ) )  .OR.  ;
          ( nEvent = xbeP_Close .AND. oXbp = oParentDlg .AND. aGetList == aMasterGetList )

    IF oGetList:lastEvent # DCGUI_NONE
      BREAK
    ELSEIF mp1 = K_ESC .OR. (mp1 # 0 .AND. mp1 = DC_ReadGuiExitKey(DCGUI_EXIT_ABORT))
      DC_ReadGuiAbort(aGetList)
    ELSEIF Valtype(oGetList:closeQueryBlock) = 'B'
      oGetList:isDialogActive := !Eval(oGetList:closeQueryBlock)
      IF !oGetList:isDialogActive
         oGetList:IsOkStatus := .f.
      ENDIF
    ELSEIF !oGetList:isCloseQuery
      oGetList:isDialogActive := .f.
    ELSE
      oGetList:isDialogActive := !DC_MsgBox(,,{DC_LangMsg(DCMSG_CLOSEQUERY)},,,,.t.)
    ENDIF
    IF !oGetList:isDialogActive
      nEvent := xbeP_Close
      // DC_ClearEvents()
      BREAK
    ENDIF
  ENDIF

  IF nEvent = xbeP_Keyboard

    nLastKey := mp1

    IF mp1 = DC_SetPopKey() .AND. oXbp:isDerivedFrom('DC_XbpGet')
      IF Valtype(oXbp:popupButton) = 'O' .AND. Valtype(oXbp:popupButton:activate) = 'B'
        Eval(oXbp:popupButton:activate,,,oXbp:popupButton)
      ELSEIF _PopUp(oXbp) .AND. Valtype(oXbp:validate) = 'B'
        Eval(oXbp:validate,oXbp)
      ENDIF

    ELSEIF ( nHotKey := AScan( oGetList:keyboardControls, {|a|a[1]==mp1} ) ) > 0 ;
            .AND. oGetList:lastEvent # DCGUI_NOHOTKEY

      IF  _ProcessHotKey( nHotKey, oGetList:keyboardControls, oXbp, mp1, oGetList )
        DC_GetWhen(aGetList)
      ENDIF

    ELSEIF DC_SetKeyActive() .AND. _ProcessSetKey(mp1)
      DC_ClearEvents()

    ENDIF

    IF oGetList:lastEvent == DCGUI_NOHOTKEY
      oGetList:lastEvent := DCGUI_NONE
    ENDIF

    IF lEditNav .AND. (Len(oGetList:editControls) > 1 .OR. oGetList:isExitEnter .OR. ;
       nLastKey == xbeK_ENTER )

      DC_GetWhen(aGetlist)
      lHitBottom := .f.

      FOR i := 1 TO LEN(oGetList:editControls)
        IF oXbp == oGetList:editControls[i]
          IF !(oXbp:isDerivedFrom('DC_XbpGet')) .OR. oXbp:isGetDataOnLostFocus
            oXbp:GetData()
          ENDIF

          lHitBottom := _SetFocusEdit( oGetList:editControls, i, mp1 # xbeK_UP, ;
                         oXbp:setParent(), oGetList:isSuperVise, oGetList:isExitEnter, ;
                         oGetList )
          EXIT
        ENDIF
      NEXT

      IF DC_EnterExitMode()=2 .OR. ; // Enter Exit mode exits any time ENTER is hit
          (lHitBottom .AND. (oGetList:isExitEnter .OR. oXbp == SetAppFocus()))

        IF !DC_GetValidate( oXbp )
          BREAK
        ENDIF
        IF oGetList:isExitEnter
          IF Valtype(DC_GetObject(aGetList,'DCGUI_BUTTON_OK')) = 'O' .AND. ;
              DC_EnterExitMode()=1 // Enter Exit mode sets focus to OK button when ENTER is hit
            SetAppFocus(DC_GetObject(aGetList,'DCGUI_BUTTON_OK'))
          ELSE // Exit on ENTER if Enter Exit mode is 0 or 2

            // DC_ReadGuiExit(aGetList)
            DC_ReadGuiExit(oGetList)
            IF oGetList:isDialogActive
              BREAK
            ENDIF
            nEvent := xbeP_Close
            oGetList:IsOkStatus := .t.
            DC_ClearEvents()
            BREAK
          ENDIF
        ENDIF
      ENDIF

    ELSEIF mp1 = DC_ReadGuiExitKey( DCGUI_EXIT_OK )
      DC_GetGather(aGetList)
      oGetList:isDialogActive := .f.
      nEvent := xbeP_Close
      BREAK

    ELSEIF oXbp:isDerivedFrom('XbpBrowse') .AND. ;
           ( ( mp1 = xbeK_RIGHT .AND. oXbp:colPos < oXbp:colCount ) .OR. ;
             ( mp1 = xbeK_LEFT  .AND. oXbp:colPos > 1 ) .OR. ;
             ( mp1 = xbeK_HOME  .AND. oXbp:colPos > 1 ) .OR. ;
             ( mp1 = xbeK_END   .AND. oXbp:colPos < oXbp:colCount ) )

      _SetFocusBrow( mp1, oXbp, aGetList )

    ELSEIF mp1 == DC_DotHotKey(,@bDotBlock)

      DC_ClearEvents()
      Eval(bDotBlock,{oParentDlg,aGetList,oGetList})

    ELSEIF mp1 == DC_CallStackHotKey(,@bDotBlock)
      DC_ClearEvents()
      Eval(bDotBlock)

      /* -- Handle pushbutton hot key -- */
    ELSEIF ( bBlock := SetAppEvent( mp1)) != NIL .AND. !oXbp:isDerivedFrom('XBPCRT')
      IF Valtype(bBlock) = 'B'
        DC_ClearEvents()
        EVAL( bBlock, mp1, mp2, oXbp)
      ENDIF
    ENDIF

  ELSEIF ( nHotKey := AScan( oGetList:keyboardControls, {|a|a[1]==nEvent} ) ) > 0

    IF _ProcessHotKey( nHotKey, oGetList:keyboardControls, oXbp, nEvent, oGetList )
      DC_GetWhen(aGetList)
    ENDIF

  ELSEIF ASCan( { xbeP_SetInputFocus, ;
                  xbeBRW_ItemMarked, ;
                  xbeTV_ItemMarked }, nEvent ) > 0  .OR. ;
      ( !oGetList:IsDesignOn .AND. nEvent = xbeM_LbDown ) .OR. ;
      ( !oGetList:IsDesignOn .AND. nEvent = xbeM_Motion .AND. Valtype(oGetList:messageBox) = 'O' .AND. ;
        oGetList:messageBox:cargo[5])
    lGetWhen := .t.

    IF nEvent == xbeBRW_ItemMarked .AND. oXbp:isDerivedFrom('XbpCellGroup')
      lGetWhen := .f.
    ELSEIF nEvent == xbeBRW_ItemMarked .AND. oXbp:isDerivedFrom('DC_XbpBrowse') .AND. ;
                 IsMemberVar(oXbp,'isItemMarkedCodeBlock') .AND. ;
                 !oXbp:isItemMarkedCodeBlock
      lGetWhen := .f.
    ELSEIF nEvent == xbeM_LbDown .AND. oXbp:isDerivedFrom('XbpCellGroup')
      lGetWhen := .f.
    ELSEIF nEvent == xbeP_SetInputFocus .AND. oXbp:isDerivedFrom('XbpColumn')
      lGetWhen := .f.
    ELSEIF nEvent == xbeM_Motion // .AND. oXbp:isDerivedFrom('XbpBrowse')
      lGetWhen := .f.
    ELSEIF nEvent == xbeM_LbDown .AND. !DC_LbDownGetWhen()
      lGetWhen := .f.
    ENDIF
    IF lGetWhen
      DC_GetWhen(aGetList)
      oGetList:Message( oXbp, .f., mp1, nEvent ) // display message
    ENDIF

  ELSEIF nEvent == DC_InspectObjectEvent() .AND. nEvent # 0

      DCMSGBOX 'Inspecting object' TIMEOUT .1
      DC_InspectObject(oXbp)

  ELSEIF oGetList:isDataToolTips .AND. nEvent == xbeM_Motion .AND. ;
         (oXbp:isderivedFrom('XbpCellGroup') .AND. ;
           Valtype(oXbp:cargo) = 'A' .AND. Len(oXbp:cargo) = 8) .OR. ;
         (oXbp:isDerivedFrom('XbpScrollBar') .AND. ;
           Valtype(oXbp:cargo)=='A' .AND. Len(oXbp:cargo) == 8)   // DATA TOOL TIP enabled

     // :cargo[1] = Enable Code Block
     // :cargo[2] = Return Code Block
     // :cargo[3] = Value to display in tooltip by MagicHelp() thread
     // :cargo[4] = Last moused cell record offset
     // :cargo[5] = Last selected record
     // :cargo[6] = Last moused cell record
     // :cargo[7] = Pointer to Browse object
     // :cargo[8] = Alias(), Array or SQL Object

     IF Valtype(oXbp:cargo[1]) = 'B' .AND. Eval(oXbp:cargo[1])
        IF Valtype(oXbp:cargo[2]) == 'B' .AND. oXbp:isDerivedFrom('XbpScrollBar')
          oXbp:cargo[3] := Eval(oXbp:cargo[2])
        ELSEIF Valtype(oXbp:cargo[2]) == 'B' .AND. oXbp:isDerivedFrom('XbpCellGroup') // store value from codeblock
          nOffset := oXbp:CellFromPos(mp1) - oXbp:cargo[7]:RowPos  // calculate moused cell position offset from current record
          IF Valtype(oXbp:cargo[8]) == 'C' // it's a database we're browsing
            IF Empty((oXbp:cargo[8])->(DC_SetScopeArray()))
              nSaveRecord := Eval(oXbp:cargo[7]:phyPosBlock)
              IF nSaveRecord # oXbp:cargo[5] .OR. nOffset # oXbp:cargo[4]
                nSkipped := Eval(oXbp:cargo[7]:skipBlock,nOffset)
                nCellRecord := (oXbp:cargo[8])->(RecNo())
                IF nSkipped == nOffset
                  oXbp:cargo[3] := Eval(oXbp:cargo[2],nCellRecord)
                ELSE
                  oXbp:cargo[3] := ''
                ENDIF
                oXbp:cargo[4] := nOffset
                oXbp:cargo[5] := nSaveRecord
                oXbp:cargo[6] := nCellRecord
                Eval(oXbp:cargo[7]:phyPosBlock,nSaveRecord)
              ENDIF
            ELSE
              nSaveRecord := (oXbp:cargo[8])->(RecNo())
              nPointer := (oXbp:cargo[8])->(DC_SetScopeArrayPointer())
              aTokens := (oXbp:cargo[8])->(DC_SetScopeArray())
              nPointer += nOffset
              IF nPointer > 0 .AND. nPointer <= Len(aTokens)
                IF Valtype(aTokens[nPointer]) == "A"
                  (oXbp:cargo[8])->(dbGoTo(aTokens[nPointer][1]))
                ELSE
                  (oXbp:cargo[8])->(dbGoTo(aTokens[nPointer]))
                ENDIF
                nCellRecord := (oXbp:cargo[8])->(RecNo())
                oXbp:cargo[3] := Eval(oXbp:cargo[2],nCellRecord)
              ELSE
                oXbp:cargo[3] := ''
              ENDIF
              (oXbp:cargo[8])->(dbGoTo(nSaveRecord))
            ENDIF
          ELSEIF Valtype(oXbp:cargo[8]) == 'A' // it's an array we're browsing
           // nSaveRecord := oXbp:cargo[7]:cargo[4] // current array element
            nSaveRecord := oXbp:cargo[7]:arrayElement
            IF nSaveRecord # oXbp:cargo[5] .OR. nOffset # oXbp:cargo[4]
              IF oXbp:cargo[7]:descending
                nCellRecord := nSaveRecord - nOffset
              ELSE
                nCellRecord := nSaveRecord + nOffset
              ENDIF
              IF nCellRecord <= Len(oXbp:cargo[8])
                oXbp:cargo[3] := Eval(oXbp:cargo[2],nCellRecord)
                oXbp:cargo[4] := nOffset
                oXbp:cargo[5] := nSaveRecord
                oXbp:cargo[6] := nCellRecord
              ENDIF
            ENDIF
          ELSEIF Valtype(oXbp:cargo[8]) == 'O' .AND. ;
              (oXbp:cargo[8]:isDerivedFrom('SQLDataSet') .OR. oXbp:cargo[8]:isDerivedFrom('SQLStatement'))

            oXbp:cargo[8] := oXbp:setParent():parent:dataSource

            nSaveRecord := oXbp:cargo[8]:recNo()
            IF nSaveRecord # oXbp:cargo[5] .OR. nOffset # oXbp:cargo[4]
              oXbp:cargo[8]:Skip( nOffset )
              nCellRecord := oXbp:cargo[8]:recNo()
              oXbp:cargo[3] := Eval(oXbp:cargo[2],nCellRecord)
              oXbp:cargo[4] := nOffset
              oXbp:cargo[5] := nSaveRecord
              oXbp:cargo[6] := nCellRecord
              oXbp:cargo[8]:GoTo(nSaveRecord)
            ELSE
              oXbp:cargo[3] := ''
            ENDIF
          ENDIF
        ELSE // store value from cell
          oXbp:cargo[3] := oXbp:GetCell(oXbp:CellFromPos(mp1))
        ENDIF
      ELSE
         oXbp:cargo[3] := ''
      ENDIF

  ENDIF

  END SEQUENCE

  IF !(aGetList == aMasterGetList)
    aGetList := aMasterGetList
  ENDIF
  IF !(nDataStore == nMasterDataStore)
    nDataStore := nMasterDataStore
  ENDIF
  IF !(oParentDlg == oMasterParentDlg)
    oParentDlg := oMasterParentDlg
  ENDIF

ENDDO

IF lToolTips
   /*
    02-04-2011 J.Duijf remove references in tooltip.
    This prevents memory leaks (All references to oXbp's are actualy cleared)
    */
   IF DC_ToolTipThread() = 2  // <<< Jack Duijf's Single-Thread system
      if ValType(DC_HelpThreadObject()) = "O"
         DC_HelpThreadObject():RemoveToolTip(oHelp)
      endif
      if ValType(oHelp) = "O"
         oHelp:Destroy()
      endif
   ELSE // <<< Standard Multi-Thread system
      oHelp:hideTip()
      DC_KillMagicHelp(nThreadID)
   ENDIF
endif

/*
IF lToolTips .AND. Valtype(aMagicHelp[nThreadID]) = 'O'
  aMagicHelp[nThreadID]:Terminate()
  aMagicHelp[nThreadID]:Synchronize(0)
  Sleep(5)
  aMagicHelp[nThreadID] := nil
ENDIF
*/

IF snEventSpy > 0 .AND. lLoadSpy
   oEventSpy := DllCall( snEventSpy, DLL_XPPCALL, 'EventSpy' )
   oEventSpy:hide()
ENDIF

RETURN oGetList:IsOkStatus

* ---------------

PROCEDURE DC_KillMagicHelp(nThreadID)                // <-TW

IF IsFunction('DC_aMagicHelp') .AND. ;               // <-TW
       len(DC_aMagicHelp()) >= nThreadID .AND. ;     // <-TW
         Valtype(DC_aMagicHelp()[nThreadID]) = 'O'   // <-TW
  DC_aMagicHelp()[nThreadID]:Terminate()             // <-TW
  DC_aMagicHelp()[nThreadID]:Synchronize(0)          // <-TW
  Sleep(5)                                           // <-TW
  DC_aMagicHelp()[nThreadID] := NIL                  // <-TW
ENDIF                                                // <-TW

RETURN                                               // <-TW

* ---------------

STATIC FUNCTION _EditProtected( oXbp, lEditNav, oParentDlg, oGetList, nEvent )
//
// Date        Author                  Remarks
// ----------- ----------------------  ---------------------------------------------
// 27-08-2005  Jack Duijf              Add WHEN clause to check for EditProtect. This prevents editing
//                                     if the WHEN clause becomes FALSE while on exit on the previous get.
//
LOCAL nPointer ,;
      aGetList ,;
      bBlock, xValue

LOCAL lEditProtect  := .F.  // Jack Duijf  27-08-2005

// allow scrolling of XbpMle objects even if they are protected
IF oXbp:isDerivedFrom('XbpMle') .AND. ( nEvent = xbeM_LbDown .OR. nEvent = xbeM_LbUp )
   RETURN FALSE
ELSEIF Valtype(oXbp:cargo) = 'A' .AND. ;
       Len(oXbp:cargo) >= 2 .AND. Valtype(oXbp:cargo[1]) = 'N' .AND. ;
       oXbp:cargo[1] > 0 .AND. Valtype(oXbp:cargo[2]) = 'A' .AND. !lEditNav
   nPointer = oXbp:cargo[1]
   aGetList = oXbp:cargo[2]
ELSEIF oXbp:isderivedFrom('XBPPUSHBUTTON') .AND. Valtype(oXbp:cargo) = 'A' .AND. ;
       Len( oXbp:cargo ) = 1 .AND. Valtype(oXbp:cargo[1]) = 'A' .AND. ;
       Len( oXbp:cargo[1] ) = 3 .AND. Valtype( oXbp:cargo[1,1] ) = 'N' .AND. ;
       oXbp:cargo[1,1] == PICKPOINTER
   nPointer := oXbp:cargo[1,2]
ELSE
   nPointer := 0
ENDIF

IF nPointer > 0  .AND. Valtype(aGetList) == 'A' .AND. nPointer <= Len(aGetList)
  bBlock := DC_GetBlock(aGetList[nPointer,bGETLIST_WHEN])   // Jack Duijf 27-08-2005
  if Valtype(bBlock) = 'B'                                  // Jack Duijf 27-08-2005
    // lEditProtect  := !Eval(bBlock,oXbp)                     // Jack Duijf 27-08-2005
    xValue := Eval(bBlock,oXbp)
    IF Valtype(xValue) == 'L'
      lEditProtect := !xValue
    ENDIF
    IF lEditProtect
      RETURN .t.
    ENDIF
  endif                                                                    // Jack Duijf 27-08-2005

  bBlock := oGetList:editProtectBlockSafe
  IF Valtype(bBlock) == 'B' .AND. Eval(bBlock,oXbp) .AND. ;
     AScan( oGetList:editControls, oXbp ) > 0
    RETURN .t.
  ENDIF

  // don't allow a protected get to accept focus
  bBlock := DC_GetBlock(aGetList[nPointer,bGETLIST_PROTECT])

  IF Valtype(bBlock) # 'B' .AND. ;
     Valtype(oGetList:editProtectBlock) == 'B' .AND. ;
     AScan( oGetList:editControls, oXbp ) > 0
    bBlock := oGetList:editProtectBlock
  ENDIF

  IF Valtype(bBlock) = 'B' .AND. !oXbp:isDerivedFrom('XbpColumn')
    IF !oGetList:IsDesignOn .AND. Eval(bBlock,oXbp)
      IF IsMemberVar(oParentDlg,'DRAWINGAREA')
        SetAppFocus(oParentDlg:drawingarea)
      ELSEIF Valtype(oParentDlg) = 'O'
        SetAppFocus(oParentDlg)
      ENDIF
      lEditProtect := .T.
      oXbp:captureMouse(.f.)
    ENDIF
  ENDIF
ENDIF

RETURN lEditProtect                                                        // Jack Duijf 27-08-2005

* -----------

STATIC FUNCTION _NavKey( oXbp, mp1 )

IF mp1 $ { xbeK_ENTER, K_ENTER } .AND. _IsNavEnterObject(oXbp)
  RETURN .t.
ELSEIF mp1 $ { xbeK_UP, xbeK_DOWN } .AND. _IsNavUpDownObject(oXbp)
  RETURN .t.
ELSEIF oXbp:isDerivedFrom('DC_XbpMle')
  IF Valtype(oXbp:exitKey) == 'A'
    IF mp1 == oXbp:exitKey[1]
      RETURN .t.
    ELSEIF mp1 == oXbp:exitKey[2]
      mp1 := xbeK_UP
      RETURN .t.
    ENDIF
  ELSEIF Valtype(oXbp:exitKey) == 'N' .AND. mp1 == oXbp:exitKey
    RETURN .t.
  ENDIF
ENDIF

RETURN .f.

/*
a = 1
b = 2
c = 3
d := ''
@ 0,0 dcget a
@ 1,0 dcget b
@ 2,0 dcget c
@ 3,0 dcmultiline d size 10,3 exitkey { xbeK_F2, xbeK_F3 }
@ 7,0 dcget a
@ 8,0 dcget b
@ 9,0 dcget c
dcread gui fit
*/

* -------------------

FUNCTION DC_IsGetEditControl( oXbp )

LOCAL i, aObjects := ;
  { 'DC_XBPGET', ;
    'DC_XBPGETC', ;
    'DC_XBPMGET', ;
    'DC_XBPCHECKBOX', ;
    'DC_XBPSLE', ;
    'DC_XBPLISTBOX', ;
    'DC_XBPCOMBOBOX', ;
    'DC_XBPRADIOBUTTON', ;
    'DC_XBPSPINBUTTON', ;
    'KLMLE' }

IF Valtype(oXbp) = 'O'
  FOR i := 1 TO Len(aObjects)
    IF oXbp:isDerivedFrom(aObjects[i])
      RETURN .t.
    ENDIF
  NEXT
ENDIF

RETURN .f.

* -------------------

FUNCTION DC_GetGather( aGetList, nElement, aGroup  )

LOCAL nType, oXbp, i, j, nStart, nEnd, lGoodGroup, ;
      lDataLink, bErrorBlock

IF DC_Recursion('DC_GETGATHER',3,.f.)
  RETURN nil
ENDIF
IF Valtype(aGroup)='C'
  aGroup := { aGroup }
ENDIF

IF Valtype(nElement) = 'N'
  nStart := nElement
  nEnd := nElement
ELSEIF Valtype(nElement) = 'C' // It's an ID
  nStart := AScan(aGetList,{|a|a[cGETLIST_ID]==nElement})
  nEnd := nStart
  IF nStart = 0
     RETURN nil
  ENDIF
ELSE
  nStart := 1
  nEnd := Len(aGetList)
ENDIF

// bErrorBlock := ErrorBlock({||_GetWhenError()})

lDataLink := DC_GetDataLink()
DC_GetDataLink(.f.)
IF Valtype(aGetList)='A' .AND. !Empty(aGetList) .AND. ;
         Len(aGetList[1]) >= nGET_ARRAY_SIZE
  FOR i := nStart TO nEnd
    IF !Empty(aGroup)
      IF Empty(aGetList[i,cGETLIST_GETGROUP])
         LOOP
      ENDIF
      lGoodGroup := .f.
      FOR j := 1 TO Len(aGroup)
        IF aGetList[i,cGETLIST_GETGROUP]==aGroup[j]
          lGoodGroup := .t.
          EXIT
        ENDIF
      NEXT
      IF !lGoodGroup
         LOOP
      ENDIF
    ENDIF
    bErrorBlock := ErrorBlock({||_GetWhenError()})
    BEGIN SEQUENCE
    nType := aGetList[i,nGETLIST_TYPE]
    oXbp := aGetList[i,oGETLIST_OBJECT]
    IF Valtype(oXbp) # 'O'
    ELSEIF nType = GETLIST_MLE .OR.  ;
           nType = GETLIST_SLE .OR. ;
           nType = GETLIST_KLMLE .OR. ;
           nType = GETLIST_GET .OR. ;
           nType = GETLIST_RADIOBUTTON .OR. ;
           nType = GETLIST_CHECKBOX .OR. ;
           nType = GETLIST_3STATE .OR. ;
           nType = GETLIST_SPINBUTTON .OR. ;
           nType = GETLIST_LISTBOX

      oXbp:GetData()
    ELSEIF nType = GETLIST_COMBOBOX
      oXbp:XbpSLE:GetData()
    ENDIF
    DC_GetWhen( aGetList, i )
    END SEQUENCE
    ErrorBlock(bErrorBlock)
  NEXT
ENDIF

DC_GetEditActive(nil)
DC_GetDataLink(lDataLink)
//ErrorBlock(bErrorBlock)

RETURN nil

* -------------------

STATIC PROCEDURE _GetWhenError()
BREAK
RETURN

* --------------------

STATIC FUNCTION _ProcessHotKey( nHotKey, aKeyboardControls, oXbp, nEvent )

LOCAL lStatus := .f., i, oLastFocus, oAppFocus := SetAppFocus(), ;
      lError, nIterations := 0

IF oXbp:setOwnerthread() # oAppFocus:setownerthread()  // Thanks to Cliff Wiernik
  oAppFocus := oXbp
ENDIF

/*
aKeyboardControls Array elements
1 - Hotkey (accelerator key)
2 - ACTION code block
3 - WHEN code block
4 - HIDE code block
5 - Object tied to this hotkey
6 - Object receiving keyboard event
7 - Cargo
8 - If true, object must have focus
*/

DO WHILE nIterations++ < 3

   lError := .F.

   BEGIN SEQUENCE

      FOR i := 1 TO Len(aKeyboardControls)

         IF Empty(aKeyboardControls[nHotKey,5]) .OR. ; // No focus object
               (!Empty(aKeyboardControls[nHotkey,6]) .AND. !aKeyboardControls[nHotkey,8]) // set focus

            IF (Valtype(aKeyboardControls[nHotKey,3]) # 'B' .OR. ;
                  Eval(aKeyboardControls[nHotKey,3],aKeyboardControls[nHotKey,6])) ; // When clause
                  .AND. ;
                  (Valtype(aKeyboardControls[nHotKey,4]) # 'B' .OR. ;
                  !Eval(aKeyboardControls[nHotKey,4],aKeyboardControls[nHotKey,6])) // Hide clause

               // DC_ClearEvents()
               IF IsMethod(oAppFocus,'GETDATA') .AND. !(oAppFocus:isDerivedFrom('XbpColumn'))
                  IF _TestForCancelEvent( xbeP_SetInputFocus, aKeyboardControls[nHotKey,6] )
                     // don't validate
                  ELSEIF Valtype(aKeyboardControls[nHotkey,7]) = 'C' .AND. ;
                        Upper(aKeyboardControls[nHotkey,7]) == 'CANCEL'
                     // don't validate
                  ELSEIF !DC_GetValidate( oAppFocus )
                     DC_ClearEvents()
                     RETURN .f.
                  ENDIF
                  oAppFocus:GetData()
               ENDIF

               IF Empty(aKeyboardControls[nHotKey,6]) .OR. ;
                     (Valtype(aKeyboardControls[nHotKey,6]) == 'O' .AND. ;
                     aKeyboardControls[nHotkey,6]:isVisible())
                  oLastFocus := nil
                  IF Valtype(aKeyboardControls[nHotkey,6]) == 'O'
                     oLastFocus := aKeyboardControls[nHotkey,6]
                     lStatus := .t.
                     IF SetAppFocus() # oLastFocus
                       SetAppFocus(oLastFocus)
                       DC_CompleteEvents()     // put this back to force lost focus to be evaluated
                     ENDIF
                     IF oLastFocus:isDerivedFrom('DC_XbpRadioButton')
                        oLastFocus:select()
                        lStatus := .t.
                        EXIT
                     ELSEIF oLastFocus:isDerivedFrom('DC_XbpCheckBox')
                        oLastFocus:setData(!oLastFocus:editBuffer())
                        PostAppEvent( xbeP_Selected,,, oLastFocus )
                        lStatus := .t.
                        EXIT
                     ENDIF
                  ENDIF

                  Eval( aKeyboardControls[nHotKey,2], nil, nil, aKeyboardControls[nHotKey,6] ) // Action block

                  IF Valtype(oLastFocus) == 'O' .AND. oLastFocus:isDerivedFrom('XbpStatic') ;
                        .AND. Valtype(oLastFocus:cargo) == 'O' .AND. ;
                        oLastFocus:cargo:isDerivedFrom('XbpPushButton') // fancy button
                     oLastFocus:cargo:captureMouse(.f.)
                     oLastFocus:cargo:hide()
                     oLastFocus:show()
                  ENDIF
                  lStatus := .t.
                  EXIT
               ENDIF
            ENDIF

         ELSEIF aKeyboardControls[nHotkey,5] == oXbp .AND. aKeyboardControls[nHotKey,8] // Object must have focus

            IF (Valtype(aKeyboardControls[nHotKey,3]) # 'B' .OR. ;
                  Eval(aKeyboardControls[nHotKey,3],aKeyboardControls[nHotKey,6])) ; // When clause
                  .AND. ;
                  (Valtype(aKeyboardControls[nHotKey,4]) # 'B' .OR. ;
                  !Eval(aKeyboardControls[nHotKey,4],aKeyboardControls[nHotKey,6])) // Hide clause
               DC_ClearEvents()
               IF IsMethod(oAppFocus,'GETDATA') .AND. !(oAppFocus:isDerivedFrom('XbpColumn'))
                  IF oAppFocus:isDerivedFrom('DC_XbpGet') .AND. ;
                        Valtype(oAppFocus:popupButton) = 'O' .AND. ;
                        !Empty(oAppFocus:popupButton:activate)
                     // don't validate
                  ELSEIF _TestForCancelEvent( xbeP_SetInputFocus, aKeyboardControls[nHotKey,5] )
                     // don't validate
                  ELSEIF Valtype(aKeyboardControls[nHotkey,7]) = 'C' .AND. ;
                        Upper(aKeyboardControls[nHotkey,7]) == 'CANCEL'
                     // don't validate
                  ELSEIF !DC_GetValidate( oAppFocus )
                     DC_ClearEvents()
                     RETURN .f.
                  ENDIF
                  oAppFocus:GetData()
               ENDIF

               Eval( aKeyboardControls[nHotKey,2], nil, nil, aKeyboardControls[nHotkey,6] ) // Action block
               lStatus := .t.
               EXIT
            ENDIF

         ENDIF

         IF ( nHotKey := AScan( aKeyboardControls, {|a|a[1]==nEvent}, ;
               nHotKey + 1 ) ) = 0
            EXIT
         ENDIF

      NEXT

   END SEQUENCE

   IF lError
     oAppFocus := oXbp
   ELSE
     EXIT
   ENDIF

ENDDO

RETURN lStatus

* ------------------

STATIC FUNCTION _MessageFocus( oXbp, oFocus )

IF oXbp:isDerivedFrom('XbpCellGroup')
  oXbp := oXbp:setParent():parent
ELSEIF oXbp:isDerivedFrom('XbpColumn')
  oXbp := oXbp:parent
ENDIF

IF oFocus:isDerivedFrom('XbpCellGroup')
  oFocus := oFocus:setParent():parent
ELSEIF oFocus:isDerivedFrom('XbpColumn')
  oFocus := oFocus:parent
ENDIF

RETURN oXbp == oFocus .OR. ;
  (Valtype(oFocus:setParent()) == 'O' .AND. oFocus:setParent():isDerivedFrom('XbpCellGroup'))

* ------------------

METHOD DC_GetList:Message( oXbp, lMotion, mp1, nEvent )

LOCAL nPointer, abcMessage, bBlock, lClear, oMsgBox := ::messageBox

/*
IF !lMotion .AND. !_MessageFocus(oXbp,SetAppFocus())
  RETURN Nil
ENDIF
*/

Grok(lMotion)
IF oXbp:isDerivedFrom('DC_XbpBrowse') .AND. oXbp:colCount > 0
  IF nEvent == xbeBRW_ItemMarked .AND. oXbp # SetAppFocus()
    RETURN nil
  ELSEIF Valtype(oXbp:cargo)='A' .AND. !Empty(oXbp:cargo) .AND. Len(oXbp:cargo) >= 2 .AND. ;
      Valtype(oXbp:cargo[1])='N' .AND. ;
      Valtype(oXbp:cargo[2])='A' .AND. ;
      oXbp:cargo[1] > 0 .AND. oXbp:cargo[1] <= Len(::getListArray) .AND. ;
      oXbp:cargo[2]==::getListArray
    nPointer := oXbp:cargo[1]
    abcMessage := ::GetListArray[nPointer,cGETLIST_MESSAGE]
    IF Empty(abcMessage)
      oXbp := oXbp:getColumn(oXbp:colPos)
    ENDIF
  ENDIF
ENDIF

IF Valtype(mp1) = 'O'
  oXbp := mp1
ENDIF

IF Valtype(oXbp:cargo)='A' .AND. !Empty(oXbp:cargo) .AND. ;
      Valtype(oXbp:cargo[1])='N' .AND. ;
      oXbp:cargo[1] > 0 .AND. oXbp:cargo[1] <= Len(::getListArray) .AND. ;
      Valtype(oXbp:cargo[2])=='A' .AND. ;
      (oXbp:cargo[2] == ::getListArray .OR. oXbp:isDerivedFrom('DC_XbpMenu'))
  lClear := ::isClearMessage
  DEFAULT lClear := .f.
  IF (oXbp:isDerivedFrom('XbpMenu') .OR. oXbp:isDerivedFrom('XbpMenuBar')) ;
       .AND. Len(oXbp:cargo) >= 6 .AND. ;
       Valtype(oXbp:cargo[6]) = 'A' .AND. Valtype(mp1) = 'N'
     IF mp1 > 0 .AND. mp1 <= Len(oXbp:cargo[6])
       abcMessage := oXbp:cargo[5,mp1]
       IF Empty(abcMessage)
         lClear := .t.
       ELSE
         ::isClearMessage := .t.
         lClear := .f.
       ENDIF
     ELSEIF mp1 = 0
       lClear := .f.
       ::isClearMessage := .t.
     ENDIF
  ELSE
    nPointer := oXbp:cargo[1]
    abcMessage := ::GetListArray[nPointer,cGETLIST_MESSAGE]
    IF Empty(abcMessage) .AND. ::isClearMessage
      lClear := .t.
    ENDIF
    ::isClearMessage := .f.
  ENDIF
  IF Valtype(abcMessage) = 'B'
    abcMessage := DC_XtoC(Eval(abcMessage))
  ENDIF
  IF !Empty(abcMessage) .OR. Valtype(abcMessage)='C' .OR. lClear
    IF oXbp:isDerivedFrom('XbpTabPage')
       lClear := .f.
    ENDIF
    IF Valtype(abcMessage) = 'A'
      IF Valtype(abcMessage[2]) = 'O'
        oMsgBox := abcMessage[2]
      ELSE
        bBlock := DC_GetBlock(abcMessage[2])
        IF Valtype(bBlock) = 'B'
          oMsgBox := Eval(bBlock)
        ENDIF
      ENDIF
      abcMessage := abcMessage[1]
      IF Valtype(abcMessage) = 'B'
         abcMessage := Eval(abcMessage)
      ENDIF
    ENDIF

    IF !(Valtype(oMsgBox) $ 'OB')
      oMsgBox := ::messageInto
    ENDIF

    IF Valtype(oMsgBox) == 'B'
      IF lClear
        Eval( oMsgBox, '' )
      ELSEIF !Empty(abcMessage)
        Eval( oMsgbox, abcMessage )
      ENDIF
      RETURN
    ENDIF
    IF Valtype(oMsgBox) # 'O' .OR. oMsgBox:status() == 0
      RETURN
    ENDIF
    IF !Empty(oMsgBox:childList()) .AND. oMsgBox:childList()[1]:isderivedFrom('XBPSTATIC')
      oMsgBox := oMsgBox:childList()[1]
    ENDIF
    IF lClear //  .OR. Empty(abcMessage)
      oMsgBox:SetCaption('')
    ELSEIF Valtype(abcMessage) = 'C' .OR. abcMessage == NIL // .AND. !Empty(abcMessage)
      IF abcMessage == NIL
        oMsgBox:SetCaption('')
      ELSE
        oMsgBox:SetCaption(abcMessage)
      ENDIF
    ENDIF
  ENDIF
ENDIF

RETURN nil

* --------------

METHOD DC_GetList:Refresh( nElement, nRefreshMode, aRefreshList, acGroup, lDataLink, ;
                           lInvisible )

DC_GetRefresh( ::getListArray, nElement, nRefreshMode, aRefreshList, acGroup, ;
               lDataLink, lInvisible )

RETURN self

* --------------

FUNCTION DC_GetRefresh( aGetList, nElement, nRefreshMode, aRefreshList, ;
                        acGroup, lDataLink, lInvisible )

LOCAL nType, oXbp, i, j, nStart, nEnd, lGoodGroup, lSaveDataLink, cId, ;
      bErrorBlock, nDataStore, oGetList, bRefreshBlock := DC_GetRefreshBlock()

DEFAULT nRefreshMode := 0, ;
        lDataLink := .t., ;
        lInvisible := .t.

IF Valtype(bRefreshBlock) = 'B'
  Eval(bRefreshBlock,aGetList,nElement,nRefreshMode,aRefreshList,acGroup)
ENDIF

IF Valtype(aGetList) == 'O' .AND. !aGetlist:isDerivedFrom('DC_GetList')
  RETURN _GetRefresh(aGetList)
ELSEIF Valtype(aGetlist) == 'O' .AND. aGetlist:isDerivedFrom('DC_GetList')
  aGetlist := aGetList:getListArray
ENDIF

IF DC_Recursion('DC_GETREFRESH',3,.f.) .OR. Valtype(aGetList) # 'A' .OR. Empty(aGetList)
  RETURN nil
ENDIF

IF Valtype(acGroup)='C'
  acGroup := { acGroup }
ENDIF

IF Valtype(aRefreshList) $ 'CN'
  aRefreshList := {aRefreshList}
  IF GETLIST_BROWSE $ aRefreshList .AND. !GETLIST_BROWSECOL $ aRefreshList
    AAdd(aRefreshList,GETLIST_BROWSECOL)
  ENDIF
ENDIF
IF Valtype(nElement) = 'N'
  nStart := nElement
  nEnd := nElement
ELSEIF Valtype(nElement) = 'C' // It's an ID
  nStart := AScan(aGetList,{|a|a[cGETLIST_ID]==nElement})
  nEnd := nStart
  IF nStart = 0
     RETURN nil
  ENDIF
ELSE
  nStart := 1
  nEnd := Len(aGetList)
ENDIF

nDataStore := AScan(aGetList,{|a|a[nGETLIST_TYPE]==GETLIST_DATASTORE})
IF nDataStore > 0
  oGetList := aGetList[nDataStore,oGETLIST_OBJECT]
  IF Valtype(oGetList:title) == 'B'
    oGetList:parentDlg:setTitle(Eval(oGetList:title))
  ENDIF
ENDIF

lSaveDataLink := DC_GetDataLink()
DC_GetDataLink(lDataLink)

IF Valtype(aGetList)='A' .AND. !Empty(aGetList) .AND. Len(aGetList[1]) >= 60 // nGET_ARRAY_SIZE

  IF DC_TrapRefreshError()
    bErrorBlock := ErrorBlock({|e|_RefreshError(e,i,aGetList)})
  ENDIF
  BEGIN SEQUENCE
  FOR i := nStart TO nEnd
    IF !Empty(acGroup)
      IF Empty(aGetlist[i,cGETLIST_GETGROUP])
         LOOP
      ENDIF
      lGoodGroup := .f.
      FOR j := 1 TO Len(acGroup)
         //
         // J. Duijf 18-10-2014
         // An array of groups is supported now
         //
         If ValType(aGetlist[i,cGETLIST_GETGROUP]) = "C" .and. ;
            aGetlist[i,cGETLIST_GETGROUP]==acGroup[j]
            lGoodGroup := .t.
            EXIT
         ElseIf ValType(aGetlist[i,cGETLIST_GETGROUP]) = "A" .and. ;
            Ascan(aGetlist[i,cGETLIST_GETGROUP],acGroup[j]) > 0
            lGoodGroup := .t.
            EXIT
         ENDIF
      NEXT
      IF !lGoodGroup
         LOOP
      ENDIF
    ENDIF
    nType := aGetlist[i,nGETLIST_TYPE]
    cId := aGetlist[i,cGETLIST_ID]

    IF nRefreshMode = 0
      * do nothing
    ELSEIF nRefreshMode = DCGETREFRESH_ID_INCLUDE
      IF (!Empty(cId) .AND. AScan( aRefreshList, cId ) = 0) .OR. Empty(cId)
        LOOP
      ENDIF
    ELSEIF nRefreshMode = DCGETREFRESH_ID_EXCLUDE
      IF !Empty(cId) .AND. AScan( aRefreshList, cId ) > 0
        LOOP
      ENDIF
    ELSEIF nRefreshMode = DCGETREFRESH_TYPE_INCLUDE
      IF AScan( aRefreshList, nType ) = 0
        LOOP
      ENDIF
    ELSEIF nRefreshMode = DCGETREFRESH_TYPE_EXCLUDE
      IF AScan( aRefreshList, nType ) > 0
        LOOP
      ENDIF
    ELSEIF nRefreshMode = DCGETREFRESH_IDTYPE_INCLUDE
      IF AScan( aRefreshList, {|x|Valtype(x)==Valtype(cID) .AND. x==cID}) = 0
        LOOP
      ELSEIF AScan( aRefreshList, {|x|Valtype(x)==Valtype(nType) .AND. x==nType}) = 0
        LOOP
      ENDIF
    ELSEIF nRefreshMode = DCGETREFRESH_IDTYPE_EXCLUDE
      IF AScan( aRefreshList, {|x|Valtype(x)==Valtype(cID) .AND. x==cID}) > 0
        LOOP
      ELSEIF AScan( aRefreshList, {|x|Valtype(x)==Valtype(nType) .AND. x==nType}) > 0
        LOOP
      ENDIF
    ENDIF

    DC_GetWhen( aGetList, i,,, acGroup )
    oXbp := aGetlist[i,oGETLIST_OBJECT]

    IF Valtype(oXbp) # 'O' .OR. oXbp:isDerivedFrom('DC_GetList')
      LOOP
    ELSEIF oXbp:isDerivedFrom('XbpActiveXControl') .AND. !(oXbp:isDerivedFrom('XbpRTF'))
      LOOP
    ELSEIF !lInvisible .AND. !oXbp:isVisible() // don't refresh objects that are not visible
      LOOP
    ELSEIF IsMethod(oXbp,'STATUS') .AND. oXbp:status() == 0 .AND. !oXbp:isDerivedFrom('XbpBitmap')
      LOOP
    ELSEIF IsMethod(oXbp,'Refresh')
      oXbp:refresh()
    ELSEIF IsMethod(oXbp,'RefreshAll')
      oXbp:RefreshAll()
    ELSEIF IsMethod(oXbp,'SetData')
      oXbp:setdata()
    ENDIF

  NEXT
  END SEQUENCE
  IF DC_TrapRefreshError()
    ErrorBlock(bErrorBlock)
  ENDIF
ELSEIF Valtype(aGetlist)='A'
  FOR i := 1 TO Len(aGetList)
    aGetList[i]:display()
  NEXT
ENDIF

DC_GetDataLink(lSaveDataLink)

RETURN nil

* ---------------

GETSETFUNCTION DC_TrapRefreshError DEFAULT .t.

* ---------------

FUNCTION DC_GetRefreshBlock( bBlock )

STATIC sbBlock := nil
LOCAL bOldBlock := sbBlock

IF Pcount() = 1
  sbBlock := bBlock
ENDIF

RETURN bOldBlock

* ---------------

STATIC FUNCTION _GetRefresh( oXbp )

LOCAL aGetList, nPointer, i, aChildList

IF !oXbp:isDerivedFrom('DC_XbaseParts')
  RETURN nil
ENDIF

aGetList := oXbp:cargo[2]
nPointer := oXbp:cargo[1]

DC_GetWhen( aGetList, nPointer )

IF oXbp:isDerivedFrom('XbpActiveXControl')
  RETURN nil
ELSEIF oXbp:status() == 0 .AND. !oXbp:isDerivedFrom('XbpBitMap')
  RETURN nil
ELSEIF IsMethod(oXbp,'Refresh')
  oXbp:refresh()
ELSEIF IsMethod(oXbp,'RefreshAll')
  oXbp:RefreshAll()
ELSEIF IsMethod(oXbp,'SetData')
  oXbp:setdata()
ENDIF

aChildList := oXbp:ChildList()
FOR i := 1 TO Len(aChildList)
  _GetRefresh(aChildList[i])
NEXT

RETURN nil

* ---------------

STATIC PROCEDURE _RefreshError(e,i,aGetList)

LOCAL cInfo, nType, cId, aProc, cProc, cLine, aInfo
//
// J. Duijf: Prevent runtime error.  17-07-2014
//
If ValType(aGetList) = "A" .and. Len(aGetList) >= i .and. i > 0
   nType    := aGetList[i,nGETLIST_TYPE]
   cId      := DC_XtoC(aGetList[i,cGETLIST_ID])
   aProc    := aGetList[i,aGETLIST_PROC]
   IF Valtype(aProc) = 'A'
     ASize(aProc,2)
     cProc  := DC_XtoC(aProc[1])
     cLine  := DC_Xtoc(aProc[2])
   ELSE
     cProc  := 'Unknown'
     cLine  := 'Unknown'
   ENDIF

   aInfo    := {}

   /*
   cInfo :=   e:description+' '+e:operation+;
              IIF(!EMPTY(e:subsystem),;
              "  "+e:subsystem + "[" + LTrim(Str(e:subCode)) + "]",'')+;
              IIF(e:OSCode>0," OS Code["+LTrim(Str(e:OSCode))+"]",'') + ;
              Chr(13) + 'GetList Item ' + Str(i) + ;
              Chr(13) + 'GetList Type ' + DC_GetListType(nType) + ;
              Chr(13) + 'GetList ID   ' + cId + ;
              Chr(13) + 'GetList Proc ' + cProc + ;
              Chr(13) + 'GetList Line ' + cLine + ;
              Chr(13) + 'Thread ID ' + DC_XtoC(ThreadID())
   */

   AAdd(aInfo,'Error while Refreshing an Object in DC_GetRefresh()')
   AAdd(aInfo,'')
   AAdd(aInfo, e:description+' '+e:operation+;
              IIF(!EMPTY(e:subsystem),;
              "  "+e:subsystem + "[" + LTrim(Str(e:subCode)) + "]",'')+;
              IIF(e:OSCode>0," OS Code["+LTrim(Str(e:OSCode))+"]",''))

   AAdd(aInfo,'')
   AAdd(aInfo,'GetList Item ' + Str(i))
   AAdd(aInfo,'GetList Type ' + DC_GetListType(nType) )
   AAdd(aInfo,'GetList ID   ' + cId )
   AAdd(aInfo,'GetList Proc ' + cProc )
   AAdd(aInfo,'GetList Line ' + cLine )
   AAdd(aInfo,'Thread ID ' + DC_XtoC(ThreadID()))

   AAdd(aInfo, Repl('-',80))

   i := 0
   DO WHILE ! Empty( ProcName(++i) )
     AAdd(aInfo,"Called from " + Trim( ProcName(i) )   + "(" + ;
                 LTrim( Str( ProcLine(i) ) ) + ")" )
   ENDDO

   DC_MsgBox(,,aInfo)
Endif
BREAK
RETURN

* -----------------

FUNCTION DC_GetWhen( aGetList, nElement, lTestProtect, acId, acGroup )

LOCAL nType, oXbp, i, nStart, nEnd, lStatus := .f.

IF Valtype(aGetList) == 'O' .AND. !aGetlist:isDerivedFrom('DC_GetList')
  RETURN _GetWhen(aGetList)
ELSEIF Valtype(aGetlist) == 'O' .AND. aGetlist:isDerivedFrom('DC_GetList')
  aGetlist := aGetList:getListArray
ENDIF

IF Valtype(acId) == 'C'
  acId := { acId }
ENDIF
IF Valtype(acId) == 'A'
  FOR i := 1 TO Len(acId)
    nElement := AScan(aGetList,{|a|DC_XtoC(a[cGETLIST_ID]) == acId[i]})
    IF nElement > 0
      DC_GetWhen(aGetList,nElement)
    ELSE
      RETURN .f.
    ENDIF
  NEXT
ENDIF

IF Valtype(acGroup) == 'C'
  acGroup := { acId }
ENDIF

DEFAULT lTestProtect := .f.

IF Empty(nElement) .AND. Valtype(acGroup) == 'A'
  FOR i := 1 TO Len(acGroup)
    nElement := 0
    DO WHILE (nElement := AScan(aGetList,{|a|DC_XtoC(a[cGETLIST_GETGROUP]) == acGroup[i]},nElement+1)) > 0
      IF (Valtype(aGetList[nElement,bGETLIST_WHEN]) = 'B' .OR. Valtype(aGetList[nElement,bGETLIST_HIDE]) = 'B')
        _DCGetWhen(aGetList,nElement,nElement,lTestProtect)
      ENDIF
    ENDDO
  NEXT
  RETURN .t.
ENDIF

IF Valtype(nElement) = 'N'
  nStart := nElement
  nEnd := nElement
ELSE
  nStart := 1
  nEnd := Len(aGetList)
ENDIF

IF Valtype(aGetList)='A' .AND. !Empty(aGetList) .AND. ;
         Len(aGetList[1]) >= nGET_ARRAY_SIZE

  lStatus := _DCGetWhen( aGetList, nStart, nEnd, lTestProtect )
ENDIF

RETURN lStatus

* ---------------

STATIC FUNCTION _DCGetWhen( aGetList, nStart, nEnd, lTestProtect )

LOCAL i, j, nType, nSubType, oXbp, lProtect, lEnable, lShow, ;
      bWhen, bHide, lHide, aItem, aList, cCaption

lProtect := .f.
lEnable := .f.
lShow := .f.

FOR i := nStart TO nEnd

  nType := aGetlist[i,nGETLIST_TYPE]
  nSubType := aGetList[i,nGETLIST_SUBTYPE]
  oXbp := aGetlist[i,oGETLIST_OBJECT]
  lProtect := .f.
  lEnable := .t.
  lShow := .t.

  IF nType == GETLIST_DATASTORE .OR. nType == GETLIST_RMCHARTREGION
    LOOP
  ELSEIF Valtype(oXbp) # 'O'
    LOOP
  ELSEIF oXbp:isDerivedFrom('DC_QbColumn')
    LOOP
  ELSEIF oXbp:status() <= 0 .AND. !oXbp:isDerivedFrom('XbpColumn')
    LOOP
  ELSEIF IsMethod(oXbp,'WhenHideEval')
    IF lTestProtect
      lProtect := .f.
      oXbp:WhenHideEval( @lEnable, @lShow, @lProtect )
    ELSE
      oXbp:WhenHideEval( @lEnable, @lShow )
    ENDIF
  ELSEIF nType == GETLIST_TREEITEM .OR. oXbp:isDerivedFrom('XbpTreeViewItem')
    bWhen := oXbp:checkWhenBlock
    IF Valtype(bWhen) = 'B'
      lEnable := Eval(bWhen,oXbp)
      oXbp:checkitem(lEnable)
    ENDIF

  // This below code has been moved to a function named DC_MenuWhenChecked()
  // The WHEN and CHECKWHEN clauses now are evaluated when the menu is invoked
  // Improves performance

  /*
  ELSEIF nType == GETLIST_MENUBAR .OR. nType == GETLIST_SUBMENU

    aList := oXbp:cargo[4]   // WHEN clauses
    FOR j := 1 TO LEN(aList)
      bWhen := aList[j,1]
      IF Valtype(bWhen) = 'B'
        lEnable := .t. // Eval(bWhen,oXbp)
//
//          IF lEnable
//             oXbp:enableitem(j)
//          ELSE
//             oXbp:disableitem(j)
//          ENDIF
//
// 08-apr-2006 J. Duijf.
// To prevent a overload of enable/disable drawing of menu items, causing extreme flickering
// if multiple WHEN clauses are used in DCMENU, and OWNERDRAW is enabled, the item is only disabled
// when it is enabled, and enabled when it's disabled
//
        IF lEnable
          if !oXbp:isItemEnabled(j)
             oXbp:enableitem(j)
          endif
        ELSE
          if oXbp:isItemEnabled(j)
             oXbp:disableitem(j)
          endif
        ENDIF
      ENDIF
    NEXT

    aList := oXbp:cargo[7]   // CHECK clauses
    FOR j := 1 TO LEN(aList)
      bWhen := aList[j,1]
      IF Valtype(bWhen) = 'B'
        lEnable := Eval(bWhen,oXbp)
        oXbp:checkitem(j,lEnable)
      ENDIF
    NEXT

    aList := oXbp:cargo[8]  // CAPTIONS
    FOR j := 1 TO LEN(aList)
      cCaption := aList[j]
      IF Valtype(cCaption) = 'B'
        cCaption := Eval(cCaption)
        aItem := oXbp:getItem(j)
        IF Valtype(aItem[1]) = 'C' .AND. aItem[1] # cCaption
          aItem[1] := cCaption
          oXbp:setItem(j,aItem)
        ELSEIF ValType(aItem[1]) = "O" .AND. aItem[1]:IsDerivedFrom("XbpMenu") .AND. ;
            aItem[1]:title # cCaption
          aItem[1]:setTitle(cCaption)
        ENDIF
      ENDIF
    NEXT
    LOOP
    */

  ELSE

    IF Valtype(aGetList[i,bGETLIST_WHEN]) = 'B' .AND. IsMethod(oXbp,'ENABLE')
      lEnable := Eval(aGetList[i,bGETLIST_WHEN],oXbp)
      IF lEnable
        // 25-aug-2009 Jack Duijf
        // Only Enable if Disabled
        if !oXbp:IsEnabled()
          oXbp:enable()
        endif
      ELSE
        // 25-aug-2009 Jack Duijf
        // Only Disable if Enabled
        if oXbp:IsEnabled()
         oXbp:disable()
        endif
      ENDIF
    ENDIF
    IF Valtype(aGetList[i,bGETLIST_HIDE]) = 'B' .AND. IsMethod(oXbp,'SHOW')
      lShow := !Eval(aGetList[i,bGETLIST_HIDE],oXbp)
      IF lShow
        // 25-aug-2009 Jack Duijf
        // Only Show if Hidden
        if !oXbp:IsVisible()
           oXbp:show()
        endif
      ELSE
        // 25-aug-2009 Jack Duijf
        // Only Hide is visible
         if oXbp:IsVisible()
            oXbp:hide()
         endif
      ENDIF
    ENDIF

    IF Valtype(lProtect) == 'L' .AND. Valtype(aGetList[i,bGETLIST_PROTECT]) = 'B'
      lProtect := Eval(aGetList[i,bGETLIST_PROTECT],oXbp)
    ENDIF
  ENDIF

NEXT

RETURN lEnable .AND. lShow .AND. !lProtect


* ---------------

STATIC FUNCTION _GetWhen( oXbp )

LOCAL aGetList, nPointer

IF !oXbp:isDerivedFrom('DC_XbaseParts')
  RETURN nil
ENDIF

aGetList := oXbp:cargo[2]
nPointer := oXbp:cargo[1]

RETURN DC_GetWhen( aGetList, nPointer )

*----------------

FUNCTION DC_MenuWhenChecked( oXbp, lSetFlag )

LOCAL bWhen, i, j, aChildList, aList, aItem, cCaption, lEnable

DEFAULT lSetFlag := .t.

IF lSetFlag
  slMenuWhenFlag := .t.
ENDIF

IF oXbp:isDerivedFrom('DC_WindowMenu')
  RETURN nil
ENDIF

IF Valtype(oXbp:cargo) # 'A' .OR. Len(oXbp:cargo) < 8 .OR. Valtype(oXbp:cargo[4]) # 'A'
  RETURN nil
ENDIF

aList := oXbp:cargo[4]   // WHEN clauses
IF Valtype(aList) == 'A'
  FOR j := 1 TO LEN(aList)
    IF aList[j] == nil
      LOOP
    ENDIF
    IF Valtype(aList[j]) == 'B'
      bWhen := aList[j]
    ELSE
      bWhen := aList[j,1]
    ENDIF
    IF Valtype(bWhen) = 'B'
      lEnable := Eval(bWhen,oXbp)
      IF lEnable .AND. !oXbp:isItemEnabled(j)
        oXbp:enableitem(j)
      ELSEIF !lEnable .AND. oXbp:isItemEnabled(j)
        oXbp:disableitem(j)
      ENDIF
    ELSE
      IF !oXbp:IsItemEnabled(j)
        oXbp:enableItem(j)
      ENDIF
    ENDIF
  NEXT
ENDIF

aList := oXbp:cargo[7]   // CHECK clauses
IF Valtype(aList) == 'A'
  FOR j := 1 TO LEN(aList)
    IF aList[j] == nil
      LOOP
    ENDIF
    IF Valtype(aList[j]) == 'B'
      bWhen := aList[j]
    ELSE
      bWhen := aList[j,1]
    ENDIF
    IF Valtype(bWhen) = 'B'
      lEnable := Eval(bWhen,oXbp)
      IF lEnable .AND. !oXbp:isItemChecked(j)
        oXbp:checkitem(j,.t.)
      ELSEIF !lEnable .AND. oXbp:isItemChecked(j)
        oXbp:checkitem(j,.f.)
      ENDIF
    ENDIF
  NEXT
ENDIF

aList := oXbp:cargo[8]  // CAPTIONS
IF Valtype(aList) == 'A'
  FOR j := 1 TO LEN(aList)
    cCaption := aList[j]
    IF Valtype(cCaption) = 'B'
      cCaption := Eval(cCaption)
      aItem := oXbp:getItem(j)
      IF Valtype(aItem[1]) = 'C' .AND. aItem[1] # cCaption
        aItem[1] := cCaption
        oXbp:setItem(j,aItem)
      ELSEIF ValType(aItem[1]) = "O" .AND. aItem[1]:IsDerivedFrom("XbpMenu") .AND. ;
        aItem[1]:title # cCaption
        aItem[1]:setTitle(cCaption)
      ENDIF
    ENDIF
  NEXT
ENDIF

aChildList := oXbp:childList()
FOR i := 1 TO Len(aChildList)
  DC_MenuWhenChecked(aChildList[i])
NEXT

RETURN nil

* ---------------

STATIC FUNCTION _MenuWhen( oMenu )

LOCAL aList, i, bWhen, aChildList, lEnable

IF !oMenu:isDerivedFrom('DC_WindowMenu')
  RETURN nil
ENDIF

aList := oMenu:cargo[4]

FOR i := 1 TO LEN(aList)
  bWhen := aList[i,1]
  IF Valtype(bWhen) = 'B'
    lEnable := Eval(bWhen,oMenu)
    aList[i,2] := lEnable
    IF lEnable
      oMenu:enableitem(i)
    ELSE
      oMenu:disableitem(i)
    ENDIF
  ENDIF
NEXT
aChildList := oMenu:ChildList()
FOR i := 1 TO Len(aChildList)
  _MenuWhen( aChildList[i] )
NEXT

RETURN nil

* ---------------

FUNCTION DC_GetOptDefault( aGetOptions, lExpress )

STATIC aGetOptDefault := {}
LOCAL i
LOCAL aGetOptValid := ;
     { 'Untitled',                            /*  1 cGETOPT_NAME         */   ;
       '',                                    /*  2 cGETOPT_TITLE        */   ;
       24*20,                                 /*  3 nGETOPT_WNDHEIGHT    */   ;
       80*7,                                  /*  4 nGETOPT_WNDWIDTH     */   ;
       20,                                    /*  5 nGETOPT_ROWSPACE     */   ;
       nil,                                   /*  6 nGETOPT_SAYWIDTH     */   ;
       nil,                                   /*  7 oGETOPT_SAYFONT      */   ;
       nil,                                   /*  8 oGETOPT_GETFONT      */   ;
       20,                                    /*  9 nGETOPT_GETHEIGHT    */   ;
       nil,                                   /* 10 aGETOPT_BUTTONS      */   ;
       nil,                                   /* 11 nGETOPT_WNDROW       */   ;
       nil,                                   /* 12 nGETOPT_WNDCOL       */   ;
       0,                                     /* 13 nGETOPT_ROWOFFSET    */   ;
       0,                                     /* 14 nGETOPT_COLOFFSET    */   ;
       .f.,                                   /* 15 lGETOPT_DESIGN       */   ;
       nil,                                   /* 16 cGETOPT_MENU         */   ;
       .f.,                                   /* 17 lGETOPT_PIXEL        */   ;
       nil,                                   /* 18 xGETOPT_SPARE        */   ;
       1,                                     /* 19 nGETOPT_ICON         */   ;
       .f.,                                   /* 20 lGETOPT_CHECKGET     */   ;
       nil,                                   /* 21 cGETOPT_HELPFILE     */   ;
       .f.,                                   /* 22 lGETOPT_VISIBLE      */   ;
       .t.,                                   /* 23 lGETOPT_TRANSLATE    */   ;
       .f.,                                   /* 24 lGETOPT_SAYRIGHT     */   ;
       nil,                                   /* 25 nGETOPT_BITMAP       */   ;
       nil,                                   /* 26 nGETOPT_PRESENT      */   ;
       nil,                                   /* 27 nGETOPT_BGCOLOR      */   ;
       0,                                     /* 28 nGETOPT_SAYOPT       */   ;
       nil,                                   /* 29 bGETOPT_EVAL         */   ;
       nil,                                   /* 30 nGETOPT_MODALSTATE   */   ;
       20,                                    /* 31 nGETOPT_SAYHEIGHT    */   ;
       .t.,                                   /* 32 lGETOPT_MINBUTTON    */   ;
       .t.,                                   /* 33 lGETOPT_MAXBUTTON    */   ;
       .f.,                                   /* 34 lGETOPT_TABSTOP      */   ;
       {.f.,nil},                             /* 35 lGETOPT_ABORTQUERY   */   ;
       20,                                    /* 36 nGETOPT_ROWPIXELS    */   ;
       7.0,                                   /* 37 nGETOPT_COLPIXELS    */   ;
       .t.,                                   /* 38 nGETOPT_ESCAPEKEY    */   ;
       '',                                    /* 39 cGETOPT_SOURCECODE   */   ;
       {GRA_CLR_BLACK,GRA_CLR_WHITE},         /* 40 aGETOPT_TOOLCOLOR    */   ;
       nil,                                   /* 41 nGETOPT_BORDER       */   ;
       .f.,                                   /* 42 lGETOPT_EXVALID      */   ;
       {.f.,nil},                             /* 43 lGETOPT_CLOSEQUERY   */   ;
       .f.,                                   /* 44 lGETOPT_NOTASKBAR    */   ;
       nil,                                   /* 45 aGETOPT_MINSIZE      */   ;
       nil,                                   /* 46 aGETOPT_MAXSIZE      */   ;
       .f.,                                   /* 47 lGETOPT_NORESIZE     */   ;
       .f.,                                   /* 48 lGETOPT_NOTITLEBAR   */   ;
       .f.,                                   /* 49 lGETOPT_NOMOVE       */   ;
       XBPDLG_ORIGIN_OWNER,                   /* 50 nGETOPT_ORIGIN       */   ;
       nil,                                   /* 51 nGETOPT_HILITEGETS   */   ;
       .t.,                                   /* 52 lGETOPT_SUPERVISE    */   ;
       .f.,                                   /* 53 lGETOPT_HIDE         */   ;
       .f.,                                   /* 54 lGETOPT_NOBUSY       */   ;
       '',                                    /* 55 cGETOPT_BUSYMSG      */   ;
       0,                                     /* 56 nGETOPT_DESIGNKEY    */   ;
       .f.,                                   /* 57 lGETOPT_CASCADE      */   ;
       .f.,                                   /* 58 lGETOPT_AUTORESIZE   */   ;
       nil,                                   /* 59 aGETOPT_COLORGETS    */   ;
       .t.,                                   /* 60 lGETOPT_CONFIRM      */   ;
       nil,                                   /* 61 nGETOPT_FITPAD       */   ;
       0,                                     /* 62 nGETOPT_BUTTONALIGN  */   ;
       {.f.,nil},                             /* 63 lGETOPT_EXITQUERY    */   ;
       nil,                                   /* 64 nGETOPT_DISABLEDCOLOR*/   ;
       .f.,                                   /* 65 lGETOPT_ENTERTAB     */   ;
       nil,                                   /* 66 bGETOPT_PREEVAL      */   ;
       nil,                                   /* 67 cGETOPT_FONT         */   ;
       nil,                                   /* 68 bGETOPT_EDITPROTECT  */   ;
       nil,                                   /* 69 oGETOPT_MESSAGEINTO  */   ;
       nil,                                   /* 70 bGETOPT_NOEDITNAVKEYS*/   ;
       nil,                                   /* 71 aGETOPT_BUTTONSOUND  */   ;
       .f.,                                   /* 72 lGETOPT_MESSAGECLEAR */   ;
       nil,                                   /* 73 cGETOPT_HELPCODE     */   ;
       .f.,                                   /* 74 lGETOPT_AUTOWINMENU  */   ;
       nil,                                   /* 75 cGETOPT_KEYBOARD     */   ;
       .f.,                                   /* 76 lGETOPT_NOWINMENU    */   ;
       {.f.,nil},                             /* 77 lGETOPT_QUITQUERY    */   ;
       nil,                                   /* 78 cGETOPT_TOOLFONT     */   ;
       nil,                                   /* 79 nGETOPT_TOOLTIME     */   ;
       .f.,                                   /* 80 lGETOPT_AUTOFOCUS    */   ;
       .f.,                                   /* 81 lGETOPT_COMPATIBLE   */   ;
       .f.,                                   /* 82 lGETOPT_RESIZE       */   ;
       nil,                                   /* 83 aGETOPT_SCALEFACTOR  */   ;
       nil,                                   /* 84 cGETOPT_FONTDEFAULT  */   ;
       {nil,nil},                             /* 85 aGETOPT_RESIZEDEFAULT*/   ;
       nil,                                   /* 86 lGETOPT_NOTABSTOP    */   ;
       .f.,                                   /* 87 lGETOPT_ALWAYSONTOP  */   ;
       nil,                                   /* 88 bGETOPT_ONCLICK      */   ;
       .f.,                                   /* 89 lGETOPT_ENTEREXIT    */   ;
       .f.,                                   /* 90 lGETOPT_RESTDEFBUTT  */   ;
       0,                                     /* 91 nGETOPT_SCROLLBARS   */   ;
       'W',                                   /* 92 cGETOPT_GETTEMPLATE  */   ;
       nil,                                   /* 93 bGETOPT_EDITPROTECTSAFE */;
       .f.,                                   /* 94 lGETOPT_LOCKTOOWNER  */   ;
       '' ,                                   /* 95 cGETOPT_SOURCEEDITOR */   ;
       .f.,                                   /* 96 lGETOPT_NO_UNDO      */   ;
       nil,                                   /* 97 nGETOPT_GESTURES     */   ;
       nil,                                   /* 98 bGETOPT_GESTUREHANDLER*/  ;
       .f.,                                   /* 99 lGETOPT_SLEEP        */   ;
       .f.,                                   /*100 lGETOPT_STOREPROFILE */   ;
       nil                                    /*101 nGETOPT_BUSYCOLOR    */   ;
     }

LOCAL aOldOptions

DEFAULT lExpress := .f.
IF lExpress
  RETURN aGetOptValid
ENDIF

IF Valtype( aGetOptions ) = 'A' .OR. Empty(aGetOptDefault)
  IF Valtype(aGetOptions) = 'A'
    aGetOptDefault := AClone(aGetOptions)
  ENDIF
  ASize(aGetOptDefault,nGETOPT_ARRAY_SIZE)
  FOR i := 1 TO nGETOPT_ARRAY_SIZE
    IF Len(aGetOptValid) < i
      EXIT
    ENDIF
    IF !(Valtype(aGetOptDefault[i]) == Valtype(aGetOptValid[i])) .AND. !(aGetOptValid[i]==NIL)
       aGetOptDefault[i] := aGetOptValid[i]
    ENDIF
  NEXT
  IF Valtype(aOldOptions) # 'A'
     aOldOptions := AClone(aGetOptDefault)
  ENDIF
ELSE
  aOldOptions := AClone(aGetOptDefault)
ENDIF

RETURN aOldOptions

* ---------------

FUNCTION DC_GetEditActive( oXbp )

STATIC soXbpActive := nil

IF PCount() == 1
  soXbpActive := oXbp
ELSEIF Valtype(soXbpActive) == 'O'
  oXbp := soXbpActive
  IF Valtype(oXbp:cargo)='A' .AND. ;
       Valtype(oXbp:cargo[1]) = 'A' .AND. ;
         Valtype(oXbp:cargo[1,1])='N' .AND. oXbp:cargo[1,1] == PICKPOINTER
     oXbp := oXbp:cargo[1,3] // s::editControls[oXbp:cargo[1,2]]
     oXbp:exitState := MOUSE_ENTER
  ENDIF
ENDIF
RETURN oXbp

* ---------------

FUNCTION DC_GetEditUpdated( lUpdated )

STATIC slUpdated := .f.

IF Valtype(lUpdated)  = 'L'
  slUpdated := lUpdated
ENDIF
RETURN slUpdated

* ---------------

FUNCTION DC_GetColBlock( nElement, oXbp )

RETURN {|u|DC_GetColArray(nElement,oXbp,u)}

* ---------------

FUNCTION DC_GetEditPick( lPick )

Grok(lPick)

RETURN .f.

* ---------------

FUNCTION DC_GetEditList( aGetList )

LOCAL aOldGetList, oGetList

oGetList := DC_GetListObject( aGetList )

aOldGetList := oGetList:editControls
IF Valtype(aGetList) = 'A'
  oGetList:editControls := aGetList
ENDIF
RETURN aOldGetList

* ---------------

FUNCTION DC_VarFromListBox( oXbp )

LOCAL aArray, i := 0, imax, bOutVar, oListBox, lDataLink, cValType, xValue

IF oXbp:isDerivedFrom('XbpComboBox')
  oListBox := oXbp:XbpListBox
ELSEIF oXbp:isDerivedFrom('XbpListBox')
  oListBox := oXbp
ELSEIF oXbp:isDerivedFrom('XbpPickList')
  oListBox := oXbp:rightListBox
ELSE
  RETURN nil
ENDIF
aArray := oListBox:getData() // numeric indexes

imax := Len(aArray)
DO WHILE ++i <= imax               // assign character strings
  aArray[i] := oListBox:getItem( aArray[i] )
ENDDO

IF IsMemberVar(oXbp,'VARBLOCK')
  bOutVar := oXbp:varBlock
ENDIF
IF Valtype(aArray) = 'A' .AND. Valtype(bOutVar) == 'B'
  xValue := Eval(bOutVar)
  cValtype := Valtype(xValue)
  lDataLink := DC_GetDataLink(.f.)
  IF cValtype='C' .AND. Len(aArray) >= 1
    aArray := aArray[1]
  ENDIF
  IF cValtype == Valtype(aArray)
    Eval(bOutVar,aArray)
  ENDIF
  DC_GetDataLink(lDataLink)
ENDIF
RETURN aArray

* ---------------

FUNCTION DC_VarToListBox( oXbp, aVar, aMarked )

LOCAL bVar, aArray, i, oListBox, aArrayLeft, aArrayRight

IF oXbp:isDerivedFrom('XbpComboBox')
  oListBox := oXbp:XbpListBox
ELSEIF oXbp:isDerivedFrom('XbpListBox')
  oListBox := oXbp
ELSEIF oXbp:isDerivedFrom('DC_XbpPickList')
  oXbp:leftListBox:clear()
  oListBox := oXbp:leftListBox
  IF Valtype(aVar) = 'A'
    aArrayLeft := aVar
  ELSE
    bVar := oXbp:leftAnchor
    aArrayLeft := Eval(bVar)
  ENDIF
  oXbp:rightListBox:clear()
  oListBox := oXbp:rightListBox
  IF Valtype(aMarked) = 'A'
    aArrayRight := aMarked
  ELSE
    bVar := oXbp:dataLink
    aArrayRight := Eval(bVar)
  ENDIF
  oXbp:SetData(aArrayLeft,aArrayRight)
  RETURN nil
ELSE
  RETURN nil
ENDIF
oListBox:clear()
IF Valtype(aVar) = 'A'
   aArray := aVar
ELSE
  bVar := oXbp:listBlock
  aArray := Eval(bVar)
ENDIF
IF Valtype(aArray) = 'A'
  FOR i := 1 TO LEN(aArray)
    oListBox:Additem(aArray[i])
  NEXT
  IF oXbp:isDerivedFrom('XbpPickList')
    oXbp:SetData(aArray)
  ELSEIF Valtype(aMarked) = 'A' // Preset the list
    oListBox:setData(aMarked, .T.)
    DC_VarFromListBox(oXbp)
  ENDIF
ENDIF

RETURN nil

* ---------------

STATIC FUNCTION _SetFocusEdit( aEdit, i, lDown, oParent, lSupervise, lEnterExit, oGetList )

LOCAL lHitBottom := .f., nPass

IF Len(aEdit) = 1
  PostAppEvent(xbeP_KillInputFocus,,,aEdit[1])
  RETURN .t.
ENDIF
nPass := 0

IF lDown
  DO WHILE nPass < 2
    IF i = LEN(aEdit)
      IF Set(_SET_WRAP) .OR. lEnterExit
        i := 1
        lHitBottom := .t.
        nPass++
      ELSE
        lHitBottom := .t.
        EXIT
      ENDIF
    ELSE
      i++
    ENDIF
    IF IIF( lSupervise, aEdit[i]:setParent() == oParent, .t. ) .AND. ;
             DC_GetWhen(aEdit[i]:cargo[2],aEdit[i]:cargo[1],.t.) .AND. ;
             !(IsMemberVar(aEdit[i],"isNoEditNavKey") .AND. aEdit[i]:isNoEditNavKey)
      IF !lSupervise .AND. aEdit[i]:setParent() # oParent
         _SetFocusParent(aEdit[i])
      ENDIF
      SetAppFocus( aEdit[i] )
      EXIT
    ENDIF
  ENDDO
ELSE
  DO WHILE nPass < 2
    IF i = 1
      IF Set(_SET_WRAP)
        i := LEN(aEdit)
        nPass++
      ELSE
        EXIT
      ENDIF
    ELSE
      i--
    ENDIF
    IF IIF( lSupervise, aEdit[i]:setParent() == oParent, .t. ) .AND. ;
             DC_GetWhen(aEdit[i]:cargo[2],aEdit[i]:cargo[1],.t.) .AND. ;
             !(IsMemberVar(aEdit[i],"isNoEditNavKey") .AND. aEdit[i]:isNoEditNavKey)
      IF !lSupervise .AND. aEdit[i]:setParent() # oParent
         _SetFocusParent(aEdit[i])
      ENDIF
      SetAppFocus( aEdit[i] )
      EXIT
    ENDIF
  ENDDO
ENDIF

RETURN lHitBottom

* ---------------

STATIC FUNCTION _SetFocusParent( oXbp )

LOCAL aObjects := {}, i

DO WHILE .t.
  oXbp := oXbp:setParent()
  IF Valtype(oXbp)#'O' .OR. oXbp:isDerivedFrom('XbpIWindow')
    EXIT
  ENDIF
  AAdd(aObjects,oXbp)
ENDDO
FOR i := Len(aObjects) TO 1 STEP -1
  SetAppFocus(aObjects[i])
NEXT

RETURN nil

* ---------------

STATIC FUNCTION _SetFocusBrow( mp1, oBrowse, GetList )

LOCAL oColumn, lOk

oColumn := oBrowse:getColumn(oBrowse:colPos)
IF !_BrowColValid( oColumn, GetList )
  RETURN .f.
ENDIF

lOk := DC_GetWhen( GetList, oColumn:cargo[1] )

IF lOk
  PostAppEvent( xbeP_KillInputFocus, nil, nil, oColumn )
ENDIF
lOk := .f.

IF mp1 = xbeK_RIGHT
  oColumn := oBrowse:getColumn(oBrowse:colPos+1)
  IF !_BrowColValid( oColumn, GetList )
    RETURN .f.
  ELSEIF DC_GetWhen( GetList, oColumn:cargo[1] )
    lOk := .t.
  ELSEIF oBrowse:colPos < oBrowse:colCount - 1
    PostAppEvent( xbeP_Keyboard, xbeK_RIGHT, nil, oBrowse )
  ELSE
    PostAppEvent( xbeP_Keyboard, xbeK_LEFT, nil, oBrowse )
  ENDIF
ELSEIF mp1 = xbeK_LEFT
  oColumn := oBrowse:getColumn(oBrowse:colPos-1)
  IF !_BrowColValid( oColumn, GetList )
    RETURN .f.
  ELSEIF DC_GetWhen( GetList, oColumn:cargo[1] )
    lOk := .t.
  ELSEIF oBrowse:colPos > 2
    PostAppEvent( xbeP_Keyboard, xbeK_LEFT, nil, oBrowse )
  ELSE
    PostAppEvent( xbeP_Keyboard, xbeK_RIGHT, nil, oBrowse )
  ENDIF
ELSEIF mp1 = xbeK_HOME
  oColumn := oBrowse:getColumn(1)
  IF !_BrowColValid( oColumn, GetList )
    RETURN .f.
  ELSEIF DC_GetWhen( GetList, oColumn:cargo[1] )
    lOk := .t.
  ELSE
    PostAppEvent( xbeP_Keyboard, xbeK_RIGHT, nil, oBrowse )
  ENDIF
ELSEIF mp1 = xbeK_END
  oColumn := oBrowse:getColumn(oBrowse:colCount)
  IF !_BrowColValid( oColumn, GetList )
    RETURN .f.
  ELSEIF DC_GetWhen( GetList, oColumn:cargo[1] )
    lOk := .t.
  ELSE
    PostAppEvent( xbeP_Keyboard, xbeK_LEFT, nil, oBrowse )
  ENDIF
ENDIF

IF lOk
   PostAppEvent( xbeP_SetInputFocus, nil, nil, oColumn )
ENDIF

RETURN .t.

* -----------------

STATIC FUNCTION _BrowColValid( oColumn, GetList )

IF Valtype(oColumn)#'O' .OR. Valtype(oColumn:cargo) # 'A' .OR. ;
   Len(oColumn:cargo) < 3 .OR. ;
   Valtype(oColumn:cargo[1]) # 'N' .OR. ;
   oColumn:cargo[1] > Len(GetList)
  RETURN .f.
ENDIF

RETURN .t.

* ---------------

STATIC FUNCTION _SetFocus( aGetList, oCurrentXbp, nMode )

LOCAL oXbp, oParent, nSavePointer, i

FOR i := 1 TO Len(aGetList)
  oXbp := aGetList[i,oGETLIST_OBJECT]
  IF oXbp == oCurrentXbp
    EXIT
  ENDIF
NEXT
IF i > Len(aGetList)
  RETURN .f.
ENDIF

nSavePointer := i

IF nMode == DCGUI_MOVE_DOWN_PAR .OR. nMode == DCGUI_MOVE_UP_PAR .OR. ;
   nMode == DCGUI_MOVE_TOP_PAR .OR. nMode == DCGUI_MOVE_BOTTOM_PAR
  oParent := oXbp:setParent()
ENDIF

IF nMode == DCGUI_MOVE_DOWN .OR. nMode == DCGUI_MOVE_DOWN_PAR

  DO WHILE .t.
    IF i = LEN(aGetList)
      i := 1
    ELSE
      i++
    ENDIF
    oXbp := aGetList[i,oGETLIST_OBJECT]
    IF _IsEditControl(oXbp) .AND. ;
       ( Valtype(oParent) = 'U' .OR. oXbp:setParent() == oParent ) .AND. ;
       DC_GetWhen( aGetList, i )
      EXIT
    ENDIF
    IF i == nSavePointer
      EXIT
    ENDIF
  ENDDO

ELSEIF nMode == DCGUI_MOVE_UP .OR. nMode == DCGUI_MOVE_UP_PAR

  DO WHILE .t.
    IF i = 1
      i := Len(aGetList)
    ELSE
      i--
    ENDIF
    oXbp := aGetList[i,oGETLIST_OBJECT]
    IF _IsEditControl(oXbp) .AND. ;
      ( Valtype(oParent) = 'U' .OR. oXbp:setParent() == oParent ) .AND. ;
       DC_GetWhen( aGetList, i )
      EXIT
    ENDIF
    IF i == nSavePointer
      EXIT
    ENDIF
  ENDDO

ELSEIF nMode == DCGUI_MOVE_TOP .OR. nMode == DCGUI_MOVE_TOP_PAR

  i := 1
  DO WHILE .t.
    oXbp := aGetList[i,oGETLIST_OBJECT]
    IF _IsEditControl(oXbp) .AND. ;
      ( Valtype(oParent) = 'U' .OR. oXbp:setParent() == oParent ) .AND. ;
       DC_GetWhen( aGetList, i )
      EXIT
    ENDIF
    i++
    IF i == nSavePointer .OR. i == Len(aGetList)
      i := nSavePointer
      EXIT
    ENDIF
  ENDDO

ELSEIF nMode == DCGUI_MOVE_BOTTOM .OR. nMode == DCGUI_MOVE_BOTTOM_PAR

  i := Len(aGetList)
  DO WHILE .t.
    oXbp := aGetList[i,oGETLIST_OBJECT]
    IF _IsEditControl(oXbp) .AND. ;
      ( Valtype(oParent) = 'U' .OR. oXbp:setParent() == oParent ) .AND. ;
       DC_GetWhen( aGetList, i )
      EXIT
    ENDIF
    i--
    IF i == nSavePointer .OR. i == 1
      i := nSavePointer
      EXIT
    ENDIF
  ENDDO

ENDIF

SetAppFocus(oXbp)

RETURN i == nSavePointer

* ----------------

STATIC FUNCTION _IsEditControl( oXbp )

IF Valtype(oXbp) # 'O'
  RETURN .f.
ENDIF

RETURN oXbp:isDerivedFrom('XbpGet') .OR. ;
       oXbp:isDerivedFrom('XbpSle') .OR. ;
       oXbp:isDerivedFrom('XbpRadioButton') .OR. ;
       oXbp:isDerivedFrom('XbpPushButton') .OR. ;
       oXbp:isDerivedFrom('XbpTabPage') .OR. ;
       oXbp:isDerivedFrom('XbpComboBox') .OR. ;
       oXbp:isDerivedFrom('XbpListBox') .OR. ;
       oXbp:isDerivedFrom('XbpBrowseCol') .OR. ;
       oXbp:isDerivedFrom('XbpCheckBox') .OR. ;
       oXbp:isDerivedFrom('XbpSpinButton') .OR. ;
       oXbp:isDerivedFrom('XbpMle') .OR. ;
       oXbp:isDerivedFrom('Xbp3State')

* -----------------

STATIC FUNCTION _PopUp( oXbp )

LOCAL i, aCargo

IF !(oXbp:isDerivedFrom('XbpGet')) .OR. Valtype(oXbp:options)#'A' .OR. ;
      LEN(oXbp:options) = 0
  RETURN .f.
ENDIF
FOR i := 1 TO LEN(oXbp:options)
  aCargo := oXbp:options[i]
  IF Valtype(aCargo[1])='N' .AND. aCargo[1]  == 102
    RETURN .t.
  ENDIF
NEXT
RETURN .f.

* ------------------

FUNCTION DC_ReadGuiAbort( aGetList )

LOCAL oGetList := DC_GetListObject( aGetList )

DC_GetEditActive(nil)

IF DC_GetOrigUpdated(aGetList)
  IF Valtype(oGetList:abortQueryBlock) = 'B'
    IF Eval(oGetList:abortQueryBlock)
      DC_GetListUndo(aGetList)
      oGetList:closeQueryBlock := nil
      oGetList:isOkStatus := .f.
      oGetList:isDialogActive := .f.
      RETURN .t.
    ELSE
      DC_ClearEvents()
      oGetList:isDialogActive := .t.
      RETURN .f.
    ENDIF
  ELSEIF !oGetList:isAbortQuery .OR. DC_MsgBox(,,{DC_LangMsg(DCMSG_ABORTQUERY)},,,,.t.)
    DC_GetListUndo(aGetList)
    oGetList:isOkStatus := .f.
    oGetList:isDialogActive := .f.
    RETURN .t.
  ELSE
    DC_ClearEvents()
    oGetList:isDialogActive := .t.
    RETURN .f.
  ENDIF
ELSEIF Valtype(oGetList:abortQueryBlock) = 'B'
  IF Eval(oGetList:abortQueryBlock)
    DC_GetListUndo(aGetList)
    oGetList:closeQueryBlock := nil
    oGetList:isOkStatus := .f.
    oGetList:isDialogActive := .f.
    RETURN .t.
  ELSE
    oGetList:isDialogActive := .t.
    RETURN .f.
  ENDIF
ELSE
  oGetList:isOkStatus := .f.
ENDIF
oGetList:isDialogActive := .f.
RETURN .t.

* ------------------------------

PROCEDURE DC_ReadGuiExit( aGetList )

LOCAL lOk
LOCAL oGetList

IF Valtype(aGetList) == 'O'
  oGetList := aGetList
  aGetList := oGetList:getListArray
ELSE
  oGetList := DC_GetListObject( aGetList )
ENDIF

DC_GetEditActive(nil)

IF oGetList:isExitValidate
  IF !DC_GetlistValidate(aGetList,,,,,.t.)
    oGetList:isDialogActive := .t.
    RETURN
  ENDIF
ENDIF
IF Valtype(oGetList:exitQueryBlock) = 'B'
  lOk := Eval(oGetList:exitQueryBlock)
  IF Valtype(lOk) # 'L'
    RETURN
  ENDIF
  IF lOk
    oGetList:isOkStatus := .t.
    DC_GetGather(aGetList)
    oGetList:isDialogActive := .f.
  ELSE
    oGetList:isDialogActive := .t.
  ENDIF
ELSEIF !oGetList:isExitQuery .OR. DC_MsgBox(,,{DC_LangMsg(DCMSG_EXITQUERY)},,,,.t.)
  oGetList:isOkStatus := .t.
  oGetList:isDialogActive := .f.
ELSE
  oGetList:isDialogActive := .t.
ENDIF
RETURN

* --------------------------- *

FUNCTION DC_AppEvent( lOk, nExit, nDelay )

LOCAL nEvent, mp1, mp2, oXbp, lDebugEvent, oEventSpy

DEFAULT lOk := .t., ;
        nExit := xbeP_Close, ;
        nDelay := 0

lDebugEvent := DC_BitTest( DC_ReadGuiDebug(), DCGUI_DEBUG_EVENTS )

IF lDebugEvent .AND. snEventSpy = 0
  snEventSpy := DllLoad('EVENTSPY.DLL')
ENDIF

nEvent := -1
DO WHILE lOk .AND. nEvent # nExit
  IF lDebugEvent .AND. snEventSpy > 0
    nEvent := DllCall( snEventSpy, DLL_XPPCALL, 'SpyAppEvent', ;
              @mp1, @mp2, @oXbp, nDelay )
  ELSE
    nEvent := AppEvent( @mp1, @mp2, @oXbp, nDelay )
  ENDIF
  IF Valtype(oXbp) = 'O'
     IF nEvent = xbeP_Keyboard .AND. mp1 = K_ESC
        EXIT
     ELSEIF nEvent = 0 .OR. ( nEvent == xbeM_Motion .AND. mp1 == NIL )
        LOOP
     ENDIF
     oXbp:HandleEvent( nEvent, mp1, mp2 )
  ENDIF
ENDDO
IF lDebugEvent .AND. snEventSpy > 0
   oEventSpy := DllCall( snEventSpy, DLL_XPPCALL, 'EventSpy' )
   oEventSpy:hide()
ENDIF

RETURN nEvent

* --------------- *

FUNCTION DC_GetListUndo( aGetList )

LOCAL i, bBlock, nType, xValue, oGetList

DC_GetDataLink(.f.)

oGetList := DC_GetListObject(aGetList)

IF oGetList:isNoUndo
  RETURN nil
ENDIF

FOR i := 1 TO LEN(aGetList)
  nType := aGetList[i,nGETLIST_TYPE]
  IF aGetList[i,nGETLIST_STARTCOL] == nil  .OR. aGetList[i,nGETLIST_STARTROW] == nil
    IF ( nType = GETLIST_GET .OR. nType = GETLIST_COMBOBOX .OR. ;
                nType = GETLIST_LISTBOX .OR. nType = GETLIST_MLE .OR. ;
                nType = GETLIST_SPINBUTTON .OR. nType = GETLIST_KLMLE .OR. ;
                nType = GETLIST_CHECKBOX .OR. nType = GETLIST_3STATE ) .AND. ;
                Empty(aGetList[i,nGETLIST_POINTER])
      LOOP
    ENDIF
  ENDIF
  IF !(aGetList[i,nGETLIST_TYPE] = GETLIST_BROWSECOL)
    bBlock := aGetList[i,bGETLIST_VAR]
    IF Valtype(bBlock)='A'
      bBlock := bBlock[1]
    ENDIF
    IF Valtype( bBlock ) = 'B'
      xValue := Eval( bBlock )
      IF !(Valtype(xValue) == Valtype(aGetList[i,xGETLIST_ORIGVALUE])) .OR. !(xValue == aGetList[i,xGETLIST_ORIGVALUE])
        Eval( bBlock, aGetList[i,xGETLIST_ORIGVALUE], .t. )
      ENDIF
    ENDIF
  ENDIF
NEXT
DC_GetEditUpdated(.f.)
DC_GetDataLink(.t.)
RETURN nil

* --------------- *

STATIC FUNCTION _TabSelect( aTabPages, nMode )

LOCAL nTab := 0, nStartTab, i, oTabPage

IF Empty(aTabPages)
   RETURN .f.
ENDIF
FOR i := 1 TO Len(aTabPages)
  IF !aTabPages[i]:minimized .AND. aTabPages[i]:isVisible()
    oTabPage := aTabPages[i]
    nTab := i
    nStartTab := i
    EXIT
  ENDIF
NEXT

DO WHILE .t.

  IF nMode = DCGUI_TAB_SELECT_NEXT   // Next Tab
     nTab++
     IF nTab > Len(aTabPages)
       nTab := 1
     ENDIF
     IF !aTabPages[nTab]:isEnabled() .OR. !aTabPages[nTab]:isVisible()
       LOOP
     ENDIF
  ELSEIF nMode = DCGUI_TAB_SELECT_PREVIOUS  // Previous Tab
     nTab--
     IF nTab < 1
        nTab := Len(aTabPages)
     ENDIF
     IF !aTabPages[nTab]:isEnabled() .OR. !aTabPages[nTab]:isVisible()
       LOOP
     ENDIF
  ELSEIF nMode = DCGUI_TAB_SELECT_FIRST  //  First Tab
     nTab := 1
     nMode := DCGUI_TAB_SELECT_NEXT
  ELSEIF nMode = DCGUI_TAB_SELECT_LAST   //  Last Tab
     nTab := Len(aTabPages)
     nMode := DCGUI_TAB_SELECT_PREVIOUS
  ENDIF
  IF nTab = nStartTab
    RETURN .f.
  ELSEIF !(aTabPages[nTab]:setParent() == oTabPage:setParent())
    LOOP
  ENDIF
  PostAppEvent(xbeP_SetInputFocus,,,aTabPages[nTab])
  SetAppFocus(aTabPages[nTab])

  EXIT

ENDDO

RETURN .t.

* --------------- *

STATIC FUNCTION _TabActivate( aTabPages, oTabPage, lFocus )

LOCAL i, bWhen, bValid, nTab, j, aChildList, oParent := SetAppWindow()

IF Empty(aTabPages)
   RETURN nil
ENDIF
IF Valtype(oTabPage) = 'O' .AND. oTabPage:isDerivedFrom('XbpTabPage')
  IF !oTabPage:minimized
     RETURN nil
  ENDIF
  nTab := oTabPage:tabNumber
  bWhen := oTabPage:whenBlock
  oParent := oTabPage:setParent()
ELSE
  nTab := 0
ENDIF
IF (Valtype(bWhen)='B' .AND. !Eval(bWhen)) .OR. !lFocus
  RETURN nil
ENDIF
FOR i := 1 TO LEN(aTabPages)
  IF aTabPages[i]:setParent() == oParent
    IF !aTabPages[i]:minimized
      bValid := aTabPages[i]:validBlock
      IF Valtype(bValid) = 'B' .AND. !Eval(bValid)
         RETURN nil
      ENDIF
      aTabPages[i]:minimize()
    ENDIF
  ENDIF
NEXT
FOR i := 1 TO LEN(aTabPages)
  IF i = nTab
    bWhen := aTabPages[i]:whenBlock
    IF Valtype(bWhen) # 'B' .OR. Eval(bWhen)
      IF Valtype(aTabPages[i]:enabledColorBG) = 'N'
        aTabPages[i]:setColorBG(aTabPages[i]:enabledColorBG)
      ENDIF
      IF Valtype(aTabPages[i]:enabledColorFG) = 'N'
        aTabPages[i]:setColorFG(aTabPages[i]:enabledColorFG)
      ENDIF
      aTabPages[i]:maximize()
      aChildList := aTabPages[i]:childList()
      FOR j := 1 TO Len(aChildList)
        IF aChildList[j]:isDerivedFrom('XbpCrt')
          SetAppFocus(aChildList[j])
          EXIT
        ENDIF
      NEXT
      IF Valtype(aTabPages[i]:actionBlock) = 'B' // Run ACTION block
        Eval(aTabPages[i]:actionBlock)
      ENDIF
    ELSE
      IF Valtype(aTabPages[i]:disabledColorBG) = 'N'
        aTabPages[i]:setColorBG(aTabPages[i]:disabledColorBG)
      ENDIF
      IF Valtype(aTabPages[i]:disabledColorFG) = 'N'
        aTabPages[i]:setColorFG(aTabPages[i]:disabledColorFG)
      ENDIF
    ENDIF
  ENDIF
NEXT
RETURN nil

* --------------- *

FUNCTION DC_GetAssign( nPos, nAssign, aArray, xVar )

IF Valtype(aArray)='A'
  IF Valtype(nAssign)='N'
    xVar := aArray[nAssign]
  ELSE
    nPos := Ascan(aArray,xVar)
    IF nPos = 0
      nPos := 1
    ENDIF
    xVar := aArray[nPos]
  ENDIF
ELSE
  IF Valtype(nAssign)='N'
    xVar := nAssign
    nPos := nAssign
  ELSE
    nPos := xVar
  ENDIF
ENDIF
RETURN xVar

* ----------------------- *

STATIC FUNCTION _GetWidth( nWidth, aOptions, nCol, xOptions, ;
                           nRightMargin, nWindowWidth, lFit )

LOCAL lPopUp := .f., aSubCargo, i

IF Empty(nCol)
  nCol := 0
ENDIF
IF lFit
  RETURN nWidth
ENDIF
IF Valtype(xOptions)='A' .AND. LEN(xOptions) > 0
  FOR i := 1 TO LEN(xOptions)
    aSubCargo := xOptions[i]
    IF Valtype(aSubCargo) = 'A' .AND. Valtype(aSubCargo[1])='N' .AND. aSubCargo[1]  == 102
      lPopUp := .t.
      EXIT
    ENDIF
  NEXT
ENDIF
IF Valtype(aOptions)='A'
  RETURN Min( nWidth, nWindowWidth-nCol-nRightMargin-IIF(lPopUp,20,0) )
ENDIF
RETURN Min( nWidth, aOptions:currentsize()[1]-nCol-nRightMargin-IIF(lPopUp,20,0) )

* ----------------------- *

FUNCTION DC_GetAnchorCB( uVar, cType, xValue, cPicture, bLink, xSetVal, ;
                         aTransform, cVarName )

LOCAL cValType := Valtype(uVar), cAlias

DEFAULT cType := '', ;
        cPicture := '', ;
        cVarName := ''

DO CASE

  CASE Valtype(uVar) = 'B'
    RETURN uVar

  CASE '->' $ cVarName .AND. !Upper(Left(cVarName,3)) == 'M->' .AND. ;
                             !Upper(Left(cVarName,8)) == 'MEMVAR->' .AND. ;
                             !Upper(Left(cVarName,7)) == 'FIELD->' .AND. ;
                             DC_AutoLockEditedRecord()

     cAlias := Substr(cVarName,1,At('->',cVarName)-1)

     IF Valtype(xSetVal)#'U'
       IF Valtype(bLink) == 'B'
         RETURN  {|x| IIf( x==nil, uVar,;
                    uVar := IIF(Valtype(x)='L',IIF(x,xSetVal,uVar),xSetVal)), ;
                    IIF(DC_GetDataLink(),Eval(bLink,x),nil), uVar }
       ELSE
         RETURN  {|x,l| IIf( x==nil, uVar, ;
                    (l:=!(cAlias)->(RecNo())$(cAlias)->(dbRLockList()), ;
                    IIF(l,(cAlias)->(dbRLock()),nil), ;
                    uVar := IIF(Valtype(x)='L',IIF(x,xSetVal,uVar),xSetVal), ;
                    IIF(l,(cAlias)->(dbRUnlock()),nil)))}
       ENDIF

     ELSEIF Valtype(bLink)='B'
       RETURN  {|x| IIf( x==nil .OR. uVar==x, uVar, ;
                    ((cAlias)->(dbRLock()),uVar:=x,(cAlias)->(dbRUnlock()))), ;
                    IIf(DC_GetDataLink(),Eval(bLink,x),nil), uVar }
     ELSE

        RETURN {|x,y,z|GetSetAliased(x,y,z,@uVar,cAlias)}

/*

       RETURN  {|x,y,z,l| ;
                 IIF(Valtype(y)=='O' .AND. IsMemberVar(y,'DATAALIAS'), ;
                 y:dataAlias := cAlias,nil), ;
                 IIf( x==nil .OR. uVar==x, uVar, ;
                 (l:=!(cAlias)->(RecNo())$(cAlias)->(dbRLockList()), ;
                 IIF(l,(cAlias)->(dbRLock()),nil), ;
                 uVar:=x, ;
                 IIF(l,(cAlias)->(dbRUnlock()),nil)))}
*/
     ENDIF


  CASE Valtype(xSetVal)#'U'
     IF Valtype(bLink)='B'
       RETURN  {|x|IIf( x==nil, uVar,;
                  uVar := IIF(Valtype(x)='L',IIF(x,xSetVal,uVar),xSetVal)), ;
                  IIF(DC_GetDataLink(),Eval(bLink,x),nil), uVar }
     ELSE
       RETURN  {|x| IIf( x==nil, uVar, ;
                  uVar := IIF(Valtype(x)='L',IIF(x,xSetVal,uVar),xSetVal))}
     ENDIF

  CASE Valtype(aTransform)=='A'
     IF Valtype(bLink)='B'
       RETURN  {|x| IIf( x==nil, uVar==aTransform[1], uVar:=IIf(x,aTransform[1],aTransform[2]) ), ;
                    IIf(DC_GetDataLink(),Eval(bLink,x),nil), uVar }
     ELSE
       RETURN  {|x| IIf( x==nil, uVar==aTransform[1], uVar:=IIf(x,aTransform[1],aTransform[2]) )}
     ENDIF

  CASE Valtype(xValue)#'U'
     IF Valtype(bLink)='B'
       RETURN  {|x| IIf( x==nil .OR. uVar==x, uVar, uVar:=x), ;
                    IIf(DC_GetDataLink(),Eval(bLink,x),nil), uVar }
     ELSE
       RETURN  {|x| IIf( x==nil .OR. uVar==x, uVar, uVar:=x )}
     ENDIF

  CASE cType $ 'LOAN' .OR. cValType $'CAOM' .OR. !DC_Gui()

     IF Valtype(bLink)='B'
       RETURN  {|x,y| IIf( x==nil .OR. uVar==x, uVar, uVar:=x), ;
                      IIf(DC_GetDataLink(),Eval(bLink,x),nil), ;
                      uVar }
     ELSE
       RETURN  {|x| IIf( x==nil .OR. (Valtype(uVar)==Valtype(x) .AND. uVar==x), uVar, uVar:=x), ;
                    uVar }
     ENDIF

  CASE cValType = 'D'
     IF Valtype(bLink)='B'
       RETURN  {|x,y| IIF( x==nil .OR. uVar==Ctod(x), ;
                      y := Transform(uVar,cPicture), ;
                      uVar := Ctod(x) ) , ;
                      IIF(DC_GetDataLink(),Eval(bLink,x),nil), y }
     ELSE
       RETURN  {|x| IIF( x==nil, Transform(uVar,cPicture), uVar := Ctod(x) ) }
     ENDIF

  CASE cValType = 'L'
     IF Valtype(bLink)='B'
       RETURN  {|x,y| IIF( x==nil , y := IIF(uVar,'Y','N'), ;
                      uVar := IIF(UPPER(x)='Y',.t.,.f.) ), ;
                      IIF(DC_GetDataLink(),Eval(bLink,x),nil), ;
                      y }
     ELSE
       RETURN  {|x| IIF( x==nil , IIF(uVar,'Y','N'), ;
                     uVar := IIF(UPPER(x)='Y',.t.,.f.) ) }
     ENDIF

  CASE cValType = 'N'
     IF Valtype(bLink)='B'
       RETURN  {|x,y| IIF( x==nil , y := Transform(uVar,cPicture), ;
               uVar := Val(x) ), IIF(DC_GetDataLink(),Eval(bLink,x),nil), y }
     ELSE
       RETURN  {|x| IIF( x==nil , Transform(uVar,cPicture), ;
               uVar := Val(x) ) }
     ENDIF

  CASE cValType = 'U'
     RETURN  {|| NIL }

ENDCASE

RETURN nil

* ---------

STATIC FUNCTION GetSetAliased( x, y, z, uVar, cAlias )

LOCAL lNeedsLock

IF Valtype(y)=='O' .AND. IsMemberVar(y,'DATAALIAS')
  y:dataAlias := cAlias
ENDIF

lNeedsLock :=!(cAlias)->(RecNo())$(cAlias)->(dbRLockList()) .AND. x # nil .AND. x # uVar
IF lNeedsLock
  (cAlias)->(dbRLock())
ENDIF

IF x==nil .OR. uVar == x
 // uVar := uVar
ELSE
  uVar := x
ENDIF
IF lNeedsLock
  (cAlias)->(dbRUnlock())
ENDIF

RETURN uVar

* ---------

GETSETFUNCTION DC_AutoLockEditedRecord DEFAULT .t.

* -----------------------

STATIC FUNCTION _GetRow( nRow, nPointer, GetList )

IF Valtype(nRow) = 'N'
  RETURN nRow
ENDIF
RETURN GetList[nPointer,nGETLIST_STARTROW]

* -----------------------

STATIC FUNCTION _GetCol( nCol, nPointer, aGetList )

LOCAL cCaption

IF Valtype(nCol) = 'N'
  RETURN nCol
ENDIF
cCaption := aGetList[nPointer,cGETLIST_CAPTION]
IF Valtype(cCaption)#'C'
  RETURN aGetList[nPointer,nGETLIST_STARTCOL]
ENDIF
RETURN aGetList[nPointer,nGETLIST_STARTCOL] + Len(cCaption) + 1

* -----------------------

FUNCTION DC_ReadPresent( a )

Grok(a)

RETURN nil

* -----------------------

FUNCTION DC_ReadGets( aGetList, cTitle, aReadArea, GetOptions, ;
                      bEventHandler, aRef, oDlg, oAppWindow )

LOCAL i, GetList := {}, nPointer, lEdited := .f.,;
      j, aCargo, nColOffset, nRowOffset, xCargo, bBlock, ;
      bWhen, bValid, lFit := .f., cVarName

IF DC_Gui()

  IF Valtype( GetOptions) # 'A' .OR. Empty(GetOptions)
    GetOptions := DC_GetOptDefault()
  ENDIF

  IF Empty(aReadArea)
    nColOffset := 0
    nRowOffset := 0
    DEFAULT GetOptions[nGETOPT_WNDHEIGHT] := AppDeskTop():currentSize()[2]
    DEFAULT GetOptions[nGETOPT_WNDWIDTH]  := AppDeskTop():currentSize()[1]
    lFit := .t.
  ELSE
    DEFAULT GetOptions[nGETOPT_ROWPIXELS] := 20
    DEFAULT GetOptions[nGETOPT_COLPIXELS] := 7.0
    nColOffset := aReadArea[2] * GetOptions[nGETOPT_COLPIXELS]
    nRowOffset := ( aReadArea[1] * GetOptions[nGETOPT_ROWPIXELS] ) // -20
    GetOptions[nGETOPT_WNDHEIGHT] := (aReadArea[3]-aReadArea[1]+2) * ;
      GetOptions[nGETOPT_ROWPIXELS]
    GetOptions[nGETOPT_WNDWIDTH]  := (aReadArea[4]-aReadArea[2]+1) * ;
      GetOptions[nGETOPT_COLPIXELS]
  ENDIF
  GetOptions[nGETOPT_COLOFFSET] := nColOffset
  GetOptions[nGETOPT_ROWOFFSET] := nRowOffset
  GetOptions[nGETOPT_MODALSTATE] := XBP_DISP_APPMODAL

  lEdited := DC_ReadGui( aGetList, cTitle, GetOptions, .t., ;
                         bEventHandler, aRef, oDlg, lFit, nil, nil, ;
                         oAppWindow, .t., nil, .t. )

ELSE

    FOR i := 1 TO Len(aGetList)

      IF Len(aGetList[i]) < nGET_ARRAY_SIZE
        ASize(aGetList[i],nGET_ARRAY_SIZE)
      ENDIF

      bWhen := aGetList[i,bGETLIST_WHEN]
      IF Valtype(bWhen)='A'
        bWhen := bWhen[1]
      ENDIF

      bValid := aGetList[i,bGETLIST_VALID]
      IF Valtype(bValid)='A'
        bValid := bValid[1]
      ENDIF

      cVarName := aGetList[i,cGETLIST_VARNAME]
      IF Valtype(cVarName) = 'A'
        cVarName := cVarName[1]
      ENDIF

      IF Valtype(aGetList[i,nGETLIST_STARTCOL]) # 'N'
        nPointer := aGetlist[i,nGETLIST_POINTER]
        xCargo := aGetlist[nPointer,xGETLIST_OPTIONS]
        aGetList[i,nGETLIST_STARTCOL] := xCargo[1]
      ENDIF

      IF Valtype(aGetList[i,nGETLIST_STARTROW]) # 'N'
        nPointer := aGetlist[i,nGETLIST_POINTER]
        xCargo := aGetlist[nPointer,xGETLIST_OPTIONS]
        aGetList[i,nGETLIST_STARTROW] := xCargo[2]
      ENDIF

      IF aGetList[i,nGETLIST_TYPE] = GETLIST_SAY
        DEFAULT aGetList[i,cGETLIST_CAPTION] := ''
        aGetList[i,nGETLIST_WIDTH] := ;
                LEN(aGetList[i,cGETLIST_CAPTION])
        DC_GetDevOut( aGetList[i,nGETLIST_STARTROW],;
                      aGetList[i,nGETLIST_STARTCOL],;
                      aGetList[i,cGETLIST_CAPTION],;
                      DC_Gra2Color(aGetList[i,aGETLIST_COLOR]) )
        aGetlist[i,xGETLIST_OPTIONS] := ;
          { aGetlist[i,nGETLIST_STARTCOL] + aGetlist[i,nGETLIST_WIDTH] + 1,;
            aGetlist[i,nGETLIST_STARTROW] }

      ELSEIF aGetList[i,nGETLIST_TYPE] = GETLIST_STATIC

          DispBox( aGetList[i,nGETLIST_STARTROW],;
                   aGetList[i,nGETLIST_STARTCOL],;
                   aGetList[i,nGETLIST_ENDROW],;
                   aGetList[i,nGETLIST_ENDCOL],;
                   aGetList[i,xGETLIST_OPTIONS],;
                   DC_Gra2Color(aGetList[i,aGETLIST_COLOR]) )

      ELSEIF aGetList[i,nGETLIST_TYPE] = GETLIST_GROUPBOX
        DispBox( aGetList[i,nGETLIST_STARTROW],;
                 aGetList[i,nGETLIST_STARTCOL],;
                 aGetList[i,nGETLIST_ENDROW],;
                 aGetList[i,nGETLIST_ENDCOL],;
                 aGetList[i,xGETLIST_OPTIONS],;
                 DC_Gra2Color(aGetList[i,aGETLIST_COLOR]) )
        bBlock := aGetList[i,bGETLIST_GROUP]
        IF Valtype(bBlock)='A'
          bBlock := bBlock[1]
        ENDIF
        Eval( bBlock, i )

      ELSEIF aGetList[i,nGETLIST_TYPE] = GETLIST_RADIOBUTTON
        bBlock := aGetList[i,bGETLIST_PARENT]
        IF Valtype(bBlock)='A'
          bBlock := bBlock[1]
        ENDIF
        IF Valtype(bBlock) = 'B'
          nPointer := Eval(bBlock)
          DevPos( aGetList[i,nGETLIST_STARTROW] + ;
                    aGetList[nPointer,nGETLIST_STARTROW], ;
                  aGetList[i,nGETLIST_STARTCOL] + 3 + ;
                    aGetList[nPointer,nGETLIST_STARTCOL] )
        ELSE
          DevPos( aGetList[i,nGETLIST_STARTROW],;
                  aGetList[i,nGETLIST_STARTCOL] + 3  )
        ENDIF
        DevOut( aGetlist[i,cGETLIST_CAPTION])

        AAdd( GetList, Get():new( ;
                 aGetList[i,nGETLIST_STARTROW] + ;
                   aGetList[nPointer,nGETLIST_STARTROW],;
                   aGetList[i,nGETLIST_STARTCOL] + ;
                   aGetList[nPointer,nGETLIST_STARTCOL],;
                 aGetList[i,bGETLIST_DELIMVAR],;
                 cVarName, nil, nil,;
                 bValid,;
                 bWhen ))
        DC_GetDisplay( GetList )
        GetList := DC_AddCargo( GetList,;
                    { 111,Eval(bBlock),'(*)',;
                      aGetList[i,bGETLIST_READVAR] } )

      ELSEIF aGetList[i,nGETLIST_TYPE] = GETLIST_GET
        bBlock := aGetList[i,bGETLIST_VAR]
        IF Valtype(bBlock)='A'
          bBlock := bBlock[1]
        ENDIF
        AAdd( GetList, Get():new( ;
                         aGetList[i,nGETLIST_STARTROW],;
                         aGetList[i,nGETLIST_STARTCOL],;
                         bBlock,;
                         cVarName,;
                         aGetList[i,cGETLIST_PICTURE],;
                         nil,;
                         bValid,;
                         bWhen ) )
        DC_GetDisplay( GetList )
        IF Valtype(aGetList[i,nGETLIST_POINTER])='N'  // Say Pointer
          nPointer := aGetList[i,nGETLIST_POINTER]
          IF nPointer > 0
            GetList := DC_AddCargo(GetList,{ 108, ;
                         { aGetList[nPointer,nGETLIST_STARTROW],;
                          aGetlist[nPointer,nGETLIST_STARTCOL],;
                          aGetList[nPointer,cGETLIST_CAPTION] }})
          ENDIF
        ENDIF
        IF Valtype(aGetList[i,xGETLIST_OPTIONS])='A'
          aCargo := aGetList[i,xGETLIST_OPTIONS]
          FOR j := 1 TO LEN(aCargo)
            GetList := DC_AddCargo(GetList,aCargo[j,1],aCargo[j,2])
          NEXT
        ENDIF

      ELSEIF aGetList[i,nGETLIST_TYPE] = GETLIST_CHECKBOX
        bBlock := aGetList[i,bGETLIST_PARENT]
        IF Valtype(bBlock)='A'
          bBlock := bBlock[1]
        ENDIF
        IF Valtype(bBlock)='B'
          nPointer := Eval(bBlock)
          DevPos( aGetList[i,nGETLIST_STARTROW] + ;
                    aGetList[nPointer,nGETLIST_STARTROW], ;
                  aGetList[i,nGETLIST_STARTCOL] + 3 + ;
                    aGetList[nPointer,nGETLIST_STARTCOL] )
        ELSE
          DevPos( aGetList[i,nGETLIST_STARTROW],;
                  aGetList[i,nGETLIST_STARTCOL] + 3  )
        ENDIF
        DevOut( aGetlist[i,cGETLIST_CAPTION])

        AAdd( GetList, Get():new( ;
                 aGetList[i,nGETLIST_STARTROW] + ;
                   aGetList[nPointer,nGETLIST_STARTROW],;
                   aGetList[i,nGETLIST_STARTCOL] + ;
                   aGetList[nPointer,nGETLIST_STARTCOL],;
                 aGetList[i,bGETLIST_DELIMVAR],;
                 cVarName, nil, nil,;
                 bValid,;
                 bWhen ))
        DC_GetDisplay( GetList )
        GetList := ;
           DC_AddCargo( GetList,{110,'()',aGetList[i,bGETLIST_READVAR]})

      ENDIF

    NEXT

    lEdited := DC_ReadModal( GetList, cTitle, aReadArea ) .OR. DC_Updated()

ENDIF
RETURN lEdited

* -----------------------

FUNCTION DC_ReadOptions( nType, aOptions )

LOCAL i

DO CASE

  CASE nType = GETLIST_STATIC
     ASize(aOptions,3)
     FOR i := 1 TO 3
       aOptions[i] := IIF(Valtype(aOptions[i])='L',aOptions[i],.f.)
     NEXT
     RETURN XBPSTATIC_TEXT_VCENTER + ;
            IIF(aOptions[1],XBPSTATIC_TEXT_RIGHT,0) + ;
            IIF(aOptions[2],XBPSTATIC_TEXT_LEFT,0) + ;
            IIF(aOptions[3],XBPSTATIC_TEXT_CENTER,0)
ENDCASE
RETURN nil

* -----------------------

FUNCTION DC_GetValid( bAnchor, bValid, uVar )

Grok(bValid)

RETURN Eval(bAnchor,uVar)

* -----------------------

FUNCTION DC_GetAddOption( GetList, xOption, xParam1 )

LOCAL oGet := GetList[LEN(GetList)]

IF VALTYPE( oGet[xGETLIST_OPTIONS] ) # 'A'
  oGet[xGETLIST_OPTIONS] := {}
ENDIF
AADD( oGet[xGETLIST_OPTIONS], { xOption, xParam1 } )
RETURN GetList

* ----------------------

FUNCTION DC_XbpSetColor( aColor, oXbp, oParent, aPres, lSet, lParentColor )

LOCAL nFG, nBG, i

IF !Empty(aPres)
  aPres := _Pres(aPres)
  FOR i := 1 TO Len(aPres)
    IF aPres[i,1] == XBP_PP_FGCLR
      nFG := aPres[i,2]
    ELSEIF aPres[i,1] == XBP_PP_BGCLR
      nBG := aPres[i,2]
    ENDIF
  NEXT
  IF Valtype(nFG)=='N' .AND. Valtype(nBG)=='N'
    RETURN { nil, 15 }
  ENDIF
ENDIF

IF Valtype(aColor) == 'B'
  aColor := Eval(aColor,oXbp)
ENDIF

/*
IF Empty(aColor)
  RETURN nil
ELSEIF Valtype(aColor) = 'A' .AND. Valtype(aColor[1]) = 'B'
  aColor := Eval(aColor[1],oXbp)
ELSEIF Valtype(aColor) = 'B'
  aColor := Eval(aColor,oXbp)
ENDIF
*/

IF Valtype(aColor) = 'A' .AND. Valtype(aColor[1]) = 'B'
  aColor := Eval(aColor[1],oXbp)
ELSEIF Valtype(aColor) = 'B'
  aColor := Eval(aColor,oXbp)
ENDIF

IF Valtype(aColor) # 'A' .OR. ( Len(aColor) = 2 .AND. ;
         !(Valtype(aColor[1]) $ 'AN') .AND. !(Valtype(aColor[2]) $ 'AN') )

  IF lSet .AND. lParentColor
    IF Valtype(oParent) # 'O'
      oParent := oXbp:SetParent()
    ENDIF
    IF IsMethod(oParent,'setColorBG') .AND. !Empty(oParent:setColorBG()) .AND. Valtype(nBG) = 'U'
      oXbp:setcolorBG( oParent:setColorBG() )
    ELSEIF IsMemberVar(oParent,'colorBG') .AND. !Empty(oParent:colorBG) .AND. Valtype(nBG) = 'U'
      oXbp:setcolorBG( oParent:colorBG )
    ENDIF
    IF IsMethod(oParent,'setColorFG') .AND. !Empty(oParent:setColorFG()) .AND. Valtype(nFG) = 'U'
      oXbp:setcolorFG( oParent:setColorFG() )
    ELSEIF IsMemberVar(oParent,'colorFG') .AND. !Empty(oParent:colorFG) .AND. Valtype(nFG) = 'U'
      oXbp:setcolorFG( oParent:colorFG )
    ENDIF
  ENDIF
  RETURN nil

ELSE

  IF Valtype(aColor[1]) = 'A'
    nFG := GraMakeRGBColor(aColor[1])
  ELSE
    nFG := aColor[1]
  ENDIF
  IF Valtype(aColor[2]) = 'A'
    nBG := GraMakeRGBColor(aColor[2])
  ELSE
    nBG := aColor[2]
  ENDIF
  IF Valtype(nFG) = 'C'
    IF Empty(nBG)
      aColor := DC_Color2Gra( nFG )
      nFG := aColor[1]
      nBG := aColor[2]
    ELSE
      nFG := DC_Color2Gra( nFG )[1]
      nBG := DC_Color2Gra( nBG )[1]
    ENDIF
  ENDIF
  IF lSet
    IF Valtype(nFG)='N'
      oXbp:setcolorFG( nFG )
    ELSEIF lParentColor
      IF Valtype(oParent) # 'O'
        oParent := oXbp:SetParent()
      ENDIF
      IF IsMethod(oParent,'setColorFG') .AND. !Empty(oParent:setColorFG())
        oXbp:setcolorBG( oParent:setColorFG() )
      ELSEIF IsMemberVar(oParent,'colorFG') .AND. !Empty(oParent:colorFG)
        oXbp:setcolorFG( oParent:colorFG )
      ENDIF
    ENDIF
    IF Valtype(nBG)='N'
      oXbp:setcolorBG( nBG )
    ELSEIF lParentColor
      IF Valtype(oParent) # 'O'
        oParent := oXbp:SetParent()
      ENDIF
      IF IsMethod(oParent,'setColorBG') .AND. !Empty(oParent:setColorBG())
        oXbp:setcolorBG( oParent:setColorBG() )
      ELSEIF IsMemberVar(oParent,'colorBG') .AND. !Empty(oParent:colorBG)
        oXbp:setcolorBG( oParent:colorBG )
      ENDIF
    ENDIF
  ENDIF
ENDIF

RETURN { nFG, nBG }

* ---------------------- *

METHOD DC_GetList:AutoFit ( oDlg, nFitPad, lMainDialog, aCustomButtons )

LOCAL i, nStartCol := 1000, nStartRow := 1000, nEndCol := 0, nEndRow := 0, ;
      nColOffset, nRowOffset, oXbp, nWidth, nHeight, aChildList, ;
      nCol, nRow, oParent, nButtonCol := 0, aButtons[0], ;
      aCoords, nStatWidth, nStatHeight, nHeightDelta, nButtonHeight := 22, ;
      nButtons, aWorkArea, nScreenWidth, nScreenHeight, aButtonConfig

DEFAULT nFitPad := 10 * ::scaleFactor[1]

nButtons := ::buttons

IF DC_BitTest(::buttons,1)
  AAdd(aButtons,DCGUI_BUTTON_OK)
ENDIF
IF DC_BitTest(::buttons,2)
  AAdd(aButtons,DCGUI_BUTTON_CANCEL)
ENDIF
IF DC_BitTest(::buttons,3)
  AAdd(aButtons,DCGUI_BUTTON_EXIT)
ENDIF
IF DC_BitTest(::buttons,4)
  AAdd(aButtons,DCGUI_BUTTON_HELP)
ENDIF

nButtonCol := nFitPad
IF Len(aButtons) > 0
  FOR i := 1 TO Len(aButtons)
    aButtonConfig := DC_AddButtonConfig(aButtons[i])
    nButtonHeight := Max(nButtonHeight,aButtonConfig[4])
    nButtonCol += (aButtonConfig[3] + 10) * ::scaleFactor[1]
  NEXT
  nButtonCol += nFitPad
ENDIF

IF Valtype( aCustomButtons ) = 'A'
  FOR i := 1 TO Len(aCustomButtons)
    DEFAULT aCustomButtons[i,2] := 60, ;
            aCustomButtons[i,3] := 22
    nButtonCol += (aCustomButtons[i,2] + 10 ) * ::scaleFactor[1]
    nButtons++
    nButtonHeight := Max(nButtonHeight,aCustomButtons[i,3]*::scaleFactor[2])
  NEXT
ENDIF

nHeightDelta := oDlg:currentSize()[2] - oDlg:drawingArea:currentSize()[2]

aChildList := oDlg:drawingarea:ChildList()
FOR i := 1 TO Len(aChildList)
  oXbp    := aChildList[i]
  IF oXbp:isderivedFrom('XbpMenu')
     LOOP
  ENDIF
  nStartCol := Min( nStartCol, oXbp:currentPos()[1] )
  nStartRow := Min( nStartRow, oXbp:currentPos()[2] )
  nEndCol   := Max( nEndCol, oXbp:currentPos()[1]+oXbp:currentSize()[1] )
  nEndRow   := Max( nEndRow, oXbp:currentPos()[2]+oXbp:currentSize()[2] )
NEXT

nStatHeight := 0
nStatWidth := 0

FOR i := 1 TO Len(::statusBar)
  oXbp := ::statusBar[i]
  IF oXbp:align == DCGUI_ALIGN_TOP
    nStatHeight += oXbp:height
  ELSEIF oXbp:align == DCGUI_ALIGN_BOTTOM
    nStatHeight += oXbp:height
  ELSEIF oXbp:align == DCGUI_ALIGN_RIGHT
    nStatWidth += oXbp:width
  ELSEIF oXbp:align == DCGUI_ALIGN_LEFT
    nStatWidth += oXbp:width
  ENDIF
NEXT

nColOffset := nStartCol - nFitPad
// nRowOffset := nStartRow - nFitPad - IIF(nButtons>0,nButtonHeight+18,0)
nRowOffset := nStartRow - nFitPad - ;
              IIF(nButtons>0,(nButtonHeight*::scaleFactor[2])+(1.8*nFitPad),0)

nWidth     := Max( nEndCol - nStartCol + nFitPad*2, nButtonCol ) + GetSystemMetrics(32)*2

// Note to Roger: Use DC_GraQueryTextBox() to calculate actual title width
nWidth  := Max( nWidth, ( Len(oDlg:title) * 8 ) + 40 )

nHeight := nEndRow - nStartRow + ;
           IIF(nButtons>0,(nFitPad*2) + (nButtonHeight*::scaleFactor[2]), 0 ) + ;
           (nFitPad*2) + nHeightDelta // + GetSystemMetrics(32)

FOR i := 1 TO Len(aChildList)
  oXbp := aChildList[i]
  oXbp:setPos( { oXbp:currentPos()[1] - nColOffset, ;
                 oXbp:currentPos()[2] - nRowOffset } )
NEXT

IF lMainDialog .AND. ::isNoResize
  oDlg:minSize := { nWidth, nHeight }
  oDlg:maxSize := { nWidth, nHeight }
ENDIF
IF Valtype(oDlg:minSize) = 'A'
  IF oDlg:minSize[1] = -1
     oDlg:minSize[1] := nWidth
  ENDIF
  IF oDlg:minSize[2] = -1
     oDlg:minSize[2] := nHeight
  ENDIF
ENDIF
IF Valtype(oDlg:maxSize) = 'A'
  IF oDlg:maxSize[1] = -1
     oDlg:maxSize[1] := nWidth
  ENDIF
  IF oDlg:maxSize[2] = -1
     oDlg:maxSize[2] := nHeight
  ENDIF
ENDIF

/*
oDlg:setSize( { nWidth + nStatWidth, oDlg:currentSize()[2] } )
nHeightDelta := oDlg:currentSize()[2] - oDlg:drawingArea:currentSize()[2]
oDlg:setSize( { oDlg:currentSize()[1], nHeight + nStatHeight + nHeightDelta } )
*/

oDlg:setSize( { nWidth + nStatWidth, nHeight + nStatHeight } )

oParent := oDlg:setParent() // AppDeskTop()

aWorkArea := DC_GetWorkArea()
nScreenHeight := aWorkArea[4] - aWorkArea[2]
nScreenWidth  := aWorkArea[3] - aWorkArea[1]

IF lMainDialog .AND. Valtype(::getOptions[nGETOPT_WNDCOL]) = 'N'
  nCol := ::getOptions[nGETOPT_WNDCOL]
ELSEIF oDlg:origin = XBPDLG_ORIGIN_MOUSE
  nCol := nil
ELSEIF oParent == AppDeskTop()
  nCol := (nScreenWidth-nWidth)/2 + aWorkArea[1]
ELSE
  nCol := (oParent:currentSize()[1]-nWidth)/2
ENDIF

IF lMainDialog .AND. Valtype(::getOptions[nGETOPT_WNDROW]) = 'N'
  nRow := ::getOptions[nGETOPT_WNDROW]
ELSEIF oDlg:origin = XBPDLG_ORIGIN_MOUSE
  nRow := nil
ELSEIF oParent == AppDeskTop()
  nRow := (nScreenHeight-nHeight)/2 + (oParent:currentSize()[2]-aWorkArea[4])
ELSE
  nRow := (oParent:currentSize()[2]-nHeight)/2
ENDIF

IF lMainDialog .AND. ::isCascade .AND. !(oParent == AppDeskTop())
  nCol := 0
  nRow := oParent:currentSize()[2]
  aCoords := DC_CascadeCoords(oParent,.f.,{nRow,nCol},.t.,oDlg)
  nRow := aCoords[1] - oDlg:currentSize()[2]
  nCol := aCoords[2]
ENDIF

IF Valtype(nCol) = 'N' .AND. Valtype(nRow) = 'N'
  oDlg:setPos( { nCol, nRow } )
ENDIF

RETURN

* ---------------------

STATIC FUNCTION _ColorBlock( aColor )

IF Valtype(aColor) = 'A' .AND. Len(aColor) = 2
  IF Valtype(aColor[1]) = 'B'
     RETURN aColor[1]
  ELSE
     RETURN {||aColor}
  ENDIF
ENDIF

RETURN nil

* ----------------------

FUNCTION DC_GetDestroy( aGetlist, acoGroup, lRemove, lChildrenOnly, ;
                        lDestroy, oGetList )

LOCAL oXbp, i, j, aChildList, lGoodGroup, oChild, nDataStore, nFound

DEFAULT lRemove := .t., ;
        lChildrenOnly := .f., ;
        lDestroy := .t.

IF Valtype(aGetList) # 'A' .OR. Empty(aGetList)
  RETURN nil
ENDIF

IF Valtype(oGetList) # 'O'
  oGetList := DC_GetListObject( aGetList )
ENDIF

IF Valtype(acoGroup)='C'
  acoGroup := { acoGroup }
ENDIF

IF Valtype(acoGroup) == 'O'

  oXbp := acoGroup
  DO WHILE AScan( aGetList, ;
      {|a,b,o|b:=a[bGETLIST_PARENT], ;
              IIF(Valtype(b)=='B',o:=Eval(b),nil), ;
              IIF(Valtype(b)=='O',o:=b,nil), ;
              oChild := a[oGETLIST_OBJECT], ;
              Valtype(oChild)=='O'.AND. Valtype(o)=='O'.AND.o==oXbp} ) > 0
    DC_GetDestroy( aGetList, oChild, lRemove, .f.,, oGetList )
  ENDDO
  aChildList := oXbp:childList()
  FOR i := 1 TO Len(aChildList)
    oChild := aChildList[i]
    IF IsMethod(oChild,'STATUS') .AND. oChild:status() > 0
      oChild:destroy()
    ENDIF
  NEXT
  IF !lChildrenOnly
    i := AScan( aGetList, {|a|a[oGETLIST_OBJECT]==oXbp} )
    IF i > 0
      oXbp:destroy()
      IF lRemove
        ARemove( aGetList, i )
      ELSE
        aGetList[i,oGETLIST_OBJECT] := nil
      ENDIF
      IF Valtype(oGetList) = 'O'
        i := AScan( oGetList:editControls,oXbp)
        IF i > 0
          ARemove( oGetList:editControls,i)
        ENDIF
      ENDIF
    ENDIF
  ENDIF
  FOR i := 1 TO Len(aGetlist)
    oXbp := aGetList[i,oGETLIST_OBJECT]
    IF Valtype(oXbp) == 'O' .AND. Valtype(oXbp:cargo) == 'A'
      oXbp:cargo[1] := i
    ENDIF
  NEXT

ELSEIF Valtype(acoGroup) == 'A' .AND. !Empty(acoGroup)

  FOR i := 1 TO Len(aGetlist)
    IF Empty(aGetlist[i,cGETLIST_GETGROUP])
       LOOP
    ENDIF
    lGoodGroup := .f.
    FOR j := 1 TO Len(acoGroup)
      IF aGetlist[i,cGETLIST_GETGROUP]==acoGroup[j]
        lGoodGroup := .t.
        EXIT
      ENDIF
    NEXT
    IF !lGoodGroup
       LOOP
    ENDIF
    oXbp := aGetlist[i,oGETLIST_OBJECT]
    aGetlist[i,oGETLIST_OBJECT] := nil

    IF Valtype(oXbp) = 'O' .AND. IsMethod(oXbp,'STATUS') .AND. oXbp:status() > 0
      oXbp:destroy()
      IF Valtype(oGetList) = 'O'
        nFound := AScan( oGetList:editControls,oXbp)
        IF nFound > 0
          ARemove( oGetList:editControls,nFound)
        ENDIF
      ENDIF
    ENDIF

    IF lRemove
      ARemove(aGetlist,i)
      i--
    ENDIF
  NEXT

  FOR i := 1 TO Len(aGetlist)
    oXbp := aGetList[i,oGETLIST_OBJECT]
    IF Valtype(oXbp) == 'O' .AND. Valtype(oXbp:cargo) == 'A'
      oXbp:cargo[1] := i
    ENDIF
  NEXT

ELSE

  FOR i := 1 TO Len(aGetlist)
    oXbp := aGetlist[i,oGETLIST_OBJECT]
    IF Valtype(oXbp) = 'O' .AND. IsMethod(oXbp,'STATUS') .AND. oXbp:status() > 0
      _DelChildren( oXbp, aGetlist, lRemove )
      IF !lChildrenOnly
        oXbp:Destroy()
        aGetList[i,oGETLIST_OBJECT] := nil
        IF lRemove
          ARemove(aGetlist,i)
          i--
        ENDIF
        IF Valtype(oGetList) = 'O'
          i := AScan( oGetList:editControls,oXbp)
          IF i > 0
            ARemove( oGetList:editControls,i)
          ENDIF
        ENDIF
      ENDIF
    ENDIF
  NEXT

  FOR i := 1 TO Len(aGetlist)
    oXbp := aGetList[i,oGETLIST_OBJECT]
    IF Valtype(oXbp) == 'O' .AND. Valtype(oXbp:cargo) == 'A'
      oXbp:cargo[1] := i
    ENDIF
  NEXT

ENDIF

RETURN nil

* -------------------

STATIC FUNCTION _DelChildren( oXbp, aGetList, lRemove )

LOCAL aChildlist, j, k, oChild, oXbpChild

IF !IsMethod( oXbp, 'CHILDLIST' )
  RETURN nil
ENDIF
aChildList := oXbp:ChildList()
FOR j := 1 TO Len(aChildList)
  oChild := aChildList[j]
  IF !Empty(oChild:ChildList())
    _DelChildren( oChild, aGetList, lRemove )
  ENDIF
  FOR k := 1 TO Len(aGetlist)
    oXbpChild := aGetlist[k,oGETLIST_OBJECT]
    IF oXbpChild == oChild
      IF Valtype(oXbp) = 'O' .AND. IsMethod(oXbp,'STATUS') .AND. oXbp:status() > 0
        aGetlist[k,oGETLIST_OBJECT] := nil
        IF lRemove
          ARemove(aGetlist,k)
          k--
        ENDIF
      ENDIF
    ENDIF
  NEXT
NEXT
RETURN nil

* ---------------------

PROCEDURE DC_GetListSet( GetList, nItem, xValue, nSubItem )

IF Valtype(nSubItem) == 'N'
  IF Len(Atail(GetList)[nItem]) < nSubItem
    ASize(Atail(GetList)[nItem],nSubItem)
  ENDIF
  ATail(GetList)[nItem,nSubItem] := xValue
ELSE
  IF nItem > Len(Atail(GetList))
    ASize(Atail(GetList),nItem)
  ENDIF
  Atail(GetList)[nItem] := xValue
ENDIF

RETURN

* ---------------------

/*
CLASS DC_OGet

EXPORTED:
VAR type
VAR caption
VAR varGet
VAR startRow
VAR startCol
VAR width
VAR height
VAR font
VAR when
VAR valid
VAR tooltip
VAR cargo
VAR pres
VAR action
VAR colorFG
VAR colorBG
VAR message
VAR messageInto
VAR helpCode
VAR varName
VAR readVar
VAR delimVar
VAR object
VAR parent
VAR parentID
VAR protect
VAR pixel
VAR cursor
VAR eval
VAR relative
VAR title
VAR id
VAR hide
VAR accelKey
VAR gotFocus
VAR lostFocus
VAR tabStop
VAR tabGroup
VAR visible
VAR getGroup
VAR classType
VAR preEval
VAR postEval
VAR config
VAR resize
VAR scaleFont
VAR options
VAR options2
VAR options3
VAR options4
VAR options5
VAR options6
VAR options7
VAR options8
VAR options9
VAR dragDrop
VAR subClass

INLINE METHOD Init()

RETURN self

ENDCLASS
*/

* ---------------------

FUNCTION DC_GetTemplate( nType, nSubType )

LOCAL lTabStop

DEFAULT nType := 0, ;
        nSubType := 0

IF nType $ { GETLIST_SAY, GETLIST_STATIC, GETLIST_BROWSECOL, GETLIST_DIALOG, ;
             GETLIST_TOOLBAR, GETLIST_MESSAGEBOX, GETLIST_BITMAP, GETLIST_PROGRESS, ;
             GETLIST_STATUSBAR, GETLIST_PANEL }
  lTabStop := .f.
ENDIF

RETURN ;
    { nType,                                    /* nGETLIST_TYPE         */ ;
      nSubType,                                 /* nGETLIST_SUBTYPE      */ ;
      nil,                                      /* cGETLIST_CAPTION      */ ;
      nil,                                      /* bGETLIST_VAR          */ ;
      nil,                                      /* nGETLIST_STARTROW     */ ;
      nil,                                      /* nGETLIST_STARTCOL     */ ;
      nil,                                      /* nGETLIST_ENDROW       */ ;
      nil,                                      /* nGETLIST_ENDCOL       */ ;
      nil,                                      /* nGETLIST_WIDTH        */ ;
      nil,                                      /* nGETLIST_HEIGHT       */ ;
      nil,                                      /* cGETLIST_FONT         */ ;
      nil,                                      /* cGETLIST_PICTURE      */ ;
      nil,                                      /* bGETLIST_WHEN         */ ;
      nil,                                      /* bGETLIST_VALID        */ ;
      nil,                                      /* cGETLIST_TOOLTIP      */ ;
      nil,                                      /* xGETLIST_CARGO        */ ;
      nil,                                      /* aGETLIST_PRESENTATION */ ;
      nil,                                      /* bGETLIST_ACTION       */ ;
      nil,                                      /* oGETLIST_OBJECT       */ ;
      nil,                                      /* xGETLIST_ORIGVALUE    */ ;
      nil,                                      /* xGETLIST_OPTIONS      */ ;
      nil,                                      /* aGETLIST_COLOR        */ ;
      nil,                                      /* cGETLIST_MESSAGE      */ ;
      nil,                                      /* cGETLIST_HELPCODE     */ ;
      nil,                                      /* cGETLIST_VARNAME      */ ;
      nil,                                      /* bGETLIST_READVAR      */ ;
      nil,                                      /* bGETLIST_DELIMVAR     */ ;
      nil,                                      /* bGETLIST_GROUP        */ ;
      nil,                                      /* nGETLIST_POINTER      */ ;
      nil,                                      /* bGETLIST_PARENT       */ ;
      nil,                                      /* bGETLIST_REFVAR       */ ;
      nil,                                      /* lGETLIST_READONLY     */ ;
      .f.,                                      /* lGETLIST_PIXEL        */ ;
      nil,                                      /* nGETLIST_CURSOR       */ ;
      nil,                                      /* bGETLIST_EVAL         */ ;
      nil,                                      /* bGETLIST_RELATIVE     */ ;
      nil,                                      /* xGETLIST_OPTIONS2     */ ;
      nil,                                      /* xGETLIST_OPTIONS3     */ ;
      nil,                                      /* xGETLIST_OPTIONS4     */ ;
      nil,                                      /* xGETLIST_OPTIONS5     */ ;
      nil,                                      /* xGETLIST_OPTIONS6     */ ;
      nil,                                      /* xGETLIST_OPTIONS7     */ ;
      nil,                                      /* xGETLIST_OPTIONS8     */ ;
      nil,                                      /* xGETLIST_OPTIONS9     */ ;
      nil,                                      /* cGETLIST_LEVEL        */ ;
      nil,                                      /* cGETLIST_TITLE        */ ;
      nil,                                      /* cGETLIST_ACCESS       */ ;
      nil,                                      /* bGETLIST_COMPILE      */ ;
      nil,                                      /* cGETLIST_ID           */ ;
      nil,                                      /* dGETLIST_REVDATE      */ ;
      nil,                                      /* cGETLIST_REVTIME      */ ;
      nil,                                      /* cGETLIST_REVUSER      */ ;
      nil,                                      /* bGETLIST_HIDE         */ ;
      nil,                                      /* nGETLIST_ACCELKEY     */ ;
      nil,                                      /* bGETLIST_GOTFOCUS     */ ;
      nil,                                      /* bGETLIST_LOSTFOCUS    */ ;
      lTabStop,                                 /* lGETLIST_TABSTOP      */ ;
      nil,                                      /* nGETLIST_TABGROUP     */ ;
      nil,                                      /* lGETLIST_VISIBLE      */ ;
      nil,                                      /* cGETLIST_GETGROUP     */ ;
      .f.,                                      /* lGETLIST_FLAG         */ ;
      {ProcName(1),ProcLine(1)},                /* aGETLIST_PROC         */ ;
      nil,                                      /* bGETLIST_PREEVAL      */ ;
      nil,                                      /* bGETLIST_POSTEVAL     */ ;
      nil,                                      /* bGETLIST_CLASS        */ ;
      nil,                                      /* aGETLIST_RESIZE       */ ;
      nil,                                      /* aGETLIST_DRAGDROP     */ ;
      nil,                                      /* oGETLIST_CONFIG       */ ;
      nil,                                      /* cGETLIST_SUBCLASS     */ ;
      nil,                                      /* aGETLIST_VARS         */ ;
      nil                                       /* aGETLIST_PROFILE      */ ;
   }

* -------------------------

FUNCTION DC_GetProgress( oProgress, nCurrCount, nMaxCount, nEvery, lBar )

LOCAL nX, aSize, aAttr[ GRA_AA_COUNT], lClear, lVertical, aPoints, ;
      aAttrS[ GRA_AS_COUNT ], aPos, aPos2[2], nPercent, cPercent, ;
      nWidth, nHeight, nOldPercent

IF Valtype(oProgress) # 'O'
  RETURN nil
ELSE
  DEFAULT nCurrCount := 0
  DEFAULT nMaxCount := oProgress:maxCount
  DEFAULT nEvery := oProgress:every
  DEFAULT lVertical := oProgress:vertical
  IF nEvery > 0 .AND. nCurrCount % Int(nEvery) # 0 .AND. ;
       Valtype(nMaxCount) = 'N' .AND. nCurrCount < nMaxCount
    RETURN nil
  ENDIF
ENDIF

DEFAULT lBar := .t.

IF nMaxCount = 0
  nPercent := 0
ELSE
  nPercent := nCurrCount/nMaxCount
ENDIF
IF nMaxCount == 0
  nOldPercent := 0
ELSE
  nOldPercent := oProgress:currCount/nMaxCount
ENDIF
lClear := nCurrCount <= oProgress:currCount
IF Valtype(nMaxCount) = 'N'
  oProgress:maxCount := nMaxCount
ELSE
  nMaxCount := oProgress:maxCount
ENDIF

IF lBar

  IF lVertical
    aSize := { oProgress:currentSize()[2], oProgress:currentSize()[1] }
  ELSE
    aSize := oProgress:currentSize()
  ENDIF
  aSize[1] -= 2
  aSize[2] -= 2
  IF nMaxCount > 0
    nX := aSize[1] * ( nCurrCount / nMaxCount )
  ELSE
    nX := 0
  ENDIF
  nX := Min( nX, aSize[1] )           // Calculate width for rectangle
  IF nX <= 0
    nX := 1
  ENDIF
  IF Valtype(oProgress:presSpace) # 'O'
    oProgress:presSpace := oProgress:lockPS()
  ENDIF
  IF !Empty(oProgress:bitmap)
    lClear := .t.
  ENDIF
  IF lClear .OR. ( oProgress:percent .AND. !oProgress:dynamic ) .OR. nPercent < .1
    aAttr[ GRA_AA_COLOR ] := oProgress:backColor
    GraSetAttrArea( oProgress:presSpace, aAttr )
    GraBox( oProgress:presSpace, {1,1}, ;
            IIF( lVertical, {aSize[2], aSize[1]},{aSize[1], aSize[2]}), GRA_FILL )
    lClear := .T.
  ENDIF
  aAttr[ GRA_AA_COLOR ] := oProgress:barColor
  GraSetAttrArea( oProgress:presSpace, aAttr )

  IF Int(nOldPercent*100) # Int(nPercent*100) .OR. lClear
    GraBox( oProgress:presSpace, {1,1}, ;
            IIF( lVertical, {aSize[2],nX},{nX, aSize[2]} ), ;
            IIF( oProgress:outline,GRA_OUTLINEFILL,GRA_FILL ), ;
            oProgress:radius, oProgress:radius )
    IF !Empty(oProgress:bitmap)
      oProgress:bitmap:draw( oProgress:presSpace, IIF(lVertical,{2,nX},{nX,2}) )
    ENDIF
  ENDIF

ENDIF

IF oProgress:percent

  IF lVertical
    aSize := { oProgress:currentSize()[2], oProgress:currentSize()[1] }
  ELSE
    aSize := oProgress:currentSize()
  ENDIF

  IF Int(nOldPercent*100) # Int(nPercent*100) .OR. lClear .OR. nCurrCount >= nMaxCount

    cPercent := Str(100*nPercent,3,0)+"%"
    aPoints := GraQueryTextBox( oProgress:presSpace, cPercent )
    nWidth := aPoints[3,1] - aPoints[1,1]
    nHeight := aPoints[1,2] - aPoints[2,2]

    IF oProgress:dynamic
      aPos2[1] := (nX-nWidth) / 2
      IF aPos2[1] < 2
        aPos2[1] := 2
      ENDIF
    ELSE
      aPos2[1] := ( aSize[1] - nWidth ) / 2
    ENDIF
    aPos2[2] := (( aSize[2] - nHeight ) / 2) + 1
    IF Valtype( oProgress:percentColor ) == 'N'
      aAttrs[ GRA_AS_COLOR ] := oProgress:percentColor
    ENDIF
    GraSetAttrString( oProgress:presSpace, aAttrS )
    GraStringAt( oProgress:presSpace, aPos2, cPercent )

  ENDIF

ENDIF

oProgress:currCount := nCurrCount

RETURN .t.

* -----------------

FUNCTION DC_GetOrigSet( aGetList, acGroup )

LOCAL i, j, bBlock, nType, lGoodGroup

IF Valtype(acGroup)='C'
  acGroup := { acGroup }
ENDIF

DC_GetDataLink(.f.)
FOR i := 1 TO Len(aGetList)
  IF !Empty(acGroup)
    IF Empty(aGetlist[i,cGETLIST_GETGROUP])
      LOOP
    ENDIF
    lGoodGroup := .f.
    FOR j := 1 TO Len(acGroup)
      IF aGetlist[i,cGETLIST_GETGROUP]==acGroup[j]
        lGoodGroup := .t.
        EXIT
      ENDIF
    NEXT
    IF !lGoodGroup
       LOOP
    ENDIF
  ENDIF
  nType := aGetlist[i,nGETLIST_TYPE]
  IF nType # GETLIST_SUBMENU .AND. nType # GETLIST_MENUITEM
    IF Valtype(aGetList[i,bGETLIST_VAR])$'AB'
      bBlock := DC_GetBlock(aGetList[i,bGETLIST_VAR])
      IF Valtype(bBlock) = 'B'
        aGetList[i,xGETLIST_ORIGVALUE] := Eval( bBlock )
      ENDIF
    ENDIF
  ENDIF
NEXT
DC_GetDataLink(.t.)
RETURN nil

/* ---------------------- */

FUNCTION DC_GetOrigUpdated( aGetList, cId, acGroup, lVerbose )

LOCAL i := 1, bBlock, nType, aCargo, nStart, nEnd, j, lGoodGroup, ;
      xOrigValue, xNewValue, lCompare, aProc, cProc, cLine
LOCAL lRet     := .F.   // Jack Duijf 17-07-2014

IF Valtype(cId) = 'A'
  FOR i := 1 TO Len(cId)
    lCompare := DC_GetOrigUpdated( aGetList, cId[i], acGroup, lVerbose )
    IF !lCompare
      RETURN .T.
    ENDIF
  NEXT
ENDIF

DEFAULT lVerbose := .f.
IF Valtype(acGroup)='C'
  acGroup := { acGroup }
ENDIF
DC_GetDataLink(.f.)
IF Valtype(aGetlist) = 'A'       // It's a Getlist
  IF Valtype(aGetlist[1]) = 'N'  // It's only a single Get
    aGetlist := { aGetlist }
    nStart := 1
    nEnd := Len(aGetList)
  ELSEIF !Empty(cId)
    nStart := AScan(aGetList,{|a|a[cGETLIST_ID]==cId})
    IF nStart = 0
      nEnd := -1
    ELSE
      nEnd := nStart
    ENDIF
  ELSE
    nStart := 1
    nEnd := Len(aGetList)
  ENDIF

  FOR i := nStart TO nEnd
    IF !Empty(acGroup)
      IF Empty(aGetlist[i,cGETLIST_GETGROUP])
         LOOP
      ENDIF
      lGoodGroup := .f.
      FOR j := 1 TO Len(acGroup)
        IF aGetlist[i,cGETLIST_GETGROUP]==acGroup[j]
          lGoodGroup := .t.
          EXIT
        ENDIF
      NEXT
      IF !lGoodGroup
         LOOP
      ENDIF
    ENDIF
    nType := aGetlist[i,nGETLIST_TYPE]
    IF nType # GETLIST_SUBMENU .AND. nType # GETLIST_MENUITEM .AND. nType # GETLIST_BROWSECOL
      IF Valtype(aGetList[i,bGETLIST_VAR])$'AB'
        bBlock := DC_GetBlock(aGetList[i,bGETLIST_VAR])
        IF Valtype(bBlock) = 'B'
          xOrigValue := aGetList[i,xGETLIST_ORIGVALUE]
          xNewValue := Eval(bBlock)
          /*
          IF nType = GETLIST_MLE
            xOrigValue := Strtran(xOrigValue,Chr(0),'')
            xNewValue := Strtran(xNewValue,Chr(0),'')
          ENDIF
          */
          IF Valtype(xOrigValue) = 'A' .AND. Valtype(xNewValue) = 'A'
            lCompare := DC_ACompare(xOrigValue,xNewValue)
          ELSEIF Valtype(xOrigValue) == Valtype(xNewValue)
            lCompare := (xOrigValue == xNewValue)
          ELSE
            lCompare := .f.
          ENDIF

          IF !lCompare
            DC_GetDataLink(.t.)
            IF lVerbose
              cId := DC_XtoC(aGetList[i,cGETLIST_ID])
              aProc := aGetList[i,aGETLIST_PROC]
              IF Valtype(aProc) = 'A'
                ASize(aProc,2)
                cProc := DC_XtoC(aProc[1])
                cLine := DC_Xtoc(aProc[2])
              ELSE
                cProc := 'Unknown'
                cLine := 'Unknown'
              ENDIF

               DC_MsgBox({'  Orig Value: ' + Pad(DC_XtoC(xOrigValue),60), ;
                          '   New Value: ' + Pad(DC_XtoC(xNewValue),60), ;
                          '       Group: ' + DC_XtoC(aGetList[i,cGETLIST_GETGROUP]), ;
                          '        Type: ' + DC_GetListType(nType), ;
                          'GetList Item: ' + Str(i), ;
                          'GetList Type: ' + DC_GetListType(nType), ;
                          '  GetList ID: ' + cId, ;
                          'GetList Proc: ' + cProc, ;
                          'GetList Line: ' + cLine },,,,,,,,,,,,'10.Lucida Console')
            ENDIF
            lRet  := .t.   // Jack Duijf 17-07-2014
            exit
          ENDIF
        ENDIF
      ENDIF
    ENDIF
  NEXT
ELSEIF Valtype(aGetlist) = 'O'   // It's an object
  aCargo := aGetlist:cargo
  IF Valtype(aCargo) = 'A' .AND. Valtype(aCargo[1]) = 'N' .AND. ;
     Valtype(aCargo[2]) = 'A'
    aGetList := aCargo[2]
    i := aCargo[1]
    nType := aGetlist[i,nGETLIST_TYPE]
    IF nType # GETLIST_SUBMENU .AND. nType # GETLIST_MENUITEM
      IF Valtype(aGetList[i,bGETLIST_VAR])$'AB'
        bBlock := DC_GetBlock(aGetList[i,bGETLIST_VAR])
        IF Valtype(bBlock) = 'B'
          IF aGetList[i,xGETLIST_ORIGVALUE] # Eval( bBlock )
            lRet := .t.
          ENDIF
        ENDIF
      ENDIF
    ENDIF
  ENDIF
ENDIF

DC_GetDataLink(.t.)
bBlock := nil
aGetList := nil
RETURN lRet   // Jack Duijf 17-07-2014

* -----------

FUNCTION DC_GetValidateDebugBlock( bBlock )

STATIC sbBlock := nil
LOCAL bOldBlock := sbBlock

IF Valtype(bBlock) == 'B'
  sbBlock := bBlock
ENDIF

RETURN bOldBlock

* -------------

FUNCTION DC_GetValidate( oXbp, lPassBuffer, lTestForBlock, lExitValidate, lValidateOnChange )

LOCAL nPointer, aCargo := oXbp:cargo, nType, aGetlist, xValue, ;
      mp1, mp2, oNextXbp, nEvent, lOk, bValidate, bProtect, cEditBuffer, ;
      bDebugBlock := DC_GetValidateDebugBlock(), lValid := .F., lLocked
LOCAL bHide // J. Duijf 17-07-2014
DEFAULT lPassBuffer := .f., ;
        lTestForBlock := .f., ;
        lExitValidate := .f., ;
        lValidateOnChange := DC_GetValidateOnChange()

IF !Empty(bDebugBlock)
  Eval(bDebugBlock,oXbp,1)
ENDIF

IF Valtype(aCargo) = 'A' .AND. Len(aCargo) >= 2 .AND. ;
   Valtype(aCargo[1]) = 'N' .AND. Valtype(aCargo[2]) = 'A' .AND. ;
   aCargo[1] > 0 .AND. aCargo[1] <= Len(aCargo[2])

  aGetList := aCargo[2]
  nPointer := aCargo[1]
  nType := aGetlist[nPointer,nGETLIST_TYPE]
  bValidate := nil

  IF !( nType $ {GETLIST_GET,GETLIST_COMBOBOX,GETLIST_CHECKBOX,GETLIST_MLE,GETLIST_KLMLE} )
    RETURN _ReturnFromValid( .T., oXbp, bDebugBlock )
  ENDIF

  bProtect := aGetList[nPointer,bGETLIST_PROTECT]

  IF Valtype(bProtect) == 'B' .AND. Eval(bProtect,oXbp)
    // Don't validate a protected GET
    RETURN _ReturnFromValid( .T., oXbp, bDebugBlock )
  ELSEIF _IsParentMinimized(oXbp)
    RETURN .f.
  ENDIF
  //
  // J. Duijf 17-07-2014 Do not validate if HIDDEN
  //
  bHide  := aGetList[nPointer,bGETLIST_HIDE]
  IF Valtype(bHide) == 'B' .AND. Eval(bHide,oXbp)
    RETURN _ReturnFromValid( .T., oXbp, bDebugBlock )
  Endif
  IF nType = GETLIST_GET
    IF oXbp:isValidateOnChange
      IF lValidateOnChange .AND. !oXbp:get:changed
        RETURN .t.
      ENDIF
    ENDIF
    bValidate := DC_GetValidBlock()
    IF Valtype(oXbp:popupButton) == 'O' .AND. (!Empty(oXbp:validate) .OR. !Empty(bValidate))
      nEvent := NextAppEvent(@mp1,@mp2,@oNextXbp)
      //  Don't validate if clicked on Pop-Up button
      IF nEvent == xbeP_SetInputFocus .AND. ;
         (oXbp:popupButton == oNextXbp .OR. oXbp:popupFlag )
        IF !lTestForBlock
          lValid := .T.
        ENDIF
        RETURN _ReturnFromValid( lValid, oXbp, bDebugBlock )
      ENDIF
    ENDIF
    IF Valtype( bValidate ) == 'B'
      IF _TestForCancelEvent(,,aGetList)
        RETURN _ReturnFromValid( .T., oXbp, bDebugBlock )
      ENDIF
      IF lLocked := (oXbp:isDerivedFrom('DC_XbpGet') .AND. !Empty(oXbp:dataAlias) .AND. ;
                     !((oXbp:dataAlias)->(RecNo()) $ (oXbp:dataAlias)->(dbRLockList())))
        (oXbp:dataAlias)->(dbRLock())
      ENDIF
      lValid := Eval(bValidate,oXbp,lExitValidate)
      IF lLocked
        (oXbp:dataAlias)->(dbRUnLock())
      ENDIF
      IF !lValid
        DC_SetAppFocus( oXbp )
        // DC_ClearEvents()
        RETURN _ReturnFromValid( .F., oXbp, bDebugBlock )
      ENDIF
    ENDIF
    cEditBuffer := oXbp:EditBuffer()
    IF oXbp:isGetDataOnLostFocus
      xValue := Eval(oXbp:datalink,oXbp:GetData())
    ELSE
      xValue := Eval(oXbp:dataLink)
    ENDIF
    IF Valtype(xValue)='D' .AND. !lTestForBlock
      IF (Empty(xValue) .AND. ;
          !Empty(Strtran(Strtran(Strtran(cEditBuffer,'/',''),'.',''),'-',''))) .OR. ;
        !ValidateDateRange(xValue)
        IF _TestForCancelEvent(,,aGetList)
          RETURN _ReturnFromValid( .T., oXbp, bDebugBlock )
        ENDIF
        DC_WinAlert(DC_LangMsg(DCMSG_DATE_INVALID))
        DC_SetAppFocus( oXbp )
        // DC_ClearEvents()
        RETURN _ReturnFromValid( .F., oXbp, bDebugBlock )
      ENDIF
      IF oXbp:isGetDataOnLostFocus
        oXbp:setData(oXbp:GetData())
      ENDIF
    ENDIF
    IF Valtype(oXbp:range) = 'A' .AND. !lTestForBlock .AND. !_TestForCancelEvent(,,aGetList)
      IF xValue < oXbp:range[1] .OR. xValue > oXbp:range[2]
        DC_WinAlert(DC_LangMsg(DCMSG_RANGE_INVALID) + ' ' + ;
                    Alltrim(DC_XtoC(oXbp:range[1])) + ' - ' + ;
                    Alltrim(DC_XtoC(oXbp:range[2])))
        DC_SetAppFocus( oXbp )
        // DC_ClearEvents()
        RETURN _ReturnFromValid( .F., oXbp, bDebugBlock )
      ENDIF
    ENDIF
    bValidate := oXbp:validate
    IF lTestForBlock
      lValid := Valtype(bValidate) = 'B'
      RETURN _ReturnFromValid( lValid, oXbp, bDebugBlock )
    ENDIF
    IF Valtype(bValidate) # 'B'
      RETURN _ReturnFromValid( .T., oXbp, bDebugBlock )
    ENDIF
  ELSEIF nType = GETLIST_COMBOBOX
    bValidate := oXbp:XbpSLE:validate
    IF lTestForBlock
      lValid := Valtype(bValidate) = 'B'
      RETURN _ReturnFromValid( lValid, oXbp, bDebugBlock )
    ENDIF
    IF Valtype(bValidate) # 'B'
      RETURN _ReturnFromValid( .T., oXbp, bDebugBlock )
    ENDIF
    xValue := Eval(oXbp:XbpSLE:datalink,oXbp:XbpSLE:GetData())
  ELSEIF nType = GETLIST_CHECKBOX
    bValidate := oXbp:validate
    IF lTestForBlock
      lValid := Valtype(bValidate) = 'B'
      RETURN _ReturnFromValid( lValid, oXbp, bDebugBlock )
    ENDIF
    IF Valtype(bValidate) # 'B'
      RETURN _ReturnFromValid( .T., oXbp, bDebugBlock )
    ENDIF
    xValue := Eval(oXbp:datalink,oXbp:GetData())
  ELSEIF nType = GETLIST_MLE .OR. nType = GETLIST_KLMLE
    IF !IsMemberVar( oXbp, "validBlock" )
      RETURN _ReturnFromValid( .T., oXbp, bDebugBlock )
    ENDIF
    bValidate := oXbp:validBlock
    IF lTestForBlock
      lValid := Valtype(bValidate) = 'B'
      RETURN _ReturnFromValid( lValid, oXbp, bDebugBlock )
    ENDIF
    IF Valtype(bValidate) # 'B'
      RETURN _ReturnFromValid( .T., oXbp, bDebugBlock )
    ENDIF
    xValue := Eval(oXbp:datalink,oXbp:GetData())
  ENDIF
  IF lTestForBlock
    lValid := Valtype(bValidate) = 'B'
    RETURN _ReturnFromValid( lValid, oXbp, bDebugBlock )
  ENDIF

  IF Valtype(bValidate) = 'B' // .AND. oXbp:isEnabled() .AND. oXbp:isVisible()
    // nEvent := DC_NextAppEvent(@mp1,@mp2,@oNextXbp)
    IF DC_ReadGuiDebug()>0 .AND. DC_BitTest(DC_ReadGuiDebug(),DCGUI_DEBUG_VALIDATE)
      DCQDEBUG 'Validating ' + oXbp:ClassName()
      IF IsMemberVar( oXbp, 'CAPTION' )
        DCQDEBUG oXbp:caption
      ENDIF
    ENDIF
    IF _TestForCancelEvent(,,aGetList)
      RETURN _ReturnFromValid( .T., oXbp, bDebugBlock )
    ELSEIF lPassBuffer
      IF lLocked := (oXbp:isDerivedFrom('DC_XbpGet') .AND. !Empty(oXbp:dataAlias) .AND. ;
                     !((oXbp:dataAlias)->(RecNo()) $ (oXbp:dataAlias)->(dbRLockList())))
        (oXbp:dataAlias)->(dbRLock())
      ENDIF

      lValid := Eval(bValidate,xValue,oXbp,lExitValidate )

      IF lLocked
        (oXbp:dataAlias)->(dbRLock())
      ENDIF
    ELSE
      IF lLocked := (oXbp:isDerivedFrom('DC_XbpGet') .AND. !Empty(oXbp:dataAlias) .AND. ;
                     !((oXbp:dataAlias)->(RecNo()) $ (oXbp:dataAlias)->(dbRLockList())))
        (oXbp:dataAlias)->(dbRLock())
      ENDIF
      lValid := Eval(bValidate,oXbp,lExitValidate)
      IF lLocked
        (oXbp:dataAlias)->(dbRLock())
      ENDIF
    ENDIF
    IF Valtype(lValid) # 'L'
      RETURN .T.
    ELSEIF !lValid
      DC_SetAppFocus( oXbp )
      // DC_ClearEvents()
      RETURN _ReturnFromValid( .F., oXbp, bDebugBlock )
    ELSEIF DC_ValidCompleteEvents()
      DC_CompleteEvents()
    ENDIF
  ENDIF
ENDIF
IF lTestForBlock
  RETURN _ReturnFromValid( .F., oXbp, bDebugBlock )
ENDIF

RETURN .T.

* ------------

STATIC FUNCTION _IsParentMinimized( oXbp )

oXbp := oXbp:setParent()
DO WHILE !oXbp:isDerivedFrom('XbpDialog') .AND. !oXbp == AppDeskTop()
  oXbp := oXbp:setParent()
ENDDO

IF oXbp:isDerivedFrom('XbpDialog')
  IF oXbp:getFrameState()==XBPDLG_FRAMESTAT_MINIMIZED
    RETURN .t.
  ELSEIF oXbp:setParent():isDerivedFrom('XbpIWindow') .AND. ;
         Valtype(oXbp:setParent():setParent()) = 'O' .AND. ;
         oXbp:setParent():setParent():isDerivedFrom('XbpDialog') .AND. ;
         oXbp:setParent():setParent():getFrameState() == XBPDLG_FRAMESTAT_MINIMIZED
    RETURN .t.
  ENDIF
ENDIF

RETURN .f.

* ------------

GETSETFUNCTION DC_GetValidateLast DEFAULT .f.

* ------------

GETSETFUNCTION DC_GetValidateClearEventsOnInvalid DEFAULT .t.

* ------------

STATIC FUNCTION _ReturnFromValid( lValid, oXbp, bDebugBlock )

IF !Empty(bDebugBlock)
  Eval(bDebugBlock,oXbp,2,lValid)
ENDIF

IF !lValid
  DC_GetValidateLast(.f.)
  IF DC_GetValidateClearEventsOnInvalid()
    DC_ClearEvents()
  ENDIF
ELSE
ENDIF

RETURN lValid

* --------------------

STATIC FUNCTION _TestForCancelEvent( nEvent, oNextXbp, aGetList )

LOCAL mp1, mp2, lCancelled

IF Empty(nEvent) .AND. Empty(oNextXbp)
  nEvent := NextAppEvent( @mp1,@mp2,@oNextXbp )
ENDIF

IF Valtype(oNextXbp) = 'O' .AND. ;
   oNextXbp:isDerivedFrom('XbpStatic') .AND. ;
   Valtype(oNextXbp:cargo)=='O'
   IF oNextXbp:cargo:isDerivedFrom('DC_XbpPushButton') .AND. ;
      oNextXbp:cargo:ignoreValid
     RETURN .t.
   ENDIF
ELSEIF Valtype(oNextXbp) = 'O' .AND. oNextXbp:isDerivedFrom('XbpMenu')
   RETURN .t.
ENDIF

lCancelled := nEvent == xbeP_SetInputFocus .AND. Valtype(oNextXbp) = 'O' .AND. ;
      (oNextXbp:isDerivedFrom('DC_XbpPushButton') .OR. ;
       oNextXbp:isDerivedFrom('DC_XbpRadioButton') .OR. ;
       oNextXbp:isDerivedFrom('DC_XbpPushButtonXP') .OR. ;
       oNextXbp:isDerivedFrom('DC_XbpCheckBox') .OR. ;
       oNextXbp:isDerivedFrom('CJ_PushButton') .OR. ;
       oNextXbp:isDerivedFrom('DC_XbpGet') .OR. ;
       oNextXbp:isDerivedFrom('XbpMenu')) .AND. ;
      ((Valtype(oNextXbp:cargo) = 'C' .AND. oNextXbp:cargo == 'CANCEL') .OR. ;
       (Valtype(DC_GetCargo(oNextXbp)) = 'C' .AND. Upper(DC_GetCargo(oNextXbp)) == 'CANCEL'))

IF lCancelled .AND. Valtype(aGetList) == 'A' .AND. DC_ReadGuiLastKey(aGetList) == xbeK_TAB
  lCancelled := .f.
  DC_ReadGuiLastKey(aGetList,0)
ENDIF

RETURN lCancelled

////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                        //
// Date     : 05-07-2005                                                                  //
// By       : Jack Duijf   (jack@jdsoftware.nl)                                           //
//                                                                                        //
// Enhanced Dc_GetListValidate() can now include/excluded objects for validation.         //
//                                                                                        //
// Code taken from Dc_GetRefresh(), and adapted for this function                         //
// also included some comments, and reduced lines of code.                                //
//                                                                                        //
// Parameters    aGetList                                                                 //
//               nElement | cId                                                           //
//               nValidMode                                                               //
//               aValidList                                                               //
//               acGroup                                                                  //
// Return        .T.          : All entrys are valid                                      //
//               .F.          : Entry not valid, object gets focus                        //
//                                                                                        //
// aGetList      An array containing a list of Get objects to validate.  The GetList      //
//               may be Dual-Mode Getlist compatible with DC_ReadGets() or DC_ReadGui()   //
//               or a text-based GetList compatible with DC_ReadModal().                  //
// nElement      May be a numeric value, a character string,or a NIL. If it is a numeric  //
//               value, then <nElement> is a specific GetList element to validate. This   //
//               must be a number from 1 to the Length of <aGetList>. If it is a          //
//               character string, then <cID> is a character string equal to the ID of    //
//               the GetList element to validate. If no parameter is passed then the      //
//               entire Getlist will be validated.                                        //
// nValidMode    <nValidMode> and <aValidList> are used together to validate the Getlist  //
// aValidList    based on the Validation mode <nValidMode> and the the Getlist based on   //
//               the validation mode <nValidMode> and the contents of <aRefreshList>.     //
//               These parameters can be used to validate all items in the Getlist        //
//               "except" a specified list, group or only those in a specified list or    //
//               group.  <aValidList> is an array of Character strings matching the       //
//               cGETLIST_ID element of the GetList if <nValidMode> is                    //
//               DCGETLISTVALIDATE_ID_* -or- <aValidList> is an array of Numeric values   //
//               matching the nGETLIST_TYPE of the GetList if <nValidMode> is             //
//               DCGETLISTVALIDATE_TYPE_*.                                                //
//                                                                                        //
//               <nValidMode>                   Description                               //
//               ---------------                ---------------------------------------   //
//               DCGETLISTVALIDATE_ID_INCLUDE   Validate only the items with IDs that     //
//                                              are included in <aValidList> or the group //
//                                              is member of acGroup.                     //
//                                                                                        //
//               DCGETLISTVALIDATE_ID_EXCLUDE   Validate all items in with IDs that are   //
//                                              NOT included in <aValidList> or the group //
//                                              is NOT a member of acGroup.               //
//                                                                                        //
//               DCGETLISTVALIDATE_TYPE_INCLUDE Validate only the items with TYPEs that   //
//                                              are included in <aValidList> or the group //
//                                              is member of acGroup.                     //
//                                                                                        //
//               DCGETLISTVALIDATE_TYPE_EXCLUDE Validate all items in with TYPEs that are //
//                                              NOT included in <aValidList> or the group //
//                                              is NOT a member of acGroup.               //
//                                                                                        //
// acGroup       The GetList group to validate.  Each item in the GetList may be assigned //
//               a group name GROUP <ancGroup> clause.  If a character value is passed    //
//               then only the items in the GetList which match <ancGroup> will be        //
//               validated or not validated. See <nValidMode> for details.                //
//                                                                                        //
// lExit         TRUE      - Is called on exit of DC_READ                                 //
//               FALSE     - Regular validation                                           //
//                                                                                        //
// 09-08-2005  J. Duijf    - Prevent error if nElement is a non existing ID and acGroup   //
//                           is a non existing group                                      //
// 27-08-2005  J. Duijf    - Improved evaluation if ID's and Group                        //
//                         - Docs                                                         //
// 26-09-2005  J. Duijf    - lExit added as parameter (NOEXITVALID)                       //
////////////////////////////////////////////////////////////////////////////////////////////

FUNCTION DC_GetListValidate( aGetList, nElement, nValidMode, aValidList, acGroup,lExit)

LOCAL nType, oXbp, i, j, nStart, nEnd, lGoodGroup, lSaveDataLink, cId, ;
      bErrorBlock, oGetList, cGroup

DEFAULT nValidMode      := 0                                                     // Default behaviour, no include/exclude
DEFAULT lExit           := FALSE

IF Valtype(aGetList)='A' .AND. !Empty(aGetList) .AND. ;                          // Validate Getlist array
   Len(aGetList[1]) >= nGET_ARRAY_SIZE
   IF Valtype(acGroup)='C'       ; acGroup      := { acGroup }    ; ENDIF        // Group ID's
   IF Valtype(aValidList) $ 'CN' ; aValidList   := {aValidList}   ; ENDIF        // List of ID's to validate

   do case
      case Valtype(nElement) = 'N'                                               // Just a single element
         nStart         := nElement
         nEnd           := nElement
         acGroup        := {}                                                    // Forget group (J. Duijf 27-8-2005)
      case Valtype(nElement) = 'C'                                               // It's an ID
         nStart         := AScan(aGetList,{|a|a[cGETLIST_ID]==nElement})         // locate single element number
         nEnd           := nStart
         if nStart = 0                                                           // Not found, ignore ID
            nStart      := 1
            nEnd        := Len(aGetList)
         else
            Asize(acGroup,0)                                                     // Forget the group
         endif
      otherwise
         nStart         := 1                                                     // All entry's of Getlist (J. Duijf 9-8-2005)
         nEnd           := Len(aGetList)                                         // All entry's of Getlist (J. Duijf 9-8-2005)
   endcase
   FOR i                := nStart TO nEnd                                        // Validate range
      nType             := aGetlist[i,nGETLIST_TYPE]
      cId               := aGetlist[i,cGETLIST_ID]
      cGroup            := aGetlist[i,cGETLIST_GETGROUP]
      if Empty(acGroup)                                                          // Do not check for GROUP
         do case
            case nValidMode = DCGETLISTVALIDATE_ID_INCLUDE                       // Must include ID
               IF AScan( aValidList, cId ) = 0     ; LOOP ; Endif                // ID not found, next
            case nValidMode = DCGETLISTVALIDATE_ID_EXCLUDE                       // Must exclude ID
               IF AScan( aValidList, cId ) > 0     ; LOOP ; Endif                // ID found, next
            case nValidMode = DCGETLISTVALIDATE_TYPE_INCLUDE                     // Must include type
               IF AScan( aValidList, nType ) = 0   ; LOOP ; Endif                // Type not found, next
            case nValidMode = DCGETLISTVALIDATE_TYPE_EXCLUDE                     // Must exnclude type
               IF AScan( aValidList, nType ) > 0   ; LOOP ; Endif                // Type found, next
         endcase
      else
         do case
            case nValidMode = DCGETLISTVALIDATE_ID_INCLUDE                       // Must include GROUP
               if _GetListValidate_TestGroup(acGroup,cGroup) = 0 ; LOOP ; Endif
            case nValidMode = DCGETLISTVALIDATE_ID_EXCLUDE                       // Must exclude GROUP
               if _GetListValidate_TestGroup(acGroup,cGroup) > 0 ; LOOP ; Endif
            case nValidMode = DCGETLISTVALIDATE_TYPE_INCLUDE                     // Must include GROUP
               if _GetListValidate_TestGroup(acGroup,cGroup) = 0 ; LOOP ; Endif
            case nValidMode = DCGETLISTVALIDATE_TYPE_EXCLUDE                     // Must exclude GROUP
               if _GetListValidate_TestGroup(acGroup,cGroup) > 0 ; LOOP ; Endif
            otherwise                                                            // Assume exclude
               if _GetListValidate_TestGroup(acGroup,cGroup) > 0 ; LOOP ; Endif
         endcase
      endif
      oXbp              := aGetlist[i,oGETLIST_OBJECT]                           // Get object
      IF Valtype(oXbp) = 'O'
         DC_GetEditActive(oXbp)

         IF !DC_GetValidate(oXbp,,,lExit,.f.)                                    // Not valid !!
            DC_ClearEvents()                                                     // Clear all pending events
            SetAppFocus(oXbp)                                                    // Set focus to object that is invallid
            RETURN .f.                                                           // Signal caller Invallid
         ENDIF
      ENDIF
   NEXT i
ENDIF
RETURN .T.

* --------------

STATIC FUNCTION _GetListValidate_TestGroup(acGroup,cGroup)

LOCAL nRet := 0, ni := 0

If ValType(cGroup) <> "A"
   nRet := Ascan(acGroup,cGroup)
Else
   For ni := 1 To Len(cGroup)
     nRet := Ascan(acGroup,cGroup[ni])
      If nRet > 0
         exit
      Endif
   Next ni
Endif

Return nRet

* --------------

FUNCTION DC_GetListType( nType )

LOCAL nFound
LOCAL aTypes := { ;
 { 'GETLIST_STATIC'          , GETLIST_STATIC }, ;
 { 'GETLIST_GET'             , GETLIST_GET }, ;
 { 'GETLIST_MLE'             , GETLIST_MLE }, ;
 { 'GETLIST_3STATE'          , GETLIST_3STATE }, ;
 { 'GETLIST_CHECKBOX'        , GETLIST_CHECKBOX }, ;
 { 'GETLIST_COMBOBOX'        , GETLIST_COMBOBOX }, ;
 { 'GETLIST_LISTBOX'         , GETLIST_LISTBOX }, ;
 { 'GETLIST_PUSHBUTTON'      , GETLIST_PUSHBUTTON }, ;
 { 'GETLIST_PUSHBUTTONXP'    , GETLIST_PUSHBUTTON }, ;
 { 'GETLIST_RADIOBUTTON'     , GETLIST_RADIOBUTTON }, ;
 { 'GETLIST_SAY'             , GETLIST_SAY }, ;
 { 'GETLIST_SAY_OPT'         , GETLIST_SAY_OPT }, ;
 { 'GETLIST_ADDBUTTON'       , GETLIST_ADDBUTTON }, ;
 { 'GETLIST_SPINBUTTON'      , GETLIST_SPINBUTTON }, ;
 { 'GETLIST_GROUPBOX'        , GETLIST_GROUPBOX }, ;
 { 'GETLIST_TABPAGE'         , GETLIST_TABPAGE }, ;
 { 'GETLIST_SCROLLBAR'       , GETLIST_SCROLLBAR }, ;
 { 'GETLIST_BITMAP'          , GETLIST_BITMAP }, ;
 { 'GETLIST_METAFILE'        , GETLIST_METAFILE }, ;
 { 'GETLIST_TOOLBAR'         , GETLIST_TOOLBAR }, ;
 { 'GETLIST_TOOLBAR_OPT'     , GETLIST_TOOLBAR_OPT }, ;
 { 'GETLIST_MENUBAR'         , GETLIST_MENUBAR }, ;
 { 'GETLIST_SUBMENU'         , GETLIST_SUBMENU }, ;
 { 'GETLIST_MENUITEM'        , GETLIST_MENUITEM }, ;
 { 'GETLIST_BROWSE'          , GETLIST_BROWSE }, ;
 { 'GETLIST_BROWSECOL'       , GETLIST_BROWSECOL }, ;
 { 'GETLIST_MESSAGEBOX'      , GETLIST_MESSAGEBOX }, ;
 { 'GETLIST_MESSAGEBOX_OPT'  , GETLIST_MESSAGEBOX_OPT }, ;
 { 'GETLIST_CUSTOM'          , GETLIST_CUSTOM }, ;
 { 'GETLIST_APPCRT'          , GETLIST_APPCRT }, ;
 { 'GETLIST_PICKLIST'        , GETLIST_PICKLIST }, ;
 { 'GETLIST_PROGRESS'        , GETLIST_PROGRESS }, ;
 { 'GETLIST_APPEDIT'         , GETLIST_APPEDIT }, ;
 { 'GETLIST_APPBROWSE'       , GETLIST_APPBROWSE }, ;
 { 'GETLIST_APPFIELD'        , GETLIST_APPFIELD }, ;
 { 'GETLIST_DIRTREE'         , GETLIST_DIRTREE }, ;
 { 'GETLIST_HOTKEY'          , GETLIST_HOTKEY }, ;
 { 'GETLIST_TREEARRAY'       , GETLIST_TREEARRAY }, ;
 { 'GETLIST_TREEROOT'        , GETLIST_TREEROOT }, ;
 { 'GETLIST_TREEITEM'        , GETLIST_TREEITEM }, ;
 { 'GETLIST_SETPARENT'       , GETLIST_SETPARENT }, ;
 { 'GETLIST_QUICKBROWSE'     , GETLIST_QUICKBROWSE }, ;
 { 'GETLIST_DATASTORE'       , GETLIST_DATASTORE }, ;
 { 'GETLIST_STATUSBAR'       , GETLIST_STATUSBAR }, ;
 { 'GETLIST_PANEL'           , GETLIST_PANEL }, ;
 { 'GETLIST_SETGROUP'        , GETLIST_SETGROUP }, ;
 { 'GETLIST_ACTIVEX'         , GETLIST_ACTIVEX }, ;
 { 'GETLIST_HTMLVIEWER'      , GETLIST_HTMLVIEWER }, ;
 { 'GETLIST_KLMLE'           , GETLIST_KLMLE } }

nFound := AScan(aTypes,{|a|a[2]==nType})

IF nFound > 0
  RETURN aTypes[nFound,1]
ENDIF
RETURN '<unknown>'

* ---------------

FUNCTION DC_ReadGuiDebug( nDebug )

STATIC nGuiDebug := 0

LOCAL nOldDebug := nGuiDebug

IF Valtype(nDebug) = 'N'
  nGuiDebug := nDebug
ELSEIF Valtype(nDebug) ='L'
  nGuiDebug := IIF( nDebug, DCGUI_DEBUG_EVENTS+DCGUI_DEBUG_CREATE, 0 )
ENDIF

RETURN nOldDebug

* --------------------

GETSETFUNCTION DC_ReadDataCheckValidate DEFAULT TRUE

* --------------------

FUNCTION DC_ReadDataCheck( xData, cValid, aGetList, nPointer, ;
                           lEmptyOk, oBusyScreen, oXbp )

LOCAL aMsg, i, cMsg, cProc := '', cLine := '', aGetListItem

DEFAULT lEmptyOK := .t., ;
        nPointer := 1

aGetListItem := aGetList[nPointer]

IF (DC_ReadDataCheckValidate() .AND. !(Valtype(xData) $ cValid)) ;
     .OR. (Empty(xData) .AND. !lEmptyOk)

  IF Valtype(oBusyScreen) = 'O'
    DC_Impl(oBusyScreen)
    oBusyScreen := NIL
  ENDIF
  cMsg := aGetListItem[cGETLIST_MESSAGE]
  IF Valtype(cMsg) = 'A' .AND. Len(cMsg) >= 1
    cMsg := DC_XtoC(cMsg[1])
  ELSEIF !Empty(aGetListItem[cGETLIST_TOOLTIP])
    cMsg := DC_XtoC(aGetListItem[cGETLIST_TOOLTIP])
  ELSEIF !Empty(aGetListItem[cGETLIST_CAPTION])
    cMsg := DC_XtoC(aGetListItem[cGETLIST_CAPTION])
  ENDIF
  IF Valtype(aGetListItem[aGETLIST_PROC]) = 'A'
    cProc := aGetListItem[aGETLIST_PROC,1]
    cLine := Alltrim(Str(aGetListItem[aGETLIST_PROC,2]))
  ENDIF

  aMsg := { ;
   'An Error Occurred in DC_ReadGui() while creating objects from the GetList array.',;
   'GetList Array Element : ' + Str( nPointer ), ;
   'Type : ' + DC_GetListType(aGetListItem[nGETLIST_TYPE]), ;
   'ID   : ' + DC_XtoC(aGetListItem[cGETLIST_ID]) , ;
   'Title: ' + DC_XtoC(aGetListItem[cGETLIST_TITLE]) , ;
   'Msg  : ' + DC_XtoC(cMsg), ;
   'Proc : ' + cProc, ;
   'Line : ' + cLine, ;
   '', ;
   IIF( Empty(xData) .AND. !lEmptyOk, 'Variable cannot be empty', ;
                       'Variable must contain data of the following type:'), ;
   '' }

   FOR i := 1 TO Len(cValid)
      IF Substr(cValid,i,1) = 'C'
         AAdd( aMsg, 'C - String' )
      ELSEIF Substr(cValid,i,1) = 'N'
         AAdd( aMsg, 'N - Numeric')
      ELSEIF Substr(cValid,i,1) = 'D'
         AAdd( aMsg, 'D - Date')
      ELSEIF Substr(cValid,i,1) = 'L'
         AAdd( aMsg, 'L - Logical')
      ELSEIF Substr(cValid,i,1) = 'B'
         AAdd( aMsg, 'B - Code Block' )
      ELSEIF Substr(cValid,i,1) = 'O'
         AAdd( aMsg, 'O - Object')
      ELSEIF Substr(cValid,i,1) = 'A'
         AAdd( aMsg, 'A - Array')
      ELSEIF Substr(cValid,i,1) = 'U'
         AAdd( aMsg, 'U - Nil')
      ELSEIF Substr(cValid,i,1) = 'M'
         AAdd( aMsg, 'M - Memo')
      ELSEIF Substr(cValid,i,1) = 'F'
         AAdd( aMsg, 'F - Floating (Double)')
      ELSEIF Substr(cValid,i,1) = 'I'
         AAdd( aMsg, 'I - Integer')
      ENDIF
   NEXT
   DC_MsgBox(,,aMsg)
   RETURN .f.
ENDIF

RETURN .t.

* ----------

STATIC FUNCTION ErrorMessage( oError, aGetList, nPointer )

LOCAL cMessage, cMsg := '', cType := '', cID := '', cProc := '', cLine := ''

IF nPointer <= Len(aGetList)
  cMsg := aGetList[nPointer,cGETLIST_MESSAGE]
  IF Valtype(cMsg) = 'A' .AND. Len(cMsg) >= 1
    cMsg := DC_XtoC(cMsg[1])
  ELSEIF !Empty(aGetList[nPointer,cGETLIST_TOOLTIP])
    cMsg := DC_XtoC(aGetList[nPointer,cGETLIST_TOOLTIP])
  ELSEIF !Empty(aGetList[nPointer,cGETLIST_CAPTION])
    cMsg := DC_XtoC(aGetList[nPointer,cGETLIST_CAPTION])
  ELSEIF Valtype(cMsg) # 'C'
    cMsg := ''
  ENDIF
  cType := DC_GetListType(aGetList[nPointer,nGETLIST_TYPE])
  cID := DC_XtoC(aGetList[nPointer,cGETLIST_ID])
  IF Valtype(aGetList[nPointer,aGETLIST_PROC]) = 'A'
    cProc := aGetList[nPointer,aGETLIST_PROC,1]
    cLine := Alltrim(Str(aGetList[nPointer,aGETLIST_PROC,2]))
  ENDIF
ENDIF

cMessage := ;
  'An Error Occurred in DC_ReadGui() while creating objects from the GetList array.;' + ;
  'GetList Array Element : ' + Str( nPointer ) + ;
  ';Type : ' + cType + ;
  ';ID   : ' + cID + ;
  ';Msg  : ' + cMsg + ;
  ';Proc : ' + cProc + ;
  ';Line : ' + cLine

cMessage +=  ';' + ;                              // Generic
         IIf( oError:severity > XPP_ES_WARNING, ; // error message
                          "Error ", "Warning " )

   IF Valtype( oError:subSystem ) == "C"          // Add name of the
      cMessage += oError:subSystem                // subsystem
   ELSE
      cMessage += "????"                          // Unknown subsystem
   ENDIF

   IF Valtype( oError:subCode ) == "N"            // Add error code of
      cMessage += "/"+ LTrim(Str(oError:subCode)) // the subsystem
   ELSE
      cMessage += "/????"                         // Unknown error code
   ENDIF

   IF Valtype( oError:description ) == "C"        // Add error
      cMessage += ";Description : " + ;           // description
                   oError:description
   ENDIF

   IF ! Empty( oError:fileName )                  // Name of file where
      cMessage += ";File : " + oError:fileName    // the error occured
   ELSEIF ! Empty( oError:operation )             // Operation where the
      cMessage += ";Operation : " + ;             // error occured
                   oError:operation
   ENDIF

   cMessage += ";Thread ID : " + ;                // Thread ID
                LTrim(Str(oError:thread))         // where the error occured

RETURN cMessage

* -------------

STATIC PROCEDURE ErrorLog( oError )

LOCAL i:=0, bError := nil // ErrorBlock( {|e| Break(e)} )
LOCAL cExtension:= "LOG"

IF Upper ( SetAppWindow():ClassName() ) <> "ROOTCRT"
   SET CONSOLE OFF
ENDIF

DO WHILE .T.                        // Trap errors that might occur

      bError      := ErrorBlock( {|e| Dc_Break(e)} )
      BEGIN SEQUENCE                   // while opening the ALTERNATE file
        SET ALTERNATE TO ("XPPERROR."+cExtension)
        SET ALTERNATE ON
      RECOVER
        ErrorBlock( bError )
        cExtension := PadL(++i,3,"0")  // Try new file extension
        IF i > 999
           IF AppType() <> APPTYPE_PM
              ? Chr(7)
              ? "Unable to open error log file"
           ELSE
              MsgBox( "Unable to open error log file" )
           ENDIF
           ErrorLevel(1)
           QUIT
        ENDIF
        LOOP
      END SEQUENCE
      ErrorBlock( bError )
      EXIT
   ENDDO

//   ErrorBlock( bError )

   ? Replicate( "-", 78 )
   ? "ERROR LOG"
   ? Replicate( "-", 78 )
   ? "oError:args         :"
   IF Valtype(oError:Args)=="A"
      AEval( oError:Args, ;
             {|x,y| Qout( Space(9),"-> VALTYPE:", y:=Valtype(x) )  , ;
                     IIf( y=="O", QQout( " CLASS:", x:className() ), ;
                                  QQout( " VALUE:", x )            ) } )
   ELSE
      Qout( Space(10),"-> NIL" )
   ENDIF

   ? "oError:canDefault   :" , oError:canDefault
   ? "oError:canRetry     :" , oError:canRetry
   ? "oError:canSubstitute:" , oError:canSubstitute
   ? "oError:cargo        :" , oError:cargo
   ? "oError:description  :" , oError:description
   ? "oError:filename     :" , oError:filename
   ? "oError:genCode      :" , oError:genCode
   ? "oError:operation    :" , oError:operation
   ? "oError:osCode       :" , oError:osCode
   ? "oError:severity     :" , oError:severity
   ? "oError:subCode      :" , oError:subCode
   ? "oError:subSystem    :" , oError:subSystem
   ? "oError:thread       :" , oError:thread
   ? "oError:tries        :" , oError:tries

   ? Replicate( "-", 78 )
   ? "CALLSTACK:"
   ? Replicate( "-", 78 )

   DO WHILE ! Empty( ProcName(++i) )
      ? "Called from", Trim( ProcName(i) )   + "(" + ;
                 LTrim( Str( ProcLine(i) ) ) + ")"
   ENDDO

   SET ALTERNATE TO
   SET ALTERNATE OFF

   MsgBox( "Error log was written to the file XPPERROR."+ cExtension  )

   ErrorLevel(1)                       // Set error level
   QUIT                                // End of program

RETURN

* ---------------

STATIC FUNCTION _XbpCrtCall( aGetList, i, xOptions, oParent, lNewThread )

LOCAL oThread, oCrt

DEFAULT lNewThread := .f.

IF lNewThread
  Sleep(10)
  oThread := Thread():new()
  oThread:start( {|| _XbpCrt( aGetList, i, xOptions, oParent, @oCrt, .t. ) } )
ELSE
  _XbpCrt( aGetList, i, xOptions, oParent, @oCrt, .f. )
ENDIF

RETURN oCrt

* ---------------

STATIC FUNCTION _XbpCrt( aGetList, i, xOptions, oParent, oCrt, lNewThread )

LOCAL bBlock, oAppWindow := SetAppWindow()

DEFAULT aGetList[i,nGETLIST_HEIGHT] := 25
DEFAULT aGetList[i,nGETLIST_WIDTH]  := 80
DEFAULT aGetList[i,xGETLIST_OPTIONS2] := .f.

oCrt := XbpCrt():new( oParent, , {0,0},;
         aGetList[i,nGETLIST_HEIGHT], aGetList[i,nGETLIST_WIDTH],;
         aGetList[i,cGETLIST_CAPTION] )

IF !Empty(aGetList[i,cGETLIST_FONT])
  oCrt:fontname := aGetList[i,cGETLIST_FONT]
ENDIF
IF !Empty(xOptions[1])
  oCrt:fontwidth  := xOptions[1]
  oCrt:fontheight := xOptions[2]
ENDIF
IF Valtype(xOptions[3]) = 'N'
  oCrt:border := xOptions[3]
ENDIF
oCrt:titleBar := !aGetList[i,xGETLIST_OPTIONS2]
oCrt:closeable  := .f.
oCrt:create()

IF Empty(oCrt:cargo)
  oCrt:cargo := { i, aGetlist, aGetlist[i,xGETLIST_CARGO] }
ENDIF

bBlock := DC_GetBlock(aGetList[i,bGETLIST_GROUP],'O')
IF Valtype( bBlock ) = 'B'
  Eval( bBlock, oCrt )
ENDIF

bBlock := DC_GetBlock(aGetList[i,bGETLIST_ACTION])
IF Valtype(bBlock) = 'B'
  DC_QoutWindow(oCrt)
  SetAppWindow(oCrt)
  Eval( bBlock )
ENDIF

IF lNewThread
  IF oAppWindow:status() > 0
    SetAppWindow( oAppWindow )
  ENDIF
  IF oCrt:status() > 0
    oCrt:Destroy()
  ENDIF
ELSE
  SetAppWindow(oCrt)
ENDIF

RETURN nil

* ------------------

FUNCTION DC_ReadGuiEvent( nEvent, aGetList )

LOCAL nLastEvent := 0, oGetList

IF Empty(aGetList) .AND. TYPE('GetList') = 'A' .AND. !Empty(M->GetList)
  aGetList := M->GetList
ENDIF

IF !Empty(aGetList)
  oGetList := DC_GetListObject( aGetList )
  IF Valtype(oGetList) == 'O'
    nLastEvent := oGetList:lastEvent
    IF Valtype(nLastEvent) # 'N'
      nLastEvent := DCGUI_NONE
    ENDIF
    IF Valtype(nEvent) == 'N'
      oGetList:lastEvent := nEvent
    ENDIF
  ENDIF
ENDIF

PostAppEvent( xbeM_Motion, {0,0} )

RETURN nLastEvent

* ------------------

METHOD DC_GetList:CellEditSetup( oXbp )

LOCAL aGetList, i

aGetList := ::getListArray
i := ::getListPointer

DEFAULT aGetlist[i,xGETLIST_OPTIONS2] := {}  // Cell Editing
ASize(aGetlist[i,xGETLIST_OPTIONS2],6)
DEFAULT aGetlist[i,xGETLIST_OPTIONS2,1] := 0   // event
DEFAULT aGetlist[i,xGETLIST_OPTIONS2,3] := DCGUI_BROWSE_EDITACROSS
DEFAULT aGetlist[i,xGETLIST_OPTIONS2,6] := ;
   ( aGetlist[i,nGETLIST_SUBTYPE] == BROWSE_DATABASE )

IF aGetlist[i,xGETLIST_OPTIONS2,1] > 0

  ::AddHotKey( aGetlist[i,xGETLIST_OPTIONS2,1], ;
              DC_BrowCellBlock( ;
                oXbp, ;
                aGetlist[i,xGETLIST_OPTIONS2,3],;     // Edit mode
                nil, ;                                // nil
                aGetlist[i,xGETLIST_OPTIONS2,2],;     // Edit Action block
                aGetlist[i,xGETLIST_OPTIONS8], ;      // Handler block
                aGetlist[i,xGETLIST_OPTIONS2,5],;     // Exit block
                aGetlist[i,xGETLIST_OPTIONS9],;       // Reference Array
                aGetList),;
                {||oXbp:isVisible()}, nil, oXbp, oXbp, ;
                aGetlist[i,xGETLIST_CARGO], .T. )
ENDIF

DEFAULT aGetlist[i,xGETLIST_OPTIONS3] := {}  // Cell Inserting
ASize(aGetlist[i,xGETLIST_OPTIONS3],5)

DEFAULT aGetlist[i,xGETLIST_OPTIONS3,1] := 0
IF aGetlist[i,xGETLIST_OPTIONS3,1] > 0
  ::AddHotKey( aGetlist[i,xGETLIST_OPTIONS3,1], ;
               DC_BrowCellBlock( ;
                 oXbp, ;
                 DCGUI_BROWSE_INSERT,;                 // Insert mode
                 aGetlist[i,xGETLIST_OPTIONS3,3], ;    // Default value
                 aGetlist[i,xGETLIST_OPTIONS3,2], ;    // Action Block
                 aGetlist[i,xGETLIST_OPTIONS8],   ;    // Handler Block
                 aGetlist[i,xGETLIST_OPTIONS3,4], ;    // Exit Block
                 aGetlist[i,xGETLIST_OPTIONS9],   ;    // Reference Array
                 aGetlist), ;
                 {||oXbp:isVisible()}, nil, oXbp, oXbp, ;
                 aGetlist[i,xGETLIST_CARGO], .T. )
ENDIF

DEFAULT aGetlist[i,xGETLIST_OPTIONS3,5] := 0
IF aGetlist[i,xGETLIST_OPTIONS3,5] > 0
  ::AddHotKey( aGetlist[i,xGETLIST_OPTIONS3,5], ;
               DC_BrowCellBlock( ;
                 oXbp, ;
                 DCGUI_BROWSE_APPEND,;                 // Append mode
                 aGetlist[i,xGETLIST_OPTIONS3,3], ;    // Default value
                 aGetlist[i,xGETLIST_OPTIONS3,2], ;    // Action Block
                 aGetlist[i,xGETLIST_OPTIONS8],   ;    // Handler Block
                 aGetlist[i,xGETLIST_OPTIONS3,4], ;    // Exit Block
                 aGetlist[i,xGETLIST_OPTIONS9],   ;    // Reference Array
                 aGetlist ), ;
                 {||oXbp:isVisible()}, nil, oXbp, oXbp, ;
                 aGetlist[i,xGETLIST_CARGO], .T.  )
ENDIF

DEFAULT aGetlist[i,xGETLIST_OPTIONS4] := {}  // Cell Deleting
ASize(aGetlist[i,xGETLIST_OPTIONS4],3)
DEFAULT aGetlist[i,xGETLIST_OPTIONS4,1] := 0

IF aGetlist[i,xGETLIST_OPTIONS4,1] > 0

  ::AddHotKey( aGetlist[i,xGETLIST_OPTIONS4,1], ;
               DC_BrowCellBlock( ;
                 oXbp, ;
                 DCGUI_BROWSE_DELETE,;               // Delete mode
                 nil,;                               // nil
                 aGetlist[i,xGETLIST_OPTIONS4,2], ;  // Action block
                 aGetlist[i,xGETLIST_OPTIONS8],;     // Handler block
                 aGetlist[i,xGETLIST_OPTIONS4,3],;   // Exit block
                 aGetlist[i,xGETLIST_OPTIONS9],;     // Reference Array
                 aGetlist ), ;
                 {||.f.}, nil, oXbp, oXbp, ;
                 aGetlist[i,xGETLIST_CARGO], .T.  )
ENDIF

RETURN self

* ----------------------

FUNCTION DC_BrowCellBlock( oBrowse, nbMode, abDefault, ;
                           bEditAction, bHandler, bEditExit, ;
                           xRef, aGetList )

RETURN {|a,b,o| DC_BrowCellEdit( oBrowse, nil, nil, nbMode, nil, abDefault, ;
                                bEditAction, o, bHandler, bEditExit, ;
                                xRef, aGetList )}

* ----------------------

FUNCTION DC_BrowCellEdit( oBrowse, nRow, nCol, nbMode, lArray, ;
                     abDefault, bEditAction, oCellGroup, bHandler, ;
                     bEditExit, xRef, aGetList, lKeyboard, mp1 )

LOCAL oColumn, aRect, GetList, GetOptions, lOk, xGet, bValid, bWhen, bProtect, lReEdit, ;
      aRef := { 0, nil, nil, xbeK_ENTER, nil, nil, nil, nil, nil, nil, .f., nil, nil, nil }, aArray, i, ;
      cFont, oParent, bAnchorCB, bGetSet, lHitBottom := .f., bSaveBottom, ;
      lMoveAcross, xOptions, nbSaveMode := nbMode, ;
      xSaveKeyVal, lQuickBrowse := .f., lMoveDown, lInsert := .f., ;
      lAppend := .f., aChildren, xMessage, xMessageInto, nMode, bSaveTop, ;
      lHitTop := .F., lStatus, nHitBottom := 0, lPopValid, lValidateAlways

DEFAULT lKeyboard := .F.

Grok(aGetList)
IF lKeyboard .AND. Valtype(mp1) = 'U'
  RETURN .F.
ENDIF

DC_BrowCellEditKeyStuff( mp1 )

lArray := IIF( Valtype(lArray)='L',lArray,.f. )

IF Valtype(nbMode) == 'N'
  nMode := nbMode
ELSEIF Valtype(nbMode) == 'B'
  nMode := Eval(nbMode)
ENDIF

DEFAULT nMode := DCGUI_BROWSE_EDITACROSSDOWN

IF Valtype( oBrowse ) # 'O' .OR. ;
   ( !(oBrowse:isDerivedFrom('DC_XbpBrowse')) .AND. ;
     !(oBrowse:isDerivedFrom('XbpCellGroup')) .AND. ;
     !(oBrowse:isDerivedFrom('DC_XbpQuickBrowse')) )
  DC_MsgBox( ;
    'DC_BrowCellEdit() must be called with a valid DC_XbpBrowse, DC_XbpQuickBrowse, or DC_XbpColumn object')
  RETURN .f.
ENDIF

lOk := .f.
lReEdit := .f.
lQuickBrowse := oBrowse:isDerivedFrom('DC_XbpQuickBrowse')
IF (oBrowse:isDerivedFrom('DC_XbpBrowse') .OR. lQuickBrowse )
  lArray := Valtype(oBrowse:dataSource) == 'A'
  IF !lQuickBrowse
    cFont := oBrowse:font
  ENDIF
ENDIF
IF lQuickBrowse .AND. !lArray
  GOTO oBrowse:getData()
ENDIF

lStatus := .T.
IF Valtype(bEditAction) = 'B'
  lStatus := Eval( bEditAction, oBrowse )
  DEFAULT lStatus := .T.
  IF !lStatus
    RETURN .f.
  ENDIF
ENDIF

IF nMode = DCGUI_BROWSE_INSERT
  lInsert := .t.
  nMode := DCGUI_BROWSE_EDITACROSS
ELSEIF nMode = DCGUI_BROWSE_APPEND
  lAppend := .t.
  nMode := DCGUI_BROWSE_EDITACROSS
ELSEIF nMode = DCGUI_BROWSE_DELETE
  IF lArray
    IF Len(oBrowse:dataSource) >= 1
      IF lStatus
        ARemove(oBrowse:dataSource,oBrowse:arrayElement)
        oBrowse:RefreshAll()
      ENDIF
    ENDIF
  ELSE
     RETURN lStatus
  ENDIF
  DC_ClearEvents()
  IF Valtype(bEditExit) = 'B'
    Eval( bEditExit, oBrowse, nbSaveMode, aRef[1] )
  ENDIF
  RETURN lStatus
ENDIF

aRef[1] := aRef[4]
aRef[5] := nMode
aRef[7] := bHandler
aRef[8] := 0 // nEvent

oBrowse:isCellEditing := .t.

DO WHILE .t.

  IF Valtype(aRef[3]) == 'O'
    aChildren := aRef[3]:childList()
    FOR i := 1 TO Len(aChildren)
      IF aChildren[i]:status() > 0
        aChildren[i]:destroy()
      ENDIF
    NEXT
    aRef[3]:invalidateRect()
    aRef[3] := nil
  ENDIF

  IF lAppend .OR. lInsert
    IF lArray
      IF Valtype(abDefault) = 'A'
        aArray := AClone(abDefault)
      ELSEIF Valtype(abDefault) = 'B'
        aArray := Eval(abDefault,oBrowse)
      ELSEIF Len(oBrowse:dataSource) >= 1
        aArray := AClone(oBrowse:dataSource[1])
        FOR i := 1 TO LEN(aArray)
           IF Valtype(aArray[i]) = 'C'
             aArray[i] := Space(Len(aArray[i]))
           ELSEIF Valtype(aArray[i]) = 'D'
             aArray[i] := CTOD('  /  /  ')
           ELSEIF Valtype(aArray[i]) = 'L'
             aArray[i] := .f.
           ELSEIF Valtype(aArray[i]) = 'N'
             aArray[i] := 0
           //ELSE
             //aArray[i] := nil
           ENDIF
         NEXT
      ELSE
         oBrowse:isCellEditing := .f.
         RETURN .f.
      ENDIF

      ASize( oBrowse:dataSource, Len(oBrowse:dataSource)+1 )
      IF lInsert
        AIns( oBrowse:dataSource, oBrowse:arrayElement )
      ELSE
        oBrowse:arrayElement := Len(oBrowse:dataSource)
      ENDIF

      oBrowse:dataSource[oBrowse:arrayElement] := aArray

    ELSEIF Valtype(abDefault) == 'B'

      Eval(abDefault,aRef[1])

    ELSE

      _AddRec(oBrowse)  // J. Duijf 27-11-2002

    ENDIF

    IF lAppend
      oBrowse:goBottom()
      nRow := nil
    ENDIF
    oBrowse:firstCol()
    oBrowse:forceStable()
    oBrowse:RefreshAll()
    lAppend := .f.
    lInsert := .f.

  ENDIF

  aRef[2] := nil  // Get Object
  IF !lReEdit
    GetList := {}
    IF oBrowse:isDerivedFrom('DC_XbpBrowse')
      IF Empty(nCol)
        nCol := oBrowse:colPos
      ELSEIF nCol > oBrowse:colCount
        EXIT
      ENDIF
      oColumn := oBrowse:getColumn(nCol)
    ELSEIF lQuickBrowse
      IF Empty(nCol)
        nCol := oBrowse:colPos
      ELSEIF nCol > oBrowse:colCount
        EXIT
      ENDIF
      oColumn := oBrowse:columns[nCol]
    ELSE
      oColumn := oBrowse
      oBrowse := oColumn:setParent()
    ENDIF
    IF !lQuickBrowse .AND. Empty(oBrowse:hitBottomBlock)
      bSaveBottom := oBrowse:hitBottomBlock
      bSaveTop := oBrowse:hitTopBlock

      oBrowse:hitBottomBlock := ;
        DC_MergeBlocks(oBrowse:hitBottomBlock,{||lHitBottom := .f.},oBrowse)

      oBrowse:hitTopBlock := ;
        DC_MergeBlocks(oBrowse:hitTopBlock,{||lHitTop:=.t.},oBrowse)
    ENDIF
    IF Valtype(oColumn) # 'O' .OR. ;
         (!(oColumn:isDerivedFrom('DC_XbpColumn')) .AND. ;
          !(oColumn:isDerivedFrom('DC_QBColumn')))
       EXIT
    ENDIF

    IF Empty(nRow)
      IF oBrowse:isDerivedFrom('XbpBrowse')
         nRow := oBrowse:rowPos
      ELSE
         nRow := 1
      ENDIF
    ENDIF

    aRef[4] := xbeK_ENTER               // Exit Key
    IF lQuickBrowse
      aRef[3] := oBrowse:dataArea
      aRect := oBrowse:CellRect()
      cFont := 'DEFAULT'
    ELSE
      aRef[3] := oColumn:dataArea       // Pointer to XbpCellGroup
      aRect := aRef[3]:CellRect( nRow )
    ENDIF

    IF aRect == NIL
      RETURN .f.
    ENDIF

    IF Valtype(oCellGroup) = 'O' .AND.  ;
               oCellGroup:isDerivedFrom('XbpCellGroup') ;
               .AND. !( oCellGroup == aRef[3] )
       EXIT
    ENDIF

    aRef[11] := .f.

    IF Valtype(oColumn:cargo) = 'A'
      bGetSet := nil
      bValid := oColumn:validBlock
      aRef[11] := oColumn:validateAlways
      bWhen := oColumn:whenBlock
      bProtect := oColumn:protectBlock
      xMessage := oColumn:getList:getListArray[oColumn:getListPointer][cGETLIST_MESSAGE]
      xMessageInto := oColumn:getList:getOptions[oGETOPT_MESSAGEINTO]

      IF Valtype(oColumn:cellEditGetList) = 'A'
        GetList := AClone(oColumn:cellEditGetList) // GetList contains Editor object
        // GetList := oColumn:cellEditGetList // GetList contains Editor object
        bGetSet := DC_GetBlock(GetList[1,bGETLIST_VAR])
        aRef[4] := oColumn:cellEditExitKey // Exit Key
      ELSEIF Valtype(oColumn:cellEditID) = 'B'
        Eval(oColumn:cellEditID)
        EXIT
      ENDIF
      IF bGetSet == NIL .OR. Eval(bGetSet) == NIL
        bGetSet := oColumn:getsetBlock  // Get-Set Block
      ENDIF
    ELSE
      bGetSet := oColumn:dataLink
    ENDIF
  ENDIF
  lReEdit := .f.

  IF Empty(GetList) // No Editor attached to this Cell

    aRef[6] := .t.  // lValidate by passing buffer
    IF Empty(cFont)
      cFont := oColumn:setFontCompoundName()
      oParent := oColumn
      DO WHILE Empty(cFont)
        oParent := oParent:setParent()
        IF Valtype(oParent) = 'U'
          EXIT
        ENDIF
        IF oParent:isDerivedFrom('XbpDialog')
          cFont := oParent:drawingArea:setFontCompoundName()
          IF Empty(cFont)
            cFont := oParent:setFontCompoundName()
          ENDIF
        ENDIF
        IF !Empty(cFont)
          EXIT
        ENDIF
      ENDDO
    ENDIF
    IF Empty(cFont)
       cFont := 'DEFAULT'
    ENDIF

    bAnchorCB := bGetSet

    @ aRect[2], aRect[1] DCGET bAnchorCB ;
      GETSIZE aRect[3]-aRect[1], aRect[4]-aRect[2] ;
      PARENT aRef[3] PIXEL GETOBJECT aRef[2] ;
      CELLEDITOR ;
      FONT cFont ;
      EVAL {|o|aRef[2]:setModalState(XBP_DISP_APPMODAL)}

    IF Valtype(bValid) = 'B'
       GetList[1,bGETLIST_VALID] := bValid
    ENDIF
    GetList[1,cGETLIST_MESSAGE] := xMessage
    GetList[1,cGETLIST_PICTURE] := oColumn:picture

  ELSE // Custom Editor attached to this Cell
    //
    // J. Duijf 25-07-2017
    // Calc height in pixels
    //
    IF GetList[1,nGETLIST_TYPE] = GETLIST_GET
       // Always idential to cell height
       GetList[1,nGETLIST_HEIGHT] := aRect[4] - aRect[2]
    Else
      // Combo / listbox / mle
      If !GetList[1,lGETLIST_PIXEL]
        DEFAULT GetList[1,nGETLIST_HEIGHT] := 1
        GetList[1,nGETLIST_HEIGHT] := (aRect[4]-aRect[2]) * GetList[1,nGETLIST_HEIGHT]
      Else
        DEFAULT GetList[1,nGETLIST_HEIGHT] := aRect[4] - aRect[2]
      Endif
    ENDIF

    IF GetList[1,nGETLIST_HEIGHT] < (aRect[4]-aRect[2])
      GetList[1,nGETLIST_HEIGHT] := (aRect[4]-aRect[2])
    ENDIF

    GetList[1,nGETLIST_STARTROW] := aRect[2] - GetList[1,nGETLIST_HEIGHT] + ;
                                    aRect[4] - aRect[2]
    GetList[1,nGETLIST_STARTCOL] := aRect[1]
    GetList[1,lGETLIST_PIXEL] := .t.

    xOptions := GetList[1,xGETLIST_OPTIONS]

    IF Valtype(GetList[1,xGETLIST_OPTIONS2]) == 'A'
      lPopValid := GetList[1,xGETLIST_OPTIONS2,5]
      DEFAULT lPopValid := .f.
    ELSE
      lPopValid := .f.
    ENDIF

    IF GetList[1,nGETLIST_TYPE] = GETLIST_GET .AND. ;
          ((Valtype(DC_GetBlock(GetList[1,xGETLIST_OPTIONS2])) = 'B') ; // PopUp Button
           .OR. ;
           lPopValid ;  // POPVALID clause
           .OR. ;
           (Valtype(xOptions) = 'A' .AND. !Empty(xOptions) .AND. xOptions[1,1,1] == 120))
       GetList[1,nGETLIST_WIDTH] := aRect[3]-aRect[1] - GetList[1,nGETLIST_HEIGHT]- IIF( DC_GetPopupCaption()[3]==0,1,-5)
    ELSE
       GetList[1,nGETLIST_WIDTH] := aRect[3]-aRect[1]
    ENDIF
    GetList[1,lGETLIST_PIXEL]    := .t.
    GetList[1,bGETLIST_PARENT]   := DC_GetAnchorCB(@aRef[3],'O')  // Cell Group
    GetList[1,bGETLIST_GROUP]    := DC_GetAnchorCB(@aRef[2],'O')  // Get Object
    GetList[1,oGETLIST_OBJECT] := nil
    // GetList[1,nGETLIST_SUBTYPE]  := 1
    xGet := Eval(bGetSet) // Get data from Cell Data Source
    bAnchorCB := DC_GetBlock(GetList[1,bGETLIST_VAR])  // Editor Var Anchor

    IF Eval(bAnchorCb) = NIL // Use Column block as Anchor
      bAnchorCB := bGetSet
      GetList[1,bGETLIST_VAR] := bAnchorCB
    ELSEIF Valtype(bAnchorCB) = 'B' .AND. Valtype(xGet) = Valtype(Eval(bAnchorCB))
      // Holding Variable is the one pointed to by Editor Anchor Block
    ELSE
      bAnchorCB := DC_GetAnchorCB(@xGet,,xGet) // Holding Variable is xGet
    ENDIF
    IF Valtype(xGet) = 'C'
      xGet := Pad(xGet,Len(Eval(bAnchorCB)))
    ENDIF

    Eval( bAnchorCB, xGet ) // Store Cell contents to Variable

    IF Valtype(Getlist[1,bGETLIST_EVAL]) # 'B'
      GetList[1,bGETLIST_EVAL]  := {||aRef[2]:setModalState(XBP_DISP_APPMODAL)}
    ENDIF

    GetList[1,nGETLIST_POINTER] = nil
    IF Empty(GetList[1,cGETLIST_MESSAGE])
      GetList[1,cGETLIST_MESSAGE] := xMessage
    ENDIF

    IF Valtype(bValid) = 'B' .AND. ;
         Valtype(DC_GetBlock(GetList[1,bGETLIST_VALID])) # 'B'
      aRef[6] := .t. // Validate by passing buffer
      GetList[1,bGETLIST_VALID] := bValid
    ELSE
      aRef[6] := .f. // Validate by passing object
    ENDIF

  ENDIF

  IF Valtype(bWhen) # 'B'
    bWhen := DC_GetBlock(GetList[1,bGETLIST_WHEN])
  ENDIF

  IF Valtype(bProtect) # 'B'
    bWhen := DC_GetBlock(GetList[1,bGETLIST_PROTECT])
  ENDIF

  IF (Valtype(bWhen) # 'B' .OR. Eval(bWhen)) .AND. ;
     (Valtype(bProtect) # 'B' .OR. !Eval(bProtect))

    IF oBrowse:autoLock
      IF !_Reclock(oBrowse) // J. Duijf 27-11-2002
        oBrowse:isCellEditing := .f.
        RETURN .f.
      ENDIF
    ENDIF

    DCGETOPTIONS NOTRANSLATE TABSTOP MESSAGEINTO xMessageInto _NOESCAPEKEY .f. ;
      ABORTQUERY MSG {||IIF(oBrowse:autoLock,_RecLock(oBrowse),nil),.t.}

    IF Valtype(oBrowse:itemMarked) == 'B'
      Eval(oBrowse:itemMarked,nil,nil,oBrowse)
    ENDIF
    xSaveKeyVal := NIL
    if oBrowse:dataSourceType = BROWSE_DATABASE                         // J. Duijf 27-11-2002
      if !Empty((oBrowse:dataSource)->(IndexKey(0)))
        xSaveKeyVal := (oBrowse:dataSource)->(&(IndexKey(0)))
      endif
    elseif oBrowse:dataSourceType = BROWSE_DATAOBJECT                   // J. Duijf 27-11-2002
      if !Empty(oBrowse:dataSource:IndexKey(0))                         // J. Duijf 27-11-2002
        xSaveKeyVal := oBrowse:dataSource:OrdKeyVal(0)                  // J. Duijf 27-11-2002
      endif                                                             // J. Duijf 27-11-2002
    elseif oBrowse:dataSourceType = BROWSE_ACESERVER
      if !Empty(oBrowse:dataSource:OrdKey())
        xSaveKeyVal := &(oBrowse:dataSource:OrdKey())
      endif
    elseif oBrowse:dataSourceType = BROWSE_SPSQL // silex
      if ! Empty(oBrowse:dataSource:GetIndex())
        xSaveKeyVal := oBrowse:dataSource:GetIndex()
      endif
    endif
    aRef[8] := 0
    DC_BrowCellEditExit(0)
    IF lQuickBrowse .AND. !lArray
      dbSuspendNotifications()
    ENDIF

    DCREAD GUI ;
       EXPRESS ;
       PARENT oBrowse ;
       OPTIONS GetOptions ;
       HANDLER CellHandler REFERENCE { aRef, xRef, oBrowse } TO lOk ;
       SAVE ;
       TIMEOUT DC_CellEditTimeout() ;
       EVAL {|c|_StuffKeys(aRef)} ;
       TO lStatus

    IF !lStatus
      EXIT
    ENDIF

    IF lQuickBrowse .AND. !lArray
      dbResetNotifications()
    ENDIF

    IF !lArray .and. !(xSaveKeyVal==NIL)
       if oBrowse:dataSourceType = BROWSE_DATABASE                         // J. Duijf 27-11-2002
          if !Empty((oBrowse:dataSource)->(IndexKey(0))) .AND.;
             !(oBrowse:dataSource)->(&(IndexKey(0))) == xSaveKeyVal
             oBrowse:RefreshAll()
             EXIT
          endif
       elseif oBrowse:dataSourceType = BROWSE_DATAOBJECT              // J. Duijf 27-11-2002
          if !Empty(oBrowse:dataSource:IndexKey(0)) .AND. ;           // J. Duijf 27-11-2002
             !oBrowse:dataSource:OrdKeyVal(0) == xSaveKeyVal          // J. Duijf 27-11-2002
             oBrowse:RefreshAll()
             EXIT
          endif
       elseif oBrowse:dataSourceType = BROWSE_ACESERVER
          if !Empty(oBrowse:dataSource:OrdKey()) .AND. ;
             !&(oBrowse:dataSource:OrdKey()) == xSaveKeyVal
             oBrowse:RefreshAll()
             EXIT
          endif
       elseif oBrowse:dataSourceType = BROWSE_SPSQL // silex
          if !Empty(oBrowse:dataSource:GetIndex()) .AND. ;
             ! oBrowse:dataSource:GetIndex() == xSaveKeyVal
             oBrowse:RefreshAll()
             EXIT
          endif
       endif
    endif

  ELSE

    lHitBottom := .f.
    lHitTop := .f.

    IF (nMode == DCGUI_BROWSE_EDITACROSS .OR. ;
        nMode == DCGUI_BROWSE_EDITACROSSDOWN .OR. ;
        nMode == DCGUI_BROWSE_EDITACROSSDOWN_APPEND) .AND. aRef[1] == aRef[4]

      nCol     := DC_BrowCellEdit_NextCol(oBrowse,nCol)                       // J. Duijf 23-04-2015
      //nCol++

      IF nCol > oBrowse:colCount
        oBrowse:firstCol()
        nCol := 1
        IF nMode == DCGUI_BROWSE_EDITACROSSDOWN .OR. nMode == DCGUI_BROWSE_EDITACROSSDOWN_APPEND
          oBrowse:forcestable()
          oBrowse:refreshCurrent()
          IF oBrowse:autoLock   // TRUE if No Record Lock
             _recUnlock(oBrowse)                                                 // J. Duijf 27-11-2002
          ENDIF
          IF oBrowse:dataSourceType == BROWSE_DATABASE .AND. nMode == DCGUI_BROWSE_EDITACROSSDOWN_APPEND
            IF (oBrowse:datasource)->(DC_TestEof())
              lAppend := .t.
            ENDIF
          ELSEIF lArray .AND. oBrowse:arrayElement >= Len(oBrowse:dataSource)
            IF nMode == DCGUI_BROWSE_EDITACROSSDOWN_APPEND
              lAppend := .t.
            ELSE
              EXIT
            ENDIF
          ENDIF
          oBrowse:down()
          nRow := 0
        ELSE
          oBrowse:forcestable()
          EXIT
        ENDIF
      ELSE
        oBrowse:right()
      ENDIF
      oBrowse:forcestable()
      LOOP
    ELSEIF (nMode == DCGUI_BROWSE_EDITDOWN .OR. ;
           (aRef[1] == xbeK_DOWN .AND. aRef[4] # xbeK_ENTER)) .AND. aRef[1] # xbeK_UP
      IF oBrowse:autoLock
         _recUnlock(oBrowse)                                                 // J. Duijf 27-11-2002
      ENDIF
      IF lArray .AND. oBrowse:arrayElement >= Len(oBrowse:dataSource)
         EXIT
      ENDIF
      oBrowse:down()
      oBrowse:forcestable()
      nRow := 0
    ELSEIF aRef[1] == xbeK_UP // .AND. aRef[4] # xbeK_ENTER
      IF oBrowse:autoLock
          _recUnlock(oBrowse)                                                 // J. Duijf 27-11-2002
      ENDIF
      oBrowse:up()
      oBrowse:forcestable()
      nRow := 0
    ELSE
      oBrowse:forcestable()
      EXIT
    ENDIF

  ENDIF

  lMoveAcross := (nMode == DCGUI_BROWSE_EDITACROSS .OR. ;
                  nMode == DCGUI_BROWSE_EDITACROSSDOWN .OR. ;
                  nMode == DCGUI_BROWSE_EDITACROSSDOWN_APPEND) ;
                  .AND. (aRef[1] = xbeK_ENTER .OR. aRef[1] = xbeK_TAB)

  lMoveDown :=  (nMode == DCGUI_BROWSE_EDITDOWN .OR. nMode == DCGUI_BROWSE_EDITACROSSDOWN_APPEND) ;
                 .AND. (aRef[1] = xbeK_ENTER .OR. aRef[1] = xbeK_TAB)

  IF Valtype(aRef[2]) = 'O'
    IF lMoveAcross .OR. lMoveDown .OR. aRef[8] == xbeM_LbDown .OR. !lOk
      IF Valtype(aRef[2]:killInputFocus) = 'B'
        Eval(aRef[2]:killInputFocus,nil,nil,aRef[2])
      ELSEIF oBrowse:isDerivedFrom('DC_XbpQuickBrowse')
        IF Valtype(oBrowse:columns[nCol]:killInputfocus) = 'B'
          Eval(oBrowse:columns[nCol]:killinputfocus,nil,nil,oBrowse:columns[nCol])
        ENDIF
      ELSEIF Valtype(oBrowse:getColumn(nCol):killInputfocus) = 'B'
        Eval(oBrowse:getColumn(nCol):killinputfocus,nil,nil,oBrowse:getColumn(nCol))
      ENDIF
    ENDIF
  ENDIF

  IF !lOk .OR. nCol > oBrowse:colCount
    EXIT
  ENDIF

  IF lQuickBrowse
    oBrowse:dataLink:refresh()
    oBrowse:refreshrows(oBrowse:rowpos,oBrowse:rowpos)
  ELSE
    oBrowse:refreshcurrent()
  ENDIF
  lHitBottom := .f.
  lHitTop := .f.

  IF lMoveAcross

    nCol := DC_BrowCellEdit_NextCol(oBrowse,nCol)                         // J. Duijf 23-04-2015
    // nCol++

    IF nCol > oBrowse:colCount
      IF lQuickBrowse
        oBrowse:panFirstCol()
      ELSEIF  oBrowse:colPos > 1
        oBrowse:firstCol()
      ENDIF
      nCol := 1
      IF nMode == DCGUI_BROWSE_EDITACROSSDOWN .OR. nMode == DCGUI_BROWSE_EDITACROSSDOWN_APPEND
        oBrowse:forceStable()
        IF lQuickBrowse
          oBrowse:refreshRows(oBrowse:rowPos,oBrowse:rowPos)
        ELSE
          oBrowse:refreshCurrent()
        ENDIF
        // oBrowse:forcestable()
        IF oBrowse:autoLock
           _recUnlock(oBrowse)                                                  // J. Duijf 27-11-2002
        ENDIF

        IF !lArray .AND. nMode == DCGUI_BROWSE_EDITACROSSDOWN_APPEND
            if oBrowse:dataSourceType = BROWSE_DATABASE                         // J. Duijf 27-11-2002
               if (oBrowse:datasource)->(DC_TestEof())
                  lAppend := .t.
                  LOOP
               endif
            elseif oBrowse:dataSourceType = BROWSE_DATAOBJECT                   // J. Duijf 27-11-2002
               if oBrowse:datasource:Eof()
                  lAppend := .t.
                  LOOP
               endif
            elseif oBrowse:dataSourceType = BROWSE_ACESERVER
               if oBrowse:datasource:Eof()
                  lAppend := .t.
                  LOOP
               endif
            endif
        ELSEIF lArray .AND. oBrowse:arrayElement >= Len(oBrowse:dataSource)
          IF nMode == DCGUI_BROWSE_EDITACROSSDOWN_APPEND
            lAppend := .t.
            LOOP
          ELSE
            EXIT
          ENDIF
        ENDIF
        oBrowse:down()
        nRow := 0
      ELSE
        oBrowse:forcestable()
        EXIT
      ENDIF

    ELSE
      oBrowse:right()
    ENDIF
    oBrowse:forcestable()

  ELSEIF aRef[1] == xbeK_UP

    IF oBrowse:autoLock
       _recUnlock(oBrowse)                                                 // J. Duijf 27-11-2002
    ENDIF
    oBrowse:up()
    oBrowse:forcestable()
    nRow := 0

  ELSEIF lMoveDown .OR. aRef[1] == xbeK_DOWN

    IF oBrowse:autoLock
       _recUnlock(oBrowse)                                                 // J. Duijf 27-11-2002
    ENDIF
    IF !lArray .AND. nMode == DCGUI_BROWSE_EDITACROSSDOWN_APPEND
      if oBrowse:dataSourceType = BROWSE_DATABASE                          // J. Duijf 27-11-2002
         if (oBrowse:datasource)->(DC_TestEof())
            lAppend := .t.
            LOOP
         endif
      elseif oBrowse:dataSourceType = BROWSE_DATAOBJECT                    // J. Duijf 27-11-2002
         if oBrowse:datasource:Eof()                                       // J. Duijf 27-11-2002
            lAppend := .t.
            LOOP
         endif
      elseif oBrowse:dataSourceType = BROWSE_ACESERVER
         if oBrowse:datasource:Eof()
            lAppend := .t.
            LOOP
         endif
      endif
    ELSEIF lArray .AND. oBrowse:arrayElement >= Len(oBrowse:dataSource)
      IF nMode == DCGUI_BROWSE_EDITACROSSDOWN_APPEND
        lAppend := .t.
        LOOP
      ELSE
        EXIT
      ENDIF
    ENDIF
    oBrowse:down()
    oBrowse:forcestable()

    nRow := 0

  ELSE
    EXIT

  ENDIF

  IF lHitTop .OR. lHitBottom
    EXIT
  ENDIF

ENDDO

IF Valtype(aRef[3]) == 'O'
  aChildren := aRef[3]:childList()
  FOR i := 1 TO Len(aChildren)
    IF aChildren[i]:status() > 0
      aChildren[i]:destroy()
    ENDIF
  NEXT
  aRef[3]:invalidateRect()
  DC_CompleteEvents()
ENDIF

IF !lQuickBrowse
  oBrowse:hitBottomBlock := bSaveBottom
  oBrowse:hitTopBlock := bSaveTop
ENDIF
IF oBrowse:autoLock
   _recUnlock(oBrowse)                                                 // J. Duijf 27-11-2002
ENDIF

IF Valtype(bEditExit) = 'B'
   Eval( bEditExit, oBrowse, nbSaveMode, aRef[1], ;
         aRef[8], aRef[12], aRef[13], aRef[14] )
ENDIF

oBrowse:isCellEditing := .f.

RETURN .t.


//
// J. Duijf 24-04-2015
// Get next column number that can be edited
//
STATIC FUNCTION DC_BrowCellEdit_NextCol(oBrowse,nCol)
LOCAL oColumn     := nil
LOCAL lEdit       := FALSE
nCol++
Do while nCol <= oBrowse:colCount
   oColumn        := oBrowse:GetColumn(nCol)                                  // DC_XbpColumn
   If oColumn:IsVisible()                                                     // Active column in browse
      If oColumn:IsEnabled()                                                  // Can be edited
         exit
      Endif
      //
      // Column is active, but can not be edited
      //
      If nCol < oBrowse:colCount
         oBrowse:Right()
      Endif
   Else
      //
      // All columns to the right are invisible.
      // Ignore further testing
      //
      nCol        := oBrowse:colCount
   Endif
   nCol++
Enddo
Return nCol

* --------------------

STATIC FUNCTION _StuffKeys( aRef )

LOCAL aKeys, i, oXbp := aRef[2]

aKeys := DC_BrowCellEditKeyStuff()

FOR i := 1 TO Len(aKeys)
  PostAppEvent(xbeP_Keyboard,aKeys[i],,oXbp)
NEXT

RETURN nil

* --------------------

FUNCTION DC_BrowCellEditKeyStuff( mp1 )

STATIC saKeys := {}
LOCAL aOldKeys := AClone(saKeys)
IF Valtype(mp1) == 'N' .AND. mp1 # 0
  AAdd(saKeys,mp1)
ELSEIF Valtype(mp1) == 'A'
  saKeys := mp1
ELSE
  ASize(saKeys,0)
ENDIF
RETURN aOldKeys

* --------------------

STATIC FUNCTION CellHandler( nEvent, mp1, mp2, oXbp, oDlg, GetList, aArray )

LOCAL nReturn, aRef := aArray[1], xRef := aArray[2], oBrowse := aArray[3]

IF !Empty(DC_BrowCellEditExit())
  RETURN DC_BrowCellEditExit(0)
ENDIF

IF Valtype(aRef[7]) = 'B' // Custom Handler
  nReturn := Eval(aRef[7],nEvent,mp1,mp2,oXbp,oDlg,GetList,xRef)
  IF nReturn # DCGUI_NONE
     RETURN nReturn
  ENDIF
ENDIF
aRef[1] := 0

IF nEvent = xbeP_Keyboard
   IF mp1 == xbeK_TAB
     mp1 := xbeK_ENTER
   ELSEIF oXbp:isDerivedFrom('DC_XbpMle')
     IF Valtype(oXbp:exitKey) == 'A' .AND. mp1 $ oXbp:exitKey
       IF mp1 == oXbp:exitKey[1]
         mp1 := xbeK_ENTER
       ELSE
         mp1 := xbeK_UP
       ENDIF
     ELSEIF mp1 == oXbp:exitKey
       mp1 := xbeK_ENTER
     ELSEIF mp1 == xbeK_ENTER
       RETURN DCGUI_NONE
     ENDIF
   ENDIF

   DC_BrowCellEditLastKey( mp1 )
   aRef[1] := mp1

   If oDlg:IsDerivedFrom("Dc_XbpBrowse")                                      // J. Duijf 17-07-2014
      If ValType(oDlg:CellEditKeyBlock) = "B"
         If Eval(oDlg:CellEditKeyBlock,nEvent,mp1,mp2,oXbp,oDlg,GetList,aArray) = DCGUI_IGNORE
            Return DCGUI_IGNORE
         Endif
      Endif
   Endif
   IF ( aRef[1] = xbeK_UP .OR. aRef[1] = xbeK_DOWN ) .AND. ;
      ( aRef[5] = DCGUI_BROWSE_EDITACROSS .OR. oXbp:isderivedFrom("XBPLISTBOX") .OR. ;
                  oXbp:isDerivedFrom('XbpMle'))
      IF oXbp:isderivedFrom("XBPLISTBOX") .OR. oXbp:isDerivedFrom('XbpMle')
         RETURN DCGUI_NONE
      ELSE
         RETURN DCGUI_IGNORE
      ENDIF
   ELSEIF mp1 == xbeK_PGDN .OR. aRef[1] = aRef[4]  .OR. ;
      ( (aRef[1] = xbeK_UP .OR. aRef[1] = xbeK_DOWN ) .AND. aRef[4] = xbeK_ENTER )

      IF oBrowse:autoLock
         IF !_RecLock(oBrowse)
            RETURN DCGUI_EXIT_ABORT
         ENDIF
      ENDIF

      IF aRef[11] .AND. oXbp:isDerivedFrom('DC_XbpGet')
        oXbp:get:changed := .t.
      ENDIF

      IF !DC_GetValidate(oXbp,aRef[6])
         DC_ClearEvents()
         IF !Empty(DC_BrowCellEditExit())
           RETURN DC_BrowCellEditExit(0)
         ENDIF
         RETURN DCGUI_IGNORE
      ENDIF
      IF !Empty(DC_BrowCellEditExit())
        RETURN DC_BrowCellEditExit(0)
      ENDIF
      IF mp1 == xbeK_ENTER
        oXbp:handleEvent(nEvent,mp1,mp2)
      ENDIF
      RETURN DCGUI_EXIT_OK
   ELSEIF aRef[1] = xbeK_ESC .OR. aRef[1] = K_ESC
      RETURN DCGUI_EXIT_ABORT
   ENDIF
   RETURN DCGUI_NONE
ELSEIF Valtype(oXbp) = 'O' .AND. ;
      (oXbp:setParent() == aRef[3] .OR. oXbp:setparent() == aRef[2])
   RETURN DCGUI_NONE
ELSEIF nEvent = xbeM_LbDown .AND. !(oXbp == aRef[2])
   IF !DC_GetValidate(aRef[2],aRef[6])
      DC_ClearEvents()
      IF !Empty(DC_BrowCellEditExit())
        RETURN DC_BrowCellEditExit(0)
      ENDIF
      RETURN DCGUI_IGNORE
   ENDIF
   IF !Empty(DC_BrowCellEditExit())
     RETURN DC_BrowCellEditExit(0)
   ENDIF
   aRef[8] := xbeM_LbDown
   aRef[12] := mp1
   aRef[13] := mp2
   aRef[14] := oXbp
   RETURN DCGUI_EXIT_OK
ENDIF

RETURN DCGUI_IGNORE

* ----------------------------*

FUNCTION DC_BrowCellEditExit( nMode )

STATIC snMode := 0
LOCAL nOldMode := snMode
IF Valtype(nMode) = 'N'
  snMode := nMode
ENDIF

RETURN nOldMode

* ----------------------------*

FUNCTION DC_BrowCellEditLastKey( nKey )

STATIC snKey := 0
LOCAL nOldKey := snKey
IF Valtype(nKey) = 'N'
  snKey := nKey
ENDIF

RETURN nOldKey

* --------------------------- *

FUNCTION DC_ButtonPaint( oButton )

LOCAL oPS, oFont, i, nHorizOffset, nVertOffset, nHeight, cFont, aCaption, ;
      cFamily, nPointSize, nButtonHeight

nButtonHeight := oButton:currentSize()[2]
cFont := oButton:cargo[6]
nHorizOffset := oButton:cargo[7]
nVertOffset := oButton:cargo[8]
nHeight := oButton:cargo[9]
aCaption := oButton:cargo[10]
IF Valtype(oButton:cargo) # 'O'
   oButton:cargo[11] := oButton:LockPS()
ENDIF
oPS := oButton:cargo[11]
IF !Empty(cFont)
   nPointSize := Val(DC_Token(cFont,'.',1))
   cFamily := DC_Token(cFont,'.',2)
   oFont := XbpFont():new()
   oFont:familyName := cFamily
   oFont:nominalPointSize := nPointSize
   IF '.BOLD' $ Upper(cFont)
     oFont:bold := .t.
   ENDIF
   IF '.ITALIC' $ Upper(cFont)
     oFont:italic := .t.
   ENDIF
   oFont:create()
   GraSetFont( oPS, oFont )
ENDIF
FOR i := 1 TO LEN(aCaption)
  GraStringAt( oPS, { nHorizOffset , nButtonHeight - (((i-1)*nHeight) + ;
                      nVertOffset + nHeight ) }, aCaption[i] )
NEXT

RETURN nil

* ---------------------

METHOD DC_GetList:AddHotKey( bcanAccel, bAction, bWhen, bHide, oObject, oXbp, xCargo, lFocusOnly )

LOCAL oFocusObject, i, nFound

DEFAULT lFocusOnly := .F. // activate only if object has focus

IF Valtype(bAction) # 'B' .AND. Valtype(oObject) = 'O'
  bAction := {||SetAppFocus(oObject)}
  oFocusObject := nil
ELSE
  oFocusObject := oObject
ENDIF

IF Valtype(bcanAccel) == 'B'
  bcanAccel := Eval(bcanAccel)
ENDIF

IF Valtype(bcanAccel) == 'C' // Find hotkey from Ampersand
  nFound := At('&',bcanAccel)
  IF nFound > 0
    nFound++
    bcanAccel := Asc(Upper(bcanAccel[nFound])) + 327680
  ENDIF
ENDIF

IF Valtype(bcanAccel) = 'N'
  bcanAccel := { bcanAccel }
ELSEIF Valtype( bcanAccel ) # 'A'
  RETURN .f.
ENDIF

FOR i := 1 TO Len(bcanAccel)
  IF Valtype(bAction) = 'B'
    AAdd( ::keyboardControls, ;
      { bcanAccel[i], bAction, bWhen, bHide, oFocusObject, oXbp, xCargo, lFocusOnly } )
  ENDIF
NEXT

RETURN .t.

* -----------------

STATIC PROCEDURE _ClearKeys( oKey )

LOCAL i, aEvent := {}, nEvent := 1, mp1, mp2, oXbp

DO WHILE nEvent <> 0
  nEvent := AppEvent( @mp1, @mp2, @oXbp, .01 )
  IF nEvent # xbeP_Keyboard .OR. oXbp == oKey
     AAdd( aEvent, { nEvent, mp1, mp2, oXbp} )
  ENDIF
ENDDO

FOR i := 1 TO Len(aEvent)
   PostAppEvent( aEvent[i,1], aEvent[i,2], aEvent[i,3], aEvent[i,4] )
NEXT

RETURN

* ---------------------

FUNCTION DC_GetListShow( aGetList )

LOCAl i, oXbp

FOR i := 1 TO Len(aGetlist)
  oXbp := aGetlist[i,oGETLIST_OBJECT]
  IF Valtype(oXbp)='O' .AND. IsMethod(oXbp,'SHOW')
    oXbp:Show()
  ENDIF
NEXT

RETURN nil

* -------------------

FUNCTION DC_GetObject( aGetList, cId )

LOCAL nGet, cSaveId

IF Valtype(aGetList)=='C' .AND. Valtype(cId) == 'A' // parameters passed in wrong order
  cSaveId := aGetList
  aGetList := cId
  cId := cSaveId
ENDIF

IF Valtype(cId) == 'N'
  nGet := cID
ELSEIF Valtype(cId) == 'C'
  nGet := AScan(aGetList,{|a|a[cGETLIST_ID]==cId})
ELSE
  nGet := 0
ENDIF

IF nGet <= 0
   RETURN nil
ENDIF

RETURN aGetList[nGet,oGETLIST_OBJECT]

* ---------------------

FUNCTION DC_GetDataLink( lDataLink )

IF Valtype(lDataLink) = 'L'
  M->plDataLink := lDataLink
ELSEIF Type('plDataLink') = 'L'
  RETURN M->plDataLink
ENDIF
RETURN .f.

* ----------------------

FUNCTION DC_HiliteGets( o, nMode, nbColor, nPixels )

LOCAL oPS, nCol, nRow, nWidth, nHeight, aAttr[ GRA_AL_COUNT], bBlock
LOCAL oParent // J. Duijf 07-08-2012

DEFAULT nPixels := 1

IF Empty(nbColor) .OR. Valtype(o) # 'O' .OR. o:status() <= 0  ;
      .OR. o:isDerivedFrom('XbpCrt')
  RETURN nil
ENDIF
IF nMode == 1 .AND. (!o:isVisible() .OR. !o:isEnabled())
  RETURN nil
ENDIF

IF Valtype(bBlock := DC_HiliteGetsBlock()) == 'B'
  RETURN Eval( bBlock, o, nMode, nbColor )
ENDIF

IF o:isderivedfrom('XBPCOMBOBOX')
  nWidth := o:XbpSle:currentsize()[1]
  IF o:type # XBPCOMBO_SIMPLE
    nHeight := o:sleSize()[2]
    nCol := o:currentpos()[1]
    nRow := o:currentpos()[2] + o:currentsize()[2] - nHeight
  ELSE
    nHeight := o:currentsize()[2]
    nCol := o:currentpos()[1]
    nRow := o:currentpos()[2]
  ENDIF
ELSE
  nCol := o:currentpos()[1]
  nRow := o:currentpos()[2]
  nWidth := o:currentsize()[1]
  nHeight := o:currentsize()[2]
ENDIF
IF IsMethod(o:SetParent(),'LOCKPS')
  oPS := o:setParent():lockPS()
ENDIF

aAttr[ GRA_AL_WIDTH ] := nPixels
IF nMode = 1
  IF Valtype(nbColor) == 'B'
    nbColor := Eval(nbColor)                                // Hilite
    IF nbColor == NIL
      nbColor := o:setParent():setColorBG()
    ENDIF
  ENDIF
  aAttr[ GRA_AL_COLOR ] := nbColor
ELSE                                                        // De-hilite
   //
   // J. Duijf 07-08-2012
   // If de-hilite, then redraw the box using the background color of the parent
   // and not the default GRA_CLR_BACKGROUND color.
   // If the parent background is transparent, go back to the first
   // parent has a background color other than transparent.
   // Now the hilite box is completely removed (no shadow box if custom background color)
   //
   // aAttr[ GRA_AL_COLOR ] := GRA_CLR_BACKGROUND
   oParent  := o:setParent()

   aAttr[ GRA_AL_COLOR ] := oParent:setColorBG()
   Do while aAttr[ GRA_AL_COLOR ] = XBPSYSCLR_TRANSPARENT   // Transparent, go back to next parent
      oParent  := oParent:setParent()                       // Back to parent
      If ValType(oParent) <> "O"                            // ??? Then there is no choice,
         aAttr[ GRA_AL_COLOR ] := GRA_CLR_BACKGROUND        // Default backgound color
         exit
      Else
         aAttr[ GRA_AL_COLOR ] := oParent:setColorBG()      // Get background color
      Endif
   Enddo
ENDIF

// GraSetAttrLine( oPS, aAttr )
// GraBox( oPS, {nCol-1,nRow-1}, {nCol+nWidth,nRow+nHeight}, GRA_OUTLINE )

IF Valtype(oPS) = 'O'
   GraSetAttrLine( oPS, aAttr )  // Jack Duijf 17-07-2014
   GraBox( oPS, {nCol-1,nRow-1}, {nCol+nWidth,nRow+nHeight}, GRA_OUTLINE )
  o:setParent():unlockPS(oPS)
ENDIF
oParent  := nil

RETURN nil

* -----------

FUNCTION DC_HiliteGetsBlock( bBlock )

STATIC sbBlock := nil
LOCAL bSaveBlock

bSaveBlock := sbBlock

IF Valtype(bBlock) == 'B'
  sbBlock := bBlock
ENDIF

RETURN bSaveBlock

* -------------------

STATIC FUNCTION _MoveToolbar( oParent, oToolBar, nAlign, lBuildBlock )

LOCAL nHeight, nWidth, nCol, nRow

IF lBuildBlock
   RETURN {||_MoveToolBar(oParent,oToolBar,nAlign,.f.)}
ENDIF

nHeight := oParent:currentSize()[2]
nWidth := oParent:currentSize()[1]

IF nAlign = TOOLBAR_BOTTOM_LEFT .OR. nAlign = TOOLBAR_LEFT_BOTTOM
  nCol := 0
  nRow := 0
ELSEIF nAlign = TOOLBAR_BOTTOM_RIGHT .OR. nAlign = TOOLBAR_RIGHT_BOTTOM
  nCol := nWidth - oToolBar:currentSize()[1]
  nRow := 0
ELSEIF nAlign = TOOLBAR_TOP_LEFT .OR. nAlign = TOOLBAR_LEFT_TOP
  nCol := 0
  nRow := nHeight - oToolBar:currentSize()[2]
ELSEIF nAlign = TOOLBAR_TOP_RIGHT .OR. nAlign = TOOLBAR_RIGHT_TOP
  nCol := nWidth - oToolBar:currentSize()[1]
  nRow := nHeight - oToolBar:currentSize()[2]
ENDIF

IF nAlign = TOOLBAR_BOTTOM_LEFT .OR. nAlign = TOOLBAR_BOTTOM_RIGHT .OR. ;
   nAlign = TOOLBAR_TOP_LEFT .OR. nAlign = TOOLBAR_TOP_RIGHT
  oToolBar:setSize({oParent:currentSize()[1],oToolBar:currentSize()[2]})
ELSEIF nAlign = TOOLBAR_LEFT_BOTTOM .OR. nAlign = TOOLBAR_LEFT_TOP .OR. ;
   nAlign = TOOLBAR_RIGHT_BOTTOM .OR. nAlign = TOOLBAR_RIGHT_TOP
  oToolBar:setSize({oToolBar:currentSize()[1],oParent:currentSize()[2]})
ENDIF

oToolBar:setPos( {nCol,nRow} )

RETURN nil

* -------------------------

FUNCTION DC_PaintGraControls( aGetList, oXbp, acGroup, nElement )

LOCAL oGetList

IF Valtype(aGetList) # 'A'
  RETURN .f.
ENDIF
oGetList := DC_GetListObject( aGetList )
IF oGetList == NIL
  RETURN .f.
ENDIF

RETURN oGetList:paintGraControls( oXbp, acGroup, nElement )

* -------------------------

METHOD DC_GetList:paintGraControls( oXbp, acGroup, nElement )

LOCAL oPS, i, j, aCaption, nStartCol, nStartRow, nWidth, nHeight, ;
      cFont, aAttr, bHide, aOldAttr, cPicture, oParent, ;
      nType, aColor, oFont, nPointSize, cFamily, oOldFont, xOption1, ;
      xOption2, xOption3, nStart, nEnd, aFonts := {}, nFont, nAlign, aAlign[4], ;
      nTextHeight, nTextWidth, aArray, aAttrArea, aOldAttrArea, oSaveParent, ;
      aAttrLine, aOldAttrLine, cGetGroup, bWhen

Grok(acGroup) ; Grok(cGetGroup) ; Grok(bWhen)

IF Empty(::graControls)
  RETURN self
ELSEIF Valtype(nElement) = 'N'
   nStart := nElement
   nEnd := nElement
ELSE
   nStart := 1
   nEnd := Len(::graControls)
ENDIF

FOR i := nStart TO nEnd

  IF Valtype(oXbp) == 'O' .AND. !(oXbp==::graControls[i,4])
    LOOP
  ENDIF

  nType       := ::graControls[i,1]
  aCaption    := ::graControls[i,2]
  cPicture    := ::graControls[i,3]
  oParent     := ::graControls[i,4]
  nStartCol   := ::graControls[i,5]
  nStartRow   := ::graControls[i,6]
  nWidth      := ::graControls[i,7]
  nHeight     := ::graControls[i,8]
  cFont       := ::graControls[i,9]
  aAttr       := ::graControls[i,10]
  bWhen       := ::graControls[i,11]
  bHide       := ::graControls[i,12]
  cGetGroup   := ::graControls[i,13]
  aColor      := ::graControls[i,14]
  xOption1    := ::graControls[i,15]
  xOption2    := ::graControls[i,16]
  xOption3    := ::graControls[i,17]
  nAlign      := ::graControls[i,18]

  IF Valtype(aColor) == 'B'
    aColor := Eval(aColor)
  ENDIF

  oFont       := nil
  IF Valtype(oXbp)='O' .AND. !(oXbp==oParent)
     LOOP
  ELSEIF Valtype(bHide)='B' .AND. Eval(bHide)
     LOOP
  ELSEIF !oParent:isVisible()
     LOOP
  ELSEIF nStartRow < 0 .OR. nStartRow > oParent:currentSize()[2]
     LOOP
  ENDIF

  IF oSaveParent = NIL .OR. oParent # oSaveParent
    IF !(oSaveParent==NIL)
      IF IsMethod(oSaveParent,'unlockPS')
        oSaveParent:unLockPS()
      ENDIF
    ENDIF
    IF IsMethod(oParent,'lockPS')
      oPS := oParent:lockPS()
    ELSE
      oPS := SetAppWindow():PresSpace()
    ENDIF
    oSaveParent := oParent
  ENDIF

  IF nType = GETLIST_GRASTRING

     FOR j := 1 TO 4
       aAlign[j] := DC_BitTest( nAlign, j )
     NEXT

     IF Empty(nWidth)
       nWidth := ::getOptions[nGETOPT_SAYWIDTH]
     ENDIF
     IF Valtype(aCaption) = 'B'
       aCaption := DC_XtoC(Eval(aCaption))
     ELSEIF Valtype(aCaption) $ 'NDL' .AND. Empty(cPicture)
       aCaption := DC_XtoC(aCaption)
     ENDIF
     IF !Empty(cPicture) .AND. !(Valtype(aCaption)$'AB')
       aCaption := Transform(aCaption,cPicture)
     ENDIF
     IF Valtype(aCaption) = 'C'
       aCaption := { aCaption }
     ENDIF
     DEFAULT nHeight := ::getOptions[nGETOPT_ROWPIXELS]
     IF !Empty(::getOptions[cGETOPT_SAYFONT])
       DEFAULT cFont := ::getOptions[cGETOPT_SAYFONT]
     ENDIF
     IF !Empty(cFont)
       nFont := AScan(aFonts,{|a|a[1]==cFont})
       IF nFont <= 0
         nPointSize := Val(DC_Token(cFont,'.',1))
         cFamily := DC_Token(cFont,'.',2)
         oFont := XbpFont():new( oPS )
         IF cFamily == 'Courier'
           cFamily := 'Courier New'
         ENDIF
         oFont:familyName := cFamily
         oFont:nominalPointSize := nPointSize
         IF '.BOLD' $ Upper(cFont) .OR. ' BOLD' $ Upper(cFont) .OR. '.FETT' $ Upper(cFont) .OR. ' FETT' $ cFont
           oFont:bold := .t.
         ENDIF
         IF '.ITALIC' $ Upper(cFont) .OR. ' ITALIC' $ Upper(cFont)
           oFont:italic := .t.
         ENDIF
         oFont:create()
         AAdd(aFonts,{cFont,oFont})
       ELSE
         oFont := aFonts[nFont,2]
       ENDIF
       oOldFont := GraSetFont( oPS, oFont )
     ENDIF

     IF Valtype(aAttr)='A' .OR. Valtype(aColor)='A'

       IF Valtype(aAttr)#'A'
         aAttr := Array(GRA_AS_COUNT)
       ENDIF

       IF Valtype(aColor)='A'
         ASize(aColor,2)
         IF Valtype(aColor[1]) = 'B'
           aColor := Eval(aColor[1])
           DEFAULT aColor := {}
           ASize(aColor,2)
         ENDIF
         IF Valtype(aColor[1]) = 'N'
            aAttr[GRA_AS_COLOR] := aColor[1]
         ELSEIF Valtype(aColor[1]) = 'A'
            aAttr[GRA_AS_COLOR] := GraMakeRGBColor(aColor[1])
         ENDIF
         IF Valtype(aColor[2]) = 'N'
            aAttr[GRA_AS_BACKCOLOR] := aColor[2]
            aAttr[GRA_AS_BGMIXMODE] := GRA_BGMIX_OVERPAINT
         ELSEIF Valtype(aColor[2]) = 'A'
            aAttr[GRA_AS_BACKCOLOR] := GraMakeRGBColor(aColor[2])
         ENDIF
       ENDIF

       IF Valtype(aAttr)='A' .AND. !Empty(aAttr)
         aOldAttr := GraSetAttrString( oPS, aAttr )
       ENDIF

     ENDIF

     IF Valtype(aColor)='A' .AND. Len(aColor) >= 2 .AND. Valtype(aColor[2]) $ 'AN'
       aAttrArea := Array(GRA_AA_COUNT)
       IF Valtype(aColor[2]) = 'N'
          aAttrArea[GRA_AA_COLOR] := aColor[2]
       ELSEIF Valtype(aColor[2]) = 'A'
          aAttrArea[GRA_AA_COLOR] := GraMakeRGBColor(aColor[2])
       ENDIF
       aOldAttrArea := GraSetAttrArea( oPS, aAttrArea )
     ELSE
       aAttrArea := nil
       aOldAttrArea := nil
     ENDIF

     FOR j := 1 TO Len(aCaption)

       aArray := GraQueryTextBox( oPS, aCaption[j] )
       nTextWidth := aArray[3,1] - aArray[1,1]
       nTextHeight := aArray[1,2] - aArray[2,2]

       DEFAULT nWidth := nTextWidth

       IF !Empty(aAttrArea)
         GraBox( oPS, { nStartCol, nStartRow }, { nStartCol+nWidth, nStartRow+nHeight-1 }, GRA_FILL )
       ENDIF

       // None      == XBPALIGN_TOP + XBPALIGN_LEFT
       // aAlign[1] == XBPALIGN_HCENTER
       // aAlign[2] == XBPALIGN_RIGHT
       // aAlign[3] == XBPALIGN_VCENTER
       // aAlign[4] == XBPALIGN_BOTTOM

       IF aAlign[1] // hcenter
         nStartCol += Int(( nWidth - nTextWidth ) / 2)
       ELSEIF aAlign[2] // right
         nStartCol += Int( nWidth - nTextWidth )
       ENDIF

       IF aAlign[3] // vcenter
         nStartRow += Int(( nHeight - nTextHeight ) / 2) + 1
       ELSEIF aAlign[4] // bottom
         nStartRow += 1
       ELSE // align top
         nStartRow += ( nHeight - nTextHeight )
       ENDIF
       nStartRow += Int( nTextHeight/7 )

       GraStringAt( oPS, {nStartCol,nStartRow}, aCaption[j] )
       nStartRow -= nHeight

     NEXT

     IF Valtype(aAttr)='A' .AND. !Empty(aAttr)
       IF aOldAttr == NIL
          aOldAttr := Array(GRA_AS_COUNT)
       ENDIF
       ASize(aOldAttr,GRA_AS_COUNT)
       GraSetAttrString( oPS, aOldAttr )
     ENDIF

     IF Valtype(aAttrArea)='A' .AND. !Empty(aAttrArea)
       IF aOldAttrArea == NIL
          aOldAttrArea := Array(GRA_AA_COUNT)
       ENDIF
       GraSetAttrArea( oPS, aOldAttrArea )
     ENDIF

     IF Valtype(oFont) = 'O' .AND. Valtype(oOldFont) = 'O'
        GraSetFont( oPS, oOldFont )
     ENDIF

  ELSEIF nType = GETLIST_GRALINE

     IF Valtype(aAttr)='A' .OR. Valtype(aColor)='A'
       IF Valtype(aAttr)#'A'
         aAttr := Array(GRA_AL_COUNT)
       ENDIF
       IF Valtype(aColor)='A'
         ASize(aColor,2)
         IF Valtype(aColor[1]) = 'N'
            aAttr[GRA_AL_COLOR] := aColor[1]
         ELSEIF Valtype(aColor[1]) = 'A'
            aAttr[GRA_AL_COLOR] := GraMakeRGBColor(aColor[1])
         ENDIF
       ENDIF
     ENDIF
     IF Valtype(aAttr)='A'
       ASize(aAttr,GRA_AL_COUNT)
       aOldAttr := GraSetAttrLine( oPS, aAttr )
     ENDIF

     nStartRow += nHeight
     nHeight := -(nHeight)

     GraLine( oPS, {nStartCol,nStartRow}, {nStartCol+nWidth,nStartRow+nHeight} )
     IF Valtype(aAttr)='A'
       IF aOldAttr == NIL
          aOldAttr := Array(GRA_AL_COUNT)
       ENDIF
       GraSetAttrLine( oPS, aOldAttr )
     ENDIF

  ELSEIF nType = GETLIST_GRABOX

     IF Valtype(aColor)='A'
       aAttrLine := Array(GRA_AL_COUNT)
       aAttr := Array(GRA_AA_COUNT)
       ASize(aColor,2)
       IF Valtype(aColor[1]) = 'N'
         aAttrLine[GRA_AL_COLOR] := aColor[1]
         aAttr[GRA_AA_COLOR] := aColor[1]
       ELSEIF Valtype(aColor[1]) = 'A'
         aAttrLine[GRA_AL_COLOR] := GraMakeRGBColor(aColor[1])
         aAttr[GRA_AA_COLOR] := GraMakeRGBColor(aColor[1])
       ENDIF
     ENDIF
     IF Valtype(aAttr)='A'
       ASize(aAttr,GRA_AA_COUNT)
       aOldAttr := GraSetAttrArea( oPS, aAttr )
     ENDIF
     IF Valtype(aAttrLine)='A'
       ASize(aAttrLine,GRA_AL_COUNT)
       aOldAttrLine := GraSetAttrLine( oPS, aAttrLine )
     ENDIF
     GraBox( oPS, {nStartCol,nStartRow}, {nStartCol+nWidth,nStartRow+nHeight}, ;
             xOption1, xOption2, xOption3 )
     IF Valtype(aAttr)='A'
       IF aOldAttr == NIL
          aOldAttr := Array(GRA_AA_COUNT)
       ENDIF
       GraSetAttrArea( oPS, aOldAttr )
     ENDIF
     IF Valtype(aAttrLine)='A'
       IF aOldAttrLine == NIL
          aOldAttrLine := Array(GRA_AL_COUNT)
       ENDIF
       GraSetAttrLine( oPS, aOldAttrLine )
     ENDIF

  ELSEIF nType = GETLIST_GRAPROC

     IF Valtype(xOption1) = 'B'
       Eval( xOption1, oPS, nStartCol, nStartRow )
     ENDIF

  ENDIF

NEXT

IF Valtype(oSaveParent) == 'O' .AND. IsMethod(oSaveParent,'unLockPS')
  oSaveParent:unlockPS(oPS)
ENDIF

FOR i := 1 TO Len(aFonts)
   aFonts[i,2]:destroy()
NEXT

RETURN self

* ----------

STATIC PROCEDURE _RecUnlock (oBrowse)                                       // J. Duijf 27-11-2002

if oBrowse:dataSourceType = BROWSE_DATABASE                                // J. Duijf 27-11-2002
   // (oBrowse:dataSource)->(dbCommit())
   IF !(oBrowse:dataSource)->(Eof())
     (oBrowse:dataSource)->(dbUnLock())
   ENDIF
elseif oBrowse:dataSourceType = BROWSE_DATAOBJECT                          // J. Duijf 27-11-2002
   // oBrowse:dataSource:dbCommit()
   oBrowse:dataSource:dbUnLock()
elseif oBrowse:dataSourceType = BROWSE_ACESERVER
   oBrowse:dataSource:Commit()
   oBrowse:dataSource:UnLock()
endif
Return

* ----------

STATIC FUNCTION _reclock (oBrowse)

LOCAL nWait
LOCAL lLock    := FALSE                                                    // J. Duijf 27-11-2002

if oBrowse:dataSourceType = BROWSE_DATABASE                                // J. Duijf 27-11-2002
   lLock       := (oBrowse:dataSource)->(DbRlock())                        // J. Duijf 27-11-2002
elseif oBrowse:dataSourceType = BROWSE_DATAOBJECT                          // J. Duijf 27-11-2002
   lLock       := oBrowse:dataSource:Rlock()                               // J. Duijf 27-11-2002
elseif oBrowse:dataSourceType = BROWSE_ACESERVER
   lLock       := oBrowse:dataSource:Rlock()
endif
IF lLock
  RETURN (.T.)   // locked
ENDIF
DO WHILE !lLock
  nWait := 5
  DO WHILE nWait > 0
     if oBrowse:dataSourceType = BROWSE_DATABASE                           // J. Duijf 27-11-2002
        lLock       := (oBrowse:dataSource)->(DbRlock())                   // J. Duij 27-11-2002
     elseif oBrowse:dataSourceType = BROWSE_DATAOBJECT                     // J. Duijf 27-11-2002
        lLock       := oBrowse:dataSource:Rlock()                          // J. Duij 27-11-2002
     elseif oBrowse:dataSourceType = BROWSE_ACESERVER
        lLock       := oBrowse:dataSource:Rlock()
     endif
     if lLock
      RETURN (.T.)
    ENDIF
    Sleep(50)     // wait 1/2 second
    nWait -= 5
  ENDDO
  IF !DC_MsgBox(,,{DC_LangMsg(DCMSG_LOCK_RETRY)},,,,.t.)
    EXIT
  ENDIF
ENDDO
RETURN (.F.)      // not locked

* ----------

STATIC FUNCTION _addrec (oBrowse)

LOCAL nWait    := 5
LOCAL lAppend  := .F.

do while !lAppend
   if oBrowse:dataSourceType = BROWSE_DATABASE                                // J. Duijf 27-11-2002
      DbAppend()                                                              // J. Duijf 27-11-2002
      lAppend     := !Neterr()                                                // J. Duijf 27-11-2002
   elseif oBrowse:dataSourceType = BROWSE_DATAOBJECT                          // J. Duijf 27-11-2002
      oBrowse:dataSource:DbAppend()                                           // J. Duijf 27-11-2002
      lAppend     := !oBrowse:dataSource:Neterr()                             // J. Duijf 27-11-2002
   elseif oBrowse:dataSourceType = BROWSE_ACESERVER
      lAppend := oBrowse:dataSource:Append()
   endif
   if !lAppend
      Sleep(50)
      nWait -= .5
      if nWait <= 0
         IF !DC_MsgBox(,,{DC_LangMsg(DCMSG_LOCK_RETRY)},,,,.t.)
            EXIT
         ENDIF
         nWait := 5
      endif
   endif
enddo
RETURN lAppend

* ----------

FUNCTION DC_GetCargo( oXbp, xCargo )

LOCAL xOldCargo

IF Valtype(oXbp) # 'O'
   RETURN nil
ENDIF

IF Valtype(oXbp:cargo) # 'A' .OR. Len(oXbp:cargo) < 3
  xOldCargo := oXbp:cargo
ELSE
  xOldCargo := oXbp:cargo[3]
ENDIF

IF Pcount() > 1
  IF Valtype(oXbp:cargo) # 'A' .OR. Len(oXbp:cargo) < 3
    oXbp:cargo := xCargo
  ELSE
    oXbp:cargo[3] := xCargo
  ENDIF
ENDIF

RETURN xOldCargo

* ----------

FUNCTION DC_CellEditTimeOut( nTimeOut )

STATIC snTimeOut := 0
LOCAL nOldTimeOut := snTimeOut

IF Valtype(nTimeOut) = 'N'
  snTimeOut := nTimeOut
ENDIF

RETURN nOldTimeOut

* ----------

FUNCTION DC_DotVar( oDlg )

STATIC soDlg := nil

IF PCount() == 1
  soDlg := oDlg
ENDIF

RETURN soDlg

* ----------

FUNCTION DC_DotHotKey( nKey, bBlock )

STATIC snHotKey := xbeK_ALT_D, ;
       sbBlock := {|oDlg,o|o := DC_WaitOn('Please wait while loading DCLIP1.DLL'), ;
                     DllLoad('DCLIP1.DLL'), ;
                     DC_Impl(o), ;
                     DC_DotVar(oDlg), ;
                     &('DC_Dot(.t.)'), ;
                     DC_DotVar(nil)}

LOCAL nOldHotKey := snHotKey

IF Valtype(nKey) = 'N'
   snHotKey := nKey
ENDIF

bBlock := sbBlock

RETURN nOldHotKey

* ----------

FUNCTION DC_CallStackHotKey( nKey, bBlock )

STATIC snHotKey := 458819, ;  // Alt-Shift-C
       sbBlock := {|o|o := DC_WaitOn('Please wait while loading DCLIP1.DLL'), ;
                     DllLoad('DCLIP1.DLL'), ;
                     DC_Impl(o), ;
                     &('DC_CallStack()')}

LOCAL nOldHotKey := snHotKey

IF Valtype(nKey) = 'N'
   snHotKey := nKey
ENDIF

bBlock := sbBlock

RETURN nOldHotKey

* ----------

FUNCTION DC_AutoReSize( aOldSize, aNewSize, oDialog, aGetList, ;
                        lToolBars, lInit, lMinimized )

LOCAL aChild, i, nWidthDelta, nHeightDelta, nWDeltaPos, nHDeltaPos, ;
      oXbp, nWDeltaSize, nHDeltaSize, nCurrentCol, ;
      nCurrentRow, nCurrentWidth, nCurrentHeight, nFound, oParent, ;
      oAppFocus := SetAppFocus(), oGetList, nWidth, nHeight, lLoop

oGetList := DC_GetListObject( aGetList )
IF oGetList == NIL
  RETURN nil
ENDIF

DEFAULT lInit := .f. , ;
        lMinimized := .f., ;
        lToolBars := .t.


IF oDialog:isDerivedFrom('XbpDialog') .AND. !oDialog:isDerivedFrom('DC_XbpPushButtonStatic')

  oParent := oDialog:setParent()

  IF oParent:isDerivedFrom('XbpIwindow') .AND. !Empty(oParent:setParent()) .AND. ;
     oParent:setParent():getFrameState() == XBPDLG_FRAMESTAT_MINIMIZED
    RETURN nil
  ENDIF

  IF oDialog:getFrameState() == XBPDLG_FRAMESTAT_MINIMIZED
    lMinimized := .t.
    IF Valtype(oDialog:cargo) == 'A' .AND. Len(oDialog:cargo) >= 9
      IF Empty(oDialog:cargo[9])
        oDialog:cargo[9] := { aOldSize, oDialog:getFrameState() }
      ENDIF
    ENDIF
    RETURN nil
  ENDIF
  IF Valtype(oDialog:cargo) == 'A' .AND. Len(oDialog:cargo) >= 9
    IF Empty(oDialog:cargo[9])
      oDialog:cargo[9] := { aOldSize, oDialog:getFrameState() }
    ELSEIF oDialog:cargo[9,2] == oDialog:getFrameState() .AND. ;
      oDialog:getFrameState() $ { XBPDLG_FRAMESTAT_MINIMIZED,XBPDLG_FRAMESTAT_MAXIMIZED}
      RETURN nil
    ENDIF
    IF !Empty(oDialog:cargo[9])
      aOldSize := oDialog:cargo[9,1]
    ENDIF
    oDialog:cargo[9] := { aNewSize, oDialog:getFrameState() }
  ENDIF
  IF !Empty(aOldSize) .AND. aOldSize[2] <= 50
    RETURN nil
  ENDIF
  oDialog := oDialog:drawingArea
  oDialog:invalidateRect()
ENDIF

IF Valtype(oGetList:reSize) # 'A'
  oGetList:reSize := {}
  DC_AutoReSize( aOldSize, aOldSize, oDialog, aGetList, lToolBars, .t., lMinimized )
ENDIF

IF Empty(aOldSize) .OR. Empty(aNewSize)
  RETURN nil
ENDIF

IF aOldSize[1] > 0
  nWidthDelta  := aNewSize[1] / aOldSize[1]
ELSE
  nWidthDelta := 0
ENDIF

IF aOldSize[2] > 0
  nHeightDelta := aNewSize[2] / aOldSize[2]
ELSE
  nHeightDelta := 0
ENDIF

aChild := oDialog:childList()

FOR i := 1 TO Len(aChild)

  nWDeltaSize := nWidthDelta
  nHDeltaSize := nHeightDelta
  nWDeltaPos  := nWidthDelta
  nHDeltaPos  := nHeightDelta

  oXbp := aChild[i]
  aOldSize := oXbp:currentSize()

  lLoop := .F.
  IF  oXbp:isDerivedFrom('XbpPushButton') .AND. ;
        oXbp:setParent():isDerivedFrom('DC_XbpGet')
    nHDeltaSize := 1
    nWDeltaSize := 1
  ELSEIF  oXbp:isDerivedFrom('XbpPushButton') .AND. ;
         'POPUPBUTTON' $ Upper(DC_XtoC(DC_GetCodeBlockText(oXbp:activate)))
    oXbp:setPos({aChild[i-1]:currentPos()[1]+aChild[i-1]:currentSize()[1],aChild[i-1]:currentPos()[2]})
    LOOP
  ELSEIF !lToolBars .AND. ;
      oXbp:isDerivedFrom('DC_XbpToolbar')
     // don't resize toolbars
    nHDeltaSize := 1
    nWDeltaSize := 1
    lLoop := .T.
  ELSEIF !lToolBars .AND. ;
      (oXbp:isDerivedFrom('DC_XbpPushButton') .OR. oXbp:isDerivedFrom('DC_XbpPushButtonXP'))
     // don't resize pushbuttons
    nHDeltaSize := 1
    nWDeltaSize := 1
    lLoop := .T.
  ELSEIF !lToolBars .AND. ;
      oXbp:isDerivedFrom('DC_XbpPushButtonStatic')
     // don't resize static pushbuttons
    nHDeltaSize := 1
    nWDeltaSize := 1
    lLoop := .T.
  ELSEIF oXbp:isDerivedFrom('DC_XbpGet')
    nHDeltaSize := 1
    nWDeltaSize := 1
  ELSEIF oXbp:isDerivedFrom('XbpStatic') .AND. ;
      oXbp:type==XBPSTATIC_TYPE_TEXT .AND. ;
      Valtype(oXbp:cargo) = 'A' .AND. ;
      Len(oXbp:cargo) >= 2 .AND. ;
      Valtype(oXbp:cargo[1]) = 'N' .AND. ;
      Valtype(oXbp:cargo[2]) = 'A' .AND. ;
      oXbp:cargo[2,oXbp:cargo[1],nGETLIST_TYPE] == GETLIST_SAY
    nHDeltaSize := 1
  ELSEIF IsMemberVar(oXbp,'NOAUTORESIZE') .AND. oXbp:noAutoResize
    nHDeltaSize := 1
    nWDeltaSize := 1
  ENDIF

  nFound := AScan( oGetList:reSize, {|a|a[1] == oXbp} )
  IF nFound > 0
    nCurrentCol    := oGetList:reSize[nFound,2]
    nCurrentRow    := oGetList:reSize[nFound,3]
    nCurrentWidth  := oGetList:reSize[nFound,4]
    nCurrentHeight := oGetList:reSize[nFound,5]
    oGetList:reSize[nFound,2] := nCurrentCol * nWDeltaPos
    oGetList:reSize[nFound,3] := nCurrentRow * nHDeltaPos
    oGetList:reSize[nFound,4] := Max(nCurrentWidth * nWDeltaSize,1)
    oGetList:reSize[nFound,5] := Max(nCurrentHeight * nHDeltaSize,1)
  ELSE
    nCurrentCol    := oXbp:currentPos()[1]
    nCurrentRow    := oXbp:currentPos()[2]
    nCurrentWidth  := oXbp:currentSize()[1]
    nCurrentHeight := oXbp:currentSize()[2]
    AADD( oGetList:reSize, { oXbp, nCurrentCol * nWDeltaPos, ;
                           nCurrentRow * nHDeltaPos, ;
                           Max(nCurrentWidth * nWDeltaSize,1), ;
                           Max(nCurrentHeight * nHDeltaSize,1) } )
  ENDIF

  IF !lMinimized

    oXbp:setPos( { nCurrentCol * nWDeltaPos, ;
                   nCurrentRow * nHDeltaPos } )

    nWidth := Max(nCurrentWidth * nWDeltaSize,1)
    nHeight := Max(nCurrentHeight * nHDeltaSize,1)
    IF IsMethod(oXbp,'SETSIZE')
      oXbp:setSize( { nWidth, nHeight } )
    ENDIF

  ENDIF

  IF lLoop
    LOOP
  ENDIF

  IF oXbp:isDerivedFrom('DC_XbpBrowse') .AND. oXbp:resizeColumns
    oXbp:resizeColumns( aOldSize, aNewSize )
  ENDIF

  IF oXbp:isDerivedFrom('XbpBrowse') .OR. ;
     oXbp:isDerivedFrom('XbpQuickBrowse') .OR. ;
     oXbp:isDerivedFrom('MxPushButton')
    LOOP
  ENDIF

  IF !Empty(oXbp:childList())
     IF IsMemberVar(oXbp,'NOAUTORESIZE') .AND. oXbp:noAutoResize
       LOOP
     ENDIF
     aNewSize := oXbp:currentSize()

     DC_AutoReSize( aOldSize, aNewSize, oXbp, aGetList, lToolBars, .f., lMinimized )
  ENDIF

NEXT

SetAppFocus(oAppFocus)

RETURN nil

* ----------

FUNCTION DC_FancyButtonMode( nMode )

STATIC snMode := 0
LOCAL nOldMode := snMode

IF Valtype(nMode) = 'N'
  snMode := nMode
ENDIF

RETURN nOldMode

* ----------

STATIC FUNCTION _ProcessSetKey( nKey )

LOCAL bEval, nInKey := DC_KeyTran(nKey,1)

bEval := SetKey(nInkey)

IF Valtype(bEval) = 'B'
  Eval(bEval)
  RETURN .t.
ENDIF

RETURN .f.

* ----------

FUNCTION DC_SetKeyActive( lActive )

STATIC slActive := .f.
LOCAL lOldActive := slActive

IF Valtype(lActive) = 'L'
  slActive := lActive
ENDIF

RETURN lOldActive

* ----------

FUNCTION DC_ReadGuiEventLoopWhen( bBlock )

STATIC sbBlock := nil
LOCAL bOldBlock := sbBlock

IF Pcount() > 0
  sbBlock := bBlock
ENDIF

RETURN bOldBlock

* ----------

STATIC FUNCTION _ViewSource(cSource)

LOCAL oCrt, oOldCrt := SetAppWindow(), lGui := DC_Gui(.f.)

oCrt := XbpCrt():new( AppDeskTop(), , ;
          {100,100}, 25, 80, "View Modified source (in Memory)")
oCrt:icon := ICON_EXPRESS
oCrt:create()
oOldCrt := SetAppWindow( oCrt )
oCrt:setDisplayFocus := {||SetAppWindow(oCrt)}
oCrt:setInputFocus := {||SetAppWindow(oCrt)}
oCrt:PresSpace()
MemoEdit(cSource)
SetAppWindow(oOldCrt)
oCrt:Destroy()
DC_Gui(lGui)

RETURN nil

* ----------

STATIC FUNCTION _MenuAccess ( cLockCode )

LOCAL lOk := .t., cUserKeys
cLockCode := Alltrim(IIF(Valtype(cLockCode)='C',cLockCode,''))
cUserKeys := DC_ReadGuiMenuAccess()

IF SubStr(cLockCode,1,1)=='*'
ELSEIF Empty(cLockCode)
ELSEIF ;
   ',*****,' $ ','+cUserKeys+',' .OR. ;
   ','+cLockCode+',' $ ','+cUserKeys+',' .OR. ;
   ','+SubStr(cLockCode,1,1)+'*,' $ ','+cUserKeys+',' .OR.;
   ','+SubStr(cLockCode,1,1)+'*,' $ ','+cUserKeys+',' .OR.;
   ','+SubStr(cLockCode,1,2)+'*,' $ ','+cUserKeys+',' .OR. ;
   ','+SubStr(cLockCode,1,3)+'*,' $ ','+cUserKeys+',' .OR. ;
   ','+SubStr(cLockCode,1,4)+'*,' $ ','+cUserKeys+','
ELSE
  lOk := .f.
ENDIF
RETURN lOk

* ----------

FUNCTION DC_ReadGuiMenuAccess( cUserKeys )

STATIC scUserKeys := ''
LOCAL cOldUserKeys := scUserKeys

scUserKeys := IIF( Valtype(cUserKeys)='C',cUserKeys,scUserKeys )

RETURN cOldUserKeys

* ---------------------

 /* WORKAROUND for bug */

// changed by JL for testing
// CLASS DacPagedDataStoreFixed FROM DacPagedDataStore
 CLASS DacPagedDataStoreFixed FROM DacSortedPagedDataStore

 EXPORTED:

    /* refresh by disabling the cache */
    INLINE METHOD Refresh()
       LOCAL nOldPos := ::GetRowData(1)[1]
       ::GoFirst()
       ::GoLast()
       ::GoFirst()
       ::GoLast()
       ::ScrollTo(nOldPos)
    RETURN self

    /* when the rowdata is zero we will return the default value */
    INLINE METHOD GetRowData( nRow )

   // Changed by JL for testing
   //  LOCAL acData := ::DacPagedDataStore:GetRowData( nRow )
       LOCAL acData := ::DacSortedPagedDataStore:GetRowData( nRow )

       LOCAL i, acType

       IF ValType( acData[2] ) == "U"

       // Changed by JL for testing
       // acType    := ::DacPagedDataStore:GetRowInfo(FLD_TYPE)
          acType    := ::DacSortedPagedDataStore:GetRowInfo(FLD_TYPE)

          acData[1] := 0
          acData[2] := Array( Len( acType ) )
          FOR i := 1 TO Len( acType )
             IF acType[i] == "C" .OR. acType[i] == "M"
                acData[2,i] := " "
             ELSEIF acType[i] == "N"
                acData[2,i] := 0
             ELSEIF acType[i] == "D"
                acData[2,i] := DToC( Date() )
             ELSEIF acType[i] == "L"
                acData[2,i] := .F.
             ENDIF
          NEXT
       ENDIF
    RETURN acData

    INLINE METHOD GetPos()

   // Changed by JL for testing
   //  LOCAL nPos := ::DacPagedDatastore:GetPos()
       LOCAL nPos := ::DacSortedPagedDatastore:GetPos()

       IF nPos == NIL
          RETURN 100
       ENDIF
    RETURN nPos

 ENDCLASS

* ----------------

FUNCTION DC_GetActiveInfo( oXbp )

LOCAL cVarName := '', cProcName := '', nProcLine := 0, aProc

IF Valtype(oXbp) # 'O'
  oXbp := SetAppFocus()
ENDIF

IF Valtype(oXbp) = 'O' .AND. ;
   Valtype(oXbp:cargo) = 'A' .AND. Len(oXbp:cargo) >= 3 .AND. ;
   Valtype(oXbp:cargo[1]) = 'N' .AND. Valtype(oXbp:cargo[2]) = 'A' ;
   .AND. oXbp:cargo[1] > 0
  cVarName := oXbp:cargo[2,oXbp:cargo[1],cGETLIST_VARNAME]
  aProc := oXbp:cargo[2,oXbp:cargo[1],aGETLIST_PROC]
  IF Valtype(aProc)=='A'
    cProcName := aProc[1]
    nProcLine := aProc[2]
  ENDIF
  IF Valtype(cVarName) = 'A'
    cVarName := cVarName[1]
  ENDIF
  RETURN { cVarName, cProcName, nProcLine, oXbp }
ENDIF

RETURN { cVarName, cProcName, nProcLine, oXbp }

* -------------------

FUNCTION DC_ReadGuiExitKey( nMode, nKey )

STATIC saExitKeys := {0,0,0,0,0,0,0}

LOCAL nOldKey

DEFAULT nMode := DCGUI_EXIT_OK
nOldKey := saExitKeys[nMode]

IF Valtype(nKey) = 'N'
  saExitKeys[nMode] := nKey
ENDIF

RETURN nOldKey

* --------------------

FUNCTION DC_StatusBarRePaint( oDlg, lPanelResize, aOldSize, aNewSize, nAlign )

LOCAL i, j, nCol, oXbp, aChildList, oStatus, nDrawStRow, ;
      nDrawStCol, nDrawEnRow, nDrawEnCol, bHide, nOffset, ;
      aStatusBar, nOldHeight, nNewHeight, nWidth, nHeight

DEFAULT lPanelResize := .f.

IF lPanelResize
  IF nAlign == DCGUI_ALIGN_TOP .OR. nAlign == DCGUI_ALIGN_BOTTOM
    oDlg:setSize({oDlg:currentSize()[1], ;
                  oDlg:currentSize()[2]+(aNewSize[2]-aOldSize[2])})
  ELSEIF nAlign == DCGUI_ALIGN_LEFT .OR. nAlign == DCGUI_ALIGN_RIGHT
    oDlg:setSize({oDlg:currentSize()[1]+(aNewSize[1]-aOldSize[1]), ;
                  oDlg:currentSize()[2]})
  ENDIF
  // DC_ClearEvents()
ENDIF

nOffset    := oDlg:cargo[4]
aStatusBar := oDlg:cargo[5]

IF !oDlg:titleBar
  nOffSet := IIF(oDlg:titleBar,GetSystemMetrics(4),0) + ;  // Title bar Height
             IIF(oDlg:border == XBPDLG_NO_BORDER,0,GetSystemMetrics(32)*2) + ; // Frame Width
             GetSystemMetrics(15)     // Menu Height
ENDIF

nDrawStRow := 0
nDrawStCol := 0
nDrawEnRow := oDlg:currentSize()[2] - nOffset
nDrawEnCol := oDlg:currentSize()[1] - GetSystemMetrics(32)

FOR i := 1 TO Len(aStatusBar)

  oStatus := aStatusBar[i]
  oStatus:setParent(oDlg)
  oStatus:setOwner(oDlg)
  bHide := oStatus:hideBlock
  IF oStatus:isDerivedFrom('DC_XbpStatusBar')
    nWidth := oStatus:width
    nHeight := oStatus:height
  ELSE
    nWidth := oStatus:currentSize()[1]
    nHeight := oStatus:currentSize()[2]
  ENDIF
  IF Valtype(bHide) = 'B'
    IF Eval(bHide,oStatus)
      oStatus:hide()
      LOOP
    ENDIF
  ENDIF

  nAlign := oStatus:align

  IF nAlign == DCGUI_ALIGN_TOP .OR. nAlign == DCGUI_ALIGN_BOTTOM

    IF oStatus:isDerivedFrom('DC_XbpStatusBar')
      oStatus:setSize({nDrawEnCol-nDrawStCol,nHeight})
      aChildList := oStatus:childList()
      nCol := oStatus:currentSize()[1]
      IF nAlign == DCGUI_ALIGN_TOP
        oStatus:setPos( { -5, nDrawEnRow - nHeight } )
        nDrawEnRow := Min( nDrawEnRow, oStatus:currentPos()[2] )
      ELSE
        // oStatus:setPos( { nDrawStCol-5, nDrawStRow-5 } )
        oStatus:setPos( { nDrawStCol-5, nDrawStRow } )
        nDrawStRow := Max( nDrawStRow, oStatus:currentPos()[2]+nHeight )
      ENDIF

      IF oStatus:anchor == DCGUI_ALIGN_RIGHT
        FOR j := Len(aChildList) TO 1 STEP -1
          oXbp := aChildList[j]
          oXbp:hide()
          IF j = 1
            oXbp:setPos({5,oXbp:currentPos()[2]})
            oXbp:setSize({nCol-6,oXbp:currentSize()[2]})
          ELSE
            nCol -= ( oXbp:currentSize()[1] + oStatus:width )
            oXbp:setPos( { nCol, oXbp:currentPos()[2] } )
          ENDIF
          oXbp:show()
        NEXT j
      ELSE
        nCol := 5
        FOR j := 1 TO Len(aChildList)
          oXbp := aChildList[j]
          oXbp:hide()
          oXbp:setPos({nCol,oXbp:currentPos()[2]})
          nCol += oXbp:currentSize()[1]
          oXbp:show()
        NEXT j
      ENDIF
    ELSEIF oStatus:isDerivedFrom('DC_XbpPanel')
      oStatus:setSize({nDrawEnCol-nDrawStCol-8,nHeight})
      IF nAlign == DCGUI_ALIGN_TOP
        oStatus:setPos( { nDrawStCol, nDrawEnRow - nHeight } )
        nDrawEnRow := Min( nDrawEnRow, oStatus:currentPos()[2] )
      ELSE
        oStatus:setPos( { nDrawStCol, nDrawStRow} )
        nDrawStRow := Max( nDrawStRow, oStatus:currentPos()[2]+nHeight )
      ENDIF
    ENDIF

  ELSEIF nAlign == DCGUI_ALIGN_LEFT .OR. nAlign == DCGUI_ALIGN_RIGHT

    nOldHeight := oStatus:currentSize()[2]
    IF nAlign == DCGUI_ALIGN_RIGHT .AND. nDrawEnCol == oDlg:currentSize()[1]
      nWidth += 8
    ENDIF
    oStatus:setSize({nWidth,nDrawEnRow-nDrawStRow})
    nNewHeight := oStatus:currentSize()[2]
    IF nAlign == DCGUI_ALIGN_RIGHT
      oStatus:setPos( { nDrawEnCol-nWidth, ;
                        IIF(nDrawStRow=0,nDrawStRow,nDrawStRow) } )
      nDrawEnCol := Min( nDrawEnCol, nDrawEncol-nWidth )
    ELSE
      oStatus:setPos( { IIF(nDrawStCol=0,nDrawStCol,nDrawStCol), ;
                        IIF(nDrawStRow=0,nDrawStRow,nDrawStRow) } )
      nDrawStCol := ;
        Max( nDrawStCol, oStatus:currentPos()[1]+nWidth )
    ENDIF
    IF oStatus:isDerivedFrom('DC_XbpStatusBar')
      aChildList := oStatus:childList()
      FOR j := 1 TO Len(aChildList)
        oXbp := aChildList[j]
        oXbp:setPos( { oXbp:currentPos()[1], ;
                       oXbp:currentPos()[2]-(nOldHeight-nNewHeight)})
      NEXT
    ELSEIF oStatus:isDerivedFrom('DC_XbpPanel')
      aChildList := oStatus:drawingArea:childList()
      FOR j := 1 TO Len(aChildList)
        oXbp := aChildList[j]
        oXbp:setPos( { oXbp:currentPos()[1], ;
                       oXbp:currentPos()[2]+(oStatus:currentSize()[2]-oStatus:height)})
      NEXT
    ENDIF
  ENDIF

  IF oStatus:isDerivedFrom('DC_XbpPanel')
    oStatus:height := oStatus:currentSize()[2]
    oStatus:width := ostatus:currentSize()[1]
    IF Valtype(oStatus:drawingArea:resize)=='B'
      Eval(oStatus:drawingArea:resize, ;
           oStatus:drawingArea:currentSize(), ;
           oStatus:drawingArea:currentSize(), ;
           oStatus:drawingArea)
    ENDIF
  ENDIF

  oStatus:show()

NEXT i

oDlg:drawingArea:setSize({nDrawEnCol-nDrawStCol,nDrawEnRow-nDrawStRow})
oDlg:drawingArea:setPos({nDrawStCol,nDrawStRow})

RETURN nil

* --------------------

FUNCTION DC_MergeGetLists( aGetList1, aGetList2 )

LOCAL i, j, aControl, oXbp, oGetList1, oGetList2

IF Empty(aGetList1) .OR. Empty(aGetList2)
  RETURN nil
ENDIF

FOR i := 1 TO Len(aGetList1)
  IF aGetList1[i,nGETLIST_TYPE] == GETLIST_DATASTORE
    oGetList1 := aGetList1[i,oGETLIST_OBJECT]
    EXIT
  ENDIF
NEXT

FOR i := 1 TO Len(aGetList2)
  IF aGetList2[i,nGETLIST_TYPE] == GETLIST_DATASTORE
    oGetList2 := aGetList2[i,oGETLIST_OBJECT]
  ELSE
    AAdd(aGetList1,aGetList2[i])
    j := Len(aGetList1)
    oXbp := aGetList2[i,oGETLIST_OBJECT]
    IF Valtype(oXbp) = 'O' .AND. Valtype(oXbp:cargo) = 'A'
      oXbp:cargo[1] := Len(aGetList1)
      oXbp:cargo[2] := aGetList1
      IF IsMemberVar(oXbp,'getListPointer')
        oXbp:getlistPointer := oXbp:cargo[1]
        oXbp:getList := oGetList1
      ENDIF
      IF oXbp:isderivedFrom('DC_XBPGET')
        IF Valtype(oXbp:popupButton) = 'O' // popup button
          oXbp:popupButton:cargo[1,2] := Len(aGetList1)
        ENDIF
        IF Valtype(aGetList1[j,nGETLIST_POINTER]) == 'N'
          aGetList1[j,nGETLIST_POINTER] := j-1
        ENDIF
      ENDIF
    ENDIF
  ENDIF
NEXT

IF Valtype(oGetList2) = 'O' .AND. oGetList2:isDerivedFrom("DC_GetList")
  DC_MergeGetListControls( oGetList1, oGetList2 )
ENDIF

Sleep(5)

RETURN aGetList1

* ----------

FUNCTION DC_MergeGetListControls( oGetList1, oGetList2 )

LOCAL aControl, i

IF oGetList1 == nil .OR. oGetList2 == nil
  RETURN nil
ENDIF

aControl := oGetList2:editControls
FOR i := 1 TO Len(aControl)
  AADD(oGetList1:editControls,aControl[i])
NEXT
aControl := oGetList2:graControls
FOR i := 1 TO Len(aControl)
  AADD(oGetList1:graControls,aControl[i])
NEXT
aControl := oGetList2:browseControls
FOR i := 1 TO Len(aControl)
  AADD(oGetList1:browseControls,aControl[i])
NEXT
aControl := oGetList2:tabpageControls
FOR i := 1 TO Len(aControl)
  AADD(oGetList1:tabpageControls,aControl[i])
NEXT
aControl := oGetList2:pickControls
FOR i := 1 TO Len(aControl)
  AADD(oGetList1:pickControls,aControl[i])
NEXT
aControl := oGetList2:appControls
FOR i := 1 TO Len(aControl)
  AADD(oGetList1:appControls,aControl[i])
NEXT
aControl := oGetList2:keyboardControls
FOR i := 1 TO Len(aControl)
  AADD(oGetList1:keyboardControls,aControl[i])
NEXT
aControl := oGetList2:tooltipControls
FOR i := 1 TO Len(aControl)
  AADD(oGetList1:tooltipControls,aControl[i])
NEXT
IF oGetList2:isDataToolTips
  oGetList1:isDataToolTips := .t.
ENDIF

RETURN nil
* ----------

FUNCTION DC_ReadGuiLastKey( aGetList, nLastKey )

LOCAL oGetList := DC_GetListObject( aGetList )

IF oGetList == nil
  RETURN 0
ENDIF

IF Valtype(nLastKey) = 'N'
  oGetList:lastkey := nLastKey
ENDIF

RETURN oGetList:lastkey

* -----------------

METHOD DC_GetList:AddDataStore()

LOCAL nDataStore

nDataStore := AScan(::getListArray,{|a|a[nGETLIST_TYPE]==GETLIST_DATASTORE})

IF nDataStore == 0
  AAdd(::getListArray,Array(nGET_ARRAY_SIZE))
  nDataStore := Len(::getListArray)
ENDIF
::getListArray[nDataStore,nGETLIST_TYPE] := GETLIST_DATASTORE

IF Empty(::getListArray[nDataStore,oGETLIST_OBJECT])
  ::getListArray[nDataStore,oGETLIST_OBJECT] := self
ENDIF

RETURN nDataStore

* ------------------

METHOD DC_GetList:CreateObject( oXbp, aControls )

IF oXbp:Status() = XBP_STAT_INIT
  oXbp:create()
  IF oXbp:Status() = XBP_STAT_CREATE
    IF Valtype( aControls ) == 'A'
      AAdd( aControls, oXbp )
    ENDIF
  ELSE
    ::buildErrorMsg := 'Unable to create ' + oXbp:className() + Chr(13)
  ENDIF
ELSE
  ::buildErrorMsg := 'Unable to initilize  ' + oXbp:className() + Chr(13)
ENDIF

RETURN self

* ------------------

STATIC FUNCTION _Pres( aPres )

IF Valtype( aPres ) = 'B'
  RETURN Eval(aPres)
ENDIF

RETURN aPres

* -------------------

FUNCTION DC_SetMenuItemBitMap( oSubMenu, aBitMap, nPointer )

LOCAL nIndex := _SubMenu( oSubMenu ) - 1
LOCAL nWnd := oSubMenu:setParent():setParent():getHWnd()
LOCAL hMenu := GetMenu(nWnd)
LOCAL nInst := SysGetWindowLongA( nWnd )
LOCAL hSubMenu := GetSubMenu(hMenu,nIndex)
LOCAL nMenuId := GetMenuItemID(hSubMenu, nPointer - 1)
LOCAL xBitmap1, xBitmap2

IF Valtype(aBitmap[1]) == 'A'
  xBitmap1 := aBitmap[1,1]
  xBitmap2 := aBitmap[1,2]
ELSE
  xBitmap1 := aBitmap[1]
  xBitmap2 := aBitmap[2]
ENDIF

SysSetMenuItemBitmaps(hMenu, nMenuID, 4,  ;
         SysLoadBitmapA(nInst, xBitmap1), SysLoadBitmapA( nInst, xBitMap2) )

RETURN nil

* -------------------

DLLFUNCTION GetMenuItemID(hMenu, nPos) USING STDCALL FROM "USER32.DLL"

DLLFUNCTION GetMenu(hWnd) USING STDCALL FROM "USER32.DLL"

DLLFUNCTION GetSubMenu(hMenu, nPos) USING STDCALL FROM "USER32.DLL"

* --------------------

Function SysGetWindowLongA( hWnd )

   Local cCall
   Local nDll
   Local nRes

   nDll := DllLoad( "USER32.DLL")
   if nDll != 0
      cCall := DllPrepareCall( nDLL, DLL_STDCALL, "GetWindowLongA")
      if len( cCall) != 0
         nRes := DLLExecuteCall( cCall, hWnd, -6)
      endif
   endif

Return(nRes)

* ---------------------

Function SysLoadBitmapA( hInstance, nResource )

   Local cCall
   Local nDll
   Local nRes

   nDll := DllLoad( "USER32.DLL")
   if nDll != 0
      cCall := DllPrepareCall( nDLL, DLL_STDCALL, "LoadBitmapA")
      if len( cCall) != 0
         nRes := DLLExecuteCall( cCall, hInstance, nResource)
      endif
   endif

Return(nRes)

* ----------------------

Function SysSetMenuItemBitmaps( hMenu, nPos, uFlags, BmpCheck, BmpUnCheck )

   Local cCall
   Local nDll
   Local nRes

   nDll := DllLoad( "USER32.DLL")
   if nDll != 0
      cCall := DllPrepareCall( nDLL, DLL_STDCALL, "SetMenuItemBitmaps")
      if len( cCall) != 0
         nRes := DLLExecuteCall( cCall, hMenu, nPos, uFlags, BmpCheck, BmpUnCheck )
      endif
   endif

Return(nRes)

* ------------------------

FUNCTION DC_SetPopKey( nPopKey )

STATIC snPopKey := xbeK_CTRL_ENTER

LOCAL nOldPopKey := snPopKey
IF Valtype(nPopKey) = 'N'
  snPopKey := nPopKey
ENDIF

RETURN nOldPopKey

* -------------------------

FUNCTION DC_LogicTest( lOn1, lOn2, lOff1, lOff2 )

IF Valtype( lOn1 ) == 'L'
  RETURN lOn1
ELSEIF Valtype( lOn2 ) == 'L'
  RETURN lOn2
ELSEIF Valtype( lOff1 ) == 'L'
  RETURN !lOff1
ELSEIF Valtype( lOff2 ) == 'L'
  RETURN !lOff2
ENDIF

RETURN nil

* ------------------

FUNCTION DC_ReadGuiEval( bEval )

STATIC sbEval := nil
LOCAL bOldEval := sbEval
IF Valtype(bEval) == 'B'
  sbEval := bEval
ENDIF
RETURN bOldEval

* ------------------

STATIC FUNCTION _SubMenu( oSubMenu )

LOCAL i, aChildlist := oSubMenu:setParent():childList()

FOR i := 1 TO Len(aChildList)
  IF aChildList[i] == oSubMenu
    RETURN i
  ENDIF
NEXT

RETURN 0

* ------------------
FUNCTION DC_GetBitMap( xBitMap, nType, cResType, cResFile, anScale, lAllowIcons, aSize)
//
// 06-12-2012  J. Duijf
// If Icons are requirerd, then the requested aSize can be passed as a parameter
// See _IsIcon() function
//
LOCAL oBitMap, xResource, aResType, aResFile, i, j, nResDll, oPS, ;
      oTmpPs, nNewXSize, nNewYSize, oNewBitmap, xBitmapSave

DEFAULT nType := 0, ;
        lAllowIcons := .f.

// 30-11-2013 J. Duijf
// xBitmap can also be a code-block

xBitmapSave := xBitmap

IF Valtype(xBitmap) == 'B'
  xBitmap := Eval(xBitMap)
ENDIF

IF Valtype(xBitMap) $ 'OU' .OR. Empty(xBitMap) .OR. ;
          ( nType # XBPSTATIC_TYPE_BITMAP .AND. nType # 0 )

ELSEIF Valtype(xBitMap) == 'N'

  #if XPPVER > 1900345
  IF lAllowIcons .AND. _IsIcon(xBitmap,cResFile,@oBitmap,aSize)
     //
     // 13-01-2013 J. Duijf
     // Prevent runtime error while trying to scale an icon.
     //
     anScale      := nil
  ELSEIF !lAllowIcons .AND. DC_GetSetIconList():IsIcon(xBitmap)
    RETURN xBitmap
  ELSE
    oBitMap := XbpBitMap():new():create()
  ENDIF
  #else
    oBitmap := XbpBitMap():new():create()
  #endif
  //
  // Jack Duij 03-02-2013
  // Store resource ID as reference
  //
  oBitmap:Cargo   := xBitmap
  IF Empty(cResType) .AND. Empty(cResFile)
    If oBitMap:IsDerivedFrom("xbpBitmap")
       oBitMap:Load(,xBitMap)
    Else
       // If Icon, then it is already loaded
    Endif

    IF oBitmap:xSize == 0
      aResFile := DC_BitmapResourceFile()
      FOR i := 1 TO Len(aResFile)
         cResFile := aResFile[i]
         oBitMap:Load(cResFile,xBitMap)
         IF oBitmap:xSize > 0
            EXIT
         ENDIF
      NEXT i
      IF oBitmap:xSize == 0
         xResource := NIL
         aResType := { nil, 'BMP', 'JPEG', 'GIF', 'PNG' }
         FOR i := 1 TO Len(aResFile)
            IF !Empty(xResource)
               EXIT
            ENDIF
            cResFile := aResFile[i]
            FOR j := 1 TO Len(aResType)
               cResType := aResType[j]
               xResource := LoadResource( xBitmap, cResFile, cResType )
               IF !Empty(xResource)
                  oBitmap:setBuffer( xResource )
               ENDIF
            NEXT
         NEXT i
      ENDIF
    ELSEIF oBitmap:xSize > 0
      xBitmap := oBitmap
    ENDIF
  ELSE
    IF Valtype(cResFile) == 'C'
      cResFile := DllLoad(cResFile)
    ENDIF
    xResource := LoadResource( xBitMap, cResFile, cResType )
    oBitMap:setBuffer( xResource )
  ENDIF
  IF oBitMap:xSize > 0
    IF !Empty(DC_BitMapTransparentColor()) .AND. oBitmap:isDerivedFrom('XbpBitmap')
      oBitMap:transparentClr := DC_BitMapTransparentColor()
    ENDIF
    xBitMap := oBitmap
  ENDIF
ELSEIF Valtype(xBitMap) == 'C' .AND. ;
      ('.JPG' $ Upper(xBitmap) .OR. '.GIF' $ Upper(xBitmap) .OR. ;
       '.BMP' $ Upper(xBitmap) .OR. '.PNG' $ Upper(xBitmap) .OR. ;
       '.ICO' $ Upper(xBitmap)) .AND. FExists(xBitmap)
  #if XPPVER > 1900345
      //
      // 17-07-2014 J. Duijf
      // Use _IsIcon() to load (and scale) icon file.
      //
      If _IsIcon(xBitmap,,@oBitmap,aSize)
         //
         // Prevent runtime error while trying to scale an icon.
         //
         anScale      := nil
      Else
         oBitMap := XbpBitMap():new():create()
         oBitMap:LoadFile(xBitMap)
      Endif
      //
      // oBitMap = xbpIcon .or. xbpBitmap
      //
  #else
    oBitMap := XbpBitMap():new():create()
    oBitMap:LoadFile(xBitMap)
  #endif
  IF oBitMap:xSize > 0
    IF !Empty(DC_BitMapTransparentColor()) .AND. oBitmap:isDerivedFrom('XbpBitmap')
      oBitMap:transparentClr := DC_BitMapTransparentColor()
    ENDIF
    xBitMap := oBitMap
  ENDIF
ENDIF

IF Valtype(anScale) $ 'AN' .AND. Valtype(xBitmap) == 'O'
  IF Valtype(anScale) == 'A'
    nNewXSize := anScale[1]
    nNewYSize := anScale[2]
  ELSE
    nNewXSize := Int(xBitmap:xSize*anScale)
    nNewYSize := Int(xBitmap:ySize*anScale)
  ENDIF
  oPS  := XbpPresSpace():new():create()
  xBitmap:presSpace( oPS )
  oTmpPS  := XbpPresSpace():new():create()
  oNewBitmap := XbpBitmap():new():create()
  oNewBitmap:make(nNewXSize,nNewYSize)
  oNewBitmap:presSpace(oTmpPS)

  GraBitBlt( oTmpPS, oPS, ;
             {0,0,nNewXSize+2,nNewYSize+2},;
             {0,0,xBitmap:xSize,xBitmap:ySize},;
             GRA_BLT_ROP_SRCCOPY )

  xBitMap:destroy()
  xBitmap := oNewBitmap
ENDIF
//
// 03-12-2013 J. Duijf
// We did not get a bitmap or icon.
// Restore original data
//
If ValType(xBitmap) <> "O"
   xBitMap := xBitmapSave
Endif

RETURN xBitMap

* ------------------

STATIC FUNCTION _IsIcon( nResource, cResFile, oIcon, aSize )
//
// 06-12-2012  J. Duijf
// If icons are requirerd of a non-default size (32x32), then the requested size CAN be passed as a parameter
// See XbpIcon:Load() in the Alaska Xbase++ Reference documentation
//
LOCAL lStatus  := .f.
LOCAL nXsize   := 32
LOCAL nYsize   := 32
LOCAL bError   := nil
LOCAL cMsg     := ""
LOCAL nRetry   := 5  // Jack Duijf 17-07-2014
#if XPPVER > 1900345
// IF cResFile == NIL
//   RETURN .f.
// ENDIF

If !DC_GetSetIconList():IsIcon(nResource)
   Return lStatus
Endif

If ValType(aSize) = "A" .and. Len(aSize) = 2
   //
   // J. Duijf 06-12-2012
   // Auto adjust to commonly used ICON formats
   // 16 x 16
   // 32 x 32
   // 48 x 48
   // 64 x 64
   // 96 x 96
   // etc.
   //
   // J. Duijf 24-03-2013
   // There seem to be more formats.
   //  8 x 8
   // 24 x 24
   // 40 x 40
   //
   // To prevent image deformation, scale back to the closeest standard size
   // If buttons are slightly bigger, the image still fits in the button
   // an evenly spaced arround the borders.
   //
   nXsize      := aSize[1]
   nYsize      := aSize[2]
   //
   // Icons are assumed to square
   //
   nXsize      := Int(nXsize / 8) * 8                                         // Allow 8,16,24,32,40
   nYsize      := Int(nYsize / 8) * 8
   If nXsize >  40                                                            // Allow 48,64,80,96,108,128
      nXsize   := Int(nXsize / 16) * 16
      nYsize   := Int(nYsize / 16) * 16
   Endif
   If nXsize >  64                                                            // Allow 64,96,128
      nXsize   := Int(nXsize / 32) * 32
      nYsize   := Int(nYsize / 32) * 32
   Endif
   //
   nXSize      := Min(nXSize,nYSize)
   nYSize      := Min(nYSize,nXSize)
   nXsize      := Max(nXSize,8)
   nYsize      := Max(nYSize,8)
Endif

oIcon := XbpIcon():new():create()

If ValType(oIcon) = "O"
   //
   // 06-07-2013 The load of correct size ICON also
   // apply to external files
   //
   //
   // J. Duijf 17-07-2014
   // Store resourceId for later reference  (error handler)
   //
   oIcon:Cargo    := {cResFile,nResource,nXsize,nYsize}
   //
   If ValType(nResource) = "N"
     lStatus     := oIcon:load(cResFile,nResource,nXsize,nYsize)
   Else
     If ".ICO" $ Upper(nResource) .AND. FExists(nResource)
        //
        // 21-01-2014 J. Duijf
        // In case the icon file is NOT an icon, or the icon file is corrupt, this might result
        // in runtime error EH: 5 Sub: -1073741819(c0000005) OS: 0 XPP: 41
        // IMHO, this should be mentioned to the end-user
        //
        bError      := ErrorBlock({||Break()})
        BEGIN SEQUENCE
           lStatus  := oIcon:LoadFile(nResource,nXsize,nYsize)
        RECOVER
           ErrorBlock(bError)
           lStatus  := .F.
           cMsg     := Dc_LangMsg(DCMSG_ICONLOADFAIL)
           cMsg     := StrTran(cMsg,"%1",nResource)
           If !Empty(cMsg)
              MsgBox(cMsg)
           Endif
        END SEQUENCE
        ErrorBlock(bError)
      Endif
   Endif
Endif
//
// J. Duijf 03-02-2013
// Store resourceId for later reference
//
oIcon:Cargo    := nResource
IF !lStatus
  oIcon:destroy()
  oIcon := nil
ENDIF
#endif

RETURN lStatus

* ----------

FUNCTION DC_BitMapResourceFile( aResFile )

STATIC saResFile[0]
LOCAL aOldResFile, nResDll

IF Empty(saResFile)
  nResDll := DllLoad('DCRES.DLL')
  IF nResDll > 0
    AAdd(saResFile,nResDll)
  ENDIF
ENDIF

aOldResFile := saResFile

IF Valtype(aResFile) $ 'CN'
  aResFile := { aResFile }
ENDIF

IF Valtype(aResFile) == 'A'
  saResFile := aResFile
ENDIF

RETURN aOldResFile

* ----------

FUNCTION DC_BitMapTransparentColor( xColor )

STATIC snColor := 0
LOCAL nOldColor := snColor

IF Valtype(xColor) == 'A'
  snColor := GraMakeRGBColor(xColor)
ELSEIF Valtype(xColor) == 'N'
  snColor := xColor
ENDIF

RETURN nOldColor

* ----------

FUNCTION DC_ReadGuiSetAppWindow( oParent )

STATIC soParent := nil

LOCAL oOldParent := soParent
IF Valtype(oParent) == 'O'
  soParent := oParent
ENDIF

RETURN oOldParent

* ----------

FUNCTION DC_ReadGuiHandler( bHandler )

STATIC sbHandler := nil
LOCAL bOldHandler := sbHandler

IF Pcount() >= 1
  sbHandler := bHandler
ENDIF

RETURN bOldHandler

* ----------

STATIC FUNCTION _DotPromptEvent(oXbp)

IF !IsFunction('DC_DotActive') .OR. Valtype(oXbp) # 'O'
  RETURN .f.
ENDIF
IF &('DC_DotActive()')
  DO WHILE oXbp # AppDeskTop() .AND. !oXbp:isDerivedFrom('XbpDialog')
    oXbp := oXbp:setParent()
  ENDDO
  IF Valtype(oXbp) # 'O'
    RETURN .f.
  ELSEIF oXbp:isDerivedFrom('XbpDialog') .AND. Left(oXbp:title,10) == 'Dot Prompt'
    RETURN .t.
  ENDIF
ENDIF
RETURN .f.

* ----------

#ifdef EXPRESSDEMO

#DEFINE CR   Chr(13)

FUNCTION DC_ExpressDemo( nSecs, nTimeOut )

STATIC nSeconds := 0

DEFAULT nTimeOut := 60 * 15

IF nSeconds = 0
   nSeconds := Seconds()
ENDIF

nSecs := nSeconds
IF ( Seconds() - nSeconds ) > nTimeOut
  DC_Gui(.t.)
  DC_WinAlert( ;
    'This demonstration version of eXPress++ is limited to ' + CR + ;
    Alltrim(Str(nTimeOut/60)) + ' minutes run time' + CR + ;
    CR + ;
    'The Retail version is available from your local Xbase++ distributor' + CR + ;
    CR + ;
    'The Retail version also includes:' + CR + ;
    CR + ;
    '* Complete source code.' + CR + ;
    '* XDOC documentation utility - Creates Windows HELP file source.' + CR + ;
    '* Unlimited FREE technical support.' + CR + ;
    '* A Library of Bitmaps, Icons, and Cursors.' + CR + ;
    '* Access to FREE updates.' + CR + ;
    CR + ;
    'For more information check our website at http://www.donnay-software.com'  )
  RETURN .f.
ENDIF

nSecs := Seconds() - nSeconds

RETURN .t.

#endif

* ----------

GETSETFUNCTION DC_ReadGuiTypeAhead DEFAULT .f.

* ----------

FUNCTION DC_GetProperty( oXbp, nProperty, aGetList, aGetListItem, nPointer, nStatus )

IF Valtype(oXbp) == 'O' .AND. Valtype(oXbp:cargo) == 'A' ;
  .AND. Len(oXbp:cargo) >= 2 .AND. Valtype(oXbp:cargo[1]) == 'N' .AND. ;
  Valtype(oXbp:cargo[2]) == 'A' .AND. Valtype(nProperty) == 'N'
  nPointer := oXbp:cargo[1]
  aGetList := oXbp:cargo[2]
  IF nPointer == 0
    nPointer := AScan(aGetList,{|a|a[nGETLIST_TYPE]==GETLIST_DATASTORE})
  ENDIF
  IF nPointer > 0 .AND. nPointer <= Len(aGetList)
    aGetListItem := aGetList[nPointer]
    IF nProperty <= Len(aGetListItem)
      nStatus := 1
      RETURN aGetListItem[nProperty]
    ENDIF
  ENDIF
ENDIF
nStatus := 0
RETURN nil

* ----------

FUNCTION DC_SetProperty( oXbp, nProperty, xValue )

LOCAL nPointer

IF Valtype(oXbp) == 'O' .AND. Valtype(oXbp:cargo) == 'A' ;
  .AND. Len(oXbp:cargo) >= 2 .AND. Valtype(oXbp:cargo[1]) == 'N' .AND. ;
  Valtype(oXbp:cargo[2]) == 'A' .AND. Valtype(nProperty) == 'N'
  nPointer := oXbp:cargo[1]
  IF nPointer == 0
    nPointer := AScan(oXbp:cargo[2],{|a|a[nGETLIST_TYPE]==GETLIST_DATASTORE})
  ENDIF
  oXbp:cargo[2][nPointer][nProperty] := xValue
ENDIF
RETURN nil

* ----------

STATIC FUNCTION _BuildHelpCode( aGetListItem, oXbp, oParent )

LOCAL cHelpCode, cParentHelpCode

IF !DC_AutoCreateHelpCodes()
  RETURN nil
ENDIF

IF Valtype(aGetListItem) == 'A'
  cHelpCode := aGetListItem[cGETLIST_HELPCODE]
ENDIF
IF Empty(cHelpCode)
  cHelpCode := DC_GetHelpCode(oXbp,nil,@aGetListItem)
ENDIF

IF !Empty(cHelpCode) .AND. Left(cHelpCode,1) == '.'
  IF Empty(oParent) .AND. IsMethod(oXbp,'SETPARENT')
    oParent := oXbp:setParent()
    IF oParent:isDerivedFrom('XbpIWindow')
      oParent := oXbp:setParent()
    ENDIF
  ENDIF
  IF Valtype(oParent) == 'O'
    IF IsMemberVar(oParent,'HELPCODE')
      cParentHelpCode := oParent:HelpCode
    ELSE
      cParentHelpCode := DC_GetHelpCode(oParent)
    ENDIF
    IF !Empty(cParentHelpCode)
      IF cHelpCode == '.'
        cHelpCode := ''
      ELSEIF '.' $ cParentHelpCode
        cParentHelpCode := DC_TokenArray(cParentHelpCode,'.')[2]
      ENDIF
      aGetListItem[cGETLIST_HELPCODE] := cParentHelpCode + cHelpCode

      IF Valtype(oXbp) == 'O' .AND. IsMemberVar(oXbp,'HELPCODE')
        oXbp:helpCode := cParentHelpCode + cHelpCode
      ENDIF
    ENDIF
  ENDIF
ENDIF

RETURN nil

* -----------------

FUNCTION DC_GetHelpCode( oXbp, aGetList, aGetListItem )

LOCAL oParent, cHelpCode, cVarName, cString, i

cHelpCode := DC_GetProperty(oXbp,cGETLIST_HELPCODE,@aGetList,@aGetListItem)

IF Empty(cHelpCode)
  IF DC_AutoCreateHelpCodes() .AND. Valtype(aGetListItem) = 'A'
    cVarName := aGetListItem[cGETLIST_VARNAME]
    IF !Empty(cVarName)
      IF Valtype(cVarName) = 'C'
        cHelpCode := Upper(cVarName)
      ELSEIF Valtype(cVarName) = 'A' .AND. Len(cVarname) = 2
        cHelpCode := Upper(DC_XtoC(cVarName[1]))
      ENDIF
    ELSEIF !Empty(aGetListItem[cGETLIST_CAPTION])
      IF Valtype(aGetListItem[cGETLIST_CAPTION]) = 'C' .AND. ;
         !(aGetListItem[nGETLIST_TYPE] $ ;
           { GETLIST_SAY, GETLIST_STATIC, GETLIST_GRASTRING, GETLIST_BROWSECOL, ;
             GETLIST_TREEITEM } )
        cHelpCode := Upper(aGetListItem[cGETLIST_CAPTION])
      ENDIF
    ENDIF

    IF !Empty(cHelpCode)
      cString := '~!&@#$%^&*()-+=";:<>,.?/[]{}|\' + "'"
      FOR i := 1 TO Len(cString)
        cHelpCode := Strtran(cHelpCode,cString[i],'')
      NEXT
      DO WHILE '  ' $ cHelpCode
        cHelpCode := Strtran(cHelpCode,'  ',' ')
      ENDDO
      cHelpCode := Strtran(cHelpCode,' ','_')
    ENDIF
    IF !Empty(cHelpCode)
      cHelpCode := '.' + cHelpCode
    ENDIF
  ENDIF
  IF Empty(cHelpCode) .AND. Valtype(oXbp) == 'O' .AND. IsMethod(oXbp,'SETPARENT')
    oParent := oXbp:setParent()
    cHelpCode := DC_GetHelpCode( oParent, @aGetList, @aGetListItem )
  ENDIF
ENDIF

RETURN cHelpCode

* --------------

GETSETFUNCTION DC_AutoCreateHelpCodes DEFAULT .f.

* --------------

STATIC FUNCTION QuitQuery()

LOCAL nConfirm

nConfirm := DC_GuiAlert(nil, "Data may be lost if you shutdown;" + ;
            "with open records.;;" + ;
            "Do you want to shut down your computer ?", ;
            {' NO ',' YES '},XBPSTATIC_SYSICON_ICONWARNING,"Shutdown warning")

IF nConfirm == 2
  CLOSE ALL
  RETURN XBP_ALLOW
ENDIF

RETURN XBP_REJECT

* --------------

FUNCTION DC_GetValidBlock( bValid )

STATIC sbValid := nil

LOCAL bOldValid := sbValid

IF Valtype(bValid) == 'B'
  sbValid := bValid
ENDIF

RETURN bOldValid

* --------------

FUNCTION DC_GetObjectID(o)

RETURN DC_GetProperty(o,cGETLIST_ID)

* --------------

FUNCTION DC_ValidateSkip( lSkip )

STATIC slSkipValidation := .F.
LOCAL lSkipValidation := slSkipValidation

IF PCount() = 1 .AND. Valtype(lSkip) = 'L'
  slSkipValidation := lSkip
ENDIF

RETURN lSkipValidation

* --------------

FUNCTION DC_LastFocus( aGetList, oAppFocus )

LOCAL nDataStore, oGetList, oOldLastFocus

IF Empty(aGetList) .OR. PCount() < 2
  RETURN nil
ENDIF

oGetList := DC_GetListObject( aGetList )

oOldLastFocus := oGetList:lastFocus

IF Valtype(oAppFocus) == 'O'
  oGetList:lastFocus := oAppFocus
ENDIF

RETURN oOldLastFocus

* --------------

FUNCTION DC_EditControlLastFocus( aGetList )

LOCAL oGetList := DC_GetListObject( aGetList )

IF oGetList == NIL
  RETURN nil
ENDIF

RETURN oGetList:editControlLastFocus

* -------------

FUNCTION DC_AddButtonConfig( nButton, cCaption, nWidth, nHeight, oBitMap, cFont )

LOCAL aConfig, nPointer

STATIC saConfig[0]

DEFAULT nButton := 0

IF Valtype(nButton) == 'A'
  aConfig := AClone(nButton)
  ASize(aConfig,6)
  nButton := aConfig[1]
  cCaption := aConfig[2]
  nWidth := aConfig[3]
  nHeight := aConfig[4]
  oBitmap := aConfig[5]
  cFont := aConfig[6]
ENDIF

IF Empty(saConfig)
  saConfig := { ;
   { DCGUI_BUTTON_OK, {||DC_LangMsg(DCMSG_OK)}, 90, 22, nil,nil }, ;
   { DCGUI_BUTTON_CANCEL, {||DC_LangMsg(DCMSG_CANCEL)}, 90, 22, nil,nil }, ;
   { DCGUI_BUTTON_EXIT, {||DC_LangMsg(DCMSG_EXIT)}, 90, 22, nil,nil }, ;
   { DCGUI_BUTTON_HELP, {||DC_LangMsg(DCMSG_HELP)}, 90, 22, nil,nil }, ;
   { DCGUI_BUTTON_YES, {||DC_LangMsg(DCMSG_YES)}, 90, 22, nil,nil }, ;
   { DCGUI_BUTTON_NO, {||DC_LangMsg(DCMSG_NO)}, 90, 22, nil,nil } ;
   }
ENDIF

nPointer := AScan(saConfig,{|a|a[1]==nButton})
IF nPointer == 0
  RETURN nil
ENDIF
IF !Empty(cCaption)
  saConfig[nPointer,2] := cCaption
ENDIF
IF !Empty(nWidth)
  saConfig[nPointer,3] := nWidth
ENDIF
IF !Empty(nHeight)
  saConfig[nPointer,4] := nHeight
ENDIF
IF !Empty(oBitmap)
  saConfig[nPointer,5] := oBitmap
ENDIF
IF !Empty(cFont)
  saConfig[nPointer,6] := cFont
ENDIF

RETURN saConfig[nPointer]

* --------------

FUNCTION DC_AutoRestoreWindow( aParams )

STATIC saParams := nil
LOCAL aOldParams := saParams

// [1] nHKey
// [2] Start Folder
// [3] Default (.t. == ON, .f. == OFF)

IF Valtype(aParams) = 'A'
  ASize(aParams,3)
  DEFAULT aParams[3] := .t.
  saParams := aParams
ENDIF

RETURN aOldParams

* --------------

FUNCTION DC_AutoRest( l1, l2, l3, l4 )

IF Valtype(l4) == 'L'
  RETURN !l4
ELSEIF Valtype(l2) == 'L'
  RETURN l2
ELSEIF l3
  RETURN .f.
ELSEIF l1
  RETURN .t.
ENDIF

RETURN nil

* --------------

GETSETFUNCTION DC_EnterExitMode DEFAULT 0

* --------------

CLASS DC_XbpDialog1 From XbpDialog

EXPORTED:
VAR oMagicHelp
VAR lCreated
VAR menuBar
VAR resizeState
VAR frameState
VAR dropBlock
VAR dropType
VAR connection

METHOD Init, Create, Resize, Show, Destroy, setButtons, setOffset

HIDDEN:

METHOD SetRelPos
VAR nXOffset
VAR nYTitlebarheight
VAR oButtons

ENDCLASS

* ---------

METHOD DC_XbpDialog1:Init(oParent,oOwner,aPos,aSize,aPresParam,lVisible)

LOCAL oThread := ThreadObject()

::lCreated := .F.

IF oThread:isDerivedFrom('DC_Thread')
  oThread:xbp := self
ELSEIF Empty(oThread:cargo)
  oThread:cargo := self
ENDIF

::nXOffset := 90

Sleep(5)

RETURN ::xbpDialog:Init(oParent,oOwner,aPos,aSize,aPresParam,lVisible)

// The :resize() method has to be overlaoded in
// order to reposition the implemented buttons in
// the titlebar.

METHOD DC_XbpDialog1:Resize( aPos1, aPos2 )

LOCAL aNewPos

::XbpDialog:resize( aPos1, aPos2 )
IF Valtype(::oButtons) == 'O'
  aNewPos := ::SetRelPos( 1 )
  ::oButtons:setPos( aNewPos )
ENDIF

RETURN self

* ------------

METHOD DC_XbpDialog1:setButtons( oButtons )

::oButtons := oButtons

RETURN nil

* ------------

METHOD DC_XbpDialog1:setOffset( nOffset )

::nXOffset := nOffset

RETURN nil

* ------------

METHOD DC_XbpDialog1:Show()

IF !::xbpDialog:isVisible() ;
      .AND. ;
      (::xbpDialog:drawingArea:setColorBG()==nil .OR. ::xbpDialog:drawingArea:setColorBG() # XBPSYSCLR_TRANSPARENT)

   ::xbpDialog:drawingArea:lockUpdate(.t.)
   ::xbpDialog:show()
   ::xbpDialog:drawingArea:lockUpdate(.f.)
   ::xbpDialog:drawingArea:invalidateRect()
ELSE
   ::xbpDialog:show()
ENDIF

RETURN self

* -----------

METHOD DC_XbpDialog1:create( a, b, c, d, e, f )

IF ::XbpDialog:Status() = XBP_STAT_INIT
  ::XbpDialog:create( a,b,c,d,e,f )
  IF !::XbpDialog:Status() = XBP_STAT_CREATE
    DC_WinAlert('Unable to create Dialog Window')
    BREAK
  ENDIF
ELSE
  DC_WinAlert('Unable to initilize Dialog Window')
  BREAK
ENDIF

::nYTitlebarheight := GetTitleBarHeight( self )

RETURN self

* ------------

METHOD DC_XbpDialog1:Destroy()

LOCAL bError

IF DC_TooltipThread() == 2
  IF ValType(::oMagicHelp) = "O" .AND. ::lCreated
    ::oMagicHelp   := nil
  ENDIF
ELSE
  IF ValType(::oMagicHelp) = "O"
    ::oMagicHelp:terminate()
    ::oMagicHelp:Synchronize(0)
    ::oMagicHelp   := nil
  ENDIF
ENDIF

IF ::xbpDialog:status() >= 1

  bError := ErrorBlock({||Dc_Break()})

  BEGIN SEQUENCE

  IF Valtype(::oButtons) == 'O'
    ::oButtons:destroy()
  ENDIF

  ::xbpDialog:Destroy()
  //
  // 15-04-2011  J. Duijf
  // Make sure all references are removed
  // This to prevent cirular references that can cause memory leaks.
  //
  ::Cargo              := nil
  ::Resize             := nil

  END SEQUENCE

  ErrorBlock(bError)

ENDIF

Return SELF

// As the dialog can be resized the position has to be determined
// and set each time the size, e.g. the position of the titlebar has
// changed.
METHOD DC_XbpDialog1:SetRelPos( nPos )

LOCAL aPos := GetRelPos( self )
aPos[ 1 ] += ::currentSize()[ 1 ] - ::nXOffset - ( ( nPos - 1 ) * ;
             ::nYTitlebarheight )
aPos[ 2 ] += ::currentSize()[ 2 ] - ::nYTitlebarheight // - BORDER_SIZE

RETURN( aPos )


// retrieving the position of the dialog
STATIC FUNCTION GetRelPos( o )

LOCAL aPos   := {0,0}
LOCAL aPos2  := {0,0}
LOCAL oParent:= NIL

aPos := o:CurrentPos()
oParent := o:setParent()
aPos2 := oParent:CurrentPos()
aPos[ 1 ] += aPos2[ 1 ]
aPos[ 2 ] += aPos2[ 2 ]

// DO WHILE oParent != AppDesktop()

DO WHILE oParent != o:parent
   oParent := oParent:setParent()
   aPos2 := oParent:CurrentPos()
   aPos[ 1 ] += aPos2[ 1 ]
   aPos[ 2 ] += aPos2[ 2 ]
ENDDO

RETURN aPos


// Determinig the height of the titlebar as the size of the
// user defined buttons are depends on the height of the
// titlebar.
STATIC FUNCTION GetTitleBarHeight( o )

RETURN( o:currentSize()[ 2 ] - o:drawingArea:currentSize()[ 2 ] - ;
        ( 2 * BORDER_SIZE ) - 1 )


* ----------------

FUNCTION DC_SetDateRange(aRange)

STATIC saDateRange := nil
LOCAL aOldDateRange
IF Valtype(saDateRange) = 'A'
  aOldDateRange := AClone(saDateRange)
ENDIF

IF Valtype(aRange) = 'A'
  saDateRange := aRange
ENDIF

RETURN aOldDateRange

* ----------------

STATIC FUNCTION ValidateDateRange( dDate, l )

LOCAL aDateRange := DC_SetDateRange()

IF Empty(aDateRange) .OR. (Len(aDateRange) > 2 .AND. aDateRange[3] .AND. Empty(dDate))
  RETURN .T.
ENDIF

IF dDate < aDateRange[1] .OR. dDate > aDateRange[2]
  RETURN .F.
ENDIF

RETURN .T.

* -----------------

FUNCTION DC_GetIDDefault( cId, cVarName, cPrefix )

LOCAL cAlias, cVar

DEFAULT cId := '', ;
        cVarName := '', ;
        cPrefix := ''

IF !Empty(cId) .OR. Empty(cVarName)
  RETURN cId
ENDIF

IF !('->' $ cVarName)
  RETURN cId
ENDIF

cAlias := Substr(cVarName,1,At('->',cVarName)-1)
cVar := Substr(cVarName,At('->',cVarName)+2)
cId := cPreFix + cAlias + '_' + cVar

RETURN Upper(cId)

* -----------------

STATIC FUNCTION RestDefButt( oGetList, cTitle )

LOCAL lStatus, cProcName := ProcName(2)

IF Empty(DC_AutoRestoreWindow())
  DCMSGBOX 'Cannot restore defaults unless DC_AutoRestoreWindow() is set first!'
  RETURN nil
ENDIF

DCMSGBOX DC_LangMsg(DCMSG_RESTDEF_MESSAGE1) ;
   YESNO ;
   TO lStatus ;
   NOAUTORESTORE

IF lStatus
  IF Valtype(DC_AutoRestoreWindow()[1]) == 'B'
    Eval(DC_AutoRestoreWindow()[1],cTitle,nil,.t.)
  ELSE
    IF DC_RegWrite(DC_AutoRestoreWindow()[1],DC_AutoRestoreWindow()[2], ;
                 Alltrim(cTitle), 0 )
      MsgBox(DC_LangMsg(DCMSG_RESTDEF_MESSAGE2))
    ELSE
      MsgBox('Defaults could not be restored!')
    ENDIF
  ENDIF
  oGetList:restoreWindow := .F.
ENDIF

RETURN nil

* -----------------

FUNCTION DC_DropData( xData, nType, oDragXbp )

STATIC sxDropData := nil, snType := nil, soDragXbp := nil

LOCAL xOldData := sxDropData, nOldType := snType, oOldXbp := soDragXbp

IF PCount() > 0
  sxDropData := xData
  snType := nType
  soDragXbp := oDragXbp
ENDIF

RETURN { xOldData, nOldType, oOldXbp }

* -----------------

GETSETFUNCTION DC_GetValidateOnChange DEFAULT .f.

GETSETFUNCTION DC_ValidCompleteEvents DEFAULT .f.

GETSETFUNCTION Cliff DEFAULT .f.

* -----------------

FUNCTION DC_GetDataStore( aGetList )

LOCAL nPointer := AScan(aGetList,{|a|a[nGETLIST_TYPE]==GETLIST_DATASTORE})
LOCAL oGetList

IF nPointer > 0 .AND. nPointer <= Len(aGetList)
  oGetList := aGetList[nPointer,oGETLIST_OBJECT]
ENDIF

RETURN oGetList

* -----------------

FUNCTION DC_ShowSourceCode( oXbp )

LOCAL nPointer, aGetList, oGetList, cSource, nLine, nHandle, cAllSource, ;
      cLine, cPrgFile := ''

IF !oXbp:isDerivedFrom('DC_XbaseParts')
  RETURN ''
ENDIF

nPointer := oXbp:cargo[1]
aGetList := oXbp:cargo[2]
nLine := aGetList[nPointer,aGETLIST_PROC,2]

nPointer := AScan(aGetList,{|a|a[nGETLIST_TYPE]==GETLIST_DATASTORE})

IF nPointer > 0 .AND. nPointer <= Len(aGetList)
  oGetList := aGetList[nPointer,oGETLIST_OBJECT]
  cPrgFile := oGetList:sourceCode
ENDIF

IF Empty(cPrgFile)
  RETURN 'No Source file defined in DCGETOPTIONS'
ENDIF

cAllSource := MemoRead(cPrgFile)
cSource := Trim(MemoLine(cAllSource,1000,nLine))

DO WHILE .t.
  nLine--
  cLine := Trim(MemoLine(cAllSource,1000,nLine))
  IF Right(cLine,1) = ';'
    cLine := Strtran(cLine,';','<%059>') + Chr(13) + Chr(10)
    cSource := cLine + cSource
  ELSE
    EXIT
  ENDIF
ENDDO

cSource := 'Source Line: ' + Alltrim(Str(nLine+1)) + CRLF + CRLF + cSource
cSource := 'Source File: ' + cPrgFile + CRLF + cSource

RETURN cSource

* ---------------

STATIC FUNCTION _ExpressPushButton( oDrawingArea, nButtonCol, aButtonConfig, aScaleFactor,nFitPad, self )

#if XPPVER > 1900000
IF Valtype(DC_ExpressButtonStyle()) = 'O'
  RETURN DC_XbpPushButtonXP():new( oDrawingArea, , ;
               {nButtonCol*aScaleFactor[1],nFitPad}, ;
               {aButtonConfig[3]*aScaleFactor[3], ;
                aButtonConfig[4]*aScaleFactor[4]}, nil, nil, self, DC_ExpressButtonStyle() )

ENDIF
#endif

RETURN DC_XbpPushButton():new( oDrawingArea, , ;
             {nButtonCol*aScaleFactor[1],nFitPad}, ;
             {aButtonConfig[3]*aScaleFactor[3], ;
              aButtonConfig[4]*aScaleFactor[4]}, nil, nil, self )

* --------------

GETSETFUNCTION DC_LbDownGetWhen DEFAULT .t.

* --------------

GETSETFUNCTION DC_ClearLastFocusWhenMinimized DEFAULT .f.

* --------------

STATIC FUNCTION _IsNavEnterObject( oXbp )

LOCAL i, aObjects := ;
  { 'DC_XBPGET', ;
    'DC_XBPGETC', ;
    'DC_XBPCHECKBOX', ;
    'DC_XBPSLE', ;
    'DC_XBPLISTBOX', ;
    'DC_XBPCOMBOBOX', ;
    'DC_XBPSPINBUTTON' }

FOR i := 1 TO Len(aObjects)
  IF oXbp:isDerivedFrom(aObjects[i])
    RETURN .t.
  ENDIF
NEXT

RETURN .f.

* --------------

STATIC FUNCTION _IsNavUpDownObject( oXbp )

LOCAL i, aObjects := ;
  { 'DC_XBPGET', ;
    'DC_XBPGETC', ;
    'DC_XBPCHECKBOX', ;
    'DC_XBPSLE', ;
    'DC_XBP3STATE' }

FOR i := 1 TO Len(aObjects)
  IF oXbp:isDerivedFrom(aObjects[i])
    RETURN .t.
  ENDIF
NEXT

RETURN .f.

* --------------

STATIC FUNCTION _IsNavEnterTabObject( oXbp )

LOCAL i, aObjects := ;
  { 'DC_XBPGET', ;
    'DC_XBPGETC', ;
    'DC_XBPCHECKBOX', ;
    'DC_XBPSLE', ;
    'DC_XBPCOMBOBOX', ;
    'DC_XBPSPINBUTTON', ;
    'DC_XBPLISTBOX' }

FOR i := 1 TO Len(aObjects)
  IF oXbp:isDerivedFrom(aObjects[i])
    RETURN .t.
  ENDIF
NEXT

RETURN .f.

* -------------

FUNCTION DC_LockWindowToOwner(aOld,aNew,oWindow,oOwner)

LOCAL lResetPos := .F.

DEFAULT oOwner := SetAppWindow()

IF aNew[1] < oOwner:CurrentPos()[1]
  aNew[1] := oOwner:CurrentPos()[1]
  lResetPos := .T.
ENDIf
IF aNew[2] < oOwner:CurrentPos()[2]
  aNew[2] := oOwner:CurrentPos()[2]
  lResetPos := .T.
ENDIf
IF aNew[1]+oWindow:CurrentSize()[1] > oOwner:CurrentPos()[1]+oOwner:CurrentSize()[1]
  aNew[1] := (oOwner:CurrentPos()[1]+oOwner:CurrentSize()[1])-oWindow:CurrentSize()[1]
  lResetPos := .T.
ENDIf
IF aNew[2]+oWindow:CurrentSize()[2] > oOwner:CurrentPos()[2]+oOwner:CurrentSize()[2]
  aNew[2] := (oOwner:CurrentPos()[2]+oOwner:CurrentSize()[2])-oWindow:CurrentSize()[2]
  lResetPos := .T.
ENDIf

IF lResetPos
  oWindow:SetPos(aNew)
ENDIF

RETURN NIL

* -----------

FUNCTION DC_HelpThreadObject(oThread)

STATIC oMagicHelpThread  // Jack Duijf 17-07-2014

If Pcount() > 0
   oMagicHelpThread     := oThread
Endif
Return oMagicHelpThread


//////////////////////////////////////////////////////////////////////
//
//  SCMANAGE.PRG
//
//  Copyright:
//      Alaska Software, (c) 1997-2009. All rights reserved.
//
//  Contents:
//      Shortcut manager base class for dialogs.
//      To use shortcut keys in your own dialog, you have to derive the
//      dialog from SCManager and call :InitShortCuts() right after calling
//      the dialogs :Create() method. In the keyboard callback the method
//      :HandleShortCut() needs to be called in order to handle the key.
//      The :InitShortCuts() method only uses the captions of the objects
//      to construct the shortcuts.
//
//  Remarks:
//
//////////////////////////////////////////////////////////////////////


/*
#include "common.ch"
#include "appevent.ch"
#include "xbp.ch"

******************************************************************************
* Declaration of the shortcut manager base class
******************************************************************************
CLASS SCManager

   HIDDEN:
      VAR    aShortCuts                      // Shortcuts = { nKey, oXbp, bBlock }
      METHOD CreateShortCut                  // service method

   EXPORTED:
      METHOD InitShortCuts                   // initialize the ALT key combinations
      METHOD HandleShortcut                  // handle the keystrokes for the dialog
      METHOD AddShortCut                     // add a shortcut
      METHOD GetShortCut                     // inquire shortcut to key

ENDCLASS


******************************************************************************
* Call shortcut, this is called within the :keyboard method.
******************************************************************************
METHOD SCManager:HandleShortcut( nKeyCode)
   LOCAL lHandled := FALSE, nPos

   // Is the key assigned to an action?
   nPos := 1
   WHILE lHandled == FALSE .AND. nPos <= Len( ::aShortCuts )

      // Call codeblock when the object is visible.
      IF ::aShortCuts[nPos, 1] == nKeyCode .AND. ;
         ::aShortCuts[nPos, 2]:IsVisible() .AND. ;
         ::aShortCuts[nPos, 2]:IsEnabled()

         Eval( ::aShortCuts[nPos, 3], ::aShortCuts[nPos, 2] )
         lHandled := TRUE
      ENDIF
      nPos++

   ENDDO
RETURN lHandled


******************************************************************************
* Init the shortcuts for a dialog.
******************************************************************************
METHOD SCManager:InitShortCuts( oXbp )
   LOCAL i, aChilds := oXbp:childList(), lChilds := LEN( aChilds)
   LOCAL nShortCut

   DEFAULT ::aShortCuts TO { ;
      { xbeK_ESC,    self, {|| PostAppEvent( xbeP_Close,,, self) } },;
      { xbeK_RETURN, self, {|| PostAppEvent( xbeP_Close,,, self) } } }

   FOR i := 1 TO lChilds

      // Static text
      IF aChilds[i]:isDerivedFrom( XbpStatic() )

         IF aChilds[i]:Type == XBPSTATIC_TYPE_TEXT
            // Is a shortcut Key assigned?
            IF !Empty( nShortCut := ::CreateShortCut( aChilds[i] ) )
               // Add the shortcut to set focus to the _next_ control to the array
               IF i < lChilds
                  ::AddShortCut( nShortCut, aChilds[i+1], { |o| SetAppFocus( o ) } )
               ENDIF
            ENDIF
         ENDIF

      // Pushbutton
      ELSEIF aChilds[i]:isDerivedFrom( XbpPushbutton() )

         // Is a shortcut Key assigned?
         IF !Empty( nShortCut := ::CreateShortCut( aChilds[i] ) )
            ::AddShortCut( nShortCut, aChilds[i], { |o| SetAppFocus( o ), ;
                           PostAppEvent( xbeP_Activate,,,o ) } )
         ENDIF

      // Radiobutton
      ELSEIF aChilds[i]:isDerivedFrom( XbpRadiobutton() )

         // Is a shortcut Key assigned?
         IF !Empty( nShortCut := ::CreateShortCut( aChilds[i] ) )
            ::AddShortCut( nShortCut, aChilds[i], { |o| SetAppFocus( o ),   ;
                           EnableRadioButton( o ), ;
                           PostAppEvent( xbeP_Activate,,,o ) } )
         ENDIF

      // Checkbox
      ELSEIF aChilds[i]:isDerivedFrom( XbpCheckbox() )

         // Is a shortcut Key assigned?
         IF !Empty( nShortCut := ::CreateShortCut( aChilds[i] ) )
            ::AddShortCut( nShortCut, aChilds[i], { |o| SetAppFocus( o ),   ;
                           o:SetData( !o:GetData() ), ;
                           PostAppEvent( xbeP_Activate,,,o ) } )
         ENDIF

      // 3State
      ELSEIF aChilds[i]:isDerivedFrom( Xbp3State() )

         // Is a shortcut Key assigned?
         IF !Empty( nShortCut := ::CreateShortCut( aChilds[i] ) )
            ::AddShortCut( nShortCut, aChilds[i], { |o| SetAppFocus( o ), ;
                           o:SetData( IF ( o:GetData() + 1 > 2, 0, o:GetData() + 1 ) ), ;
                           PostAppEvent( xbeP_Activate,,,o ) } )
         ENDIF

      // TabPage
      ELSEIF aChilds[i]:isDerivedFrom( XbpTabPage() )

         // Is a shortcut Key assigned?
         IF !Empty( nShortCut := ::CreateShortCut( aChilds[i] ) )
            ::AddShortCut( nShortCut, aChilds[i], { |o| SetAppFocus( o ), ;
                           PostAppEvent( xbeTab_TabActivate,,,o ) } )
         ENDIF
      ENDIF

      // Call the method recursive when the childlist is not empty
      IF ! EMPTY( aChilds[ i]:childList())
         ::InitShortCuts( aChilds[i])
      ENDIF
   NEXT
RETURN self


******************************************************************************
* Save shortcut
******************************************************************************
METHOD SCManager:AddShortCut( nKey, oXbp, bBlock )

   Aadd( ::aShortCuts, { nKey, oXbp, bBlock } )

RETURN TRUE


******************************************************************************
* Inquire Shortcut
******************************************************************************
METHOD SCManager:GetShortCut( nKey )
   LOCAL bRet, nPos := AScan( ::aShortCuts, { |a| a[1] == nKey } )

   IF nPos != 0
      RETURN ::aShortCuts[nPos,2]
   ENDIF

RETURN NIL


******************************************************************************
* Create shortcut key in the form <ALT>-<character>
******************************************************************************
METHOD SCManager:CreateShortCut( o)
   LOCAL nRet, nPos
   IF VALTYPE( o:caption) == "C"
      IF ( nPos := AT( "~", o:caption)) != 0
         nRet := xbeK_ALT_A +       ;
               ASC( UPPER( SUBSTR( o:caption, nPos + 1, 1))) - 65
      ENDIF
   ENDIF
RETURN nRet
*/

******************************************************************************
* Utility function to activate radio button
******************************************************************************
STATIC PROCEDURE EnableRadioButton( oXbp )

   LOCAL aSiblings := oXbp:SetParent():ChildList(), nPos

   nPos := AScan ( aSiblings, { |o| o:IsDerivedFrom( XbpRadiobutton() ) .AND. ;
                                    o:GetData() == TRUE } )
   IF nPos > 0
      aSiblings[nPos]:SetData( FALSE )
   ENDIF
   oXbp:SetData( TRUE )

RETURN

*-- $MR FUNCTION -----------------------------------------------------------------
*         Name: Progressbar
*-----------------------------------------------------------------------------
*    Parameter: nMode, nCount, nMaxCount, cTitle
*-----------------------------------------------------------------------------
STATIC FUNCTION ProgressBar( nMode, nCount, nMaxCount, cTitle, oProgress, oDialog, nBusyColor )

LOCAL GetList[0], GetOptions, oAppWindow := SetAppWindow()

STATIC nLastCount  // Jack Duijf 17-07-2014
DEFAULT nCount := 0, ;
        nMaxCount := 0, ;
        cTitle := 'Working...' ;

IF Empty(nBusyColor)
  nBusyColor := COLOR_ORANGE
ENDIF

IF nMode == 0

  IF Valtype(oProgress) = 'O' .AND. oProgress:status() > 0
    oDialog:destroy()
    oDialog := nil
    oProgress := nil
  ENDIF
   nLastCount  := 0
  @  10,0 DCSAY cTitle PIXEL SAYSIZE 0 FONT '8.Arial Bold'

  @ 23,0 DCPROGRESS oProgress ;
        TYPE XBPSTATIC_TYPE_TEXT ;
        MAXCOUNT nMaxCount ;
        PERCENT ;
        PERCENTCOLOR GRA_CLR_BLACK ;
        FONT '12.Arial Bold' ;
        EVERY 1 ;
        COLOR nBusyColor, GRA_CLR_BACKGROUND ;
        SIZE 400,20 ;
        PIXEL ;
        RADIUS 20 ;
        OUTLINE ;
        DYNAMIC

  DCGETOPTIONS ;
     NOTITLEBAR ;
     FITPAD 5 ;
     NOBUSY

  DCREAD GUI ;
     FIT ;
     OPTIONS GetOptions ;
     PARENT @oDialog ;
     EXIT ;
     NOAUTORESTORE ;
     APPWINDOW oAppWindow ;
    ;// MODAL ;
    ;// SETAPPWINDOW

ELSEIF nMode = 1
   If Int(nLastCount) <> Int(nCount)  // Jack Duijf 17-07-2014  Prevent re-display in no value change
      DC_GetProgress(oProgress,nCount,nMaxCount)
      nLastCount  := nCount
   Endif
ELSEIF nMode = 2

  IF Valtype(oProgress) = 'O' .AND. oProgress:status() > 0
//    oDialog:setModalState(XBP_DISP_MODELESS)
    oDialog:destroy()
    oDialog := nil
    oProgress := nil
  ENDIF

ENDIF

RETURN nil

* --------

FUNCTION DC_SetIconResource(nFrom,nTo)
LOCAL oIconList   := DC_GetSetIconList()
If ValType(nFrom) = "N"
   If ValType(nTo) <> "N"
      oIconList:Add(nFrom)
   Else
      oIconList:AddRange(nFrom,nTo)
   Endif
Endif

Return oIconList

* --------

FUNCTION DC_GetSetIconList()
STATIC soIconList := nil
If ValType(soIconList) <> "O"
   soIconList     := _Icon_List():New()
Endif

Return soIconList

//
// Class to register valid icon resource Id's
//
STATIC CLASS _Icon_List
HIDDEN:
VAR      aList
EXPORTED:
METHOD   Init
METHOD   Destroy
METHOD   Add
METHOD   AddRange
METHOD   IsIcon
ENDCLASS

METHOD _Icon_List:Init()
::aList              := {{0,0}}
Return SELF

METHOD _Icon_List:Destroy()
Asize(::aList,0)
Return SELF

METHOD _Icon_List:Add(nId)
If ValType(nId) = "N"                                                         // Only register numeric resource id's
   If Ascan(::aList,{|a|a[1] >= nId .and. a[1] <= nId}) = 0                   // Not registred yet
      Aadd(::aList,{nId,nId})
   Endif
Endif
Return

METHOD _Icon_List:AddRange(nFromId,nToId)
If ValType(nFromId) = "N"                                                     // Only register numeric resource id's
   If Ascan(::aList,{|a|a[1] >= nFromId .and. a[1] <= nFromId}) = 0           // Not registred yet
      Aadd(::aList,{nFromId,nToId})
   Endif
Endif
Return

METHOD _Icon_List:IsIcon(nId)
LOCAL lRet           := .T.
If ValType(nId) = "N"                                                         // Only test numeric resource id's
   If Ascan(::aList,{|a|a[1] <= nId .and. a[2] >= nId}) > 0                   // Icon ID registred
      lRet           := .T.
   Else
      lRet           := (Len(::aList) = 0)                                    // Always ok, if no regsitration of icon id's
   Endif
Endif
Return lRet

* ------------

STATIC FUNCTION _GetClass( ocSubClass, oClass )

IF Empty(ocSubClass)
  RETURN oClass
ELSEIF Valtype(ocSubClass) == 'O'
  RETURN ocSubClass
ELSEIF Valtype(ocSubClass) == 'C'
  RETURN &ocSubClass
ENDIF

RETURN oClass

* -----------

STATIC FUNCTION _GetChildMenuItem( oXbp, mp1, mp2 )

LOCAL i, j, aChildren := oXbp:childList()

BEGIN SEQUENCE
FOR i := 1 TO Len(aChildren)
  oXbp := aChildren[i]
  FOR j := 1 TO Len(oXbp:items)
    IF oXbp:items[j,5] == mp2
      mp1 := j
      BREAK
    ENDIF
  NEXT
NEXT
END SEQUENCE

RETURN oXbp

* -----------

GETSETFUNCTION DC_GetListStoreProfile DEFAULT .f.

* -----------

GETSETFUNCTION DC_GetListSleep DEFAULT .f.

* -----------

FUNCTION DC_RestoreWindow( self, nProcLine )

LOCAL nFrameState

IF ::isRestoreWindow .AND. !Empty(DC_AutoRestoreWindow()) .AND. ::restoreWindow
  nFrameState := ::parentDlg:getFrameState()

  ::parentDlg:setFrameState(XBPDLG_FRAMESTAT_NORMALIZED)

  DEFAULT ::restoreArray := {}
  ASize(::restoreArray,4)
  ::restoreArray[1] := ::parentDlg:currentPos()
  ::restoreArray[2] := ::parentDlg:currentSize()
  ::restoreArray[3] := nFrameState

  IF Valtype(DC_AutoRestoreWindow()[1]) == 'B'
    Eval(DC_AutoRestoreWindow()[1],ProcName(nProcLine) + ':' + ::parentDlg:title, ::restoreArray, .f.)
  ELSE
    DC_RegWrite(DC_AutoRestoreWindow()[1],DC_AutoRestoreWindow()[2], ;
                ProcName(nProcLine) + ':' + Alltrim(::parentDlg:title), ::restoreArray)
  ENDIF
ENDIF

RETURN nil
